/*--------------------------------------------------------------*\
		module	:	Command.c
		purpose :	X-Send R}h
		author	:	_@ Kengo Jinno
		create	:	2001/09/26
		update	:	2001/10/19
					2001/11/02	OPENFILENAME_SIZE_VERSION_400
								gOɁAdefineĂ邩`FbN
					2001/11/13	SetCurrentDirectory( WindowstH_ )
								AXsOpenFileProc()ł
					2001/11/21	Rgs͑oȂ
					2001/12/03	鏈sȂɁAłv
								悤ɂB
					2002/03/19	XsInfo::bEditMode ǉ
					2002/03/19	XsInfo::hWndMySci ǉ
					2002/03/26	sԍw肵ăWv
					2002/03/26	֌W̒ǉ
					2002/03/27	ScintillaRestore()̒ǉ
					2002/04/09	
					2004/02/20	㏑ۑsɃG[\
					2004/02/20	Win95BŃXe[^Xo[`悳Ȃ
								Ƃ΍
					2004/02/24	]f[^̏Ɏ󂯎葤
								^CAEgȂ悤pingł
					2011/02/10	Xe[^Xo[ɕ̒l\
					2011/02/10	̐ݒUIύX
\*--------------------------------------------------------------*/

#include	"PCH.h"
#include	"Command.h"
#include	"X-Send.h"
#include	"Tools.h"
#include	"ScrlBar.h"
#include	"ToolBar.h"
#include	"MyEdit.h"
#include	"MyList.h"
#include	"StatBar.h"
#include	"IPC.h"
#include	"md5.h"
#include	"WaitDlg.h"
#include	"SetupDlg.h"
#include	"MyDDE.h"
#include	"MarkDlg.h"
#include	"MySci.h"
#include	"JumpDlg.h"
#include	"resource.h"

/*	X-Send.c	*/
extern	const	TCHAR	BASED_CODE	szXsAppName[];
extern	const	TCHAR	BASED_CODE	szVersion[];


/* INIt@C̃ZNVEGg[	*/
static	const	TCHAR	BASED_CODE	lpszProfileSection[] = _T("X-Send");
static	const	TCHAR	BASED_CODE	lpszProfileVersionEntry[] = _T("Version");
static	const	TCHAR	BASED_CODE	lpszProfileShowFunctionKeyEntry[] = _T("ShowFunctionKey");
static	const	TCHAR	BASED_CODE	lpszProfileShowNewLineEntry[] = _T("ShowNewLine");
static	const	TCHAR	BASED_CODE	lpszProfileShowLineNumEntry[] = _T("ShowLineNum");
static	const	TCHAR	BASED_CODE	lpszProfileShowScrollBarEntry[] = _T("ShowScrollBar");
static	const	TCHAR	BASED_CODE	lpszProfileShowStatusBarEntry[] = _T("ShowStatusBar");
static	const	TCHAR	BASED_CODE	lpszProfileBitmapOnToolbarEntry[] = _T("BitmapOnFunctionKey");
static	const	TCHAR	BASED_CODE	lpszProfileShowEdgeEntry[] = _T("ShowEdge");
static	const	TCHAR	BASED_CODE	lpszProfileEdgeColumnEntry[] = _T("EdgeColumn");
static	const	TCHAR	BASED_CODE	lpszProfileDiamondCurosrEntry[] = _T("DiamondCursor");
static	const	TCHAR	BASED_CODE	lpszProfileDiamondUpDownEntry[] = _T("DiamondUpDown");
static	const	TCHAR	BASED_CODE	lpszProfileCaretRightEntry[] = _T("CaretRight");
static	const	TCHAR	BASED_CODE	lpszProfileMarkAsCommentEntry[] = _T("MarkAsComment");
/*	[hI[	*/
static	const	TCHAR	BASED_CODE	lpszProfileFunctionKey10Entry[] = _T("FunctionKey10");
static	const	TCHAR	BASED_CODE	lpszProfileSystemFontOnToolbarEntry[] = _T("SystemFontOnToolbar");
static	const	TCHAR	BASED_CODE	lpszProfileNewLineCharEntry[] = _T("NewLineChar");
static	const	TCHAR	BASED_CODE	lpszProfileNoTooltipEntry[] = _T("NoTooltip");
static	const	TCHAR	BASED_CODE	lpszProfileMultilineTipEntry[] = _T("MultilineTip");
static	const	TCHAR	BASED_CODE	lpszProfileMarkStringEntry[] = _T("MarkString");
static	const	TCHAR	BASED_CODE	lpszProfileCommentStringEntry[] = _T("CommentString");
static	const	TCHAR	BASED_CODE	lpszProfileFlatToolbarEntry[] = _T("FlatToolbar");
/*	fobOp	*/
static	const	TCHAR	BASED_CODE	lpszProfileSendFileIntervalEntry[] = _T("SendFileInterval");
static	const	TCHAR	BASED_CODE	lpszProfileBeepOnResendEntry[] = _T("BeepOnResend");
/*	tHg	*/
static	const	TCHAR	BASED_CODE	lpszProfileFontSection[] = _T("Font");
static	const	TCHAR	BASED_CODE	lpszProfileHeightEntry[] = _T("Height");
static	const	TCHAR	BASED_CODE	lpszProfileWeightEntry[] = _T("Weight");
static	const	TCHAR	BASED_CODE	lpszProfileItalicEntry[] = _T("Italic");
static	const	TCHAR	BASED_CODE	lpszProfileUnderlineEntry[] = _T("Underline");
static	const	TCHAR	BASED_CODE	lpszProfileCharSetEntry[] = _T("CharSet");
static	const	TCHAR	BASED_CODE	lpszProfilePitchAndFamilyEntry[] = _T("PitchAndFamily");
static	const	TCHAR	BASED_CODE	lpszProfileFaceNameEntry[] = _T("FaceName");
/*	DDE֌W	*/
static	const	TCHAR	BASED_CODE	lpszProfileDdeSendSection[] = _T("DDE");
static	const	TCHAR	BASED_CODE	lpszProfileUseDdeEntry[] = _T("UseDde");
static	const	TCHAR	BASED_CODE	lpszProfileDdeServerEntry[] = _T("ServiceName");
static	const	TCHAR	BASED_CODE	lpszProfileDdeListEntry[] = _T("ServiceList");
/*	EditSend֌W	*/
static	const	TCHAR	BASED_CODE	lpszProfileEditSendSection[] = _T("EditSend");
/*	IMS֌W	*/
static	const	TCHAR	BASED_CODE	lpszProfileImsSendSection[] = _T("IMS");
static	const	TCHAR	BASED_CODE	lpszProfileUseImsApiEntry[] = _T("UseImsApi");
static	const	TCHAR	BASED_CODE	lpszProfileHelpMeStringEntry[] = _T("HelpMeString");
/*		*/
static	const	TCHAR	BASED_CODE	lpszProfileRecentSection[] = _T("RecentFileList");

/*	INIt@C̓ǂݍ	*/
BOOL	ReadProfile( NpXsInfo p, LPCTSTR lpszFile )
{
	BOOL	ret;
	int		nHeight;
	
	/*	[\(V)]	*/
	p->bShowToolbar     = GetPrivateProfileInt( lpszProfileSection, lpszProfileShowFunctionKeyEntry, p->bShowToolbar,     lpszFile );
	p->bShowNewLine     = GetPrivateProfileInt( lpszProfileSection, lpszProfileShowNewLineEntry,     p->bShowNewLine,     lpszFile );
	p->bShowLineNum     = GetPrivateProfileInt( lpszProfileSection, lpszProfileShowLineNumEntry,     p->bShowLineNum,     lpszFile );
	p->bShowScrollBar   = GetPrivateProfileInt( lpszProfileSection, lpszProfileShowScrollBarEntry,   p->bShowScrollBar,   lpszFile );
	p->bShowStatusBar   = GetPrivateProfileInt( lpszProfileSection, lpszProfileShowStatusBarEntry,   p->bShowStatusBar,   lpszFile );
	p->bBitmapOnToolbar = GetPrivateProfileInt( lpszProfileSection, lpszProfileBitmapOnToolbarEntry, p->bBitmapOnToolbar, lpszFile );
	p->bShowEdge        = GetPrivateProfileInt( lpszProfileSection, lpszProfileShowEdgeEntry,        p->bShowEdge,        lpszFile );
	p->nEdgeColumn      = GetPrivateProfileInt( lpszProfileSection, lpszProfileEdgeColumnEntry,      p->nEdgeColumn,      lpszFile );
	
	/*	ݒ	*/
	p->bDiamondCursor = GetPrivateProfileInt( lpszProfileSection, lpszProfileDiamondCurosrEntry,   p->bDiamondCursor, lpszFile );
	p->bCtrlXCCursor  = GetPrivateProfileInt( lpszProfileSection, lpszProfileDiamondUpDownEntry,   p->bCtrlXCCursor,  lpszFile );
	p->bCaretRight    = GetPrivateProfileInt( lpszProfileSection, lpszProfileCaretRightEntry,      p->bCaretRight,    lpszFile );
	p->bMarkAsComment = GetPrivateProfileInt( lpszProfileSection, lpszProfileMarkAsCommentEntry,   p->bMarkAsComment, lpszFile );
	
	/*	[hI[	*/
	p->cNewLine =       GetPrivateProfileInt( lpszProfileSection, lpszProfileNewLineCharEntry,         p->cNewLine,       lpszFile );
	p->bFunctionKey10 = GetPrivateProfileInt( lpszProfileSection, lpszProfileFunctionKey10Entry,       p->bFunctionKey10, lpszFile );
	p->bSystemFont =    GetPrivateProfileInt( lpszProfileSection, lpszProfileSystemFontOnToolbarEntry, p->bSystemFont,    lpszFile );
	p->bNoTooltip =     GetPrivateProfileInt( lpszProfileSection, lpszProfileNoTooltipEntry,           p->bNoTooltip,     lpszFile );
	p->bMultilineTip =  GetPrivateProfileInt( lpszProfileSection, lpszProfileMultilineTipEntry,        p->bMultilineTip,  lpszFile );
	GetProfileMarkComment( &(p->FileInfo.MarkCommentInfo), lpszProfileSection, lpszProfileMarkStringEntry, lpszProfileCommentStringEntry, lpszFile );
	p->bFlatToolbar =   GetPrivateProfileInt( lpszProfileSection, lpszProfileFlatToolbarEntry,         p->bFlatToolbar,   lpszFile );
	
	/*	fobOp	*/
	p->dwSendFileInterval = (DWORD)GetPrivateProfileInt( lpszProfileSection, lpszProfileSendFileIntervalEntry, (int)p->dwSendFileInterval, lpszFile );
	p->bBeepOnResend = GetPrivateProfileInt( lpszProfileSection, lpszProfileBeepOnResendEntry, p->bBeepOnResend, lpszFile );
	
	/*	tHg	*/
	nHeight = GetPrivateProfileInt( lpszProfileFontSection, lpszProfileHeightEntry, 0, lpszFile );
	if( nHeight != 0 ) {
		p->lfText.lfHeight = nHeight;
		p->lfText.lfWidth = 0;
		p->lfText.lfWeight = GetPrivateProfileInt( lpszProfileFontSection, lpszProfileWeightEntry, p->lfText.lfWeight, lpszFile );
		p->lfText.lfItalic = (BYTE)GetPrivateProfileInt( lpszProfileFontSection, lpszProfileItalicEntry, p->lfText.lfItalic, lpszFile );
		p->lfText.lfUnderline = (BYTE)GetPrivateProfileInt( lpszProfileFontSection, lpszProfileUnderlineEntry, p->lfText.lfUnderline, lpszFile );
		p->lfText.lfCharSet = (BYTE)GetPrivateProfileInt( lpszProfileFontSection, lpszProfileCharSetEntry, p->lfText.lfCharSet, lpszFile );
		p->lfText.lfPitchAndFamily = (BYTE)GetPrivateProfileInt( lpszProfileFontSection, lpszProfilePitchAndFamilyEntry, p->lfText.lfPitchAndFamily, lpszFile );
		GetPrivateProfileString( lpszProfileFontSection, lpszProfileFaceNameEntry, p->lfText.lfFaceName, p->lfText.lfFaceName, LF_FACESIZE, lpszFile );
	}
	
	/*	DDE֌W	*/
	p->bUseDde = GetPrivateProfileInt( lpszProfileDdeSendSection, lpszProfileUseDdeEntry, p->bUseDde, lpszFile );
	GetPrivateProfileString( lpszProfileDdeSendSection, lpszProfileDdeServerEntry, p->szDdeServerName, p->szDdeServerName, _MAX_FNAME, lpszFile );
	GetPrivateProfileString( lpszProfileDdeSendSection, lpszProfileDdeListEntry, p->szDdeServiceList, p->szDdeServiceList, _MAX_PATH, lpszFile );
	
	/*	EditSend֌W	*/
	if( p->bCanUseEditSend ) {
		(p->EdsApiInfo.lpEdsGetProfile)( lpszFile, lpszProfileEditSendSection );
	}
	
	/*	IMS֌W	*/
	p->bUseImsApi = GetPrivateProfileInt( lpszProfileImsSendSection, lpszProfileUseImsApiEntry, p->bUseImsApi, lpszFile );
	GetPrivateProfileString( lpszProfileImsSendSection, lpszProfileHelpMeStringEntry, p->szHelpMe, p->szHelpMe, _MAX_PATH, lpszFile );
	
	/*		*/
	if( GetFileMruProfile( &(p->FileMruInfo), lpszProfileRecentSection, lpszFile ) ) {
		UpdateFileMruMenu( &(p->FileMruInfo), p->hFileMenu );
	}
	
	/*	Ñ`FbN	*/
	{
		TCHAR	buff[100];
		GetPrivateProfileString( lpszProfileSection, lpszProfileVersionEntry, _T(""), buff, 100, lpszFile );
		ret = ( buff[0] == _T('\0') );
	}
	return( ret );
}

/*	INIt@C̏	*/
void	WriteProfile( NpXsInfo p, LPCTSTR lpszFile )
{
	TCHAR	buff[256];
	/*	o[W	*/
	WritePrivateProfileString( lpszProfileSection, lpszProfileVersionEntry, szVersion, lpszFile );
	
	/*	[\(V)]	*/
	WritePrivateProfileInt( lpszProfileSection, lpszProfileShowFunctionKeyEntry, p->bShowToolbar,     lpszFile );
	WritePrivateProfileInt( lpszProfileSection, lpszProfileShowNewLineEntry,     p->bShowNewLine,     lpszFile );
	WritePrivateProfileInt( lpszProfileSection, lpszProfileShowLineNumEntry,     p->bShowLineNum,     lpszFile );
	WritePrivateProfileInt( lpszProfileSection, lpszProfileShowScrollBarEntry,   p->bShowScrollBar,   lpszFile );
	WritePrivateProfileInt( lpszProfileSection, lpszProfileShowStatusBarEntry,   p->bShowStatusBar,   lpszFile );
	WritePrivateProfileInt( lpszProfileSection, lpszProfileBitmapOnToolbarEntry, p->bBitmapOnToolbar, lpszFile );
	WritePrivateProfileInt( lpszProfileSection, lpszProfileShowEdgeEntry,        p->bShowEdge,        lpszFile );
	WritePrivateProfileInt( lpszProfileSection, lpszProfileEdgeColumnEntry,      p->nEdgeColumn,      lpszFile );
	/*	ݒ	*/
	WritePrivateProfileInt( lpszProfileSection, lpszProfileDiamondCurosrEntry,   p->bDiamondCursor, lpszFile );
	WritePrivateProfileInt( lpszProfileSection, lpszProfileDiamondUpDownEntry,   p->bCtrlXCCursor,  lpszFile );
	WritePrivateProfileInt( lpszProfileSection, lpszProfileCaretRightEntry,      p->bCaretRight,    lpszFile );
	WritePrivateProfileInt( lpszProfileSection, lpszProfileMarkAsCommentEntry,   p->bMarkAsComment, lpszFile );
	
	/*	tHg	*/
	WritePrivateProfileInt( lpszProfileFontSection, lpszProfileHeightEntry, p->lfText.lfHeight, lpszFile );
	WritePrivateProfileInt( lpszProfileFontSection, lpszProfileWeightEntry, p->lfText.lfWeight, lpszFile );
	WritePrivateProfileInt( lpszProfileFontSection, lpszProfileItalicEntry, p->lfText.lfItalic, lpszFile );
	WritePrivateProfileInt( lpszProfileFontSection, lpszProfileUnderlineEntry, p->lfText.lfUnderline, lpszFile );
	WritePrivateProfileInt( lpszProfileFontSection, lpszProfileCharSetEntry, p->lfText.lfCharSet, lpszFile );
	WritePrivateProfileInt( lpszProfileFontSection, lpszProfilePitchAndFamilyEntry, p->lfText.lfPitchAndFamily, lpszFile );
	WritePrivateProfileString( lpszProfileFontSection, lpszProfileFaceNameEntry, (LPCTSTR)p->lfText.lfFaceName, lpszFile );
	
	/*	DDE֌W	*/
//	WritePrivateProfileInt( lpszProfileDdeSendSection, lpszProfileUseDdeEntry, p->bUseDde, lpszFile );
//	WritePrivateProfileString( lpszProfileDdeSendSection, lpszProfileDdeServerEntry,  p->szDdeServerName, lpszFile );
	WritePrivateProfileString( lpszProfileDdeSendSection, lpszProfileDdeListEntry,  p->szDdeServiceList, lpszFile );
	
	/*	EditSend֌W	*/
	if( p->bCanUseEditSend ) {
		(p->EdsApiInfo.lpEdsWriteProfile)( lpszFile, lpszProfileEditSendSection );
	}
	
	/*	IMS֌W	*/
	WritePrivateProfileInt( lpszProfileImsSendSection, lpszProfileUseImsApiEntry, p->bUseImsApi, lpszFile );
	WritePrivateProfileString( lpszProfileImsSendSection, lpszProfileHelpMeStringEntry,  p->szHelpMe, lpszFile );
	
	/*		*/
	WriteFileMruProfile( &(p->FileMruInfo), lpszProfileRecentSection, lpszFile );
}

/*	Xe[^Xo[̃ACR̕\	*/
void	ShowStatusBarIcon( NpXsInfo p )
{
	IconStateType	state;
	if( p->bUseDde ) {
		if( !p->bFoundServer ) {
			state = eIconDdeNg;
		} else if( p->bViewMode || p->bHelpMe ) {
			state = eIconDdeStop;
		} else {
			state = eIconDdeGo;
		}
	} else {
		if( !p->bCanSendEditSend ) {
			state = eIconEditSendNg;
		} else if( p->bViewMode || p->bHelpMe ) {
			state = eIconDdeStop;
		} else {
			state = eIconEditSendOk;
		}
	}
	SetIconStatusBar( p->hWndStatusBar, state );
}

/*	^Cgo[̕\	*/
void	ShowCaption( HWND hWnd )
{
	NpXsInfo	p = GetXsInfo( hWnd );
	
	if( p != NULL ) {
		TCHAR	szText[_MAX_PATH*2];
		int		nLoc = 0;
		if( p->szFileName[0] != _T('\0') ) {
			nLoc += wsprintf( szText+nLoc, _T("%s"), p->szFileName );
		} else {
			nLoc += LoadString( p->hInstance, IDS_FILE_NONAME, szText+nLoc, _MAX_PATH );
		}
		nLoc += wsprintf( szText+nLoc, _T(" - %s"), szXsAppName );
		if( p->bViewMode ) {
			TCHAR	szViewMode[ _MAX_PATH ];
			if( LoadString( p->hInstance, IDS_VIEW_MODE, szViewMode, _MAX_PATH ) > 0 ) {
				nLoc += wsprintf( szText+nLoc, _T(" %s"), szViewMode );
			}
		}
		if( p->hWndMySci != NULL && IsWindow( p->hWndMySci ) ) {
			if( IsModifiedMyScintilla( p->hWndMySci ) ) {
				TCHAR	szModify[ _MAX_PATH ];
				if( LoadString( p->hInstance, IDS_CAPTION_MODIFY, szModify, _MAX_PATH ) > 0 ) {
					nLoc += wsprintf( szText+nLoc, _T(" %s"), szModify );
				}
			}
		}
		SetWindowText( hWnd, szText );
		
		/*	Xe[^Xo[(P)	*/
		if( p->szFilePath[0] != _T('\0') && !p->bEditMode ) {
			int		n;
			TCHAR	fmt[40];
#ifdef	WIN32
			TCHAR	buff[20];
#endif
			nLoc = 0;
#ifdef	WIN32
			if( p->lpStrFormatByteSize != NULL && (p->lpStrFormatByteSize)( p->nSize, buff, 20 ) != NULL ) {
				LoadString( p->hInstance, IDS_FILE_SIZE_FMT1, fmt, 40 );	//	"%s / "
				nLoc += wsprintf( szText+nLoc, fmt, buff );
			} else {
				LoadString( p->hInstance, IDS_FILE_SIZE_FMT2, fmt, 40 );	//	"%ld bytes / "
				nLoc += wsprintf( szText+nLoc, fmt, p->nSize );
			}
#else
			LoadString( p->hInstance, IDS_FILE_SIZE_FMT2, fmt, 40 );	//	"%ld bytes / "
			nLoc += wsprintf( szText+nLoc, fmt, p->nSize );
#endif
			LoadString( p->hInstance, IDS_FILE_LINE_FMT, fmt, 40 );	//	"%lds / "
			nLoc += wsprintf( szText+nLoc, fmt, p->nLineCnt );
			n = p->nMaxLen / 2;
			if( ( p->nMaxLen % 2 ) == 0 ) {
				LoadString( p->hInstance, IDS_FILE_LEN_FMT1, fmt, 40 );	//	"Œ%d"
				nLoc += wsprintf( szText+nLoc, fmt, n );
			} else {
				LoadString( p->hInstance, IDS_FILE_LEN_FMT2, fmt, 40 );	//	"Œ%d.5"
				nLoc += wsprintf( szText+nLoc, fmt, n );
			}
			LoadString( p->hInstance, IDS_FILE_LOC_FMT, fmt, 40 );	//	"(%lds)"
			nLoc += wsprintf( szText+nLoc, fmt, p->nMaxAt );
#if 0
			{
				int		i;
				nLoc += wsprintf( szText+nLoc, " / MD5 (%s) = ", p->szFileName );
				for( i = 0; i < 16; i++ ) {
					nLoc += wsprintf( szText+nLoc, "%02x", p->md5Contents[i] );
				}
			}
#endif
#if 1
		} else if( p->bEditMode ) {
			TCHAR	fmt[40];
			if( p->bShowEdge ) {
				LoadString( p->hInstance, IDS_EDGE_SB_SHOW, fmt, 40 );	//	" %d"
			} else {
				LoadString( p->hInstance, IDS_EDGE_SB_HIDE, fmt, 40 );	//	" Ȃ"
			}
			wsprintf( szText, fmt, p->nEdgeColumn );
#endif
		} else {
			szText[0] = _T('\0');
		}
		ShowTextStatusBar( p->hWndStatusBar, szText );
		/*	Xe[^Xo[(Q)	*/
		if( p->bUseDde ) {
			TCHAR	fmt[40];
			LoadString( p->hInstance, IDS_DDE_DDE_FMT, fmt, 40 );	//	"DDE(%s)"
			wsprintf( szText, fmt, p->szDdeServerName );
		} else {
			LoadString( p->hInstance, IDS_DDE_EDITSEND, szText, 40 );	//	"EditSend"
		}
		SetTextStatusBar( p->hWndStatusBar, szText );
		/*	ACR(Q)	*/
		ShowStatusBarIcon( p );
		InvalidateRect( p->hWndStatusBar, NULL, TRUE );
		UpdateWindow( p->hWndStatusBar );	//	Win95B΍ŁAIɕ`悳Ă݂(2004/02/20)
	}
}



/*	Jt@C̏	*/
static	void	ParseFilePath( HWND hWnd, LPCTSTR lpszFileName )
{
	NpXsInfo	p = GetXsInfo( hWnd );
	if( p != NULL ) {
		TCHAR	buff[ _MAX_PATH ];
		LPTSTR	q = buff;
		MD5_CTX	md5context;
		
		/*	tpX	*/
		lstrcpy( p->szFilePath, lpszFileName );
		
		p->szFileName[0] = _T('\0');
		p->szPathName[0] = _T('\0');
		ZeroMemory( p->md5FileName, sizeof(p->md5FileName) );
		if( GetFullPathName( lpszFileName, _MAX_PATH, buff, &q ) > 0 ) {
			if( buff <= q && q < buff+_MAX_PATH ) {
				lstrcpyn( p->szPathName, buff, q-buff+1 );
				lstrcpy( p->szFileName, q );
				
				MD5Init( &md5context );
				MD5Update( &md5context, (unsigned char *)p->szFileName, lstrlen(p->szFileName)*sizeof(TCHAR) );
				MD5Final( p->md5FileName, &md5context );
			}
		}
	}
}

/*	t@C̓ǂݍݏ	*/
static	BOOL	NEAR	DoLoadFile( HWND hWnd, LPCTSTR lpszFileName, HGLOBAL hBuff, DWORD dwBuffSize )
{
	NpXsInfo	p = GetXsInfo( hWnd );
	BOOL		ret = FALSE;
	BOOL		bProcLoad = ( lpszFileName != NULL );
	if( p != NULL && bProcLoad ) {
		if( p->bEditMode && IsModifiedMyScintilla( p->hWndMySci ) ) {
			TCHAR	msg[ 256 ];
			int		sel;
			LoadString( p->hInstance, IDS_CFM_SAVE, msg, 255 );
			sel = MessageBox( hWnd, msg, szXsAppName, MB_APPLMODAL|MB_DEFBUTTON1|MB_ICONEXCLAMATION|MB_YESNOCANCEL );
			if( sel == IDCANCEL ) {
				return( TRUE );
			} else if( sel == IDYES ) {
				DoSendCommand( hWnd, ID_FILE_SAVE );
				if( IsModifiedMyScintilla( p->hWndMySci ) ) {
					return( TRUE );
				}
			}
		}
		if( !p->bViewMode && p->szFilePath[0] != _T('\0') ) {
			/*	o[hȂAmF	*/
			TCHAR	buff[ 256 ], msg[ 256 ];
			LoadString( p->hInstance, IDS_CFM_LOAD, buff, 255 );
			wsprintf( msg, buff, p->szFileName );
			if( IDOK != MessageBox( hWnd, msg, szXsAppName, MB_APPLMODAL|MB_DEFBUTTON1|MB_ICONEXCLAMATION|MB_OKCANCEL ) ) {
				return( TRUE );
			}
		}
	}
	if( p != NULL ) {
		LPCTSTR	lpszTemplate = MAKEINTRESOURCE( IDD_WAIT_DIALOG );
		WaitDlgInfo		Info;
		Info.hWnd = hWnd;
		Info.wParam = 0;
		Info.lParam = (LPARAM)(&(p->FileInfo));
		Info.lpfnProcess = LoadFileMyList;
		p->FileInfo.lpszFile = lpszFileName;
		p->FileInfo.hWnd1 = p->hWndListBoxLow;
		p->FileInfo.hWnd2 = p->hWndListBoxHi;
		p->FileInfo.hWndSci = p->hWndMySci;	//	bProcLoad ? p->hWndMySci : NULL;
		p->FileInfo.lpfnMessagePump = MyProcessMessage;
		p->FileInfo.hSaveBuff = hBuff;
		p->FileInfo.dwSaveBuffSize = dwBuffSize;
		DialogBoxParam( p->hInstance, lpszTemplate, hWnd, WaitDlgProc, (LPARAM)&Info );
		ret = Info.bRetCode;
		if( ret ) {
			if( bProcLoad ) {
				if( p->bHelpMe ) {
					/*	łv(2001/12/03)	*/
					DoSendCommand( hWnd, ID_OPERATE_HELP_ME );
				}
				if( !p->bViewMode && p->szFilePath[0] != _T('\0') ) {
					/*	o[hȂʒm	*/
					if( p->hWndXsd != NULL ) {
						p->XsdApiInfo.uEventID = XSD_API_EVENT_CLOSE_FILE;
						p->XsdApiInfo.hWndFrom = hWnd;
						p->XsdApiInfo.wParam = 0;
						p->XsdApiInfo.lParam = 0;
						CopyMemory( p->XsdApiInfo.md5FileName, p->md5FileName, sizeof(p->md5FileName) );
						DoXsdEvent( hWnd );
						Sleep( 100 );
					}
				}
			}
			p->nLineCnt = p->FileInfo.nLineCnt;
			p->nSize = p->FileInfo.nSize;
			p->nMaxLen = p->FileInfo.nMaxLen;
			p->nMaxAt = p->FileInfo.nMaxAt;
			CopyMemory( p->md5Contents, p->FileInfo.md5Contents, sizeof(p->md5Contents) );
			if( bProcLoad ) {
				/*	JpX̏	*/
				ParseFilePath( hWnd, lpszFileName );
				/*	ɒǉ	*/
				AddFileMruList( &(p->FileMruInfo), p->szFilePath, p->hFileMenu );
				WriteProfile( p, p->szProfile );
				DoXsIpcNotify( hWnd, XS_IPC_CMD_ADD_MRU, XS_IPC_PARAM_ADD_MRU_NOTIFY );
			}
			/*	XN[o[	*/
			SetRangeScrollBar( p->hWndScrollBar, 0, p->nLineCnt );
			/*	EBhEĔzu	*/
			RecalcLayout( hWnd );
			/*	c[o[̏	*/
			SetStateToolBar( p->hWndToolBar, p->szFilePath[0] != _T('\0'), p->bHelpMe, p->bViewMode, p->hWndMySci, p->bEditMode );
			if( bProcLoad ) {
				/*	J[\(݈ʒu)	*/
				p->nCurrentLine = -1;
				DoMove( hWnd, 0 );
			}
			if( bProcLoad ) {
				/*	LvV\	*/
				ShowCaption( hWnd );
				/*	̃t@ĈfBNgAɊJ̏fBNgƂ	*/
				lstrcpy( p->szInitialDir, p->szPathName );
			}
		}
	}
	return ret;
}

/*	VJ	*/
static	BOOL	NEAR	DoOpenNew( HWND hWnd, LPCTSTR lpszFileName )
{
	NpXsInfo	p = GetXsInfo( hWnd );
	BOOL		ret = FALSE;
	if( p != NULL ) {
		TCHAR	lpszImageName[ _MAX_PATH ];
		TCHAR	lpszFilePath[ _MAX_PATH ];
		int		nLen;
		LPTSTR	lpCmdLine;
		
		/*	st@C(Z)pX	*/
		GetModuleFileName( NULL, lpszImageName, _MAX_PATH );
		GetShortPathName( lpszImageName, lpszImageName, _MAX_PATH );
		/*	nt@C̒ZpX	*/
		if( GetShortPathName( lpszFileName, lpszFilePath, _MAX_PATH ) == 0 ) {
			wsprintf( lpszFilePath, _T("\"%s\""), lpszFileName );
		}
		
		/*	R}hĈ߂̃m	*/
		nLen = lstrlen(lpszImageName) + lstrlen(lpszFilePath) + 1;
		lpCmdLine = (LPTSTR)GlobalAlloc( GPTR, sizeof(TCHAR)*(nLen+1) );
		
		if( lpCmdLine != NULL ) {
			STARTUPINFO			si;
			PROCESS_INFORMATION	pi;
			
			ZeroMemory( &si, sizeof(si) );
			si.cb = sizeof(si);
			si.dwFlags = STARTF_USESHOWWINDOW;
			si.wShowWindow = SW_SHOWNORMAL;
			
			/*	R}hC쐬	*/
			nLen = 0;
			nLen += wsprintf( lpCmdLine+nLen, _T("%s "), lpszImageName );
			nLen += wsprintf( lpCmdLine+nLen, _T("%s"),  lpszFilePath );
			
			ret = CreateProcess( NULL, lpCmdLine, NULL, NULL, FALSE, 0, NULL, NULL, &si, &pi );
			if( ret ) {
				WaitForInputIdle( pi.hProcess, 0 );
				CloseHandle( pi.hProcess );
				CloseHandle( pi.hThread );
			}
			
			GlobalFree( (HGLOBAL)lpCmdLine );
		}
	}
	return ret;
}

/*	ut@CJȂvG[\	*/
static	void	NEAR	ShowErrorFileOpen( HWND hWnd, LPCTSTR lpszFileName, BOOL bSave )
{
	NpXsInfo	p = GetXsInfo( hWnd );
	if( p != NULL ) {
		TCHAR	fmt[ _MAX_PATH ], msg[ _MAX_PATH*2 ];
		LoadString( p->hInstance, bSave?IDS_ERROR_SAVE_FILE:IDS_ERROR_OPEN_FILE, fmt, _MAX_PATH );
		wsprintf( msg, fmt, lpszFileName );
		MessageBox( hWnd, msg, szXsAppName, MB_APPLMODAL|MB_DEFBUTTON1|MB_ICONSTOP|MB_OK );
	}
}

/*	t@C̏(sԍt)	*/
static	BOOL	NEAR	DoSaveFileNum( HWND hWnd, LPCTSTR lpszFileName )
{
	NpXsInfo	p = GetXsInfo( hWnd );
	BOOL		ret = FALSE;
	if( p != NULL ) {
		LPCTSTR	lpszTemplate = MAKEINTRESOURCE( IDD_WAIT_DIALOG );
		WaitDlgInfo		Info;
		Info.hWnd = hWnd;
		Info.wParam = 0;
		Info.lParam = (LPARAM)(&(p->FileInfo));
		Info.lpfnProcess = SaveFileMyList;
		p->FileInfo.lpszFile = lpszFileName;
		p->FileInfo.hWnd1 = p->hWndListBoxLow;
		p->FileInfo.hWnd2 = p->hWndListBoxHi;
		p->FileInfo.hWndSci = NULL;
		p->FileInfo.lpfnMessagePump = MyProcessMessage;
		p->FileInfo.nLineCnt = p->nLineCnt;
		DialogBoxParam( p->hInstance, lpszTemplate, hWnd, WaitDlgProc, (LPARAM)&Info );
		ret = Info.bRetCode;
		/*	LvV\	*/
		ShowCaption( hWnd );
	}
	return ret;
}

/*	t@C̏(ҏW[h)	*/
static	BOOL	NEAR	DoSaveFile( HWND hWnd, LPCTSTR lpszFileName )
{
	NpXsInfo	p = GetXsInfo( hWnd );
	BOOL		ret = FALSE;
	if( p != NULL ) {
		LPCTSTR	lpszTemplate = MAKEINTRESOURCE( IDD_WAIT_DIALOG );
		WaitDlgInfo		Info;
		Info.hWnd = hWnd;
		Info.wParam = 0;
		Info.lParam = (LPARAM)(&(p->FileInfo));
		Info.lpfnProcess = SaveFileMyScintilla;
		p->FileInfo.lpszFile = lpszFileName;
		p->FileInfo.hWnd1 = NULL;
		p->FileInfo.hWnd2 = NULL;
		p->FileInfo.hWndSci = p->hWndMySci;
		p->FileInfo.lpfnMessagePump = MyProcessMessage;
		p->FileInfo.nLineCnt = GetLineCntMyScintilla( p->hWndMySci );
		DialogBoxParam( p->hInstance, lpszTemplate, hWnd, WaitDlgProc, (LPARAM)&Info );
		ret = Info.bRetCode;
		if( ret ) {
			/*	JpX̏	*/
			ParseFilePath( hWnd, lpszFileName );
			/*	ɒǉ	*/
			AddFileMruList( &(p->FileMruInfo), p->szFilePath, p->hFileMenu );
			WriteProfile( p, p->szProfile );
			DoXsIpcNotify( hWnd, XS_IPC_CMD_ADD_MRU, XS_IPC_PARAM_ADD_MRU_NOTIFY );
			/*	̃t@ĈfBNgAɊJ̏fBNgƂ	*/
			lstrcpy( p->szInitialDir, p->szPathName );
		}
		/*	LvV\	*/
		ShowCaption( hWnd );
	}
	return ret;
}

/*	t@C̑I_CAO	*/
static	BOOL	NEAR	DoFileDlg( HWND hWnd, BOOL bSave, BOOL bNum, BOOL bOpenNew, LPCTSTR lpszInitialDir )
{
	NpXsInfo	p = GetXsInfo( hWnd );
	BOOL		ret = FALSE;
	if( p != NULL ) {
		newOPENFILENAME	ofn;
		TCHAR	szExtension[_MAX_PATH], szFilter[_MAX_PATH], szFileName[_MAX_PATH];
		TCHAR	szBuff[_MAX_PATH];
		TCHAR	szTitle[_MAX_PATH];
		LPTSTR	pt = szFilter;
		
		/*	JgfBNgޔ	*/
		GetCurrentDirectory( _MAX_PATH, szBuff );
		
		LoadString( p->hInstance, IDS_FILE_FILTER, szFilter, _MAX_PATH );
		LoadString( p->hInstance, IDS_FILE_EXTENSION, szExtension, _MAX_PATH );
		while( *pt != _T('\0') ) {
			if( *pt == _T('|') ) {
				*pt = _T('\0');
			}
			pt++;
		}
		szFileName[0] = _T('\0');
		if( bSave ) {
			if( bNum ) {
				TCHAR	fmt[_MAX_PATH];
				LoadString( p->hInstance, IDS_FILE_SAVE_NAME, fmt, _MAX_PATH );	//	"sԍt %s"
				wsprintf( szFileName, fmt, p->szFileName );
			} else {
				lstrcpy( szFileName, p->szFileName );
			}
		}
		ZeroMemory( &ofn, sizeof(ofn) );
#if (_WIN32_WINNT >= 0x0500) && defined(OPENFILENAME_SIZE_VERSION_400)
		ofn.lStructSize = gbIsNt2kLater ? sizeof(ofn) : OPENFILENAME_SIZE_VERSION_400;
#else
		ofn.lStructSize = gbIsNt2kLater ? sizeof(ofn) : sizeof(OPENFILENAME);
#endif
		ofn.hwndOwner = hWnd;
		ofn.hInstance = NULL;
		ofn.lpstrFilter = szFilter;
		ofn.lpstrFile = szFileName;
		ofn.lpstrInitialDir = ( lpszInitialDir == NULL ) ? p->szInitialDir : lpszInitialDir;
		ofn.nMaxFile = _MAX_PATH;
		ofn.Flags = OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT|OFN_EXPLORER|(!bSave?OFN_FILEMUSTEXIST:0);
		ofn.lpstrDefExt = szExtension;
//		ofn.lpfnHook = FileHookProc;
		ofn.lCustData = 0;
		if( bSave ) {
			if( !GetSaveFileName( (LPOPENFILENAME)&ofn ) ) {
				goto exit_open;
			}
			if( bNum ) {
				/*	sԍtŕۑ	*/
				ret = DoSaveFileNum( hWnd, ofn.lpstrFile );
			} else {
				/*	ʂɕۑ(ҏW[h)	*/
				ret = DoSaveFile( hWnd, ofn.lpstrFile );
			}
			if( !ret ) {
				/*	JȂ(LᔽH)	*/
				ShowErrorFileOpen( hWnd, ofn.lpstrFile, TRUE );
			}
		} else {
			if( !bOpenNew ) {	/*	uǂݍ݁v̏ꍇ	*/
				if( LoadString( p->hInstance, IDS_FILE_LOAD_DLG, szTitle, _MAX_PATH ) > 0 ) {
					ofn.lpstrTitle = szTitle;	/*	^Cguǂݍ݁vɂ	*/
				}
			} else {		/*	uVJv̏ꍇ	*/
				ofn.Flags |= OFN_ALLOWMULTISELECT;
			}
			if( !GetOpenFileName( (LPOPENFILENAME)&ofn ) ) {
				goto exit_open;
			}
			if( !bOpenNew ) {
				/*	uǂݍ݁v͒PI	*/
				ret = DoLoadFile( hWnd, ofn.lpstrFile, NULL, 0 );
				if( !ret ) {
					/*	JȂ(LᔽH)	*/
					ShowErrorFileOpen( hWnd, ofn.lpstrFile, FALSE );
				}
			} else {
				/*	uJv͕t@C̏ꍇB	*/
				/*	'\0'؂ŁAGh}[NƂĂ'\0'	*/
				int		nCnt = 0;
				LPTSTR*	pArray;
				pArray = (LPTSTR*)GlobalAlloc( GPTR, sizeof(LPTSTR)*_MAX_PATH );
				if( pArray != NULL ) {
					LPCTSTR	q, r;
					int		nLen;
					DWORD	dwAttr;
					int		i;
					q = ofn.lpstrFile;
					while( *q != _T('\0') ) {
						r = q++;
						while( *q != _T('\0') ) {
							q++;
						}
						nLen = q - r;
						/*	fBNgH	*/
						dwAttr = GetFileAttributes( r );
						if( dwAttr != 0xffffffff && ( dwAttr & FILE_ATTRIBUTE_DIRECTORY ) != 0 ) {
							nLen = 0;	/*	fBNg͑IłȂ͂	*/
						}
						if( nLen > 0 && nLen < _MAX_PATH ) {
							LPTSTR	buff = (LPTSTR)GlobalAlloc( GPTR, sizeof(TCHAR)*(nLen+1) );
							if( buff != NULL ) {
								pArray[nCnt++] = buff;
								lstrcpyn( buff, r, nLen+1 );
							}
						}
						q++;
					}
					
					/*	J/ǂݍ	*/
#ifdef	ENABLE_LOAD
					SendMessage( hWnd, WM_XS_OPEN_MULTI_FILE, MAKEWPARAM( TRUE, nCnt ), (LPARAM)pArray );
#else
					SendMessage( hWnd, WM_XS_OPEN_MULTI_FILE, MAKEWPARAM( FALSE, nCnt ), (LPARAM)pArray );
#endif
					
					for( i = 0; i < nCnt; i++ ) {
						if( pArray[i] != NULL ) {
							GlobalFree( (HGLOBAL)pArray[i] );
							pArray[i] = NULL;
						}
					}
					GlobalFree( (HGLOBAL)pArray );
				}
			}
		}
exit_open:
		/*	JgfBNg𕜊	*/
		SetCurrentDirectory( szBuff );
	}
	return ret;
}

/*	t@C	*/
void	DoCloseFile( HWND hWnd )
{
	NpXsInfo	p = GetXsInfo( hWnd );
	if( p != NULL && p->szFilePath[0] != _T('\0') ) {
		if( p->bHelpMe ) {
			/*	łv(2001/12/03)	*/
			DoSendCommand( hWnd, ID_OPERATE_HELP_ME );
		}
		if( !p->bViewMode ) {
			/*	o[hȂʒm	*/
			if( p->hWndXsd != NULL ) {
				p->XsdApiInfo.uEventID = XSD_API_EVENT_CLOSE_FILE;
				p->XsdApiInfo.hWndFrom = hWnd;
				p->XsdApiInfo.wParam = 0;
				p->XsdApiInfo.lParam = 0;
				CopyMemory( p->XsdApiInfo.md5FileName, p->md5FileName, sizeof(p->md5FileName) );
				DoXsdEvent( hWnd );
				Sleep( 100 );
			}
		}
		p->szFilePath[0] = p->szFilePath[0] = p->szFileName[0] = _T('\0');
		ZeroMemory( p->md5FileName, sizeof(p->md5FileName) );
		p->nCurrentLine = 0;
		p->nLineCnt = 0;
		p->nSize = 0;
		p->nMaxLen = 0;
		p->nMaxAt = 0;
		EmptyMyList( p->hWndListBoxHi );
		EmptyMyList( p->hWndListBoxLow );
		SetTextMyEdit( p->hWndMyEdit, NULL, FALSE, FALSE );
		EmptyMyScintilla( p->hWndMySci );
		/*	XN[o[	*/
		SetRangeScrollBar( p->hWndScrollBar, 0, p->nLineCnt );
		/*	EBhEĔzu	*/
		RecalcLayout( hWnd );
		/*	c[o[̏	*/
		SetStateToolBar( p->hWndToolBar, p->szFilePath[0] != _T('\0'), p->bHelpMe, p->bViewMode, p->hWndMySci, p->bEditMode );
		/*	J[\(݈ʒu)	*/
		p->nCurrentLine = -1;
		DoMove( hWnd, 0 );
		/*	LvV\	*/
		ShowCaption( hWnd );
	}
}


/*	t@C]	*/
static	BOOL	XsFileSendProc( HWND hWnd, WPARAM wParam, LPARAM lParam )
{
	NpXsInfo	p = GetXsInfo( hWnd );
	if( p != NULL ) {
		int		i;
		TCHAR	fmt[ 80 ], ttl[ 80 ];
		DWORD	dwSize = p->nSize + 2*(p->nLineCnt)*sizeof(TCHAR);
		DWORD	dwCnt = dwSize / MAX_XSD_API_BUFF + 1;
		LPBYTE	pSendBuff;
		
		LoadString( p->hInstance, IDS_SENDING_FILE, fmt, 80 );
		
		LoadString( p->hInstance, IDS_SEND_FILE, ttl, 80 );
		ShowTextStatusBar( p->hWndStatusBar, ttl );
		SetProgressSizeStatusBar( p->hWndStatusBar, dwCnt );
		
		/*	]Jn	*/
		p->XsdApiInfo.uEventID = XSD_API_EVENT_SEND_FILE;
		p->XsdApiInfo.hWndFrom = hWnd;
		CopyMemory( p->XsdApiInfo.md5FileName, p->md5FileName, sizeof(p->md5FileName) );
		p->XsdApiInfo.wParam = 0;
		p->XsdApiInfo.lParam = dwSize;
		lstrcpy( (LPTSTR)(p->XsdApiInfo.buff), p->szFileName );
		DoXsdEvent( hWnd );
		Sleep( 100 );
		
		pSendBuff = (LPBYTE)GlobalAlloc( GPTR, dwSize );
		if( pSendBuff != NULL ) {
			DWORD	dwTick;
			LPBYTE	r;
			DWORD	dwLen;		/*	](oCg)	*/
			DWORD	dwRemain;	/*	c̗(oCg)	*/
			
			/*	]f[^̏	*/
			r = pSendBuff;
			dwLen = 0;
			dwTick = GetTickCount();
			for( i = 0; i < p->nLineCnt; i++ ) {
				LPCTSTR	q = GetTextMyList( p->hWndListBoxLow, i );
				int		nLen = lstrlen( q );
				if( dwLen + (nLen+1)*sizeof(TCHAR) <= dwSize ) {
					TCHAR	c = _T('\r');
					CopyMemory( r, q, nLen*sizeof(TCHAR) );
					r += nLen*sizeof(TCHAR);
					CopyMemory( r, &c, sizeof(TCHAR) );
					r += sizeof(TCHAR);
					dwLen += (nLen+1)*sizeof(TCHAR);
				}
				if( GetTickDiff( GetTickCount(), dwTick ) > 1000 ) {
					/*	󂯎葤Ń^CAEgȂ悤Apingł	*/
					p->XsdApiInfo.uEventID = XSD_API_EVENT_SEND_FILE;
					p->XsdApiInfo.hWndFrom = hWnd;
					CopyMemory( p->XsdApiInfo.md5FileName, p->md5FileName, sizeof(p->md5FileName) );
					p->XsdApiInfo.wParam = 4;
					p->XsdApiInfo.lParam = 0;
					DoXsdEvent( hWnd );
					/*	Ƒ҂	*/
					dwTick = GetTickCount();
					while( GetTickDiff( GetTickCount(), dwTick ) < 100 ) {
						MSG	msg;
						if( PeekMessage( &msg, NULL, 0, 0, PM_REMOVE ) ) {
							MyProcessMessage( hWnd, &msg );
						} else {
							Sleep(0);
						}
					}
					dwTick = GetTickCount();
				}
			}
			/*	Pbԑ҂	*/
			dwTick = GetTickCount();
			while( GetTickDiff( GetTickCount(), dwTick ) < 1000 ) {
				MSG	msg;
				if( PeekMessage( &msg, NULL, 0, 0, PM_REMOVE ) ) {
					MyProcessMessage( hWnd, &msg );
				} else {
					Sleep(0);
				}
			}
			dwTick = GetTickCount();
			
			r = pSendBuff;
			dwRemain = dwLen;
			i = 0;
			while( dwRemain > 0 ) {
				DWORD	dwLastInterval;
				int		nResendPos = -1;	/*	đvꂽR[hԍ	*/
				DWORD	dwSend;	/*	](oCg)	*/
				
				if( dwRemain > MAX_XSD_API_BUFF ) {
					dwSend = MAX_XSD_API_BUFF;
				} else {
					dwSend = dwRemain;
				}
				/*	]	*/
				p->XsdApiInfo.uEventID = XSD_API_EVENT_SEND_FILE;
				p->XsdApiInfo.hWndFrom = hWnd;
				CopyMemory( p->XsdApiInfo.md5FileName, p->md5FileName, sizeof(p->md5FileName) );
				p->XsdApiInfo.wParam = 1;
				p->XsdApiInfo.lParam = MAKELPARAM( dwSend, i );
				CopyMemory( p->XsdApiInfo.buff, r, dwSend );
				DoXsdEvent( hWnd );
				/*
					]ɑ̃Cxgp->XsdApiInfo
					j󂳂̂ŁASZbgׂB
				*/
				
				dwLastInterval = GetTickCount();
				while( GetTickDiff( GetTickCount(), dwLastInterval ) < p->dwSendFileInterval ) {
					Sleep(10);
				}
				if( dwRemain <= MAX_XSD_API_BUFF ) {
					/*	Ō͗]ɑ҂	*/
					Sleep(500-p->dwSendFileInterval);
				}
				if( GetTickDiff( GetTickCount(), dwTick ) > 300 || dwRemain <= MAX_XSD_API_BUFF ) {
					/*	300msɃbZ[W[v	*/
					MSG	msg;
					while( PeekMessage( &msg, NULL, 0, 0, PM_REMOVE ) ) {
						MyProcessMessage( hWnd, &msg );
						if( msg.message == WM_XS_RECV_FILE && msg.wParam == 3 ) {
							if( MD5Compare( p->XsdApiInfo.md5FileName, p->md5FileName ) ) {
								int		nRecord = HIWORD( msg.lParam );
								if( nRecord <= i ) {
									/*	đv	*/
									if( nResendPos < 0 || nResendPos > nRecord ) {
										nResendPos = nRecord;
									}
									/*	̑肩AɗvꍇB	*/
									/*	̏ꍇ͈ԏ(Â)̂蒼B		*/
								}
							}
						}
					}
					dwTick = GetTickCount();
					/*	R[hڂ̏H\	*/
					wsprintf( ttl, fmt, i+1 );
					ShowTextStatusBar( p->hWndStatusBar, ttl );
					SetProgressPosStatusBar( p->hWndStatusBar, i );
					Sleep(0);
				}
				if( nResendPos < 0 ) {
					/*	̃R[hɈڂ	*/
					dwRemain -= dwSend;
					r += MAX_XSD_API_BUFF;
					i++;
				} else {
					/*	đṽR[hɈڂ	*/
					if( p->bBeepOnResend ) {
						wsprintf( ttl, "%d(%d)", i, nResendPos-i );
						ShowTextStatusBar( p->hWndStatusBar, ttl );
						MessageBeep( 0xffffffff );
					}
					dwRemain = dwLen - nResendPos * MAX_XSD_API_BUFF;
					r = pSendBuff + nResendPos * MAX_XSD_API_BUFF;
					i = nResendPos;
				}
			}
			Sleep(100);
			
			GlobalFree( (HGLOBAL)pSendBuff );
		}
		
		/*	]I	*/
		p->XsdApiInfo.uEventID = XSD_API_EVENT_SEND_FILE;
		p->XsdApiInfo.hWndFrom = hWnd;
		p->XsdApiInfo.wParam = 2;
		p->XsdApiInfo.lParam = p->nCurrentLine;
		CopyMemory( p->XsdApiInfo.md5FileName, p->md5FileName, sizeof(p->md5FileName) );
		CopyMemory( p->XsdApiInfo.md5Contents, p->md5Contents, sizeof(p->md5Contents) );
		DoXsdEvent( hWnd );
		Sleep(100);
	}
	UNUSE( wParam );
	UNUSE( lParam );
	return( TRUE );
}

/*	t@C̓]󂯂	*/
static	BOOL	XsFileRecvProc( HWND hWnd, WPARAM wParam, LPARAM lParam )
{
	MSG		msg;
	BOOL	bQuit = FALSE;
	DWORD	dwTick = GetTickCount();
	DWORD	dwLastEvent = dwTick;
	NpXsInfo	p = GetXsInfo( hWnd );
	TCHAR	fmt[ 80 ], ttl[ 80 ];
	LoadString( p->hInstance, IDS_SENDING_FILE, fmt, 80 );
	for( ; ; ) {
		WaitMessage();
		if( PeekMessage( &msg, NULL, 0, 0, PM_REMOVE ) ) {
			if( msg.message == WM_XS_RECV_FILE ) {
				if( msg.wParam == 2 ) {
					bQuit = TRUE;
				}
				if( msg.wParam == 1 && GetTickDiff( GetTickCount(), dwTick ) > 300 ) {
					wsprintf( ttl, fmt, (long)HIWORD(msg.lParam) + 1 );
					ShowTextStatusBar( p->hWndStatusBar, ttl );
					SetProgressPosStatusBar( p->hWndStatusBar, (DWORD)HIWORD(msg.lParam) );
					dwTick = GetTickCount();
				}
				dwLastEvent = GetTickCount();
			}
			MyProcessMessage( hWnd, &msg );
			if( bQuit ) {
				if( p != NULL && p->bRecvFile ) {
					p->FileInfo.lpszFile = (LPCTSTR)(p->XsdApiInfo.buff);
					p->FileInfo.hWnd1 = p->hWndListBoxLow;
					p->FileInfo.hWnd2 = p->hWndListBoxHi;
					p->FileInfo.hWndSci = p->hWndMySci;
					p->FileInfo.lpfnMessagePump = MyProcessMessage;
					LoadFileMyList( hWnd, 0, (LPARAM)&(p->FileInfo) );
					p->bRecvFile = FALSE;
					p->nCurrentLine = (int)msg.lParam;
				}
				break;
			}
		}
		if( GetTickDiff( GetTickCount(), dwLastEvent ) > 5000 ) {
			/*	5bԃCxgȂI	*/
			break;
		}
	}
	if( p != NULL ) {
		p->bRecvFile = FALSE;
	}
	UNUSE( wParam );
	UNUSE( lParam );
	return( TRUE );
}

/*	WM_XS_RECV_FILE	*/
void	XsRecvFile( HWND hWnd, WPARAM wParam, LPARAM lParam )
{
	if( wParam == 0 ) {	/*	]JnCxg	*/
		NpXsInfo	p = GetXsInfo( hWnd );
		if( p != NULL && !p->bEditMode ) {	/*	ҏW[hł͂Ȃ(2002/03/27)	*/
			LpXsdApiInfoType	pInfo = &(p->XsdApiInfo);
			BOOL	bFlag = MD5Compare( p->XsdApiInfo.md5FileName, p->md5FileName );
			if( !bFlag && p->szFilePath[0] == _T('\0') ) {
				p->szFilePath[0] = p->cFilePathDummy;	/*	t@CƂĂ肦Ȃ	*/
				p->szFilePath[1] = _T('\0');
				lstrcpy( p->szFileName, (LPCTSTR)(pInfo->buff) );
				CopyMemory( p->md5FileName, p->XsdApiInfo.md5FileName, sizeof(p->md5FileName) );
				bFlag = TRUE;
			}
			p->bRecvFile = bFlag;
			if( bFlag ) {
				TCHAR	ttl[ 80 ];
				LoadString( p->hInstance, IDS_SEND_FILE, ttl, 80 );
				ShowTextStatusBar( p->hWndStatusBar, ttl );
				SetProgressSizeStatusBar( p->hWndStatusBar, pInfo->lParam / MAX_XSD_API_BUFF + 1 );
				DoPostCommand( hWnd, ID_FILE_RECV );
				if( p->bHelpMe ) {
					/*	łv(2001/12/03)	*/
					DoSendCommand( hWnd, ID_OPERATE_HELP_ME );
				}
			}
		}
	}
	UNUSE( lParam );
}

/*	WM_LIST_LOAD_FILE	*/
void	ListLoadFile( HWND hWnd, int nFlag, int nLine, DWORD dwVal )
{
	NpXsInfo	p = GetXsInfo( hWnd );
	/*	ǂݍݒ̒ʒm	*/
	if( p != NULL ) {
		TCHAR	msg[ 80 ];
		
		msg[0] = _T('\0');
		
		switch( nFlag ) {
		case 0:		/*	Jn	*/
			SetProgressSizeStatusBar( p->hWndStatusBar, dwVal );
			LoadString( p->hInstance, IDS_LOAD_FILE, msg, 80 );
			break;
		case 1:		/*	ǂݍݒ	*/
			SetProgressPosStatusBar( p->hWndStatusBar, dwVal );
			{
				TCHAR	fmt[ 80 ];
				LoadString( p->hInstance, IDS_LOADING_FILE, fmt, 80 );
				wsprintf( msg, fmt, (long)nLine );
			}
			break;
		case 2:		/*	I	*/
			break;
		}
		/*	Xe[^Xo[ɍsԍ\	*/
		ShowTextStatusBar( p->hWndStatusBar, msg );
	}
}

/*	WM_XS_OPEN_FILE	*/
void	XsOpenFileProc( HWND hWnd, LPCTSTR lpszCmdLine )
{
	NpXsInfo	p = GetXsInfo( hWnd );
	
	/*	R}hCŎw肳ꂽt@CJ	*/
	if( p != NULL && lpszCmdLine != NULL && lpszCmdLine[0] != _T('\0') && p->szFilePath[0] == _T('\0') ) {
		int		nCnt = 0;
		LPTSTR*	pArray;
		pArray = (LPTSTR*)GlobalAlloc( GPTR, sizeof(LPTSTR)*lstrlen(lpszCmdLine) );
		if( pArray != NULL ) {
			const	TCHAR	cNull = _T('\0');
			const	TCHAR	cSpace = _T(' ');
			const	TCHAR	cTab = _T('\t');
			const	TCHAR	cDQuote = _T('\"');
			LPCTSTR	q, r;
			int		i;
			
			/*	āApArray[]Ɋi[	*/
			q = lpszCmdLine;
			while( *q != cNull ) {
				/*	̃zCgXy[XXLbv	*/
				while( *q == cSpace || *q == cTab ) {
					q++;
				}
				r = NULL;
				if( *q == cDQuote ) {
					/*	ADQuote܂łp[^	*/
					r = ++q;
					while( *q != cDQuote && *q != cNull ) {
						q++;
					}
				} else if( *q != cNull ) {
					/*	ÃzCgXy[X܂łp[^	*/
					r = q++;
					while( *q != cSpace && *q != cTab && *q != cNull ) {
						q++;
					}
				}
				if( r != NULL ) {
					int		nLen = q - r;
					LPTSTR	buff = NULL;
					if( nLen > 0 && nLen < _MAX_PATH ) {
						buff = (LPTSTR)GlobalAlloc( GPTR, sizeof(TCHAR)*(nLen+1) );
					}
					if( buff != NULL ) {
						DWORD	dwAttr;
						lstrcpyn( buff, r, nLen+1 );
						dwAttr = GetFileAttributes( buff );	/*	݂邩H	*/
						if( dwAttr != 0xffffffff ) {
							pArray[nCnt++] = buff;
						} else {
							GlobalFree( (HGLOBAL)buff );
						}
					}
				}
				/*	q̓p[^̎̕(DQuote||zCgXy[X)wĂ	*/
				if( *q != cNull ) {
					q++;
				}
			}
			
			/*	J/ǂݍ	*/
			SendMessage( hWnd, WM_XS_OPEN_MULTI_FILE, MAKEWPARAM( FALSE, nCnt ), (LPARAM)pArray );
			
			/*		*/
			for( i = 0; i < nCnt; i++ ) {
				GlobalFree( (HGLOBAL)pArray[i] );
				pArray[i] = NULL;
			}
			GlobalFree( (HGLOBAL)pArray );
		}
	}
	/*	X-Send.c CreateProc()ړ	2001/11/13	*/
	{	/*	JgfBNgWindowsfBNgɂ	*/
		TCHAR	szBuff[ _MAX_PATH ];
		if( GetWindowsDirectory( szBuff, _MAX_PATH ) > 0 ) {
			SetCurrentDirectory( szBuff );
		}
		/*	ȂƁAFDDJgȂ񂩂肷ƁA	*/
		/*	WM_DDE_INITIATE邽т(Ȃ)ANZXĂ܂B	*/
	}
}

/*	WM_XS_OPEN_MULTI_FILE	*/
void	XsOpenMultiFileProc( HWND hWnd, BOOL bEnableLoad, int nCnt, LPCTSTR* pArray )
{
	NpXsInfo	p = GetXsInfo( hWnd );
	
	if( p != NULL ) {
		int*	pFlag = (int*)GlobalAlloc( GPTR, sizeof(int)*nCnt );
		/*
			0:Jς
			1:s(fBNg)
			2:s(ȊO)
		*/
		if( pFlag != NULL ) {
			int		i;
			BOOL	ret;
			TCHAR	szPath[ _MAX_PATH ];
			int		nDirCnt = 0;
			DWORD	dwAttr;
			
			for( i = 0; i < nCnt; i++ ) {
				if( pArray[i] == NULL ) {
					continue;
				}
				lstrcpy( szPath, pArray[i] );
				ResolveShortcut( szPath );
				
				dwAttr = GetFileAttributes( szPath );
				if( dwAttr == 0xffffffff ) {
					/*	݂Ȃ	*/
					pFlag[i] = 2;
				} else if( ( dwAttr & FILE_ATTRIBUTE_DIRECTORY ) != 0 ) {
					/*	fBNg	*/
					nDirCnt++;
					pFlag[i] = 1;
				} else {
					if( bEnableLoad || p->szFilePath[0] == _T('\0') ) {
						/*	ǂݍ	*/
						ret = DoLoadFile( hWnd, szPath, NULL, 0 );
						if( !ret && nCnt == 1 ) {
							/*	JȂ(LᔽH)	*/
							ShowErrorFileOpen( hWnd, szPath, FALSE );
							/*
								̏ꍇ́Aɓǂ߂̂邩Ȃ̂ŒPɖ
							*/
						}
					} else {
						/*	VJ	*/
						ret = DoOpenNew( hWnd, szPath );
					}
					if( ret ) {
						bEnableLoad = FALSE;
						pFlag[i] = 0;
					} else {
						pFlag[i] = 2;	/*	s	*/
					}
				}
			}
			/*	sfBNgxȂ߂	*/
			for( i = 0; i < nCnt; i++ ) {
				if( pArray[i] == NULL ) {
					continue;
				}
				if( pFlag[i] == 1 ) {
					nDirCnt--;
					lstrcpy( szPath, pArray[i] );
					ResolveShortcut( szPath );
					if( p->szFilePath[0] == _T('\0') && nDirCnt == 0 ) {	/*	Ō	*/
						/*	Ń_CAOJ	*/
						ret = DoFileDlg( hWnd, FALSE, FALSE, FALSE, szPath );
					} else {
						/*	VJ	*/
						ret = DoOpenNew( hWnd, szPath );
					}
				}
			}
			GlobalFree( (HGLOBAL)pFlag );
		}
	}
}

/*	WM_LIST_SAVE_FILE	*/
void	ListSaveFile( HWND hWnd, int nFlag, int nLine, DWORD dwVal )
{
	NpXsInfo	p = GetXsInfo( hWnd );
	/*	ݒ̒ʒm	*/
	if( p != NULL ) {
		TCHAR	msg[ 80 ];
		
		msg[0] = _T('\0');
		
		switch( nFlag ) {
		case 0:		/*	Jn	*/
			SetProgressSizeStatusBar( p->hWndStatusBar, dwVal );
			LoadString( p->hInstance, IDS_SAVE_FILE, msg, 80 );
			break;
		case 1:		/*	ǂݍݒ	*/
			SetProgressPosStatusBar( p->hWndStatusBar, dwVal );
			{
				TCHAR	fmt[ 80 ];
				LoadString( p->hInstance, IDS_SAVING_FILE, fmt, 80 );
				wsprintf( msg, fmt, (long)nLine );
			}
			break;
		case 2:		/*	I	*/
			break;
		}
		/*	Xe[^Xo[ɍsԍ\	*/
		ShowTextStatusBar( p->hWndStatusBar, msg );
	}
}

/*	WM_SCI_RESTORE	*/
void	ScintillaRestore( HWND hWnd, int nFlag, int nLine, DWORD dwVal )
{
	NpXsInfo	p = GetXsInfo( hWnd );
	/*	Xg{bNXScintillaւ̕A̒ʒm	*/
	if( p != NULL ) {
		TCHAR	msg[ 80 ];
		
		msg[0] = _T('\0');
		
		switch( nFlag ) {
		case 0:		/*	Jn	*/
			SetProgressSizeStatusBar( p->hWndStatusBar, dwVal );
			LoadString( p->hInstance, IDS_RESTORE_SCINTILLA, msg, 80 );
			break;
		case 1:		/*	A	*/
			SetProgressPosStatusBar( p->hWndStatusBar, dwVal );
			{
				TCHAR	fmt[ 80 ];
				LoadString( p->hInstance, IDS_RESTORING_SCINTILLA, fmt, 80 );
				wsprintf( msg, fmt, (long)nLine );
			}
			break;
		case 2:		/*	I	*/
			break;
		}
		/*	Xe[^Xo[ɍsԍ\	*/
		ShowTextStatusBar( p->hWndStatusBar, msg );
	}
}

/*	o	*/
static	void	DoSendString( HWND hWnd, NpXsInfo p, LPCTSTR lpszString )
{
	if( p->bUseDde ) {
		if( InitiateDDE( hWnd, &(p->DdeInfo), p->hWndLastServer ) ) {
			p->hWndLastServer = p->DdeInfo.hWndServer;
			SendDDEString( hWnd, &(p->DdeInfo), lpszString );
			/*	TerminateDDE()Ȃ	*/
		} else {
			p->hWndLastServer = NULL;
		}
	} else {
		(p->EdsApiInfo.lpEdsSendString)( lpszString );
	}
}

/*	WM_COMMAND	*/
BOOL	CommandProc( HWND hWnd, WORD wNotifyCode, WORD wID, HWND hwndCtl )
{
	NpXsInfo	p = GetXsInfo( hWnd );
	BOOL	ret = FALSE;
	if( p == NULL ) {
		return FALSE;
	}
	if( wNotifyCode == 0 || wNotifyCode == 1 ) {
		if( wID == ID_APP_EXIT ) {
			PostMessage( hWnd, WM_CLOSE, 0, 0 );
		} else if( wID == ID_APP_ABOUT ) {
			TCHAR	buff[ 256 ], msg[ 256*2 ];
			if( InSendMessage() ) {
				ReplyMessage( 0 );
			}
			LoadString( p->hInstance, IDS_VERSION, buff, 255 );
			wsprintf( msg, buff, (LPCTSTR)szXsAppName, (LPCTSTR)szVersion );
			if( GetDllVersionInfoMyScintilla( buff ) ) {
				lstrcat( msg, _T("\n\n") );
				lstrcat( msg, buff );
			}
			MessageBox( hWnd, msg, szXsAppName, MB_APPLMODAL|MB_DEFBUTTON1|MB_ICONINFORMATION|MB_OK );
		} else if( wID == ID_CFM_FIRST_BOOT ) {
			TCHAR	msg[80];
			LoadString( p->hInstance, IDS_MSG_FIRST_BOOT, msg, 80 );
			if( IDYES == MessageBox( hWnd, msg, szXsAppName, MB_YESNO|MB_ICONQUESTION ) ) {
				/*	Tvǂݍ	*/
				TCHAR	path[_MAX_PATH];
				DWORD	dwAttr;
				LoadString( p->hInstance, IDS_FILE_SAMPLE, msg, 80 );
				lstrcpy( path, p->szDllPath );
				lstrcat( path, msg );
				dwAttr = GetFileAttributes( path );
				if( dwAttr == 0xffffffff || ( dwAttr & FILE_ATTRIBUTE_DIRECTORY ) != 0 ) {
					/*	Ȃ	*/
					TCHAR	fmt[ _MAX_PATH ], msg[ _MAX_PATH*2 ];
					LoadString( p->hInstance, IDS_ERROR_NO_FILE, fmt, _MAX_PATH );
					wsprintf( msg, fmt, path );
					MessageBox( hWnd, msg, szXsAppName, MB_APPLMODAL|MB_DEFBUTTON1|MB_ICONSTOP|MB_OK );
				} else if( !DoLoadFile( hWnd, path, NULL, 0 ) ) {
					ShowErrorFileOpen( hWnd, path, FALSE );
				}
			}
		} else if( wID == ID_OPERATE_SETUP ) {	/*	ݒ_CAO	*/
			LPCTSTR	lpszTemplate = MAKEINTRESOURCE( IDD_SETUP_DIALOG );
			SetupDlgInfo	Info;
			Info.hWndParent = hWnd;
			Info.lpszTitle = szXsAppName;
			Info.bViewMode = p->bViewMode;
			Info.bNoTooltip = p->bNoTooltip;
			Info.bMultilineTip = p->bMultilineTip;
			Info.bDiamondCursor = p->bDiamondCursor;
			Info.bCtrlXCCursor = p->bCtrlXCCursor;
			Info.bCaretRight = p->bCaretRight;
			Info.bMarkAsComment = p->bMarkAsComment;
			Info.bCanUseEditSend = p->bCanUseEditSend;
			Info.pEdsApiInfo = &(p->EdsApiInfo);
			Info.hWndTarget = p->EdsApiInfo.hWndTarget;
			Info.EdsParam = p->EdsApiInfo.EdsParam;
			Info.bUseDde = p->bUseDde;
			Info.pDdeInfo = &(p->DdeInfo);
			lstrcpy( Info.szDdeServerName, p->szDdeServerName );
			Info.szDdeServiceArray = p->szDdeServiceArray;
			Info.nDdeServiceArry = p->nDdeServiceArry;
			Info.bUseImsApi = p->bUseImsApi;
			lstrcpy( Info.szHelpMe, p->szHelpMe );
			if( IDOK == DialogBoxParam( p->hInstance, lpszTemplate, hWnd, SetupDlgProc, (LPARAM)&Info ) ) {
				/*	\E	*/
				if( p->bDiamondCursor != Info.bDiamondCursor ) {
					p->bDiamondCursor = Info.bDiamondCursor;
					DoXsIpcNotify( hWnd, XS_IPC_CMD_DIAMOND_CURSOR, p->bDiamondCursor );
				}
				if( p->bCtrlXCCursor != Info.bCtrlXCCursor ) {
					p->bCtrlXCCursor = Info.bCtrlXCCursor;
					DoXsIpcNotify( hWnd, XS_IPC_CMD_CTRL_XC, p->bCtrlXCCursor );
				}
				if( p->bCaretRight != Info.bCaretRight ) {
					p->bCaretRight = Info.bCaretRight;
					DoXsIpcNotify( hWnd, XS_IPC_CMD_CARET_RIGHT, p->bCaretRight );
					if( !p->bViewMode && p->bCaretRight ) {
						DoLastMyEdit( p->hWndMyEdit );
					}
				}
				if( p->bMarkAsComment != Info.bMarkAsComment ) {
					p->bMarkAsComment = Info.bMarkAsComment;
					DoXsIpcNotify( hWnd, XS_IPC_CMD_MARK_AS_COMMENT, p->bMarkAsComment );
				}
				/*	o@	*/
				if( p->bUseDde ) {
					TerminateDDE( hWnd, &(p->DdeInfo) );
				}
				p->EdsApiInfo.hWndTarget = Info.hWndTarget;
				p->EdsApiInfo.EdsParam = Info.EdsParam;
				p->bUseDde = Info.bUseDde;
				lstrcpy( p->szDdeServerName, Info.szDdeServerName );
				/*	IMS	*/
				p->bUseImsApi = Info.bUseImsApi;
				lstrcpy( p->szHelpMe, Info.szHelpMe );
				if( !p->bUseImsApi ) {
					p->hWndIms = NULL;
				} else {
					PostMessage( hWnd, WM_IMS_SEARCH_SERVER, 0, 0 );
				}
				
				WriteProfile( p, p->szProfile );
				ShowCaption( hWnd );
			}
		} else if( wID == ID_FILE_OPEN || wID == ID_FILE_LOAD || wID == ID_FILE_SAVE_NUM ) {
			BOOL	bSave = ( wID == ID_FILE_SAVE_NUM );
			BOOL	bOpenNew = ( wID == ID_FILE_OPEN );
			DoFileDlg( hWnd, bSave, bSave ,bOpenNew, NULL );
		} else if( wID == ID_FILE_SAVE_AS ) {
			if( p->bEditMode ) {
				DoFileDlg( hWnd, TRUE, FALSE ,FALSE, NULL );
			}
		} else if( wID == ID_FILE_SAVE ) {
			if( p->bEditMode ) {
				if( p->szFilePath[0] == _T('\0') || p->szFilePath[0] == p->cFilePathDummy ) {
					DoFileDlg( hWnd, TRUE, FALSE ,FALSE, NULL );
				} else {
					if( !DoSaveFile( hWnd, p->szFilePath ) ) {
						/*	JȂ(LᔽH)	*/
						ShowErrorFileOpen( hWnd, p->szFilePath, TRUE );
					}
				}
			}
		} else if( wID == ID_FILE_CLOSE ) {
			BOOL	bGo = TRUE;
			if( p->bEditMode && IsModifiedMyScintilla( p->hWndMySci ) ) {
				TCHAR	msg[ 256 ];
				int		sel;
				LoadString( p->hInstance, IDS_CFM_SAVE, msg, 255 );
				sel = MessageBox( hWnd, msg, szXsAppName, MB_APPLMODAL|MB_DEFBUTTON1|MB_ICONEXCLAMATION|MB_YESNOCANCEL );
				if( sel == IDCANCEL ) {
					bGo = FALSE;
				} else if( sel == IDYES ) {
					DoSendCommand( hWnd, ID_FILE_SAVE );
					if( IsModifiedMyScintilla( p->hWndMySci ) ) {
						bGo = FALSE;
					}
				}
			}
			if( bGo && p->szFilePath[0] != _T('\0') && !p->bViewMode ) {
				TCHAR	buff[ 256 ], msg[ 256 ];
				LoadString( p->hInstance, IDS_CFM_CLOSE, buff, 255 );
				wsprintf( msg, buff, p->szFileName );
				if( IDOK != MessageBox( hWnd, msg, szXsAppName, MB_APPLMODAL|MB_DEFBUTTON1|MB_ICONEXCLAMATION|MB_OKCANCEL ) ) {
					bGo = FALSE;
				}
			}
			if( bGo ) {
				DoCloseFile( hWnd );
			}
		} else if( wID >= ID_FILE_MRU_FILE1 && wID < ID_FILE_MRU_FILE1+MAX_FILE_MRU_CNT ) {
			/*	J	*/
			LPCTSTR	lpszPath = GetMruFileName( &(p->FileMruInfo), wID - ID_FILE_MRU_FILE1 );
			TCHAR	szPath[ _MAX_PATH ];
#ifdef	ENABLE_LOAD
			BOOL	bShiftDown = TRUE;
#else
			BOOL	bShiftDown = ( ( (WORD)GetKeyState( VK_SHIFT ) & 0xff00 ) != 0 );
#endif
			DWORD	dwAttr;
			BOOL	ret;
			lstrcpy( szPath, lpszPath );
			dwAttr = GetFileAttributes( szPath );
			if( dwAttr == 0xffffffff || ( dwAttr & FILE_ATTRIBUTE_DIRECTORY ) != 0 ) {
				/*	Ȃ	*/
				TCHAR	fmt[ _MAX_PATH ], msg[ _MAX_PATH*2 ];
				LoadString( p->hInstance, IDS_ERROR_NO_FILE, fmt, _MAX_PATH );
				wsprintf( msg, fmt, szPath );
				MessageBox( hWnd, msg, szXsAppName, MB_APPLMODAL|MB_DEFBUTTON1|MB_ICONSTOP|MB_OK );
			} else {
				if( bShiftDown || p->szFilePath[0] == _T('\0') ) {
					/*	ǂݍ	*/
					ret = DoLoadFile( hWnd, szPath, NULL, 0 );
				} else {
					/*	VJ	*/
					ret = DoOpenNew( hWnd, szPath );
				}
				if( !ret ) {
					/*	JȂ(LᔽH)	*/
					ShowErrorFileOpen( hWnd, szPath, FALSE );
				}
			}
		} else if( wID == ID_FILE_SEND ) {	/*	]	*/
			TCHAR	buff[ 256 ], msg[ 256 ];
			LoadString( p->hInstance, IDS_CFM_SEND_FILE, buff, 255 );
			wsprintf( msg, buff, p->szFileName );
			if( IDOK == MessageBox( hWnd, msg, szXsAppName, MB_APPLMODAL|MB_DEFBUTTON1|MB_ICONQUESTION|MB_OKCANCEL ) ) {
				LPCTSTR	lpszTemplate = MAKEINTRESOURCE( IDD_WAIT_DIALOG );
				WaitDlgInfo		Info;
				Info.hWnd = hWnd;
				Info.wParam = 0;
				Info.lParam = 0;
				Info.lpfnProcess = XsFileSendProc;
				DialogBoxParam( p->hInstance, lpszTemplate, hWnd, WaitDlgProc, (LPARAM)&Info );
				ShowCaption( hWnd );
				LoadString( p->hInstance, IDS_END_SEND_FILE, buff, 255 );
				MessageBox( hWnd, buff, szXsAppName, MB_APPLMODAL|MB_DEFBUTTON1|MB_ICONINFORMATION|MB_OK );
			}
		} else if( wID == ID_FILE_RECV ) {	/*	]󂯂(R}h)	*/
			LPCTSTR	lpszTemplate = MAKEINTRESOURCE( IDD_WAIT_DIALOG );
			WaitDlgInfo		Info;
			Info.hWnd = hWnd;
			Info.wParam = 0;
			Info.lParam = 0;
			Info.lpfnProcess = XsFileRecvProc;
			{
				HWND	hWndTarget = GetLastActivePopup( hWnd );
				DWORD	dwThis, dwTarget;
				dwThis = GetCurrentThreadId();
				dwTarget = GetWindowThreadProcessId( GetForegroundWindow(), NULL );
				if( dwThis != dwTarget ) {
					AttachThreadInput( dwTarget, dwThis, TRUE );
					SetForegroundWindow( hWndTarget );
					AttachThreadInput( dwTarget, dwThis, FALSE );
				}
			}
			DialogBoxParam( p->hInstance, lpszTemplate, hWnd, WaitDlgProc, (LPARAM)&Info );
			if( Info.bRetCode ) {
				int		nPos = p->nCurrentLine;
				p->nLineCnt = p->FileInfo.nLineCnt;
				p->nSize = p->FileInfo.nSize;
				p->nMaxLen = p->FileInfo.nMaxLen;
				p->nMaxAt = p->FileInfo.nMaxAt;
				CopyMemory( p->md5Contents, p->FileInfo.md5Contents, sizeof(p->md5Contents) );
				/*	XN[o[	*/
				SetRangeScrollBar( p->hWndScrollBar, 0, p->nLineCnt );
				/*	EBhEĔzu	*/
				RecalcLayout( hWnd );
				/*	c[o[̏	*/
				SetStateToolBar( p->hWndToolBar, p->szFilePath[0] != _T('\0'), p->bHelpMe, p->bViewMode, p->hWndMySci, p->bEditMode );
				/*	J[\(݈ʒu)	*/
				p->nCurrentLine = -1;
				DoMove( hWnd, nPos );
				/*	LvV\	*/
				ShowCaption( hWnd );
				/*	MD5l̃`FbN	*/
				if( MD5Compare( p->XsdApiInfo.md5Contents, p->md5Contents ) ) {
					/*	OK	*/
				} else {
					/*	]G[ۂ	*/
					TCHAR	buff[ 256 ], msg[ 256 ];
					HWND	hWndTarget = GetLastActivePopup( hWnd );
					DWORD	dwThis, dwTarget;
					dwThis = GetCurrentThreadId();
					dwTarget = GetWindowThreadProcessId( GetForegroundWindow(), NULL );
					if( dwThis != dwTarget ) {
						AttachThreadInput( dwTarget, dwThis, TRUE );
						SetForegroundWindow( hWndTarget );
						AttachThreadInput( dwTarget, dwThis, FALSE );
					}
					LoadString( p->hInstance, IDS_FILE_UNMATCH, buff, 255 );
					wsprintf( msg, buff, p->szFileName );
					MessageBox( hWnd, msg, szXsAppName, MB_APPLMODAL|MB_DEFBUTTON1|MB_ICONEXCLAMATION|MB_OK );
				}
			}
		} else if( wID == ID_OPERATE_SEND_ALL || wID == ID_OPERATE_SEND_PART ) {
			if( p->bEditMode ) {
				int		nPos = GetCurrentLineMyScintilla( p->hWndMySci );
				int		nLineCnt;
				if( IsCommentMyScintilla( p->hWndMySci, nPos ) ||
					( p->bMarkAsComment && IsMarkMyScintilla( p->hWndMySci, nPos ) ) ) {
					;
				} else {
					int		nLen;
					LPCTSTR	lpszText = GetTextMyScintilla( p->hWndMySci, nPos, &nLen );
					DWORD	dwSize = sizeof(TCHAR)*(nLen+2+1);
					LPTSTR	lpszSend = (LPTSTR)GlobalAlloc( GPTR, dwSize );
					if( lpszSend != NULL ) {
						if( lpszText != NULL ) {
							lstrcpy( lpszSend, lpszText );
							lstrcat( lpszSend, _T("\r\n") );
							DoSendString( hWnd, p, lpszSend );
						}
						GlobalFree( (HGLOBAL)lpszSend );
					}
				}
				/*	̍s	*/
				nLineCnt = GetShownLineCntMyList( p->hWndListBoxHi, FALSE );	/*	̃Xg{bNX̍s	*/
				DoMoveMyScintilla( p->hWndMySci, nPos+1, nLineCnt );
				UpdateWindow( p->hWndMySci );
			} else {
				if( IsCommentMyList( p->hWndListBoxLow, p->nCurrentLine ) ||
					( p->bMarkAsComment && IsMarkMyList( p->hWndListBoxLow, p->nCurrentLine ) ) ) {
					/*	Rgs͑oȂ(2001/11/21)	*/
					/*	u}[NsRgṽ}[NsoȂ(2002/03/06)	*/
					/*	̍s	*/
					if( p->nCurrentLine < p->nLineCnt ) {
						DoMove( hWnd, p->nCurrentLine+1 );
					}
				} else {
					int		nLen;
					BOOL	bAll = ( wID == ID_OPERATE_SEND_ALL );	/*	ƂɂSH	*/
					LPCTSTR	lpszText = GetTextMyEdit( p->hWndMyEdit, bAll, &nLen );
					DWORD	dwSize = sizeof(TCHAR)*(nLen+2+1);
					LPTSTR	lpszSend = (LPTSTR)GlobalAlloc( GPTR, dwSize );
					if( lpszSend != NULL ) {
						if( lpszText != NULL ) {
							lstrcpy( lpszSend, lpszText );
							lstrcat( lpszSend, _T("\r\n") );
							DoSendString( hWnd, p, lpszSend );
						}
						GlobalFree( (HGLOBAL)lpszSend );
					}
					if( !HasTextMyEdit( p->hWndMyEdit ) ) {
						/*	̍s	*/
						if( p->nCurrentLine < p->nLineCnt ) {
							DoMove( hWnd, p->nCurrentLine+1 );
						}
					}
				}
			}
		} else if( wID == ID_OPERATE_SEND_NULL ) {
			DoSendString( hWnd, p, _T("\r\n") );
		} else if( wID == ID_MOVE_PREV_LINE ) {
			if( p->nCurrentLine > 0 ) {
				DoMove( hWnd, p->nCurrentLine-1 );
			}
		} else if( wID == ID_MOVE_NEXT_LINE ) {
			if( p->nCurrentLine < p->nLineCnt ) {
				DoMove( hWnd, p->nCurrentLine+1 );
			}
		} else if( wID == ID_MOVE_PREV_PAGE ) {
			int		nPage = GetShownLineCntMyList( p->hWndListBoxLow, TRUE );
			int		nPos = p->nCurrentLine;
			nPos -= nPage;
			if( nPos < 0 ) {
				nPos = 0;
			}
			DoMove( hWnd, nPos );
		} else if( wID == ID_MOVE_NEXT_PAGE ) {
			int		nPage = GetShownLineCntMyList( p->hWndListBoxLow, TRUE );
			int		nPos = p->nCurrentLine;
			nPos += nPage;
			if( nPos > p->nLineCnt ) {
				nPos = p->nLineCnt;
			}
			DoMove( hWnd, nPos );
		} else if( wID == ID_MOVE_TOP ) {
			DoMove( hWnd, 0 );
		} else if( wID == ID_MOVE_LAST ) {
			DoMove( hWnd, p->nLineCnt );
		} else if( wID == ID_MOVE_PREV_MARK ) {
			if( p->bEditMode ) {
				int		nLineCnt = GetShownLineCntMyList( p->hWndListBoxHi, FALSE );	/*	̃Xg{bNX̍s	*/
				int		nPos = GetCurrentLineMyScintilla( p->hWndMySci );
				nPos = SearchPrevMarkMyScintilla( p->hWndMySci, nPos );
				DoMoveMyScintilla( p->hWndMySci, nPos, nLineCnt );
			} else {
				int		nPos;
				nPos = SearchPrevMarkMyList( p->hWndListBoxLow, p->nCurrentLine );
				DoMove( hWnd, nPos );
			}
		} else if( wID == ID_MOVE_NEXT_MARK ) {
			if( p->bEditMode ) {
				int		nLineCnt = GetShownLineCntMyList( p->hWndListBoxHi, FALSE );	/*	̃Xg{bNX̍s	*/
				int		nPos = GetCurrentLineMyScintilla( p->hWndMySci );
				DoStylingMyScintilla( p->hWndMySci, &(p->FileInfo.MarkCommentInfo) );
				nPos = SearchNextMarkMyScintille( p->hWndMySci, nPos );
				DoMoveMyScintilla( p->hWndMySci, nPos, nLineCnt );
			} else {
				int		nPos;
				nPos = SearchNextMarkMyList( p->hWndListBoxLow, p->nCurrentLine );
				DoMove( hWnd, nPos );
			}
		} else if( wID == ID_MOVE_LIST_MARK ) {
			LPCTSTR	lpszTemplate = MAKEINTRESOURCE( IDD_MARK_DIALOG );
			MarkDlgInfo	Info;
			Info.bNoTooltip = p->bNoTooltip;
			Info.bMultilineTip = p->bMultilineTip;
			Info.bViewMode = FALSE;
			Info.bShowLineNum = p->bShowLineNum;
			Info.bShowNewLine = p->bShowNewLine;
			Info.cNewLine = p->cNewLine;
			Info.hFont = p->hFont;
			Info.hFontNewLine = p->hFontNewLine;
			if( p->bEditMode ) {
				DoStylingMyScintilla( p->hWndMySci, &(p->FileInfo.MarkCommentInfo) );
				Info.nLineCnt = GetLineCntMyScintilla( p->hWndMySci );
				Info.nCurrentLine = GetCurrentLineMyScintilla( p->hWndMySci );
				Info.hWndSorcListBox = NULL;
				Info.hWndSorcScintilla = p->hWndMySci;
			} else {
				Info.nLineCnt = p->nLineCnt;
				Info.nCurrentLine = p->nCurrentLine;
				Info.hWndSorcListBox = p->hWndListBoxLow;
				Info.hWndSorcScintilla = NULL;
			}
			Info.sizeMarkList = p->sizeMarkList;
			if( IDOK == DialogBoxParam( p->hInstance, lpszTemplate, hWnd, MarkDlgProc, (LPARAM)&Info ) ) {
				if( p->bEditMode ) {
					int		nLineCnt = GetShownLineCntMyList( p->hWndListBoxHi, FALSE );	/*	̃Xg{bNX̍s	*/
					DoMoveMyScintilla( p->hWndMySci, Info.nCurrentLine, nLineCnt );
				} else {
					DoMove( hWnd, Info.nCurrentLine );
				}
			}
			p->sizeMarkList = Info.sizeMarkList;
		} else if( wID == ID_MOVE_JUMP ) {
			LPCTSTR	lpszTemplate = MAKEINTRESOURCE( IDD_JUMP_DIALOG );
			JumpDlgInfo	Info;
			Info.eDataType = eJumpDataLineNum;
			Info.hInstance = p->hInstance;
			if( p->bEditMode ) {
				Info.nValue = GetCurrentLineMyScintilla( p->hWndMySci ) + 1;
				Info.nMin = 1;
				Info.nMax = GetLineCntMyScintilla( p->hWndMySci );
			} else {
				Info.nValue = p->nCurrentLine + 1;
				Info.nMin = 1;
				Info.nMax = p->nLineCnt;
			}
			if( IDOK == DialogBoxParam( p->hInstance, lpszTemplate, hWnd, JumpDlgProc, (LPARAM)&Info ) ) {
				if( p->bEditMode ) {
					int		nLineCnt = GetShownLineCntMyList( p->hWndListBoxHi, FALSE );	/*	̃Xg{bNX̍s	*/
					DoMoveMyScintilla( p->hWndMySci, Info.nValue - 1, nLineCnt );
				} else {
					DoMove( hWnd, Info.nValue - 1 );
				}
			}
		} else if( wID == ID_MOVE_ROLLUP ) {
			if( p->bEditMode ) {
				DoRollUpMyScintilla( p->hWndMySci );
			}
		} else if( wID == ID_MOVE_ROLLDOWN ) {
			if( p->bEditMode ) {
				DoRollDownMyScintilla( p->hWndMySci );
			}
		} else if( wID == ID_EDIT_UNDO ) {
			if( p->bEditMode ) {
				DoUndoMyScintilla( p->hWndMySci );
			} else {
				if( CanUndoMyEdit( p->hWndMyEdit ) ) {
					DoUndoMyEdit( p->hWndMyEdit );
					EmptyUndoBufferMyEdit( p->hWndMyEdit );
				}
			}
		} else if( wID == ID_EDIT_REDO ) {
			if( p->bEditMode ) {
				DoRedoMyScintilla( p->hWndMySci );
			}
		} else if( wID == ID_EDIT_FIND || wID == ID_EDIT_REPLACE ) {
			if( p->bEditMode && p->hWndFindDlg == NULL ) {
				GetSelTextMyScintilla( p->hWndMySci, p->szFindText, MAX_FIND_TEXT_LEN );
				ZeroMemory( &(p->frString), sizeof(p->frString) );
				p->frString.lStructSize = sizeof(p->frString);
				p->frString.hwndOwner = hWnd;
				p->frString.Flags = 0;
				p->frString.Flags |= p->bFindNext ? FR_DOWN : 0;
				p->frString.Flags |= p->bMatchCase ? FR_MATCHCASE : 0;
				p->frString.Flags |= p->bWholeWord ? FR_WHOLEWORD : 0;
				p->frString.lpstrFindWhat = p->szFindText;
				p->frString.wFindWhatLen = MAX_FIND_TEXT_LEN;
				p->frString.lpstrReplaceWith = p->szReplaceText;
				p->frString.wReplaceWithLen = MAX_FIND_TEXT_LEN;
				if( wID == ID_EDIT_FIND ) {
					p->hWndFindDlg = FindText( &(p->frString) );
				} else if( wID == ID_EDIT_REPLACE ) {
					p->hWndFindDlg = ReplaceText( &(p->frString) );
				}
				/*
					Eu_CAÓA[hX_CAOłB
					p->nMsgFindDlgbZ[Wʒm܂B
				*/
			}
		} else if( wID == ID_EDIT_FIND_NEXT || wID == ID_EDIT_FIND_PREV ) {
			if( p->bEditMode ) {
				int		ret;
				UINT	nFlag = p->frString.Flags;
				nFlag |= FR_FINDNEXT;
				if( wID == ID_EDIT_FIND_NEXT ) {
					ret = FindNextMyScintilla( p->hWndMySci, nFlag, p->szFindText );
				} else {
					ret = FindPrevMyScintilla( p->hWndMySci, nFlag, p->szFindText );
				}
				if( ret >= 0 ) {
					ScrollCaretMyScintilla( p->hWndMySci );
				}
			}
		} else if( wID == ID_EDIT_INS_MARK ) {
			if( p->bEditMode ) {
				InsertMarkTopMyScintilla( p->hWndMySci, &(p->FileInfo.MarkCommentInfo) );
			}
		} else if( wID == ID_EDIT_INS_COMMENT ) {
			if( p->bEditMode ) {
				InsertCommentTopMyScintilla( p->hWndMySci, &(p->FileInfo.MarkCommentInfo) );
			}
		} else if( wID == ID_OPERATE_HELP_ME ) {
			p->bHelpMe = !p->bHelpMe;
			SetHelpMeMyEdit( p->hWndMyEdit, p->bHelpMe );
			SetHelpMeMyList( p->hWndListBoxLow, p->bHelpMe );
			SetHelpMeMyList( p->hWndListBoxHi, p->bHelpMe );
			SetStateToolBar( p->hWndToolBar, p->szFilePath[0] != _T('\0'), p->bHelpMe, p->bViewMode, p->hWndMySci, p->bEditMode );
			if( p->bUseImsApi && p->hWndIms != NULL && IsWindow( p->hWndIms ) ) {
				if( p->bViewMode ) {
					/*	łɉ{[hɂȂĂ	*/
					/*	̃vZXo[hɂȂ߁Aꂽ	*/
					/*	ɔCāA͂ȂɂȂ	*/
				} else if( p->bHelpMe ) {	/*	łv	*/
					COPYDATASTRUCT	cds;
					ZeroMemory( &cds, sizeof(cds) );
					cds.dwData = p->uImsApiMessage;
					cds.cbData = lstrlen( p->szHelpMe );
					cds.lpData = (PVOID)( p->szHelpMe );
					SendMessage( p->hWndIms, WM_COPYDATA, (WPARAM)hWnd, (LPARAM)&cds );
				} else {					/*	łv	*/
					LPCTSTR	q = GetTextMyList( p->hWndListBoxLow, p->nCurrentLine );
					COPYDATASTRUCT	cds;
					ZeroMemory( &cds, sizeof(cds) );
					cds.dwData = p->uImsApiMessage;
					cds.cbData = lstrlen( q );
					cds.lpData = (PVOID)q;
					SendMessage( p->hWndIms, WM_COPYDATA, (WPARAM)hWnd, (LPARAM)&cds );
				}
			}
			if( !p->bViewMode && p->hWndXsd != NULL ) {
				p->XsdApiInfo.uEventID = XSD_API_EVENT_HELP_ME;
				p->XsdApiInfo.hWndFrom = hWnd;
				p->XsdApiInfo.wParam = (WPARAM)(p->bHelpMe);
				p->XsdApiInfo.lParam = (LPARAM)(p->nCurrentLine);
				CopyMemory( p->XsdApiInfo.md5FileName, p->md5FileName, sizeof(p->md5FileName) );
				DoXsdEvent( hWnd );
			}
			ShowCaption( hWnd );
		} else if( wID == ID_OPERATE_VIEW_MODE ) {
			p->bViewMode = !p->bViewMode;
			if( !p->bViewMode ) {
				int		nPos = p->nCurrentLine;
				/*	o[hɂȂ	*/
				/*	f[ɒʒm	*/
				if( p->hWndXsd != NULL ) {
					p->XsdApiInfo.uEventID = XSD_API_EVENT_VIEW_MODE;
					p->XsdApiInfo.hWndFrom = hWnd;
					p->XsdApiInfo.wParam = 0;
					p->XsdApiInfo.lParam = 0;
					CopyMemory( p->XsdApiInfo.md5FileName, p->md5FileName, sizeof(p->md5FileName) );
					DoXsdEvent( hWnd );
					Sleep( 100 );
				}
				p->nCurrentLine = -1;
				DoMove( hWnd, nPos );
			} else {
				/*	{[hɂȂ	*/
				if( !IsSelectedMyEdit( p->hWndMyEdit ) ) {
					/*	IĂȂ΁A擪Ɉړ	*/
					DoTopMyEdit( p->hWndMyEdit );
				}
			}
			SetViewModeMyEdit( p->hWndMyEdit, p->bViewMode );
			SetViewModeMyList( p->hWndListBoxLow, p->bViewMode );
			SetViewModeMyList( p->hWndListBoxHi, p->bViewMode );
			SetStateToolBar( p->hWndToolBar, p->szFilePath[0] != _T('\0'), p->bHelpMe, p->bViewMode, p->hWndMySci, p->bEditMode );
			ShowCaption( hWnd );
		} else if( wID == ID_OPERATE_EDIT_MODE ) {
			BOOL	bNewMode = !p->bEditMode;
			int		nLineToGo = -1;
			if( !bNewMode ) {
				/*	ҏW[h甲悤ƂĂ	*/
				HGLOBAL	hSaveBuff;
				DWORD	dwSaveBuffSize;
				BOOL	restore = FALSE;
				if( p->hWndFindDlg != NULL && IsWindow( p->hWndFindDlg ) ) {
					/*	Eu_CAOJĂΕ	*/
					PostMessage( p->hWndFindDlg, WM_CLOSE, 0, 0 );
				}
				if( IsModifiedMyScintilla( p->hWndMySci ) ) {
					/*	XVĂ΁Aǂ邩mF	*/
					TCHAR	msg[ 256 ];
					int		sel;
					BOOL	cancel = FALSE;
					LoadString( p->hInstance, IDS_CFM_SAVE, msg, 255 );		/*	ύX̕ۑmF	*/
					sel = MessageBox( hWnd, msg, szXsAppName, MB_APPLMODAL|MB_DEFBUTTON1|MB_ICONEXCLAMATION|MB_YESNOCANCEL );
					if( sel == IDCANCEL ) {
						cancel = TRUE;
					} else if( sel == IDYES ) {
						DoSendCommand( hWnd, ID_FILE_SAVE );
						if( IsModifiedMyScintilla( p->hWndMySci ) ) {
							cancel = TRUE;	//	LZ(񂾂낤)
						}
					} else {	//	IDNO
						restore = TRUE;
					}
					if( cancel ) {
						SetStateToolBar( p->hWndToolBar, p->szFilePath[0] != _T('\0'), p->bHelpMe, p->bViewMode, p->hWndMySci, p->bEditMode );
						return ret;
					}
				}
				/*	Z[uĂ΁A̓eǂݍ	*/
				hSaveBuff = GetSaveBuffMyScintilla( p->hWndMySci, &dwSaveBuffSize );
				if( hSaveBuff != NULL ) {
					nLineToGo = GetCurrentLineMyScintilla( p->hWndMySci );
					DoLoadFile( hWnd, NULL, hSaveBuff, dwSaveBuffSize-sizeof(TCHAR) );
					GlobalFree( hSaveBuff );
				} else if( dwSaveBuffSize > 0 ) {
					/*	Z[uɃmێs炵̂Ńt@Cǂ	*/
					nLineToGo = GetCurrentLineMyScintilla( p->hWndMySci );
					DoLoadFile( hWnd, p->szFilePath, NULL, 0 );
				} else if( restore ) {
					//	Xg{bNX̓e
					LPCTSTR	lpszTemplate = MAKEINTRESOURCE( IDD_WAIT_DIALOG );
					WaitDlgInfo		Info;
					CopyFromListBoxMyScintillaInfoType	copyInfo;
					Info.hWnd = hWnd;
					Info.wParam = 0;
					Info.lParam = (LPARAM)(&copyInfo);
					Info.lpfnProcess = CopyFromListBoxMyScintilla;
					copyInfo.hWndFrom = p->hWndListBoxLow;
					copyInfo.hWndTo = p->hWndMySci;
					copyInfo.nLineCnt = p->nLineCnt;
					copyInfo.pInfo = &(p->FileInfo.MarkCommentInfo);
					copyInfo.lpfnMessagePump = MyProcessMessage;
					nLineToGo = GetCurrentLineMyScintilla( p->hWndMySci );
					DialogBoxParam( p->hInstance, lpszTemplate, hWnd, WaitDlgProc, (LPARAM)&Info );
				}
			}
			p->bEditMode = bNewMode;
			if( p->bEditMode ) {
				int		nLineCnt = GetShownLineCntMyList( p->hWndListBoxHi, FALSE );	/*	̃Xg{bNX̍s	*/
				DoMoveMyScintilla( p->hWndMySci, p->nCurrentLine, nLineCnt );
			} else {
				if( nLineToGo < 0 ) {
					nLineToGo = GetCurrentLineMyScintilla( p->hWndMySci );
				}
				if( nLineToGo > p->nLineCnt ) {
					nLineToGo = p->nLineCnt;
				}
				p->nCurrentLine = -1;
				DoMove( hWnd, nLineToGo );
			}
			ShowWindow( p->hWndMySci, p->bEditMode?SW_SHOW:SW_HIDE );
			ShowWindow( p->hWndScrollBar, (p->bEditMode||!p->bShowScrollBar)?SW_HIDE:SW_SHOW );
			ShowWindow( p->hWndMyEdit, p->bEditMode?SW_HIDE:SW_SHOW );
			ShowWindow( p->hWndListBoxLow, p->bEditMode?SW_HIDE:SW_SHOW );
			ShowWindow( p->hWndListBoxHi, p->bEditMode?SW_HIDE:SW_SHOW );
			SetStateToolBar( p->hWndToolBar, p->szFilePath[0] != _T('\0'), p->bHelpMe, p->bViewMode, p->hWndMySci, p->bEditMode );
			RecalcLayout( hWnd );
			InvalidateRect( hWnd, NULL, TRUE );
			SetFocus( hWnd );
			ShowCaption( hWnd );
		} else if( wID == ID_VIEW_FONT ) {
			if( OptionFont( hWnd, &(p->lfText) ) ) {
				WriteProfile( p, p->szProfile );
				p->hFont = MyCreateFont( hWnd, p->hFont, &(p->lfText) );
				p->hFontNewLine = MyCreateNewLineFont( p->hFont, p->hFontNewLine );
				SetFontMyEdit( p->hWndMyEdit, p->hFont, p->hFontNewLine );
				SetFontMyList( p->hWndListBoxLow, p->hFont, p->hFontNewLine );
				SetFontMyList( p->hWndListBoxHi, p->hFont, p->hFontNewLine );
				SetFontMyScintilla( p->hWndMySci, p->hFont, p->hFontNewLine );
				InvalidateRect( hWnd, NULL, TRUE );
				RecalcLayout( hWnd );
				DoXsIpcNotify( hWnd, XS_IPC_CMD_FONT, XS_IPC_PARAM_FONT_NOTIFY );
			}
		} else if( wID == ID_VIEW_TOOLBAR ) {
			p->bShowToolbar = !p->bShowToolbar;
			WriteProfile( p, p->szProfile );
			DoXsIpcNotify( hWnd, XS_IPC_CMD_SHOW_TOOLBAR, p->bShowToolbar );
		} else if( wID == ID_VIEW_TOOLBAR_TEXT ) {
			p->bBitmapOnToolbar = FALSE;
			WriteProfile( p, p->szProfile );
			DoXsIpcNotify( hWnd, XS_IPC_CMD_BITMAP_ON_TOOLBAR, p->bBitmapOnToolbar );
		} else if( wID == ID_VIEW_TOOLBAR_ICON ) {
			p->bBitmapOnToolbar = TRUE;
			WriteProfile( p, p->szProfile );
			DoXsIpcNotify( hWnd, XS_IPC_CMD_BITMAP_ON_TOOLBAR, p->bBitmapOnToolbar );
		} else if( wID == ID_VIEW_NEWLINE ) {
			p->bShowNewLine = !p->bShowNewLine;
			WriteProfile( p, p->szProfile );
			DoXsIpcNotify( hWnd, XS_IPC_CMD_SHOW_NEWLINE, p->bShowNewLine );
		} else if( wID == ID_VIEW_LINENUM ) {
			p->bShowLineNum = !p->bShowLineNum;
			WriteProfile( p, p->szProfile );
			DoXsIpcNotify( hWnd, XS_IPC_CMD_SHOW_LINENUM, p->bShowLineNum );
		} else if( wID == ID_VIEW_SCROLL_BAR ) {
			p->bShowScrollBar = !p->bShowScrollBar;
			WriteProfile( p, p->szProfile );
			DoXsIpcNotify( hWnd, XS_IPC_CMD_SHOW_SCROLLBAR, p->bShowScrollBar );
		} else if( wID == ID_VIEW_EDGE ) {
			LPCTSTR	lpszTemplate = MAKEINTRESOURCE( IDD_JUMP_DIALOG );
			JumpDlgInfo	Info;
			Info.eDataType = eJumpDataEdgeColumn;
			Info.hInstance = p->hInstance;
			Info.nValue = p->nEdgeColumn;
			Info.nMin = 1;
			Info.nMax = 40;
			Info.bEnable = p->bShowEdge;
			if( IDOK == DialogBoxParam( p->hInstance, lpszTemplate, hWnd, JumpDlgProc, (LPARAM)&Info ) ) {
				p->bShowEdge = Info.bEnable;
				p->nEdgeColumn = Info.nValue;
				ShowCaption( hWnd );
				WriteProfile( p, p->szProfile );
				DoXsIpcNotify( hWnd, XS_IPC_CMD_SHOW_EDGE, p->bShowEdge );
				DoXsIpcNotify( hWnd, XS_IPC_CMD_EDGE_COLUMN, p->nEdgeColumn );
			}
		} else if( wID == ID_VIEW_STATUS_BAR ) {
			p->bShowStatusBar = !p->bShowStatusBar;
			WriteProfile( p, p->szProfile );
			DoXsIpcNotify( hWnd, XS_IPC_CMD_SHOW_STATUSBAR, p->bShowStatusBar );
		} else if( wID == ID_DDE_SEARCH_SERVER ) {
			HCURSOR	hCursor = SetCursor( LoadCursor( NULL, IDC_WAIT ) );
			LPCTSTR	ret;
			if( CheckDDEServer( hWnd, &(p->DdeInfo), p->szDdeServerName ) ) {
				ret = p->szDdeServerName;
			} else {
				ret = SearchDDEServer( hWnd, &(p->DdeInfo), p->szDdeServiceArray, p->nDdeServiceArry );
			}
			SetCursor( hCursor );
			if( ret != NULL ) {
				TCHAR	msg[ _MAX_PATH ], fmt[ _MAX_PATH ];
				LoadString( p->hInstance, IDS_DDE_FOUND, fmt, _MAX_PATH );	//	"u%sv܂B"
				wsprintf( msg, fmt, ret );
				MessageBox( hWnd, msg, szXsAppName, MB_APPLMODAL|MB_DEFBUTTON1|MB_ICONINFORMATION|MB_OK );
				lstrcpy( p->szDdeServerName, ret );
				p->bFoundServer = TRUE;
				p->bUseDde = TRUE;
			} else {
				TCHAR	msg[ _MAX_PATH ];
				LoadString( p->hInstance, IDS_DDE_NOT_FOUND, msg, _MAX_PATH );	//	"܂"
				MessageBox( hWnd, msg, szXsAppName, MB_APPLMODAL|MB_DEFBUTTON1|MB_ICONSTOP|MB_OK );
			}
			ShowCaption( hWnd );
		} else if( wID == ID_DDE_EDITSEND_WINDOW ) {
			if( p->bCanUseEditSend ) {
				if( (p->EdsApiInfo.lpEdsInitWindowDialog)( hWnd, &(p->EdsApiInfo.hWndTarget) ) ) {
					HWND	hWndTarget = p->EdsApiInfo.hWndTarget;
					p->bCanSendEditSend = ( hWndTarget != NULL && IsWindow( hWndTarget ) );
					if( p->bUseDde ) {
						TerminateDDE( hWnd, &(p->DdeInfo) );
					}
					p->bUseDde = FALSE;
				}
				ShowCaption( hWnd );
			}
		} else if( wID == ID_DDE_EDITSEND_MESSAGE ) {
			if( p->bCanUseEditSend ) {
				if( (p->EdsApiInfo.lpEdsInitParamDialog)( hWnd, &(p->EdsApiInfo.EdsParam) ) ) {
					HWND	hWndTarget = p->EdsApiInfo.hWndTarget;
					p->bCanSendEditSend = ( hWndTarget != NULL && IsWindow( hWndTarget ) );
					if( p->bUseDde ) {
						TerminateDDE( hWnd, &(p->DdeInfo) );
					}
					p->bUseDde = FALSE;
				}
				ShowCaption( hWnd );
			}
		} else if( wID >= ID_DDE_SERVER_LIST0 && wID <= ID_DDE_SERVER_LIST_LAST ) {
			int		nItem = wID - ID_DDE_SERVER_LIST0;
			LPCTSTR	s = NULL;
			if( nItem == 0 ) {
				s = p->szDdeServerName;
			} else if( nItem <= p->nDdeServiceArry ) {
				s = p->szDdeServiceArray[ nItem-1 ];
			}
			if( s != NULL ) {
				if( CheckDDEServer( hWnd, &(p->DdeInfo), s ) ) {
					p->bFoundServer = TRUE;
				} else {
					TCHAR	msg[ _MAX_PATH ];
					LoadString( p->hInstance, IDS_DDE_NOT_FOUND, msg, _MAX_PATH );	//	"܂"
					MessageBox( hWnd, msg, szXsAppName, MB_APPLMODAL|MB_DEFBUTTON1|MB_ICONSTOP|MB_OK );
					p->bFoundServer = FALSE;
				}
				lstrcpy( p->szDdeServerName, s );
				p->bUseDde = TRUE;
				ShowCaption( hWnd );
			}
		} else if( wID == ID_TB_RESIZE ) {
			if( p->hWndToolBar != NULL && IsWindow( p->hWndToolBar ) && IsWindowVisible( p->hWndToolBar ) ) {
				int		nToolBarWidth = GetWidthToolBar( p->hWndToolBar );
				RECT	rect;
				int		nDiff;
				if( IsZoomed( hWnd ) ) {
					ShowWindow( hWnd, SW_RESTORE );
				}
				GetClientRect( hWnd, &rect );
				nDiff = ( rect.right - rect.left ) - nToolBarWidth;
				if( nDiff != 0 ) {
					GetWindowRect( hWnd, &rect );
					rect.right -= nDiff;
					MyMoveWindow( hWnd, &rect, TRUE );
				}
			}
		} else {
			if( p->bEditMode ) {
				switch( wID ) {
				case ID_EDIT_CUT:	DoCutMyScintilla( p->hWndMySci );	break;
				case ID_EDIT_COPY:	DoCopyMyScintilla( p->hWndMySci );	break;
				case ID_EDIT_PASTE:	DoPasteMyScintilla( p->hWndMySci );	break;
				case ID_EDIT_CLEAR:	DoDelMyScintilla( p->hWndMySci );	break;
				case ID_EDIT_TOP:	DoTopMyScintilla( p->hWndMySci );	break;
				case ID_EDIT_LAST:	DoLastMyScintilla( p->hWndMySci );	break;
				case ID_EDIT_DEL:	DoDelMyScintilla( p->hWndMySci );	break;
				case ID_EDIT_PREV:	DoPrevMyScintilla( p->hWndMySci );	break;
				case ID_EDIT_NEXT:	DoNextMyScintilla( p->hWndMySci );	break;
				case ID_EDIT_NEWLINE:	DoNewLineMyScintilla( p->hWndMySci );	break;
				case ID_EDIT_SELECT_ALL:	DoSelectAllMyScintilla( p->hWndMySci );	break;
				case ID_EDIT_BS:	DoBackMyScintilla( p->hWndMySci );	break;
				}
			} else {
				switch( wID ) {
				case ID_EDIT_CUT:	DoCutMyEdit( p->hWndMyEdit );	break;
				case ID_EDIT_COPY:	DoCopyMyEdit( p->hWndMyEdit );	break;
				case ID_EDIT_PASTE:	DoPasteMyEdit( p->hWndMyEdit );	break;
				case ID_EDIT_CLEAR:	DoDelMyEdit( p->hWndMyEdit );	break;
				case ID_EDIT_TOP:	DoTopMyEdit( p->hWndMyEdit );	break;
				case ID_EDIT_LAST:	DoLastMyEdit( p->hWndMyEdit );	break;
				case ID_EDIT_DEL:	DoDelMyEdit( p->hWndMyEdit );	break;
				case ID_EDIT_PREV:	DoPrevMyEdit( p->hWndMyEdit );	break;
				case ID_EDIT_NEXT:	DoNextMyEdit( p->hWndMyEdit );	break;
				}
			}
		}
	}
	UNUSE( hwndCtl );
	return ret;
}
