/*--------------------------------------------------------------*\
		module	:	EDS-API.h
		purpose :	X-Send EditSend API
		author	:	_@ Kengo Jinno
		create	:	2001/09/19
		update	:	2001/09/19
\*--------------------------------------------------------------*/

#ifndef	EDS_API_H
#define	EDS_API_H

#include	"EditSend.h"

typedef	struct	tagEdsApiInfoType	{
	HWND			hWndTarget;		/*	M̃EBhEnh	*/
	HINSTANCE		hInstDll;		/*	DLL̃CX^Xnh	*/
	EdsParamType	EdsParam;		/*	EditSend̃p[^	*/
	LP_FUNC_EDSINITWINDOW		lpEdsInitWindow;
	LP_FUNC_EDSINITWINDOWDIALOG	lpEdsInitWindowDialog;
	LP_FUNC_EDSINITPARAMDIALOG	lpEdsInitParamDialog;
	LP_FUNC_EDSGETPARAM			lpEdsGetParam;
	LP_FUNC_EDSGETDEFAULTPARAM	lpEdsGetDefaultParam;
	LP_FUNC_EDSSENDSTRING		lpEdsSendString;
	LP_FUNC_EDSWRITEPROFILE		lpEdsWriteProfile;
	LP_FUNC_EDSGETPROFILE		lpEdsGetProfile;
}	EdsApiInfoType, NEAR* NpEdsApiInfoType;

#ifdef	__cplusplus
extern "C" {
#endif

/*		*/
extern	BOOL	InitEdsApi( NpEdsApiInfoType pInfo );

/*	I	*/
extern	void	QuitEdsApi( NpEdsApiInfoType pInfo );

#ifdef	__cplusplus
}
#endif

#endif	/*	EDS_API_H	*/
