/*--------------------------------------------------------------*\
		module	:	HOOK.h
		purpose :	X-Send etbN
		author	:	_@ Kengo Jinno
		create	:	2001/09/17
		update	:	2001/10/09
\*--------------------------------------------------------------*/

#ifndef	HOOK_H
#define	HOOK_H

#ifdef	__cplusplus
extern "C" {
#endif

typedef	struct	tagIdleInfoType	{
	UINT	uTimerID;
	BOOL	bIsIdle;
	DWORD	dwLastTick;
}	IdleInfoType, NEAR* NpIdleInfoType;

#define	WM_CENTER_PARENT	(WM_APP+9)

extern	LRESULT	MYEXPORT	CALLBACK	MyCallWndProc( int nCode, WPARAM wParam, LPARAM lParam );
extern	LRESULT	MYEXPORT	CALLBACK	MyKeyboardProc( int nCode, WPARAM wParam, LPARAM lParam );
extern	LRESULT	MYEXPORT	CALLBACK	MyMouseProc( int nCode, WPARAM wParam, LPARAM lParam );
extern	void	InstallHook( NpIdleInfoType pInfo );
extern	void	RemoveHook( void );

#ifdef	__cplusplus
}
#endif

#endif	/*	HOOK_H	*/
