/*--------------------------------------------------------------*\
		module	:	IMS-API.h
		purpose :	̓j^[@T[o[@API
		author	:	_@ Kengo Jinno
		create	:	2001/01/16
		update	:	2001/01/18
\*--------------------------------------------------------------*/

#ifndef	IMS_API_H
#define	IMS_API_H

#if	!defined(WIN32)
#error This APIs support only Win32.
#endif

#if	defined(UNICODE) || defined(_UNICODE)
#error This APIs support only MBCS(Shift-JIS).
#endif

#ifdef	__cplusplus
extern "C" {
#endif

/*--------------------------------------------------------------*\
	APIbZ[Wʂ镶B
	UING msg = RegisterWindowMessage( IMS_API_MESSAGE_STRING );
	msggB
\*--------------------------------------------------------------*/

#define	IMS_API_MESSAGE_STRING	_T("IMS-API-0cad5300-eb9f-11d4-af4f-00c0ca10a705")


/*
	ȉAAPI
	EwParamlParaḿAAPIɂӖقȂB
	E߂lbOK͂قƂǐMpłȂB
	EAv͊{ISendMessage()B
*/


/*--------------------------------------------------------------*\
	T[o[NƂ̒ʒm
\*--------------------------------------------------------------*/

#define	IMS_API_STARTUP_SERVER	0

/*
	wParam = IMS_API_STARTUP_SERVER
	lParam = (HWND)hWndServer
	return = void

	T[o[̋NɁAu[hLXgB
	APostMessage( HWND_BROADCAST, ... );
*/

/*--------------------------------------------------------------*\
	T[o[I邱Ƃ̒ʒm
\*--------------------------------------------------------------*/

#define	IMS_API_QUIT_SERVER		1

/*
	wParam = IMS_API_QUIT_SERVER
	lParam = (HWND)hWndServer
	return = void

	T[o[IOɁAu[hLXgB
	APostMessage( HWND_BROADCAST, ... );Ȃ̂ŁA
	bZ[W̏_ł̓T[o[͎ł邩ȂB
*/

/*--------------------------------------------------------------*\
	T[o[T
\*--------------------------------------------------------------*/

#define	IMS_API_SEARCH_SERVER	2

/*
	wParam = IMS_API_SEARCH_SERVER
	lParam = (HWND)hWndFrom		ԎԂ(Av)
	return = void

	Avu[hLXgB
	: SendMessage( HWND_BROADCAST, ... );
	T[o[݂΁AIMS_API_ACK_SERVERbZ[WB
	̃T[o[ԓԂꍇB
*/

/*--------------------------------------------------------------*\
	IMS_API_SEARCH_SERVERɑ΂T[o[̕ԓ
\*--------------------------------------------------------------*/

#define	IMS_API_ACK_SERVER		3

/*
	wParam = IMS_API_ACK_SERVER
	lParam = (HWND)hWndServer	T[o[̃EBhEnh
	return = void

	ԓSendMessage()ŕԂ̂ŁÃbZ[Wnh
	őAPIg(ƂIMS_API_GET_MONITORŃj^[w
	Ă邩ǂׂ)ꍇ́AfbhbNȂ悤ɒӁB
*/

/*--------------------------------------------------------------*\
	AT[o[N
\*--------------------------------------------------------------*/

#define	IMS_API_START_ONE_MORE	4

/*
	wParam = IMS_API_START_ONE_MORE
	lParam = 0
	return = (BOOL)bOK			Ȃ[
*/

/*--------------------------------------------------------------*\
	j^[EBhE̐ݒ
\*--------------------------------------------------------------*/

#define	IMS_API_SET_MONITOR		5

/*
	wParam = IMS_API_SET_MONITOR
	lParam = (HWND)hWndMonitor	NULLw肷Ɖ
	return = (BOOL)bOK			Ȃ[

	wς݂ꍇ́A܂ꂪAĎw肵
	EBhEj^[ݒ肳B
*/

/*--------------------------------------------------------------*\
	j^[ĂEBhEnh̎擾
\*--------------------------------------------------------------*/

#define	IMS_API_GET_MONITOR		6

/*
	wParam = IMS_API_GET_MONITOR
	lParam = 0
	return = (HWND)hWndMonitor	NULLȂĂ
*/

/*--------------------------------------------------------------*\
	ݐݒ肳Ă|[gԍ̎擾
\*--------------------------------------------------------------*/

#define	IMS_API_GET_PORT		7

/*
	wParam = IMS_API_GET_PORT
	lParam = 0
	return = (UINT)nPort		|[gԍ
*/

/*--------------------------------------------------------------*\
	T[rXJn
\*--------------------------------------------------------------*/

#define	IMS_API_START_SERVICE	8

/*
	wParam = IMS_API_START_SERVICE
	lParam = (UINT)nPort		0Ȃ獡̂܂
	return = (BOOL)bOK			Ȃ[

	Iɂ́A-1w肵ɓKɃCNgB
*/

/*--------------------------------------------------------------*\
	T[rX~
\*--------------------------------------------------------------*/

#define	IMS_API_STOP_SERVICE	9

/*
	wParam = IMS_API_STOP_SERVICE
	lParam = 0
	return = (BOOL)bOK
*/

/*--------------------------------------------------------------*\
	EBhE
\*--------------------------------------------------------------*/

#define	IMS_API_CTRL_WINDOW		10

/*
	wParam = IMS_API_CTRL_WINDOW
	lParam = (int)nMode			ȉ̃}N̂ꂩ
	return = (BOOL)bOK			Ȃ[
*/

#define	IMS_API_WND_CTRL_RESTORE	0	/*		*/
#define	IMS_API_WND_CTRL_ICONIC		1	/*	ACR	*/
#define	IMS_API_WND_CTRL_TRAY		2	/*	gCɓ	*/

/*--------------------------------------------------------------*\
	Ԏ擾
\*--------------------------------------------------------------*/

#define	IMS_API_GET_STATUS		11

/*
	wParam = IMS_API_GET_STATUS
	lParam = 0
	return = (int)nStatus		ȉ̃}N̑gݍ킹
*/

#define	IMS_API_STATUS_MONITOR		0x01	/*	j^[wς	*/
#define	IMS_API_STATUS_SERVICE		0x02	/*	T[rXJnς	*/

/*--------------------------------------------------------------*\
	ڑĂNCAg̎擾
\*--------------------------------------------------------------*/

#define	IMS_API_NUM_CLIENTS		12

/*
	wParam = IMS_API_NUM_CLIENTS
	lParam = 0
	return = (int)nCnt
*/

/*--------------------------------------------------------------*\
	o[WԂ
\*--------------------------------------------------------------*/

#define	IMS_API_GET_VERSION		13

/*
	wParam = IMS_API_GET_VERSION
	lParam = 0
	return = (LPARAM)MAKELPARAM( nMinor, nMajor )	1.3Ȃ0x00010003
*/




/*--------------------------------------------------------------*\
	𑗂
\*--------------------------------------------------------------*/

/*
	WM_COPTDATA
	COPYDATASTRUCT::dwData	RegisterWindowMessage(IMS_API_MESSAGE_STRING)
	COPYDATASTRUCT::cbData	lpszText̕('\0'͊܂܂Ȃ)
	COPYDATASTRUCT::lpData	(LPCTSTR)lpszText
*/


#ifdef	__cplusplus
}
#endif

#endif	/*	IMS_API_H	*/
