/*--------------------------------------------------------------*\
		module	:	JumpDlg.c
		purpose :	X-Send sԍŃWv_CAO
		author	:	_@ Kengo Jinno
		create	:	2002/03/26
		update	:	2002/04/09
					2011/02/09	JumpDlgInfo::bEnable ǉ
					2011/02/10	IDC_EDIT_JUMP_LINE 𖳌
\*--------------------------------------------------------------*/

#include	"PCH.h"
#include	"JumpDlg.h"

#include	"bccres.h"
#include	"resource.h"

BOOL	MYEXPORT	CALLBACK	JumpDlgProc( HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	if( uMsg == WM_INITDIALOG ) {
		FpJumpDlgInfo	p = (FpJumpDlgInfo)lParam;
		TCHAR	buff[20];
		SetDlgItemInt( hDlg, IDC_EDIT_JUMP_LINE, p->nValue, FALSE );
		SendDlgItemMessage( hDlg, IDC_SPIN_JUMP_LINE, UDM_SETRANGE, 0, MAKELPARAM( p->nMax, p->nMin ) );
		{
			UDACCEL	ua[3] = { { 0, 1 }, { 1, 10 }, { 2, 100} };
			SendDlgItemMessage( hDlg, IDC_SPIN_JUMP_LINE, UDM_SETACCEL, sizeof(ua)/sizeof(UDACCEL), (LPARAM)ua );
		}
		wsprintf( buff, _T("%d"), p->nMax );
		SendDlgItemMessage( hDlg, IDC_EDIT_JUMP_LINE, EM_LIMITTEXT, lstrlen(buff), 0 );
		if( p->eDataType == eJumpDataEdgeColumn ) {
			TCHAR	buff[255];
			LoadString( p->hInstance, IDS_EDGE_COLUMN_CAPTION, buff, 255 );
			SetWindowText( hDlg, buff );
			LoadString( p->hInstance, IDS_EDGE_COLUMN_TITLE, buff, 255 );
			SetDlgItemText( hDlg, IDC_STATIC_JUMP_TITLE, buff );
			CheckDlgButton( hDlg, IDC_CHECK_VIEW_EDGE, p->bEnable ? 1 : 0 );	//	`FbN{bNX
			ShowWindow( GetDlgItem( hDlg, IDC_CHECK_VIEW_EDGE ), SW_SHOW );
			EnableWindow( GetDlgItem( hDlg, IDC_EDIT_JUMP_LINE ), p->bEnable );	//	
		}
		SetWindowLong( hDlg, DWL_USER, (long)lParam );
		return TRUE;
	} else if( uMsg == WM_COMMAND ) {
		WORD	wNotifyCode, wID;
		HWND	hWndCtrl;
#ifdef	WIN32
		wNotifyCode = HIWORD(wParam);
		wID = LOWORD(wParam);
		hWndCtrl = (HWND)lParam;
#else
		wNotifyCode = HIWORD(lParam);
		wID = wParam;
		hWndCtrl = (HWND)LOWORD(lParam);
#endif
		if( wNotifyCode == BN_CLICKED ) {
			FpJumpDlgInfo	p = (FpJumpDlgInfo)GetWindowLong( hDlg, DWL_USER );
			if( wID == IDOK ) {
				p->nValue = GetDlgItemInt( hDlg, IDC_EDIT_JUMP_LINE, NULL, FALSE );
				if( p->nValue < p->nMin ) {
					p->nValue = p->nMin;
				}
				if( p->nValue > p->nMax ) {
					p->nValue = p->nMax;
				}
				p->bEnable = ( IsDlgButtonChecked( hDlg, IDC_CHECK_VIEW_EDGE ) == 1 );
				EndDialog( hDlg, IDOK );
				return TRUE;
			} else if( wID == IDCANCEL ) {
				EndDialog( hDlg, IDCANCEL );
				return TRUE;
			} else if( wID == IDC_CHECK_VIEW_EDGE ) {
				BOOL	bIsEnable = ( IsDlgButtonChecked( hDlg, IDC_CHECK_VIEW_EDGE ) == 1 );
				EnableWindow( GetDlgItem( hDlg, IDC_EDIT_JUMP_LINE ), bIsEnable );
				return TRUE;
			}
		}
	}
	return FALSE;
}
