/*--------------------------------------------------------------*\
		module	:	MarkCmnt.c
		purpose :	X-Send }[NERg
		author	:	_@ Kengo Jinno
		create	:	2002/03/20
		update	:	2002/03/20
\*--------------------------------------------------------------*/

#include	"PCH.h"
#include	"MarkCmnt.h"
#include	"resource.h"

/*	}[NȂTRUEԂ	*/
BOOL	IsMarkStrJudge( LpMarkCommentInfoType pInfo, LPCTSTR lpszData, int nLen )
{
	BOOL	ret = FALSE;
	if( nLen >= pInfo->nMarkLen && pInfo->nMarkLen > 0 ) {
		int		i;
		ret = TRUE;
		for( i = 0; i < pInfo->nMarkLen; i++ ) {
			if( lpszData[i] != pInfo->szMark[i] ) {
				ret = FALSE;
				break;
			}
		}
	}
	return ret;
}

/*	RgȂTRUEԂ	*/
BOOL	IsCommentStrJudge( LpMarkCommentInfoType pInfo, LPCTSTR lpszData, int nLen )
{
	BOOL	ret = FALSE;
	if( nLen >= pInfo->nCommentLen && pInfo->nCommentLen > 0 ) {
		int		i;
		ret = TRUE;
		for( i = 0; i < pInfo->nCommentLen; i++ ) {
			if( lpszData[i] != pInfo->szComment[i] ) {
				ret = FALSE;
				break;
			}
		}
	}
	return ret;
}

/*		*/
void	InitMarkComment( LpMarkCommentInfoType pInfo, HINSTANCE hInstance )
{
	pInfo->nMarkLen = LoadString( hInstance, IDS_FILE_MARK, pInfo->szMark, sizeof(pInfo->szMark)/sizeof(TCHAR) );
	pInfo->nCommentLen = LoadString( hInstance, IDS_FILE_COMMENT, pInfo->szComment, sizeof(pInfo->szComment)/sizeof(TCHAR) );
}

/*	Init@Cǂݍ	*/
void	GetProfileMarkComment( LpMarkCommentInfoType pInfo, LPCTSTR lpszSection, LPCTSTR lpszMarkEntry, LPCTSTR lpszCommentEntry, LPCTSTR lpszFile )
{
	pInfo->nMarkLen = GetPrivateProfileString( lpszSection, lpszMarkEntry, pInfo->szMark, pInfo->szMark, sizeof(pInfo->szMark)/sizeof(TCHAR), lpszFile );
	pInfo->nCommentLen = GetPrivateProfileString( lpszSection, lpszCommentEntry, pInfo->szComment, pInfo->szComment, sizeof(pInfo->szMark)/sizeof(TCHAR), lpszFile );
}
