/*--------------------------------------------------------------*\
		module	:	MyDDE.h
		purpose :	X-Send DDENCAg
		author	:	_@ Kengo Jinno
		create	:	2001/09/19
		update	:	2001/09/26
\*--------------------------------------------------------------*/

#ifndef	MYDDE_H
#define	MYDDE_H

/*	NCAg̏	*/
#define	DDE_STAT_NONE		0		/*	ڑ		*/
#define	DDE_STAT_INITIATE	1		/*	ڑ	*/
#define	DDE_STAT_IDLE		2		/*	ڑ	*/
#define	DDE_STAT_EXECUTE	3		/*	s		*/
#define	DDE_STAT_TERMINATE	4		/*	ؒf	*/

#ifdef	__cplusplus
extern "C" {
#endif

typedef	struct	tagMyDdeInfoType	{
	int		nClientStatus;	/*	NCAg̏	*/
	HWND	hWndServer;		/*	T[o[̃EBhEnh	*/
	void	(FAR* lpfnMessagePump)( HWND, LPMSG );
	LPCTSTR	lpszServiceName;	/*	T[rX	*/
}	MyDdeInfoType, NEAR* NpMyDdeInfoType;

/*	WM_DDE_ACK	*/
extern	BOOL	DdeAckProc( HWND hWnd, NpMyDdeInfoType pInfo, WPARAM wParam, LPARAM lParam );
/*	WM_DDE_TERMINATE	*/
extern	BOOL	DdeTerminateProc( HWND hWnd, NpMyDdeInfoType pInfo, WPARAM wParam, LPARAM lParam );

extern	BOOL	InitiateDDE( HWND hWnd, NpMyDdeInfoType pInfo, HWND hWndTo );
extern	BOOL	SendDDEString( HWND hWnd, NpMyDdeInfoType pInfo, LPCTSTR lpszText );
extern	BOOL	TerminateDDE( HWND hWnd, NpMyDdeInfoType pInfo );

extern	BOOL	CheckDDEServer( HWND hWnd, NpMyDdeInfoType pInfo, LPCTSTR lpszServer );

extern	LPCTSTR	SearchDDEServer( HWND hWnd, NpMyDdeInfoType pInfo, LPCTSTR* pArray, int nCnt );

#ifdef	__cplusplus
}
#endif

#endif	/*	MYDDE_H	*/
