/*--------------------------------------------------------------*\
		module	:	MyEdit.h
		purpose :	X-Send ҏWs
		author	:	_@ Kengo Jinno
		create	:	2001/09/04
		update	:	2001/09/19
					2001/11/13	GetRectMyEdit()ǉ
					2001/11/21	MyEditDataType::bIsCommentǉ
					2001/11/21	SetTextMyEdit()ɈbCommentǉ
					2002/03/06	MyEditDataType::bIsMarkǉ
					2002/03/06	MyEditDataType::bMarkAsCommentǉ
					2002/03/06	SetTextMyEdit()ɈbMarkǉ
					2002/03/06	SetOptionMyEdit()ɈbMarkAsCommentǉ
\*--------------------------------------------------------------*/

#ifndef	MYEDIT_H
#define		MYEDIT_H

typedef	struct	tagMyEditDataType	{
	WNDPROC		lpfnOldWndProc;
	
	BOOL		bEnableDiamond;		/*	_CAhJ[\g	*/
	BOOL		bEnableCtrlXC;		/*	Ctrl+X/CJ[\ړ	*/
	
	HACCEL		hAccel;
	HACCEL		hAccelDiamond;		/*	_CAhJ[\̃ANZ[^	*/
	HACCEL		hAccelCtrlXC;		/*	_CAhJ[\̃ANZ[^	*/
	
	HFONT		hFontNewLine;		/*	s}[NptHg	*/
	BOOL		bShowNewLine;		/*	s}[N\TRUE	*/
	TCHAR		cNewLine;			/*	s}[Np		*/
	
	BOOL		bHelpMe;			/*	łv	*/
	BOOL		bViewMode;			/*	{[h	*/
	BOOL		bIsComment;			/*	RgȂTRUE	*/
	BOOL		bIsMark;			/*	}[NȂTRUE		*/
	BOOL		bMarkAsComment;		/*	}[NsRg	*/
	
	HGLOBAL		hTextBuff;			/*	擾pobt@	*/
	DWORD		dwTextbuffSize;		/*	obt@̃TCY		*/
	
}	MyEditDataType, FAR* LpMyEditDataType;

/*	F̎擾	*/
#define	WM_EDIT_CTLCOLOR_EDIT	(WM_APP+18)

#ifdef	__cplusplus
extern "C" {
#endif

/*	ҏWs̍쐬	*/
extern	HWND	CreateMyEdit( HWND hWndParent, UINT nCtrlID, BOOL bViewMode );

/*	ҏWs̔j	*/
extern	BOOL	DestroyMyEdit( HWND hWnd );

/*	TuNXvV[W	*/
extern	LRESULT	MYEXPORT	CALLBACK	MyEditWndProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam );

/*	œKȍԂ	*/
extern	int		GetSuitableHeightMyEdit( HWND hWnd );

/*	tHgݒ	*/
extern	void	SetFontMyEdit( HWND hWnd, HFONT hFont, HFONT hFontNewLine );

/*	IvVݒ	*/
extern	void	SetOptionMyEdit( HWND hWnd, BOOL bDiamond, BOOL bCtrlXC, BOOL bShowNewLine, TCHAR cNewLine, BOOL bMarkAsComment );

/*	ANZ[^	*/
extern	BOOL	TranslateAcceleratorMyEdit( HWND hWndParent, HWND hWnd, LPMSG pMsg );

/*	łv	*/
extern	void	SetHelpMeMyEdit( HWND hWnd, BOOL bFlag );

/*	{[h̐ݒ	*/
extern	void	SetViewModeMyEdit( HWND hWnd, BOOL bFlag );

/*	eLXgZbg	*/
extern	void	SetTextMyEdit( HWND hWnd, LPCTSTR lpszText, BOOL bComment, BOOL bMark );

/*	eLXg擾	*/
extern	LPCTSTR	GetTextMyEdit( HWND hWnd, BOOL bAll, int* pLen );

/*	``擾	*/
extern	void	GetRectMyEdit( HWND hWnd, LPRECT lprect );

extern	BOOL	CanUndoMyEdit( HWND hWnd );			/*	Undoł邩H	*/
extern	BOOL	IsSelectedMyEdit( HWND hWnd );		/*	IĂ邩H	*/
extern	BOOL	CanPasteMyEdit( HWND hWnd );		/*	\tł邩H	*/
extern	BOOL	HasTextMyEdit( HWND hWnd );			/*	eLXg邩H	*/
extern	void	DoUndoMyEdit( HWND hWnd );			/*	Undo	*/
extern	void	DoCutMyEdit( HWND hWnd );			/*	؂	*/
extern	void	DoCopyMyEdit( HWND hWnd );			/*	Rs[	*/
extern	void	DoPasteMyEdit( HWND hWnd );			/*	\t	*/
extern	void	DoTopMyEdit( HWND hWnd );			/*	擪	*/
extern	void	DoLastMyEdit( HWND hWnd );			/*	Ō	*/
extern	void	DoDelMyEdit( HWND hWnd );			/*	폜	*/
extern	void	DoPrevMyEdit( HWND hWnd );			/*	O	*/
extern	void	DoNextMyEdit( HWND hWnd );			/*		*/
extern	void	EmptyUndoBufferMyEdit( HWND hWnd );	/*	Undoobt@NA	*/
extern	BOOL	IsReadOnlyMyEdit( HWND hWnd );				/*	[hI[H	*/
extern	void	SetReadOnlyMyEdit( HWND hWnd, BOOL f );		/*	[hI[̐ݒ	*/

#ifdef	__cplusplus
}
#endif

#endif	/*	MYEDIT_H	*/
