/*--------------------------------------------------------------*\
		module	:	MyList.h
		purpose :	X-Send Xg{bNX
		author	:	_@ Kengo Jinno
		create	:	2001/09/04
		update	:	2001/10/18
					2001/11/14	MyListDataType::nMarkCnt
								MyListDataType::hMarkPos
								ǉ
					2001/11/21	MARK_ITEM_* COMMENT_ITEM_* ǉ
					2001/11/21	FileInfoType::szComment
								FileInfoType::nCommentLen
								ǉ
					2001/11/21	IsCommentMyList()ǉ
					2002/03/06	MyListDataType::bMarkAsCommentǉ
					2002/03/06	SetOptionMyList()ɈbMarkAsCommentǉ
					2002/03/20	MarkCommentInfoTypeg
					2002/03/25	InsertMarkMyList()̏𕪗
\*--------------------------------------------------------------*/

#ifndef	MYLIST_H
#define	MYLIST_H

#include	"md5.h"
#include	"MarkCmnt.h"

typedef	struct	tagMyListDataType	{
	WNDPROC		lpfnOldWndProc;
	
	BOOL		bShowLineNum;		/*	sԍ\		*/
	TCHAR		szLineNumFmt[20];	/*	sԍ\̃tH[}bg*/
	TCHAR		szDummyFmt[20];		/*	sԍȂ̃tH[}bg*/
	
	int			nLineCnt;			/*	_~[܂܂Ȃs	*/
	int			nLineNumWidth1;		/*	sԍ̕\(|)	*/
	int			nLineNumWidth2;		/*	sԍ̕\(|O)	*/
	
	HFONT		hFontNewLine;		/*	s}[NptHg	*/
	BOOL		bShowNewLine;		/*	s}[N\TRUE	*/
	TCHAR		cNewLine;			/*	s}[Np		*/
	BOOL		bMarkAsComment;		/*	}[NsRg	*/
	
	HGLOBAL		hTextBuff;			/*	擾pobt@	*/
	DWORD		dwTextbuffSize;		/*	obt@̃TCY		*/
	
	BOOL		bHelpMe;			/*	łv	*/
	BOOL		bViewMode;			/*	{[h	*/
	
	BOOL		bCanHaveFocus;		/*	tH[JXĂ	*/
	
	int			nMarkCnt;			/*	}[Ns̐	*/
	HGLOBAL		hMarkPos;			/*	}[N̍sԍ	*/
	
}	MyListDataType, FAR* LpMyListDataType;

typedef	struct	tagFileInfoType	{
	/*	output	*/
	int		nLineCnt;		/*	s	*/
	int		nSize;			/*	TCY(oCg)	*/
	int		nMaxLen;		/*	ő啶	*/
	int		nMaxAt;			/*	̍sԍ	*/
	BYTE	md5Contents[16];	/*	t@CeMD5l	*/
	
	/*	input	*/
	LPCTSTR	lpszFile;
	HWND	hWnd1;
	HWND	hWnd2;
	HWND	hWndSci;
	void	(FAR* lpfnMessagePump)( HWND, LPMSG );
	MarkCommentInfoType	MarkCommentInfo;	/*	}[NERg	*/
	HGLOBAL	hSaveBuff;		/*	ҏW[hŃZ[ue	*/
	DWORD	dwSaveBuffSize;	/*	̃TCY	*/
	
	/*	internal use	*/
	MD5_CTX	md5context;
}	FileInfoType, FAR* LpFileInfoType;

/*	f[^̍ős(ACe)	*/
#define	MAX_LISTBOX_ITEM_NUM	30000

/*	擪Ɩɑ}_~[ACe	*/
#define	DUMMY_ITEM_CNT			100
#define	DUMMY_ITEM_PARAM		MAKELPARAM(0,0)

/*	ItemData	*/
#define	ITEM_DATA_LINENUM(x)	(LOWORD((x)))
#define	ITEM_DATA_FLAG(x)		(HIWORD((x)))
#define	MAKE_ITEM_DATA(n,f)		MAKELPARAM((n),(f))

/*	}[Ns	*/
#define	MARK_ITEM_ID				1
#define	MARK_ITEM_PARAM(n)			MAKELPARAM((n),MARK_ITEM_ID)
#define	IS_MARK_ITEM_PARAM(x)		((ITEM_DATA_FLAG((x))&MARK_ITEM_ID)!=0)

/*	Rgs	*/
#define	COMMENT_ITEM_ID				2
#define	COMMENT_ITEM_PARAM(n)		MAKELPARAM((n),COMMENT_ITEM_ID)
#define	IS_COMMENT_ITEM_PARAM(x)	((ITEM_DATA_FLAG((x))&COMMENT_ITEM_ID)!=0)

/*	ǂݍݎ̃obt@TCY	*/
#define	LIST_LINE_BUFF_SIZE		4096

/*	ACe_uNbN	*/
#define	WM_LIST_SELECT		(WM_APP+12)

/*	wiF̏	*/
#define	WM_LIST_CTLCOLOR	(WM_APP+13)

/*	ǂݍݒ̒ʒm	*/
#define	WM_LIST_LOAD_FILE	(WM_APP+14)
/*
	eɑ
	wParam = MAKEWPARAM( tO, sԍ )
	lParam = t@C̃TCY or ݂̈ʒu
	tO = 0:Jn 1:ǂݍݒ 2:I
*/

/*	ݒ̒ʒm	*/
#define	WM_LIST_SAVE_FILE	(WM_APP+15)
/*
	eɑ
	wParam = MAKEWPARAM( tO, sԍ )
	lParam = Ŝ̍s or Ăsԍ
	tO = 0:Jn 1:ݒ 2:I
*/

#ifdef	__cplusplus
extern "C" {
#endif

/*	Xg{bNX쐬	*/
extern	HWND	CreateMyList( HWND hWndParent, UINT nCtrlID, BOOL bViewMode );

/*	TuNX	*/
extern	BOOL	SubclassMyList( HWND hWnd, BOOL bViewMode );

/*	Xg{bNXj	*/
extern	BOOL	DestroyMyList( HWND hWnd );

/*	TuNXvV[W	*/
extern	LRESULT	MYEXPORT	CALLBACK	MyListWndProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam );

/*	I[i[`	*/
extern	void	DrawListBoxItem( HWND hWnd, LPDRAWITEMSTRUCT lpDrawItemStruct );

/*	œKȍԂ	*/
extern	int		GetSuitableHeightMyList( HWND hWnd, int nExpectedHeight, int nExpectedLineCnt );

/*	tHgݒ	*/
extern	void	SetFontMyList( HWND hWnd, HFONT hFont, HFONT hFontNewLine );

/*	IvVݒ	*/
extern	void	SetOptionMyList( HWND hWnd, BOOL bShowLineNum, BOOL bShowNewLine, TCHAR cNewLine, BOOL bMarkAsComment );

/*	sԍ̕\tH[}bg߂	*/
extern	void	MakeLineNumFormatMyList( HWND hWnd, int nLineCnt );

/*	t@C̓ǂݍ	*/
extern	BOOL	LoadFileMyList( HWND hWnd, WPARAM wParam, LPARAM lParam );

/*	t@C̓ǂݍ(O)	*/
extern	void	LoadFilePhase1MyList( LpFileInfoType lpFileInfo, int nSize );

/*	t@C̓ǂݍ(eACe)	*/
extern	BOOL	LoadFilePhase2MyList( LpFileInfoType lpFileInfo, LPCTSTR lpszData, int nLen );

/*	t@C̓ǂݍ(㏈)	*/
extern	void	LoadFilePhase3MyList( LpFileInfoType lpFileInfo );

/*	t@C̏o(sԍt)	*/
extern	BOOL	SaveFileMyList( HWND hWnd, WPARAM wParam, LPARAM lParam );

/*	sԍ̕\Ԃ	*/
extern	int		GetLineNumWidthMyList( HWND hWnd, BOOL bFull );

/*	sԍ̕Ԃ	*/
extern	int		GetLineNumStrMyList( HWND hWnd, LPTSTR lpBuff, int num );

/*	w肵ԍ̃ACe擪/ɎĂ	*/
extern	void	SetPosIndexMyList( HWND hWnd, int nItem, int nPos );
#define	POS_INDEX_TOP		1
#define	POS_INDEX_BOTTOM	2

/*	\łsԂ	*/
extern	int		GetShownLineCntMyList( HWND hWnd, BOOL bNoZero );

/*	w肵ԍ̃ACe擾	*/
extern	LPCTSTR	GetTextMyList( HWND hWnd, int nItem );

/*	łv	*/
extern	void	SetHelpMeMyList( HWND hWnd, BOOL bFlag );

/*	{[h̐ݒ	*/
extern	void	SetViewModeMyList( HWND hWnd, BOOL bFlag );

/*	Õ}[NT	*/
extern	int		SearchPrevMarkMyList( HWND hWnd, int nLine );

/*	̃}[NT	*/
extern	int		SearchNextMarkMyList( HWND hWnd, int nLine );

/*	}[NȂTRUEԂ	*/
extern	BOOL	IsMarkMyList( HWND hWnd, int nLine );

/*	RgȂTRUEԂ	*/
extern	BOOL	IsCommentMyList( HWND hWnd, int nLine );

/*	e	*/
extern	void	EmptyMyList( HWND hWnd );

/*--------------------------------------------------------------*\
	牺́A}[Nꗗ̃EBhEŎgp
\*--------------------------------------------------------------*/

/*	tH[JXĂ	*/
extern	void	SetCanHaveFocusMyList( HWND hWnd, BOOL flag );

/*	}[NRs[	*/
extern	void	InsertMarkMyList( HWND hWndTo, HWND hWndFrom, int nLineNum );

/*	}[N̑}	*/
extern	LRESULT	InsertOneMarkMyList( HWND hWndTo, LPCTSTR lpszStr, int nLine );

/*	}[N̑}㏈	*/
extern	void	CenterMarkMyList( HWND hWndTo, int nItemSel );

/*	sԍԂ	*/
extern	int		GetLineNumMyList( HWND hWnd, int nItem );

#ifdef	__cplusplus
}
#endif

#endif	/*	MYLIST_H	*/
