/*--------------------------------------------------------------*\
		module	:	ToolTip.c
		purpose :	X-Send c[`bv
		author	:	_@ Kengo Jinno
		create	:	2001/09/18
		update	:	2001/10/17
					2001/11/01	IsBadReadPtr() IsBadCodePtr()
								ĝ߂B(Win2K/XP)
					2001/11/13	CreateMyToolTip()ɈbSubclass
								ǉATTF_SUBCLASS̎gp𔻒f
					2001/11/13	RelayEventMyToolTip()ǉ
\*--------------------------------------------------------------*/

#include	"PCH.h"
#include	"ToolTip.h"
#include	"resource.h"
#include	"Tools.h"

static	LPCTSTR		lpszPropertyName = _T("61afd100-ac49-11d5-af4f-00c0ca10a705");

/*	c[`bv쐬	*/
HWND	CreateMyToolTip( HWND hWndParent, const LpToolTipDataType pData, int nCnt, BOOL bMultiline, BOOL bSubclass )
{
	HINSTANCE	hInstance = (HINSTANCE)GetWindowLong( hWndParent, GWL_HINSTANCE );
	HWND	hWnd;
	
	hWnd = CreateWindowEx( WS_EX_TOPMOST, TOOLTIPS_CLASS, NULL,
		WS_POPUP/*|TTS_ALWAYSTIP*/,
		CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
		hWndParent, NULL, hInstance, NULL );
		/*
			TTS_ALWAYSTIPtƂH@łזH
			WS_EX_TOPMOST́AIMẼc[o[Oɏo߂ɕKvB
		*/
	if( hWnd != NULL ) {
		LpToolTipInfoType	p;
		TOOLINFO	ti;
		int			i;
		
		p = (LpToolTipInfoType)GlobalAlloc( GPTR, sizeof(ToolTipInfoType) );
		if( p == NULL ) {
			DestroyWindow( hWnd );
			return( NULL );
		}
		ZeroMemory( p, sizeof(ToolTipInfoType) );
		
		/*	eRg[ɃeLXg蓖Ă	*/
		ZeroMemory( &ti, sizeof(ti) );
		ti.cbSize = gbIe3Later ? sizeof(ti) : sizeof(oldTOOLINFO);
		ti.hwnd = hWndParent;
		ti.hinst = ( bMultiline ? NULL : hInstance );
		for( i = 0; i < nCnt; i++ ) {
			HWND	hWndTool = GetDlgItem( hWndParent, pData[i].iWndID );
			ti.uId = (UINT)hWndTool;
			if( bMultiline ) {
				/*	sł́AʒmbZ[WŕZbgB	*/
				/*	80ŋIɐ؂Ă܂̂ŁB	*/
				ti.lpszText = LPSTR_TEXTCALLBACK;
				SetWindowLong( hWndTool, GWL_USERDATA, pData[i].iStringID + 16 );
				/*	spID = PspID + 16 Ƃ邱ƁB	*/
				/*
					IE3ȍ~OȂ̂ŁATOOLINFO::lParam TOOLTIPTEXT::lParam
					gƂAIE5̊łTOOLTIPTEXT::lParamɑSႤ
					lĂB\̂̌`ς킯ł͂ȂB
				*/
			} else {
				ti.lpszText = (LPTSTR)MAKEINTRESOURCE( pData[i].iStringID );
			}
			SetRectEmpty( &(ti.rect) );
			ti.uFlags = TTF_IDISHWND|(bSubclass?TTF_SUBCLASS:0);
			SendMessage( hWnd, TTM_ADDTOOL, 0, (LPARAM)&ti );
#if 1
			{
				HWND	hWndChild;
				hWndChild = GetWindow( hWndTool, GW_CHILD );
				while( hWndChild != NULL ) {
					ti.uId = (UINT)hWndChild;
					if( bMultiline ) {
						/*	eɑĂ܂̂ŁACALLBACKȂB	*/
						/*	܂A80ȓłȂƂȂB	*/
						ti.lpszText = (LPTSTR)MAKEINTRESOURCE( pData[i].iStringID + 16 );
					}
					SendMessage( hWnd, TTM_ADDTOOL, 0, (LPARAM)&ti );
					hWndChild = GetWindow( hWndChild, GW_HWNDNEXT );
				}
			}
#endif
			/*	ȃRg[̑΍(2001/04/13)	*/
			GetWindowRect( hWndTool, &(ti.rect) );
			ScreenToClientRect( hWndParent, &(ti.rect) );
			ti.uFlags = bSubclass?TTF_SUBCLASS:0;
			SendMessage( hWnd, TTM_ADDTOOL, 0, (LPARAM)&ti );
		}
		if( bMultiline ) {
			DoMultilineMyToolTip( hWnd );
		}
		/*
			TTF_SUBCLASStĂ΁AbZ[W[v
			TTM_RELAYEVENTKv͂ȂB
		*/
		SendMessage( hWnd, TTM_ACTIVATE, TRUE, 0 );
		
		/*	vpeBɃZbg	*/
		SetProp( hWnd, lpszPropertyName, (HANDLE)p );
		/*	TuNX	*/
		p->lpfnOldWndProc = (WNDPROC)SetWindowLong( hWnd, GWL_WNDPROC, (LONG)MyToolTipWndProc );
	}
	
	return( hWnd );
}

/*	c[`bv쐬(Xe[^Xo[p)	*/
HWND	CreateMyStatusBarToolTip( HWND hWndParent, const LpToolTipDataType pData, int nCnt, BOOL bMultiline )
{
	HINSTANCE	hInstance = (HINSTANCE)GetWindowLong( hWndParent, GWL_HINSTANCE );
	HWND	hWnd;
	
	hWnd = CreateWindowEx( WS_EX_TOPMOST, TOOLTIPS_CLASS, NULL,
		WS_POPUP/*|TTS_ALWAYSTIP*/,
		CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
		hWndParent, NULL, hInstance, NULL );
		/*
			TTS_ALWAYSTIPtƂH@łזH
			WS_EX_TOPMOST́AIMẼc[o[Oɏo߂ɕKvB
		*/
	if( hWnd != NULL ) {
		LpToolTipInfoType	p;
		TOOLINFO	ti;
		int			i;
		
		p = (LpToolTipInfoType)GlobalAlloc( GPTR, sizeof(ToolTipInfoType) );
		if( p == NULL ) {
			DestroyWindow( hWnd );
			return( NULL );
		}
		ZeroMemory( p, sizeof(ToolTipInfoType) );
		
		/*	eRg[ɃeLXg蓖Ă	*/
		ZeroMemory( &ti, sizeof(ti) );
		ti.cbSize = gbIe3Later ? sizeof(ti) : sizeof(oldTOOLINFO);
		ti.hwnd = hWndParent;
		ti.hinst = NULL;
		for( i = 0; i < nCnt; i++ ) {
			ti.uId = pData[i].iWndID;		//	iStringID͖gp
			ti.lpszText = LPSTR_TEXTCALLBACK;
			SetRectEmpty( &(ti.rect) );
			ti.uFlags = TTF_SUBCLASS;
			GetClientRect( hWndParent, &(ti.rect) );	//	Ƃ肠
			SendMessage( hWnd, TTM_ADDTOOL, 0, (LPARAM)&ti );
		}
		if( bMultiline ) {
			DoMultilineMyToolTip( hWnd );
		}
		/*
			TTF_SUBCLASStĂ΁AbZ[W[v
			TTM_RELAYEVENTKv͂ȂB
		*/
		SendMessage( hWnd, TTM_ACTIVATE, TRUE, 0 );
		
		/*	vpeBɃZbg	*/
		SetProp( hWnd, lpszPropertyName, (HANDLE)p );
		/*	TuNX	*/
		p->lpfnOldWndProc = (WNDPROC)SetWindowLong( hWnd, GWL_WNDPROC, (LONG)MyToolTipWndProc );
	}
	
	return( hWnd );
}


/*	c[`bvj	*/
BOOL	DestroyMyToolTip( HWND hWnd )
{
	BOOL	ret = TRUE;
	if( IsWindow( hWnd ) ) {
		LpToolTipInfoType	p = (LpToolTipInfoType)GetProp( hWnd, lpszPropertyName );
		if( p != NULL ) {
			/*	TuNX	*/
			if( p->lpfnOldWndProc != NULL ) {
				SetWindowLong( hWnd, GWL_WNDPROC, (LONG)p->lpfnOldWndProc );
				p->lpfnOldWndProc = NULL;
			}
			/*	vpeB폜	*/
			RemoveProp( hWnd, lpszPropertyName );
			GlobalFree( (HGLOBAL)p );
		}
		/*	p	*/
		ret = DestroyWindow( hWnd );
	}
	return ret;
}

/*	TuNXvV[W	*/
LRESULT	MYEXPORT	CALLBACK	MyToolTipWndProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	LpToolTipInfoType	p = (LpToolTipInfoType)GetProp( hWnd, lpszPropertyName );
	if( p == NULL || p->lpfnOldWndProc == NULL ) {
		return DefWindowProc( hWnd, uMsg, wParam, lParam );
	}
	if( uMsg == WM_WINDOWPOSCHANGING ) {
		LPWINDOWPOS	lpwp = (LPWINDOWPOS)lParam;
		if( lpwp != NULL && !( lpwp->flags & SWP_NOMOVE ) ) {
			RECT	rect;
			POINT	point;
			GetWindowRect( hWnd, &rect );
			OffsetRect( &rect, lpwp->x - rect.left, lpwp->y - rect.top );
			if( !( lpwp->flags & SWP_NOSIZE ) ) {
				rect.right = rect.left + lpwp->cx;
				rect.bottom = rect.top + lpwp->cy;
			}
			GetCursorPos( &point );
			if( PtInRect( &rect, point ) ) {
				/*	߂֓	*/
				long	xl, xr, xm, yt, yb, ym;
				xl = point.x - rect.left + 1;
				xr = rect.right - point.x;
				xm = ( xl <= xr ) ? xl : -xr;
				yt = point.y - rect.top + 1;
				yb = rect.bottom - point.y;
				ym = ( yt <= yb ) ? yt : -yb;
				if( ( xm < 0 ? -xm : xm ) <= ( ym < 0 ? -ym : ym ) ) {
					lpwp->x += xm;
				} else {
					lpwp->y += ym;
				}
			}
		}
	} else if( uMsg == WM_DESTROY ) {
		RemoveProp( hWnd, lpszPropertyName );
	}
//	if( IsBadReadPtr( &(p->lpfnOldWndProc), sizeof(p->lpfnOldWndProc) ) || IsBadCodePtr( (FARPROC)p->lpfnOldWndProc ) ) {
//		return DefWindowProc( hWnd, uMsg, wParam, lParam );
//	}
	return CallWindowProc( p->lpfnOldWndProc, hWnd, uMsg, wParam, lParam );
}

/*	̗v	*/
void	NeedTextMyToolTip( HWND hWnd, HINSTANCE hInstance, LPTOOLTIPTEXT lptip )
{
	if( IsWindow( hWnd ) ) {
		LpToolTipInfoType	p = (LpToolTipInfoType)GetProp( hWnd, lpszPropertyName );
		if( p != NULL ) {
			HWND	hWndTool = (HWND)lptip->hdr.idFrom;
			UINT	nStrID = GetWindowLong( hWndTool, GWL_USERDATA );
			LoadString( hInstance, nStrID, p->szTooltipText, MAX_MY_TOOLTIP_TEXT );
			lptip->hinst = NULL;
			lptip->lpszText = p->szTooltipText;
		}
	}
}

/*	s	*/
void	DoMultilineMyToolTip( HWND hWnd )
{
	int		nTime;
	/*	sBIE3(4.70)ȍ~	*/
	SendMessage( hWnd, TTM_SETMAXTIPWIDTH, 0, GetSystemMetrics(SM_CXSCREEN) );
	/*	\Ԃ𒷂BIE3(4.70)ȍ~	*/
	nTime = SendMessage( hWnd, TTM_GETDELAYTIME, TTDT_AUTOPOP, 0 );
	if( nTime > 0 ) {
		nTime *= 3;		/*	3{	*/
		SendMessage( hWnd, TTM_SETDELAYTIME, TTDT_AUTOPOP, nTime );
	}
	/*	ԂWIł́ATbPTbɂȂ͂B	*/
}

/*	}EXbZ[W	*/
void	RelayEventMyToolTip( HWND hWnd, LPMSG lpmsg )
{
	if( IsWindow( hWnd ) && lpmsg != NULL ) {
		if( lpmsg->message >= WM_MOUSEFIRST && lpmsg->message <= WM_MOUSELAST ) {
			SendMessage( hWnd, TTM_RELAYEVENT, 0, (LPARAM)lpmsg );
		}
	}
}
