/*--------------------------------------------------------------*\
		module	:	Tools.h
		purpose :	X-Editor ec[
		author	:	_@ Kengo Jinno
		create	:	2001/09/04
		update	:	2001/10/15
\*--------------------------------------------------------------*/

#ifndef	TOOLS_H
#define	TOOLS_H

#ifdef	__cplusplus
extern "C" {
#endif

/*	tHgI	*/
extern	BOOL	OptionFont( HWND hWnd, LOGFONT* plf );

#if 0
/*	FI	*/
extern	BOOL	OptionColor( HWND hWnd, COLORREF* pcol, LPDWORD lpCustColors, HINSTANCE hInstance, UINT nDlgTitleID );
extern	UINT	MYEXPORT	CALLBACK	ColorHookProc( HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam );
#endif

/*	ScreenToClient()RECT	*/
extern	BOOL	ScreenToClientRect( HWND hWnd, LPRECT lprect );

/*	ClientToScreen()RECT	*/
extern	BOOL	ClientToScreenRect( HWND hWnd, LPRECT lprect );

void	ReadColorFormat( COLORREF* pCol, LPTSTR lpszData );
void	WriteColorFormat( COLORREF col, LPTSTR lpszData );

/*	ȂAPIɖ񂾁H@Get͂̂	*/
BOOL	WritePrivateProfileInt( LPCTSTR lpszSection, LPCTSTR lpszKey, DWORD dwValue, LPCTSTR lpszFile );

/*	tHg̍쐬	*/
HFONT	MyCreateFont( HWND hWnd, HFONT hFont, const LOGFONT* plf );

/*	sLptHg̍쐬	*/
HFONT	MyCreateNewLineFont( HFONT hFont, HFONT hFontNewLine );

/*	DLL̃o[W𒲂ׂ	*/
BOOL	GetDllVersion( LPCTSTR lpszDllName, LPDWORD lpdwFileMS, LPDWORD lpdwFileLS, LPDWORD lpdwProdMS, LPDWORD lpdwProdLS );

/*	`bN̍߂	*/
DWORD	GetTickDiff( DWORD dwTo, DWORD dwFrom );

/*	t@C_CAÕtbN֐	*/
UINT	MYEXPORT	CALLBACK	FileHookProc( HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam );

/*	Zt@Ct@C	*/
extern	void	GetLongPathName95( LPCTSTR lpszPathShort, LPTSTR lpszPathLong, DWORD dwBuffSize );

/*	V[gJbĝ̃t@C𓾂	*/
extern	void	ResolveShortcut( LPTSTR lpszPath );

/*	RECTłMoveWindow()	*/
extern	BOOL	MyMoveWindow( HWND hWnd, const LPRECT lpRect, BOOL bRepaint );

#ifdef	__cplusplus
}
#endif

#endif	/*	TOOLS_H	*/
