/*--------------------------------------------------------------*\
		module	:	X-Send.c
		purpose :	X-Send C
		author	:	_@ Kengo Jinno
		create	:	2001/09/03
		update	:	2001/10/19
					2001/11/13	GetRectMyEdit()g
					2001/11/13	CreateMyToolTip()̈ǉɑΉ
					2001/11/13	MyProcessMessage()TTM_RELAYEVENTǉ
					2001/11/13	SetCurrentDirectory()
								XsOpenFileProc()Ɉړ
					2001/11/21	Rg@\
					2002/03/06	XsInfo::bMarkAsComment ǉ
					2002/03/19	XsInfo::bEditMode ǉ
					2002/03/19	XsInfo::hWndMySci ǉ
					2002/03/26	֌W̒ǉ
					2002/03/27	WM_SCI_RESTOREbZ[W
					2002/04/08	WM_MENUSELECTbZ[W
					2002/04/09	
					2011/02/17	HWND_BROADCASTSendMessageTimeout()
\*--------------------------------------------------------------*/

#include	"PCH.h"
#include	"X-Send.h"
#include	"Tools.h"
#include	"ScrlBar.h"
#include	"ToolBar.h"
#include	"MyEdit.h"
#include	"MyList.h"
#include	"StatBar.h"
#include	"IMS-API.h"
#include	"IPC.h"
#include	"WaitDlg.h"
#include	"ToolTip.h"
#include	"MyDDE.h"
#include	"Command.h"
#include	"MySci.h"

#if		defined(__BORLANDC__)
#pragma resource "X-Send.res"
#endif

#define		VERSION		_T("2.1(32)")

const	TCHAR	BASED_CODE	szXsWndClass[] = _T("X-Send-FrameWndClass");	/*	EBhENX	*/
const	TCHAR	BASED_CODE	szXsAppName[] = _T("X-Send");			/*	LvV	*/
const	TCHAR	BASED_CODE	szXsdWndClass[] = _T("X-Send-Daemon-FrameWndClass");	/*	XSD̃EBhENX	*/
const	TCHAR	BASED_CODE	szXsdApiMsgString[] = _T("XSD-6fba3840-a6ee-11d5-af4f-00c0ca10a705");	/*	XSDAPIpbZ[W	*/
const	TCHAR	BASED_CODE	szXsdCmd[] = _T("XSD.exe");		/*	XSD̎st@C	*/
const	TCHAR	BASED_CODE	szVersion[] = VERSION;



/*	WM_CREATE	*/
LRESULT	NEAR	CreateProc( HWND hWnd, LPCREATESTRUCT pcs )
{
	NpXsInfo	p;
	HFONT		hSystemFont;
	BOOL		bFirst;
	
	/*	PCH.cɂ鏉֐	*/
	CheckOsVersion();
	CheckComctl32DllVersion();
	
	SetXsInfo( hWnd, NULL );
	p = (NpXsInfo)LocalAlloc( LPTR, sizeof(XsInfo) );
	if( p == NULL ) {
		return -1L;
	}
	p->hInstance = pcs->hInstance;
	
	{	/*	INIt@Č	*/
		TCHAR	buff[_MAX_PATH];
		LPSTR	q, r, s;
		static	const	TCHAR	BASED_CODE	szExtension[] = _T(".ini");
		GetModuleFileName( p->hInstance, buff, _MAX_PATH );
		q = r = s = buff;
		while( *r != _T('\0') ) {
#ifdef	WIN32
			if( IsDBCSLeadByte( *r ) ) {
#else
			if( iskanji( *r ) && iskanji2( *(r+1) ) ) {
			/*	3.1ȂIsDBCSLeadByte()Ă񂾂	*/
#endif
				r++;
			} else if( *r == _T('.') ) {
				s = r;	//	Ō'.'w
			} else if( *r == _T('\\') ) {
				q = r;	//	Ō'\\'w
			}
			r++;
		}
		/*	DLL[hfBNǧ	*/
		lstrcpy( p->szDllPath, buff );
		p->szDllPath[ q+1-buff ] = _T('\0');
#ifdef	WIN32
		{
			WIN32_FIND_DATA	wfd;
			HANDLE	h = FindFirstFile( buff, &wfd );
			if( h != INVALID_HANDLE_VALUE ) {
				FindClose( h );
				/*	t@Cǉ	*/
				*(q+1) = _T('\0');
				lstrcat( buff, wfd.cFileName );
				s = r = q;
				while( *r != _T('\0') ) {
					if( IsDBCSLeadByte( *r ) ) {
						r++;
					} else if( *r == _T('.') ) {
						s = r;	//	Ō'.'w
					}
					r++;
				}
			}
		}
#endif
		/*	INIt@C	*/
		lstrcpy( p->szProfile, buff );
		p->szProfile[ s-buff ] = _T('\0');
		lstrcat( p->szProfile, szExtension );
//		/*	Ot@C̃fBNǧ	*/
//		*(q+1) = _T('\0');
//		lstrcpy( p->szLogPath, buff );
	}
	/*	OpenFile_CAȌfBNg	*/
	GetCurrentDirectory( _MAX_PATH, p->szInitialDir );
#if 0	/*	Command.c XsOpenFileProc()Ɉړ	2001/11/13	*/
	{	/*	JgfBNgWindowsfBNgɂ	*/
		TCHAR	szBuff[ _MAX_PATH ];
		if( GetWindowsDirectory( szBuff, _MAX_PATH ) > 0 ) {
			SetCurrentDirectory( szBuff );
		}
		/*	ȂƁAFDDJgȂ񂩂肷ƁA	*/
		/*	WM_DDE_INITIATE邽т(Ȃ)ANZXĂ܂B	*/
	}
#endif
	/*	JĂt@C̃pX	*/
	p->szFilePath[0] = _T('\0');
	p->szFileName[0] = _T('\0');
	p->szPathName[0] = _T('\0');
	ZeroMemory( p->md5FileName, sizeof(p->md5FileName) );
	p->cFilePathDummy = _T('/');	/*	t@CƂĂ肦Ȃ	*/
	
	p->hAccel = LoadAccelerators( p->hInstance, MAKEINTRESOURCE( IDR_ACCEL_MAIN ) );
	
	p->nCurrentLine = 0;
	p->nLineCnt = 0;
	p->nSize = 0;
	p->nMaxLen = 0;
	p->nMaxAt = 0;
	ZeroMemory( p->md5Contents, sizeof(p->md5Contents) );
	InitMarkComment( &(p->FileInfo.MarkCommentInfo), p->hInstance );
	p->bRecvFile = FALSE;
	p->dwSendFileInterval = 100;
	p->bBeepOnResend = FALSE;
	p->sizeMarkList.cx = p->sizeMarkList.cy = 0;
	
#ifdef	WIN32
	/*	StrFormatByteSize() shlwapi.dll	*/
	{
		LPCTSTR	lpszDllName = _T("shlwapi.dll");
		p->bMustFreeShlWapiDll = FALSE;
		p->lpStrFormatByteSize = NULL;
		p->hInstShlWapiDll = GetModuleHandle( lpszDllName );
		if( p->hInstShlWapiDll == NULL ) {
			p->hInstShlWapiDll = LoadLibraryEx( lpszDllName, NULL, 0 );
			p->bMustFreeShlWapiDll = ( p->hInstShlWapiDll != NULL );
		}
		if( p->hInstShlWapiDll != NULL ) {
#ifdef UNICODE
			LPCTSTR	lpszFuncName = _T("StrFormatByteSizeW");
#else
			LPCTSTR	lpszFuncName = _T("StrFormatByteSizeA");
#endif
			p->lpStrFormatByteSize = (LP_FUNC_STRFORMATBYTESIZE)GetProcAddress( p->hInstShlWapiDll, lpszFuncName );
		}
	}
#endif
	
	/*	[h	*/
	p->bHelpMe = FALSE;
	p->bViewMode = TRUE;
	p->bEditMode = FALSE;
	
	/*	[\(V)]	*/
	p->bShowToolbar = TRUE;
	p->bShowLineNum = TRUE;
	p->bShowNewLine = TRUE;
	p->bShowScrollBar = TRUE;
	p->bShowStatusBar = TRUE;
	p->bBitmapOnToolbar = FALSE;
	p->bShowEdge = FALSE;
	p->nEdgeColumn = 10;
	
	/*	tHg(VXeŒsb`)	*/
	hSystemFont = (HFONT)GetStockObject( SYSTEM_FIXED_FONT );
	GetObject( hSystemFont, sizeof(LOGFONT), &(p->lfText) );
	
	p->cNewLine = _T('\xbf');	/*	SymbolFont	*/
	p->bDiamondCursor = TRUE;
	p->bCtrlXCCursor = TRUE;
	p->bCaretRight = TRUE;
	p->bMarkAsComment = FALSE;
	p->bFunctionKey10 = FALSE;
	p->bSystemFont = FALSE;
	p->bNoTooltip = FALSE;
	p->bMultilineTip = gbIe3Later ? TRUE : FALSE;	/*	IE3ȍ~ȂOK	*/
	p->bFlatToolbar = FALSE;
	
	/*	IMS-API֌W	*/
	p->uImsApiMessage = RegisterWindowMessage( IMS_API_MESSAGE_STRING );
	p->bUseImsApi = FALSE;
	p->hWndIms = NULL;
	p->bImsSearching = FALSE;
	LoadString( p->hInstance, IDS_IMS_HELPME, p->szHelpMe, _MAX_PATH );
	
	/*	t@C֌W	*/
	InitFileMru( &(p->FileMruInfo) );
	p->hFileMenu = GetMenu( hWnd );
	p->hFileMenu = GetSubMenu( p->hFileMenu, 0 );
	
	/*	vZXԒʐM	*/
	p->uXsIpcMessage = RegisterWindowMessage( XS_IPC_MESSAGE_STRING );
	
	/*	f[API	*/
	p->uXsdApiMsg = RegisterWindowMessage( szXsdApiMsgString );
	ZeroMemory( &(p->XsdApiInfo), sizeof(XsdApiInfoType) );
	p->hWndXsd = NULL;
	
	/*	tbN	*/
	InstallHook( &(p->IdleInfo) );
	p->IdleInfo.uTimerID = SetTimer( hWnd, 1, 1000, NULL );
	
	/*	EditSend֌W	*/
	p->bCanUseEditSend = InitEdsApi( &(p->EdsApiInfo) );
	p->bCanSendEditSend = FALSE;
	
	/*	DDE֌W	*/
	p->bUseDde = TRUE;
	p->DdeInfo.nClientStatus = DDE_STAT_NONE;
	p->DdeInfo.hWndServer = NULL;
	p->DdeInfo.lpfnMessagePump = MyProcessMessage;
	p->DdeInfo.lpszServiceName = p->szDdeServerName;
	LoadString( p->hInstance, IDS_DDE_DEFAULT_SERVER, p->szDdeServerName, _MAX_FNAME );
	LoadString( p->hInstance, IDS_DDE_DEFAULT_LIST, p->szDdeServiceList, _MAX_PATH );
	p->bFoundServer = FALSE;
	p->hWndLastServer = NULL;
	
	/*	֌W	*/
	p->hWndFindDlg = NULL;
	p->bFindNext = TRUE;
	p->bMatchCase = FALSE;
	p->bWholeWord = FALSE;
	p->nMsgFindDlg = RegisterWindowMessage( FINDMSGSTRING );
	p->szFindText[0] = _T('\0');
	p->szReplaceText[0] = _T('\0');
	
	SetXsInfo( hWnd, p );
	
	/*	INIt@C̓ǂݍ	*/
	bFirst = ReadProfile( p, p->szProfile );
	if( bFirst ) {
		WriteProfile( p, p->szProfile );	/*	Ă	*/
	}
	
	if( p->bCanUseEditSend ) {
		(p->EdsApiInfo.lpEdsGetParam)( &(p->EdsApiInfo.EdsParam) );
	} else {
		p->bUseDde = TRUE;
	}
	/*	DDET[o[Xgzɕ	*/
	{
		LPTSTR	q, r;
		lstrcpy( p->szDdeServiceBuff, p->szDdeServiceList );
		q = r = p->szDdeServiceBuff;
		p->nDdeServiceArry = 0;
		while( *q != _T('\0') ) {
			if( *q == _T(';') ) {
				*q = _T('\0');
				if( r != q ) {
					p->szDdeServiceArray[ (p->nDdeServiceArry)++ ] = r;
				}
				r = q+1;
			}
			q++;
		}
		if( r != q ) {
			p->szDdeServiceArray[ (p->nDdeServiceArry)++ ] = r;
		}
	}
	/*	DDET[o[T	*/
	if( p->bUseDde ) {
		if( CheckDDEServer( hWnd, &(p->DdeInfo), p->szDdeServerName ) ) {
			/*	OK	*/
			p->bFoundServer = TRUE;
		} else {
			LPCTSTR	ret;
			ret = SearchDDEServer( hWnd, &(p->DdeInfo), p->szDdeServiceArray, p->nDdeServiceArry );
			if( ret != NULL ) {
				lstrcpy( p->szDdeServerName, ret );
				p->bFoundServer = TRUE;
			}
		}
	}
	
	/*	Xe[^Xo[	*/
	p->hWndStatusBar = CreateStatusBar( hWnd, ID_STATUSBAR, p->bShowStatusBar, p->bNoTooltip );
	/*	c[o[	*/
	{
		ToolBarCreateInfo	tbci;
		tbci.bShow = p->bShowToolbar;
		tbci.bFunction10 = p->bFunctionKey10;
		tbci.bSystemFont = p->bSystemFont;
		tbci.bNoToolTip = p->bNoTooltip;
		tbci.bMultilineTip = p->bMultilineTip;
		tbci.bBitmap = p->bBitmapOnToolbar;
		tbci.bFlat = p->bFlatToolbar;
		p->hWndToolBar = CreateToolBar( hWnd, ID_TOOLBAR, &tbci );
	}
	/*	XN[o[	*/
	p->hWndScrollBar = CreateScrollBar( hWnd, ID_SCROLLBAR, p->bShowScrollBar );
	/*	ҏWs	*/
	p->hWndMyEdit = CreateMyEdit( hWnd, ID_EDIT_LINE, p->bViewMode );
	SetOptionMyEdit( p->hWndMyEdit, p->bDiamondCursor, p->bCtrlXCCursor, p->bShowNewLine, p->cNewLine, p->bMarkAsComment );
	/*	Xg{bNX()	*/
	p->hWndListBoxLow = CreateMyList( hWnd, ID_LISTBOX_LOW, p->bViewMode );
	SetOptionMyList( p->hWndListBoxLow, p->bShowLineNum, p->bShowNewLine, p->cNewLine, p->bMarkAsComment );
	/*	Xg{bNX()	*/
	p->hWndListBoxHi = CreateMyList( hWnd, ID_LISTBOX_HI, p->bViewMode );
	SetOptionMyList( p->hWndListBoxHi, p->bShowLineNum, p->bShowNewLine, p->cNewLine, p->bMarkAsComment );
	/*	c[`bv	*/
	if( p->bNoTooltip ) {
		p->hWndToolTip = NULL;
	} else {
		ToolTipDataType	ti[] = {
			{ ID_EDIT_LINE,   IDS_TIPS_EDIT_LINE   },
			{ ID_LISTBOX_LOW, IDS_TIPS_LISTBOX_LOW },
			{ ID_LISTBOX_HI,  IDS_TIPS_LISTBOX_HI  },
		};
		const	int		nCnt = sizeof(ti) / sizeof(ToolTipDataType);
		p->hWndToolTip = CreateMyToolTip( hWnd, ti, nCnt, p->bMultilineTip, FALSE );
	}
	/*	Scintilla		*/
	p->hWndMySci = CreateMyScintilla( hWnd, ID_SCINTILLA, p->szDllPath );
	SetOptionMyScintilla( p->hWndMySci, p->bDiamondCursor, p->bCtrlXCCursor, p->bShowLineNum, p->bShowNewLine, p->cNewLine, p->bMarkAsComment, p->bShowEdge, p->nEdgeColumn );
	/*	c[o[̏	*/
	SetStateToolBar( p->hWndToolBar, p->szFilePath[0] != _T('\0'), p->bHelpMe, p->bViewMode, p->hWndMySci, p->bEditMode );

	/*	tHg쐬āASetFont()	*/
	p->hFont = MyCreateFont( hWnd, p->hFont, &(p->lfText) );
	p->hFontNewLine = MyCreateNewLineFont( p->hFont, p->hFontNewLine );
	SetFontMyEdit( p->hWndMyEdit, p->hFont, p->hFontNewLine );
	SetFontMyList( p->hWndListBoxLow, p->hFont, p->hFontNewLine );
	SetFontMyList( p->hWndListBoxHi, p->hFont, p->hFontNewLine );
	SetFontMyScintilla( p->hWndMySci, p->hFont, p->hFontNewLine );
	
	
	/*	EBhȆ傫ς	*/
	{
		int		nToolBarWidth = GetWidthToolBar( p->hWndToolBar );
		RECT	rect;
		GetClientRect( hWnd, &rect );
		if( rect.right - rect.left > nToolBarWidth ) {
			/*	c[o[̕Lc[o[̕܂ŋ߂	*/
			int		nDiff = ( rect.right - rect.left ) - nToolBarWidth;
			GetWindowRect( hWnd, &rect );
			rect.right -= nDiff;
		} else {
			/*	c[o[̕LL	*/
			GetWindowRect( hWnd, &rect );
			rect.right += GetSystemMetrics( SM_CXVSCROLL );
		}
		MyMoveWindow( hWnd, &rect, TRUE );
	}
	
	/*	hbOhbv	*/
	DragAcceptFiles( hWnd, TRUE );
	
	/*	LvV\	*/
	ShowCaption( hWnd );
	
	if( p->bUseImsApi ) {
		/*	IMSTĂ݂	*/
		PostMessage( hWnd, WM_IMS_SEARCH_SERVER, 0, 0 );
	}
	
	if( bFirst ) {
		/*	NȂATv	*/
		DoPostCommand( hWnd, ID_CFM_FIRST_BOOT );
	}
	
	return 0L;
}


/*	WM_XS_STARTUP_XSD	*/
void	NEAR	XsStartupXsd( HWND hWnd )
{
	NpXsInfo	p = GetXsInfo( hWnd );
	if( p != NULL && p->hWndXsd == NULL ) {
		p->hWndXsd = FindWindow( szXsdWndClass, NULL );
		if( p->hWndXsd == NULL ) {
			/*	XSDN	*/
			TCHAR	szPath[ _MAX_PATH ];
			TCHAR	szCmdLine[ _MAX_PATH ];
			LPTSTR	q = szPath;
			STARTUPINFO			si;
			PROCESS_INFORMATION	pi;
			BOOL	ret;
			
			ZeroMemory( &si, sizeof(si) );
			si.cb = sizeof(si);
			si.dwFlags = STARTF_USESHOWWINDOW;
			si.wShowWindow = SW_SHOWNORMAL;
			
			/*	̎st@C̃pX	*/
			GetModuleFileName( NULL, szCmdLine, _MAX_PATH );
			GetShortPathName( szCmdLine, szCmdLine, _MAX_PATH );
			/*	t@C"xsd.exe"ɒu	*/
			if( GetFullPathName( szCmdLine, _MAX_PATH, szPath, &q ) > 0 ) {
				lstrcpy( q, szXsdCmd );
			} else {
				lstrcpy( szPath, szXsdCmd );
			}
			wsprintf( szCmdLine, _T("%s %lu"), szPath, p->uXsdApiMsg );
			
			ret = CreateProcess( NULL, szCmdLine, NULL, NULL, FALSE, 0, NULL, NULL, &si, &pi );
			if( ret ) {
				WaitForInputIdle( pi.hProcess, 5000 );
				CloseHandle( pi.hProcess );
				CloseHandle( pi.hThread );
				p->hWndXsd = FindWindow( szXsdWndClass, NULL );
			}
		}
	}
}

/*	WM_SETFOCUS	*/
BOOL	NEAR	SetFocusProc( HWND hWnd, HWND hWndLoseFocus )
{
	NpXsInfo	p = GetXsInfo( hWnd );
	if( p != NULL ) {
		if( !p->bEditMode && p->hWndMyEdit != NULL && IsWindow( p->hWndMyEdit ) ) {
			/*	ҏWsɃtH[JX𓖂Ă	*/
			SetFocus( p->hWndMyEdit );
			return TRUE;
		} else if( p->bEditMode && p->hWndMySci != NULL && IsWindow( p->hWndMySci ) ) {
			/*	ScintillaɃtH[JX𓖂Ă	*/
			SetCaretPeriodMyScintilla( p->hWndMySci, GetCaretBlinkTime() );
			SetFocus( p->hWndMySci );
			return TRUE;
		}
	}
	UNUSE(hWndLoseFocus);
	return FALSE;
}

/*	WM_SIZE/WM_WININICHANGE	*/
void	RecalcLayout( HWND hWnd )
{
	NpXsInfo	p = GetXsInfo( hWnd );
	if( p != NULL && !IsIconic( hWnd ) ) {
		RECT	rectClient;
		RECT	rectEdit;
		RECT	rectListLow, rectListHi;
		int		nHeight;
		int		nGap;
		
		AutoSizeToolBar( p->hWndToolBar );
		AutoSizeStatusBar( p->hWndStatusBar );
		
		GetClientRect( hWnd, &rectClient );
		
		/*	c[o[	*/
		if( IsWindow( p->hWndToolBar ) && IsWindowVisible( p->hWndToolBar ) ) {
			RECT	rect;
			GetWindowRect( p->hWndToolBar, &rect );
			rectClient.top += rect.bottom - rect.top;
		}
		/*	Xe[^Xo[	*/
		if( IsWindow( p->hWndStatusBar ) && IsWindowVisible( p->hWndStatusBar ) ) {
			RECT	rect;
			GetWindowRect( p->hWndStatusBar, &rect );
			rectClient.bottom -= rect.bottom - rect.top;
		}
		
		/*	Scintilla	*/
		if( IsWindow( p->hWndMySci ) ) {
			RECT	rect = rectClient;
			MyMoveWindow( p->hWndMySci, &rect, TRUE );
		}
		
		/*	XN[o[	*/
		if( IsWindow( p->hWndScrollBar ) && IsWindowVisible( p->hWndScrollBar ) ) {
			RECT	rect = rectClient;
			int		nCx = GetSystemMetrics( SM_CXVSCROLL );
			rect.left = rect.right - nCx;
			MyMoveWindow( p->hWndScrollBar, &rect, TRUE );
			rectClient.right -= nCx+1;
		}
		
		/*	ҏWs̍	*/
		GetWindowRect( p->hWndMyEdit, &rectEdit );
		ScreenToClientRect( hWnd, &rectEdit );
		OffsetRect( &rectEdit, rectClient.left-rectEdit.left, rectClient.top-rectEdit.top );
		nHeight = GetSuitableHeightMyEdit( p->hWndMyEdit );
		rectEdit.bottom = rectEdit.top + nHeight;
		
		/*	㉺̔zuʒu(2/3)	*/
		nHeight = ( rectClient.bottom - rectClient.top - nHeight ) / 3;
		rectEdit.top += nHeight;
		rectEdit.bottom += nHeight;
		rectEdit.left = rectClient.left;
		rectEdit.right = rectClient.right;
		
		/*	ҏWsƃXg{bNX̌	*/
		rectListLow = rectListHi = rectEdit;
		nGap = GetSystemMetrics( SM_CYFRAME ) - GetSystemMetrics( SM_CYEDGE );
		if( nGap < 1 ) {
			nGap = 1;
		}
		
		/*	]ɃXg{bNXzu	*/
		rectListHi.top = rectClient.top;
		rectListHi.bottom = rectEdit.top - nGap;
		rectListLow.top = rectEdit.bottom + nGap;
		rectListLow.bottom = rectClient.bottom;
		
		/*	̃Xg{bNX̍߂	*/
		nHeight = rectListHi.bottom - rectListHi.top;
		nHeight -= GetSuitableHeightMyList( p->hWndListBoxHi, nHeight, 0 );
		/*	ɍ킹Ĉړ	*/
		rectListHi.bottom -= nHeight;
		rectEdit.top -= nHeight;
		rectEdit.bottom -= nHeight;
		rectListLow.top -= nHeight;
		
		/*	̃Xg{bNX̍𒲂ׂ	*/
		nHeight = rectListLow.bottom - rectListLow.top;
		if( nHeight < GetSuitableHeightMyList( p->hWndListBoxLow, nHeight, 2 ) ) {
			/*	Qs̍	*/
			/*	̃Xg{bNXԂ	*/
			nHeight = rectListHi.bottom - rectListHi.top;
			ShowWindow( p->hWndListBoxHi, SW_HIDE );
			nHeight += nGap;
			rectEdit.top -= nHeight;
			rectEdit.bottom -= nHeight;
			rectListLow.top -= nHeight;
		} else {
			if( !p->bEditMode ) {
				ShowWindow( p->hWndListBoxHi, SW_SHOW );
			}
		}
		
		/*	ҏWs̍ɁAsԍ\p̗̈m	*/
		if( p->bShowLineNum ) {
			int		nWidth = GetLineNumWidthMyList( p->hWndListBoxHi, TRUE );
			rectEdit.left += nWidth;
			if( nWidth > 0 ) {
				RECT	rect;
				GetWindowRect( p->hWndMyEdit, &rect );
				ScreenToClientRect( hWnd, &rect );
				if( rect.top != rectEdit.top || rect.bottom != rectEdit.bottom ) {
					InvalidateRect( hWnd, NULL, TRUE );
				}
			}
		}
		
		MyMoveWindow( p->hWndMyEdit,     &rectEdit,    TRUE );
		MyMoveWindow( p->hWndListBoxLow, &rectListLow, TRUE );
		MyMoveWindow( p->hWndListBoxHi,  &rectListHi,  TRUE );
		
		SetPosIndexMyList( p->hWndListBoxLow, p->nCurrentLine+1, POS_INDEX_TOP    );
		SetPosIndexMyList( p->hWndListBoxHi,  p->nCurrentLine-1, POS_INDEX_BOTTOM );
		SetInfoScrollBar( p->hWndScrollBar, GetShownLineCntMyList( p->hWndListBoxLow, TRUE ) );
	}
}

/*	w肵sւ̈ړ	*/
void	DoMove( HWND hWnd, int nLine )
{
	NpXsInfo	p = GetXsInfo( hWnd );
	if( p != NULL ) {
		if( p->nCurrentLine != nLine ) {
			LPCTSTR	q;
			BOOL	bIsComment, bIsMark;
			
			p->nCurrentLine = nLine;
			SetPosIndexMyList( p->hWndListBoxLow, p->nCurrentLine+1, POS_INDEX_TOP    );
			SetPosIndexMyList( p->hWndListBoxHi,  p->nCurrentLine-1, POS_INDEX_BOTTOM );
			SetPosScrollBar( p->hWndScrollBar, p->nCurrentLine );
			
			/*	ړ̓eҏWsɓ	*/
			q = GetTextMyList( p->hWndListBoxLow, p->nCurrentLine );
			bIsComment = IsCommentMyList( p->hWndListBoxLow, p->nCurrentLine );
			bIsMark = IsMarkMyList( p->hWndListBoxLow, p->nCurrentLine );
			SetTextMyEdit( p->hWndMyEdit, q, bIsComment, bIsMark );
			RedrawWindow( p->hWndMyEdit, NULL, NULL, RDW_INVALIDATE|RDW_UPDATENOW );
			/*	{[hȂJ[\͐擪Ao[hȂŌ	*/
			if( !p->bViewMode && p->bCaretRight ) {
				DoLastMyEdit( p->hWndMyEdit );
			} else {
				DoTopMyEdit( p->hWndMyEdit );
			}
			
			if( p->bUseImsApi && p->hWndIms != NULL && IsWindow( p->hWndIms ) ) {
				if( !( p->bHelpMe || p->bViewMode ) ) {
					COPYDATASTRUCT	cds;
					ZeroMemory( &cds, sizeof(cds) );
					cds.dwData = p->uImsApiMessage;
					cds.cbData = lstrlen( q );
					cds.lpData = (PVOID)q;
					SendMessage( p->hWndIms, WM_COPYDATA, (WPARAM)hWnd, (LPARAM)&cds );
				}
			}
			if( p->hWndXsd != NULL ) {
				if( GetActiveWindow() == hWnd && !p->bViewMode ) {
					/*	ANeBuőo[h̎́A	*/
					/*	f[ʂđ̂𓯊XN[	*/
					p->XsdApiInfo.uEventID = XSD_API_EVENT_SCROLL;
					p->XsdApiInfo.hWndFrom = hWnd;
					p->XsdApiInfo.wParam = (WPARAM)(p->nCurrentLine);
					p->XsdApiInfo.lParam = 0;
					CopyMemory( p->XsdApiInfo.md5FileName, p->md5FileName, sizeof(p->md5FileName) );
					DoXsdEvent( hWnd );
					Sleep(20);
				}
			}
			
			/*	sԍ̕`	*/
			InvalidateRect( hWnd, NULL, TRUE );
			RedrawWindow( hWnd, NULL, NULL, RDW_INVALIDATE|RDW_UPDATENOW );
		}
	}
}

/*	w肵R}hqɎ|bvAbvڂT	*/
static	int		NEAR	IsMenuHaveChildItem( HMENU hMenuPopup, UINT nChildID )
{
	int		i, cnt;
	cnt = GetMenuItemCount( hMenuPopup );
	for( i = 0; i < cnt; i++ ) {
		if( GetMenuItemID( hMenuPopup, i ) == 0xffffffff ) {
			HMENU	h = GetSubMenu( hMenuPopup, i );
			int		j, cnt2;
			cnt2 = GetMenuItemCount( h );
			for( j = 0; j < cnt2; j++ ) {
				if( GetMenuItemID( h, j ) == nChildID ) {
					return( i );
				}
			}
		}
	}
	return( -1 );
}

/*	w肵R}hqɎ|bvAbvڂL/	*/
static	void	NEAR	EnablePopupItem( HMENU hMenuPopup, UINT nChildID, BOOL bEnable )
{
	int		nItem = IsMenuHaveChildItem( hMenuPopup, nChildID );
	if( nItem >= 0 ) {
		EnableMenuItem( hMenuPopup, nItem, MF_BYPOSITION|(bEnable?MF_ENABLED:MF_GRAYED) );
	}
}

/*	WM_INITMENUPOPUP	*/
BOOL	NEAR	InitMenuPopup( HWND hWnd, HMENU hMenuPopup, UINT uPos, BOOL fSystemMenu )
{
	NpXsInfo	p = GetXsInfo( hWnd );
	if( p != NULL ) {
		BOOL	flag, flag2;
		/*	[t@C(F)]	*/
		/*	[(T)]	*/
		flag = !( p->szFilePath[0] == _T('\0') );
		EnableMenuItem( hMenuPopup, ID_FILE_CLOSE, !flag?MF_GRAYED:MF_ENABLED );
		/*	[sԍtŕۑ(N)...]	*/
		flag = ( flag && !p->bEditMode );
		EnableMenuItem( hMenuPopup, ID_FILE_SAVE_NUM, !flag?MF_GRAYED:MF_ENABLED );
		/*	[](T)]	*/
		flag = !( p->bViewMode || p->bHelpMe || p->szFilePath[0] == _T('\0') || p->bEditMode );
		EnableMenuItem( hMenuPopup, ID_FILE_SEND, !flag?MF_GRAYED:MF_ENABLED );
		/*	[㏑ۑ(S)]	*/
		/*	[Otĕۑ(A)]	*/
		flag = p->bEditMode;
		EnableMenuItem( hMenuPopup, ID_FILE_SAVE_AS, !flag?MF_GRAYED:MF_ENABLED );
		EnableMenuItem( hMenuPopup, ID_FILE_SAVE,    !flag?MF_GRAYED:MF_ENABLED );
		
		/*	[ҏW(E)]	*/
		if( p->bEditMode ) {
			/*	[蒼(U)]	*/
			flag = CanUndoMyScintilla( p->hWndMySci );
			EnableMenuItem( hMenuPopup, ID_EDIT_UNDO, !flag?MF_GRAYED:MF_ENABLED );
			/*	[蒼̂蒼(R)]	*/
			flag = CanRedoMyScintilla( p->hWndMySci );
			EnableMenuItem( hMenuPopup, ID_EDIT_REDO, !flag?MF_GRAYED:MF_ENABLED );
			/*	[؂(T)] [Rs[(C)]	*/
			flag = IsSelectedMyScintilla( p->hWndMySci );
			EnableMenuItem( hMenuPopup, ID_EDIT_COPY, !flag?MF_GRAYED:MF_ENABLED );
			EnableMenuItem( hMenuPopup, ID_EDIT_CUT,  !flag?MF_GRAYED:MF_ENABLED );
			/*	[\t(P)]	*/
			flag = CanPasteMyScintilla( p->hWndMySci );
			EnableMenuItem( hMenuPopup, ID_EDIT_PASTE, !flag?MF_GRAYED:MF_ENABLED );
			/*	[폜(D)]	*/
			EnableMenuItem( hMenuPopup, ID_EDIT_CLEAR, MF_ENABLED );
			/*	[ׂđI(A)]	*/
			EnableMenuItem( hMenuPopup, ID_EDIT_SELECT_ALL, MF_ENABLED );
			/*	֌W	*/
			flag = !( p->hWndFindDlg != NULL && IsWindow( p->hWndFindDlg ) );
			EnableMenuItem( hMenuPopup, ID_EDIT_FIND,      !flag?MF_GRAYED:MF_ENABLED );
			EnableMenuItem( hMenuPopup, ID_EDIT_REPLACE,   !flag?MF_GRAYED:MF_ENABLED );
			flag = !( !flag || p->szFindText[0] == _T('\0') );
			EnableMenuItem( hMenuPopup, ID_EDIT_FIND_PREV, !flag?MF_GRAYED:MF_ENABLED );
			EnableMenuItem( hMenuPopup, ID_EDIT_FIND_NEXT, !flag?MF_GRAYED:MF_ENABLED );
			/*	}	*/
			EnablePopupItem( hMenuPopup, ID_EDIT_INS_MARK, TRUE );
			EnableMenuItem( hMenuPopup, ID_EDIT_INS_MARK,    MF_ENABLED );
			EnableMenuItem( hMenuPopup, ID_EDIT_INS_COMMENT, MF_ENABLED );
		} else {
			flag2 = !( p->bHelpMe || p->bViewMode );
			/*	[蒼(U)]	*/
			flag = CanUndoMyEdit( p->hWndMyEdit );
			flag = flag && flag2;
			EnableMenuItem( hMenuPopup, ID_EDIT_UNDO, !flag?MF_GRAYED:MF_ENABLED );
			/*	[蒼̂蒼(R)]	*/
			EnableMenuItem( hMenuPopup, ID_EDIT_REDO, MF_GRAYED );
			/*	[؂(T)] [Rs[(C)]	*/
			flag = IsSelectedMyEdit( p->hWndMyEdit );
			EnableMenuItem( hMenuPopup, ID_EDIT_COPY, !flag?MF_GRAYED:MF_ENABLED );
			flag = flag && flag2;
			EnableMenuItem( hMenuPopup, ID_EDIT_CUT, !flag?MF_GRAYED:MF_ENABLED );
			/*	[\t(P)]	*/
			flag = CanPasteMyEdit( p->hWndMyEdit );
			flag = flag && flag2;
			EnableMenuItem( hMenuPopup, ID_EDIT_PASTE, !flag?MF_GRAYED:MF_ENABLED );
			/*	[폜(D)]	*/
			flag = HasTextMyEdit( p->hWndMyEdit );
			flag = flag && flag2;
			EnableMenuItem( hMenuPopup, ID_EDIT_CLEAR, !flag?MF_GRAYED:MF_ENABLED );
			/*	[ׂđI(A)]	*/
			EnableMenuItem( hMenuPopup, ID_EDIT_SELECT_ALL, MF_GRAYED );
			/*	֌W	*/
			EnableMenuItem( hMenuPopup, ID_EDIT_FIND,      MF_GRAYED );
			EnableMenuItem( hMenuPopup, ID_EDIT_FIND_PREV, MF_GRAYED );
			EnableMenuItem( hMenuPopup, ID_EDIT_FIND_NEXT, MF_GRAYED );
			EnableMenuItem( hMenuPopup, ID_EDIT_REPLACE,   MF_GRAYED );
			/*	}	*/
			EnablePopupItem( hMenuPopup, ID_EDIT_INS_MARK, FALSE );
			EnableMenuItem( hMenuPopup, ID_EDIT_INS_MARK,    MF_GRAYED );
			EnableMenuItem( hMenuPopup, ID_EDIT_INS_COMMENT, MF_GRAYED );
		}
		/*	[(O)]	*/
		/*	[ҏWs𑗏o(S)] [s𑗏o(C)]	*/
		flag = !( p->bHelpMe || p->bViewMode );
		EnableMenuItem( hMenuPopup, ID_OPERATE_SEND_ALL,  !flag?MF_GRAYED:MF_ENABLED );
		EnableMenuItem( hMenuPopup, ID_OPERATE_SEND_NULL, !flag?MF_GRAYED:MF_ENABLED );
		flag = ( flag && !p->bEditMode );
		EnableMenuItem( hMenuPopup, ID_OPERATE_SEND_PART, !flag?MF_GRAYED:MF_ENABLED );
		/*	[łv(H)]	*/
		CheckMenuItem( hMenuPopup, ID_OPERATE_HELP_ME, p->bHelpMe?MF_CHECKED:MF_UNCHECKED );
		flag = !( p->bViewMode );
		EnableMenuItem( hMenuPopup, ID_OPERATE_HELP_ME, !flag?MF_GRAYED:MF_ENABLED );
		/*	[{Ӱ(V)]	*/
		CheckMenuItem( hMenuPopup, ID_OPERATE_VIEW_MODE, p->bViewMode?MF_CHECKED:MF_UNCHECKED );
		flag = !( !p->bViewMode && p->bHelpMe );
		EnableMenuItem( hMenuPopup, ID_OPERATE_VIEW_MODE, !flag?MF_GRAYED:MF_ENABLED );
		/*	[ҏWӰ(D)]	*/
		CheckMenuItem( hMenuPopup, ID_OPERATE_EDIT_MODE, p->bEditMode?MF_CHECKED:MF_UNCHECKED );
		flag = ( p->hWndMySci != NULL && IsWindow( p->hWndMySci ) );
		EnableMenuItem( hMenuPopup, ID_OPERATE_EDIT_MODE, !flag?MF_GRAYED:MF_ENABLED );
		
		/*	[ړ(M)]	*/
		/*	[Oϰ(P)]/[ϰ(N)]/[ꗗ(L)]	*/
		flag = !( p->szFilePath[0] == _T('\0') );
		if( p->bEditMode ) {
			flag = ( flag || GetLengthMyScintilla( p->hWndMySci ) > 0 );
		}
		EnableMenuItem( hMenuPopup, ID_MOVE_PREV_MARK, !flag?MF_GRAYED:MF_ENABLED );
		EnableMenuItem( hMenuPopup, ID_MOVE_NEXT_MARK, !flag?MF_GRAYED:MF_ENABLED );
		EnableMenuItem( hMenuPopup, ID_MOVE_LIST_MARK, !flag?MF_GRAYED:MF_ENABLED );
		/*	[ެ(J)]	*/
		EnableMenuItem( hMenuPopup, ID_MOVE_JUMP,      !flag?MF_GRAYED:MF_ENABLED );
		/*	[۰ٱ][۰޳]	*/
		flag = ( flag && p->bEditMode );
		EnableMenuItem( hMenuPopup, ID_MOVE_ROLLUP,    !flag?MF_GRAYED:MF_ENABLED );
		EnableMenuItem( hMenuPopup, ID_MOVE_ROLLDOWN,  !flag?MF_GRAYED:MF_ENABLED );
		
		/*	[\(V)]	*/
		CheckMenuItem( hMenuPopup, ID_VIEW_TOOLBAR,    p->bShowToolbar  ?MF_CHECKED:MF_UNCHECKED );
		CheckMenuItem( hMenuPopup, ID_VIEW_NEWLINE,    p->bShowNewLine  ?MF_CHECKED:MF_UNCHECKED );
		CheckMenuItem( hMenuPopup, ID_VIEW_LINENUM,    p->bShowLineNum  ?MF_CHECKED:MF_UNCHECKED );
		CheckMenuItem( hMenuPopup, ID_VIEW_SCROLL_BAR, p->bShowScrollBar?MF_CHECKED:MF_UNCHECKED );
        CheckMenuItem( hMenuPopup, ID_VIEW_EDGE,       p->bShowEdge     ?MF_CHECKED:MF_UNCHECKED );
		CheckMenuItem( hMenuPopup, ID_VIEW_STATUS_BAR, p->bShowStatusBar?MF_CHECKED:MF_UNCHECKED );
		flag = p->bEditMode;
		EnableMenuItem( hMenuPopup, ID_VIEW_SCROLL_BAR,  flag?MF_GRAYED:MF_ENABLED );
		EnableMenuItem( hMenuPopup, ID_VIEW_EDGE,       !flag?MF_GRAYED:MF_ENABLED );
		/*	c[o[͕\ACR\H	*/
		EnableMenuItem( hMenuPopup, ID_VIEW_TOOLBAR_TEXT, !p->bShowToolbar?MF_GRAYED:MF_ENABLED );
		EnableMenuItem( hMenuPopup, ID_VIEW_TOOLBAR_ICON, !p->bShowToolbar?MF_GRAYED:MF_ENABLED );
		CheckMenuRadioItem( hMenuPopup, ID_VIEW_TOOLBAR_TEXT, ID_VIEW_TOOLBAR_ICON, p->bBitmapOnToolbar?ID_VIEW_TOOLBAR_ICON:ID_VIEW_TOOLBAR_TEXT, MF_BYCOMMAND );
		
		/*	õReLXgj[	*/
		if( p->bUseDde ) {
			SetMenuDefaultItem( hMenuPopup, ID_DDE_SEARCH_SERVER, FALSE );
		} else {
			SetMenuDefaultItem( hMenuPopup, ID_DDE_EDITSEND_WINDOW, FALSE );
		}
		flag = p->bCanUseEditSend;
		EnableMenuItem( hMenuPopup, ID_DDE_EDITSEND_WINDOW, !flag?MF_GRAYED:MF_ENABLED );
		EnableMenuItem( hMenuPopup, ID_DDE_EDITSEND_MESSAGE, !flag?MF_GRAYED:MF_ENABLED );
		/*	c[o[̃ReLXgj[	*/
		SetMenuDefaultItem( hMenuPopup, ID_TB_RESIZE, FALSE );
	}
	UNUSE( uPos );
	UNUSE( fSystemMenu );
	return FALSE;
}

/*	WM_CONTEXTMENU	*/
void	NEAR	ContextMenuProc( HWND hWnd, HWND hWndFrom, int xPos, int yPos )
{
	NpXsInfo	p = GetXsInfo( hWnd );
	UINT	flag = TPM_LEFTALIGN|TPM_RIGHTBUTTON;
	HMENU	hMenuPopup = NULL;
	HMENU	hMenu = NULL;
	if( p == NULL ) {
		return;
	}
	if( xPos >= 0 && yPos >= 0 &&
		SendMessage( hWnd, WM_NCHITTEST, 0, MAKELPARAM( xPos, yPos ) ) != HTCLIENT ) {
		return;	/*	^Cgo[ŉENbN΍(2000/11/06)	*/
	}
	if( hWndFrom == p->hWndMySci ) {
		hMenu = GetSubMenu( GetMenu( hWnd ), 1 );
		if( xPos < 0 || yPos < 0 ) {
			GetContextMenuPosMyScintilla( p->hWndMySci, &xPos, &yPos );
		}
	} else {
		hMenuPopup = LoadMenu( p->hInstance, MAKEINTRESOURCE( IDR_MENU_POPUP ) );
		if( hMenuPopup != NULL ) {
			if( hWndFrom == p->hWndStatusBar ) {
				hMenu = GetSubMenu( hMenuPopup, 0 );
			} else if( hWndFrom == p->hWndToolBar ) {
				hMenu = GetSubMenu( hMenuPopup, 1 );
			}
		}
	}
	if( hMenu != NULL ) {
		if( hWndFrom == p->hWndStatusBar ) {
			/*	DDET[o[j[o^	*/
			int		cnt = GetMenuItemCount( hMenu );
			int		pos = -1;
			int		i;
			UINT	uID;
			/*	T[rX̍ڂ}ʒuT	*/
			for( i = 0; i < cnt; i++ ) {
				uID = GetMenuItemID( hMenu, i );
				if( uID == ID_DDE_SERVER_LIST0 || uID == ID_DDE_SERVER_LIST1 ) {
					pos = i;
					break;
				}
			}
			if( pos >= 0 ) {
				TCHAR	fmt[ _MAX_PATH ], txt[ _MAX_PATH ];
				UINT	uCheckedItem = 0;
				
				LoadString( p->hInstance, IDS_DDE_MENU_FMT, fmt, 40 );	//	"&%d DDE(%s)"
				
				/*	폜	*/
				for( i = ID_DDE_SERVER_LIST0; i <= ID_DDE_SERVER_LIST_LAST; i++ ) {
					DeleteMenu( hMenu, i, MF_BYCOMMAND );
				}
				/*	ݑIĂT[rX	*/
				for( i = 0; i < p->nDdeServiceArry; i++ ) {
					if( lstrcmp( p->szDdeServiceArray[i], p->szDdeServerName ) == 0 ) {
						break;
					}
				}
				if( i == p->nDdeServiceArry ) {
					/*	Xgɖ}	*/
					wsprintf( txt, fmt, 0, p->szDdeServerName );
					uID = ID_DDE_SERVER_LIST0;
					InsertMenu( hMenu, pos++, MF_BYPOSITION|MF_STRING, uID, txt );
					uCheckedItem = uID;
				}
				/*	Xg̃T[rX	*/
				uID = ID_DDE_SERVER_LIST1;
				for( i = 0; i < p->nDdeServiceArry; i++ ) {
					wsprintf( txt, fmt, i+1, p->szDdeServiceArray[ i ] );
					InsertMenu( hMenu, pos++, MF_BYPOSITION|MF_STRING, uID, txt );
					if( lstrcmp( p->szDdeServiceArray[i], p->szDdeServerName ) == 0 ) {
						uCheckedItem = uID;
					}
					if( ++uID > ID_DDE_SERVER_LIST_LAST ) {
						break;
					}
				}
				/*	IĂ`FbN(WIACe)	*/
				if( uCheckedItem != 0 ) {
					CheckMenuRadioItem( hMenu, ID_DDE_SERVER_LIST0, ID_DDE_SERVER_LIST_LAST, uCheckedItem, MF_BYCOMMAND );
				}
			}
		}
		TrackPopupMenu( hMenu, flag, xPos, yPos, 0, hWnd, NULL );
	}
	if( hMenuPopup != NULL ) {
		DestroyMenu( hMenuPopup );
	}
}

/*	WM_VSCROLL	*/
BOOL	NEAR	VScrollProc( HWND hWnd, int nScrollCode, int nPos, HWND hWndScrollBar )
{
	NpXsInfo	p = GetXsInfo( hWnd );
	BOOL	ret = FALSE;
	if( p != NULL ) {
		int		nLoc = p->nCurrentLine;
		int		nPage = GetShownLineCntMyList( p->hWndListBoxLow, TRUE );
		switch( nScrollCode ) {
		case SB_BOTTOM:			nLoc = p->nLineCnt;		break;
		case SB_ENDSCROLL:								break;
		case SB_LINEDOWN:		nLoc++;					break;
		case SB_LINEUP:			nLoc--;					break;
		case SB_PAGEDOWN:		nLoc += nPage;			break;
		case SB_PAGEUP:			nLoc -= nPage;			break;
		case SB_THUMBPOSITION:	nLoc = nPos;			break;
		case SB_THUMBTRACK:		nLoc = nPos;			break;
		case SB_TOP:			nLoc = 0;				break;
		}
		if( nLoc < 0 ) {
			nLoc = 0;
		}
		if( nLoc > p->nLineCnt ) {
			nLoc = p->nLineCnt;
		}
		DoMove( hWnd, nLoc );
		ret = TRUE;
	}
	UNUSE( hWndScrollBar );
	return( ret );
}

/*	WM_MOUSEWHEEL	*/
BOOL	NEAR	MouseWheelProc( HWND hWnd, WORD fwKeys, short zDelta, int xPos, int yPos )
{
	BOOL	ret = FALSE;
	RECT	rect;
	POINT	pt;
	pt.x = xPos;
	pt.y = yPos;
	ScreenToClient( hWnd, &pt );
	GetClientRect( hWnd, &rect );
	if( PtInRect( &rect, pt ) ) {	/*	}EXNCAg̈̎(c[o[ƂXe[^Xo[܂)	*/
		NpXsInfo	p = GetXsInfo( hWnd );
		if( p != NULL ) {
			int		nLoc = p->nCurrentLine;
			int		nPage = GetShownLineCntMyList( p->hWndListBoxLow, TRUE ) / 3;	/*	1/3y[W	*/
			if( nPage < 1 ) {
				nPage = 1;
			}
			if( zDelta > 0 ) {
				nLoc -= nPage;
			} else if( zDelta < 0 ) {
				nLoc += nPage;
			}
			if( nLoc < 0 ) {
				nLoc = 0;
			}
			if( nLoc > p->nLineCnt ) {
				nLoc = p->nLineCnt;
			}
			DoMove( hWnd, nLoc );
			ret = TRUE;
		}
	}
	UNUSE( fwKeys );
	return( ret );
}

/*	WM_PAINT	*/
void	NEAR	PaintProc( HWND hWnd )
{
	NpXsInfo	p = GetXsInfo( hWnd );
	HDC			hDC;
	PAINTSTRUCT	ps;
	
	hDC = BeginPaint( hWnd, &ps );
	if( ps.fErase ) {
		/*	wihԂ	*/
		HBRUSH	hBrush;
		hBrush = CreateSolidBrush( GetSysColor( COLOR_BTNFACE ) );
		FillRect( hDC, &ps.rcPaint, hBrush );
		DeleteObject( hBrush );
	}
	/*	sԍ\	*/
	if( p != NULL && p->bShowLineNum ) {
		TCHAR	buff[20];
		int		nLen = GetLineNumStrMyList( p->hWndListBoxHi, buff, p->nCurrentLine );
		if( nLen > 0 ) {
			RECT	rect;
			RECT	rectEdit, rectList;
			HFONT	hOldFont;
			UINT	nOldTextAlign;
			int		nWidth;
			
			/*	{Ƃ̋E	*/
			buff[--nLen] = _T('\0');
			
//			GetClientRect( p->hWndMyEdit, &rectEdit );
			GetRectMyEdit( p->hWndMyEdit, &rectEdit );
			ClientToScreenRect( p->hWndMyEdit, &rectEdit );
			ScreenToClientRect( hWnd, &rectEdit );
			GetClientRect( p->hWndListBoxHi, &rectList );
			ClientToScreenRect( p->hWndListBoxHi, &rectList );
			ScreenToClientRect( hWnd, &rectList );
			
			rect = rectEdit;
			rect.left = rectList.left + 1;
			
			hOldFont = (HFONT)SelectObject( hDC, p->hFont );
			SetBkColor( hDC, GetSysColor( COLOR_BTNFACE ) );
			SetTextColor( hDC, GetSysColor( COLOR_BTNTEXT ) );
			
			nOldTextAlign = SetTextAlign( hDC, TA_TOP|TA_RIGHT );	/*	El	*/
			nWidth = GetLineNumWidthMyList( p->hWndListBoxHi, FALSE );
			rect.right = rect.left + nWidth;
			ExtTextOut( hDC, rect.right, rect.top, ETO_CLIPPED|ETO_OPAQUE, &rect, buff, nLen, NULL );
			if( IsMarkMyList( p->hWndListBoxHi, p->nCurrentLine ) ) {
				/*	}[Nsł͑ɂ	*/
				int		nOldBkMode = SetBkMode( hDC, TRANSPARENT );
				ExtTextOut( hDC, rect.right+1, rect.top, ETO_CLIPPED, &rect, buff, nLen, NULL );
				SetBkMode( hDC, nOldBkMode );
			}
			SetTextAlign( hDC, nOldTextAlign );
			
			SelectObject( hDC, hOldFont );
		}
	}
	EndPaint( hWnd, &ps );
}

/*	WM_MENUSELECT	*/
void	NEAR	MenuSelectProc( HWND hWnd, UINT uItem, UINT fuFlags, HMENU hMenu )
{
	NpXsInfo	p = GetXsInfo( hWnd );
	if( p != NULL ) {
		TCHAR	buff[ MAX_STATUS_BAR_TEXT ];
		if( uItem >= ID_DDE_SERVER_LIST0 && uItem <= ID_DDE_SERVER_LIST_LAST ) {
			uItem = ID_DDE_SERVER_LIST0;
		}
		if( uItem >= ID_FILE_MRU_FILE1 && uItem <= ID_FILE_MRU_FILE16 ) {
			uItem = ID_FILE_MRU_FILE1;
		}
		switch( uItem ) {
		case SC_SIZE:		uItem = IDS_SC_SIZE;		break;
		case SC_MOVE:		uItem = IDS_SC_MOVE;		break;
		case SC_MINIMIZE:	uItem = IDS_SC_MINIMIZE;	break;
		case SC_MAXIMIZE:	uItem = IDS_SC_MAXIMIZE;	break;
		case SC_NEXTWINDOW:	uItem = IDS_SC_NEXTWINDOW;	break;
		case SC_PREVWINDOW:	uItem = IDS_SC_PREVWINDOW;	break;
		case SC_CLOSE:		uItem = IDS_SC_CLOSE;		break;
		case SC_RESTORE:	uItem = IDS_SC_RESTORE;		break;
		case SC_TASKLIST:	uItem = IDS_SC_TASKLIST;	break;
		}
		if( ( fuFlags & (MF_SEPARATOR|MF_POPUP) ) != 0 || 
			LoadString( p->hInstance, uItem, buff, MAX_STATUS_BAR_TEXT ) == 0 ) {
			buff[0] = _T('\0');
		}
		if( ( fuFlags & MF_POPUP ) != 0 ) {
			/*	|bvAbvڂ̃`FbN	*/
			typedef	struct	tagPopupMenuCheckType	{
				UINT	uItem1;
				UINT	uItem2;
			}	PopupMenuCheckType;
			PopupMenuCheckType	pmc[] = {
				ID_FILE_OPEN,			IDS_POPUP_FILE,
				ID_EDIT_COPY,			IDS_POPUP_EDIT,
				ID_OPERATE_SEND_ALL,	IDS_POPUP_OPERATE,
				ID_MOVE_LIST_MARK,		IDS_POPUP_MOVE,
				ID_VIEW_FONT,			IDS_POPUP_VIEW,
				SC_SIZE,				IDS_POPUP_SYSTEM,
				ID_EDIT_INS_MARK,		IDS_POPUP_INSERT,
			};
			int		nCnt = sizeof(pmc) / sizeof(PopupMenuCheckType);
			int		i, nItem;
			for( i = 0; i < nCnt; i++ ) {
				nItem = IsMenuHaveChildItem( hMenu, pmc[i].uItem1 );
				if( nItem >= 0 && (UINT)nItem == uItem ) {
					if( LoadString( p->hInstance, pmc[i].uItem2, buff, MAX_STATUS_BAR_TEXT ) == 0 ) {
						buff[0] = _T('\0');
					}
					break;
				}
			}
		}
		ShowSimpleTextStatusBar( p->hWndStatusBar, buff );
	}
	UNUSE( hMenu );
}


/*	WM_DROPFILES	*/
BOOL	NEAR	DropFilesProc( HWND hWnd, HDROP hDrop )
{
	NpXsInfo	p = GetXsInfo( hWnd );
	BOOL	ret = FALSE;
	SetForegroundWindow( hWnd );
	if( p != NULL ) {
		UINT	nCnt = DragQueryFile( hDrop, UINT_MAX, NULL, 0 );	/*	t@C	*/
		LPTSTR*	pArray = (LPTSTR*)GlobalAlloc( GPTR, sizeof(LPTSTR)*nCnt );
		UINT	i;
		if( pArray != NULL ) {
#ifdef	ENABLE_LOAD
			BOOL	bShiftDown = TRUE;
#else
			BOOL	bShiftDown = ( ( (WORD)GetKeyState( VK_SHIFT ) & 0xff00 ) != 0 );
#endif
			/*	t@C̈ꗗ쐬	*/
			TCHAR	szPath[_MAX_PATH];
			LPTSTR	buff;
			for( i = 0; i < nCnt; i++ ) {
				DragQueryFile( hDrop, i, szPath, _MAX_PATH );
				buff = (LPTSTR)GlobalAlloc( GPTR, sizeof(TCHAR)*(lstrlen(szPath)+1) );
				if( buff != NULL ) {
					pArray[i] = buff;
					lstrcpy( buff, szPath );
				}
			}
			
			/*	J/ǂݍ	*/
			SendMessage( hWnd, WM_XS_OPEN_MULTI_FILE, MAKEWPARAM( bShiftDown, nCnt ), (LPARAM)pArray );
			
			/*		*/
			for( i = 0; i < nCnt; i++ ) {
				if( pArray[i] != NULL ) {
					GlobalFree( (HGLOBAL)pArray[i] );
				}
				pArray[i] = NULL;
			}
			GlobalFree( (HGLOBAL)pArray );
			ret = TRUE;
		}
		DragFinish( hDrop );
	}
	return( ret );
}

/*	IMS-APĨbZ[W	*/
void	NEAR	ImsApiMsgProc( HWND hWnd, WPARAM wParam, LPARAM lParam )
{
	NpXsInfo	p = GetXsInfo( hWnd );
	
//	MYTRACE( "IMS-API wParam=%08lx, lParam=%08lx\n", wParam, lParam );
	switch( wParam ) {
	case IMS_API_ACK_SERVER:
		if( p->bImsSearching && p->hWndIms == NULL ) {
			HWND	hWndServer = (HWND)lParam;
			if( InSendMessage() ) {
				ReplyMessage( 0 );
			}
			p->hWndIms = hWndServer;
		}
		break;
	case IMS_API_STARTUP_SERVER:
		if( p->bUseImsApi && p->hWndIms == NULL ) {
			PostMessage( hWnd, WM_IMS_SEARCH_SERVER, 0, 0 );
		}
		break;
	case IMS_API_QUIT_SERVER:
		if( p->hWndIms == (HWND)lParam ) {
			p->hWndIms = NULL;
		}
		break;
	}
}

/*	WM_COPYDATA	*/
BOOL	NEAR	CopyDataProc( HWND hWnd, HWND hWndFrom, PCOPYDATASTRUCT pcds )
{
	NpXsInfo	p = GetXsInfo( hWnd );
	BOOL	ret = FALSE;
	if( p != NULL && hWndFrom != NULL && IsWindow( hWndFrom ) && pcds != NULL ) {
		if( pcds->dwData == p->uXsdApiMsg ) {
			/*	f[痈Cxg	*/
			ParseXsdEvent( hWnd, hWndFrom, pcds );
			ret = TRUE;
		} else if( pcds->dwData == (DWORD)MAKELONG( p->uXsIpcMessage, XS_IPC_CMD_ADD_MRU ) ) {
			/*	t@C̍XV	*/
			TCHAR	szPath[ _MAX_PATH ];
			lstrcpy( szPath, (LPCTSTR)pcds->lpData );
			AddFileMruList( &(p->FileMruInfo), szPath, p->hFileMenu );
			ret = TRUE;
		} else if( pcds->dwData == (DWORD)MAKELONG( p->uXsIpcMessage, XS_IPC_CMD_FONT ) ) {
			/*	tHg̕ύX	*/
			CopyMemory( &(p->lfText), pcds->lpData, sizeof(LOGFONT) );
			p->hFont = MyCreateFont( hWnd, p->hFont, &(p->lfText) );
			p->hFontNewLine = MyCreateNewLineFont( p->hFont, p->hFontNewLine );
			SetFontMyEdit( p->hWndMyEdit, p->hFont, p->hFontNewLine );
			SetFontMyList( p->hWndListBoxLow, p->hFont, p->hFontNewLine );
			SetFontMyList( p->hWndListBoxHi, p->hFont, p->hFontNewLine );
			InvalidateRect( hWnd, NULL, TRUE );
			RecalcLayout( hWnd );
			ret = TRUE;
		}
	}
	return( ret );
}

/*	WM_TIMER	*/
void	NEAR	TimerProc( HWND hWnd, UINT uTimerID )
{
	NpXsInfo	p = GetXsInfo( hWnd );
	if( p != NULL ) {
		if( p->IdleInfo.uTimerID != 0 && p->IdleInfo.uTimerID == uTimerID ) {
			DWORD	dwTick = GetTickCount();
			if( !( p->IdleInfo.bIsIdle ) ) {
				/*	OA}EX/L[{[h삳ꂽ5bo߂Ă΁AACh	*/
				p->IdleInfo.bIsIdle = ( GetTickDiff( dwTick, p->IdleInfo.dwLastTick ) > 5000 );
			}
			if( p->IdleInfo.bIsIdle || GetTickDiff( dwTick, p->IdleInfo.dwLastTick ) > 1000 ) {
				/*	ACh͍Ō̑삩1boߌ	*/
				if( p->DdeInfo.nClientStatus == DDE_STAT_NONE &&
					IsWindowEnabled( hWnd ) &&
					GetLastActivePopup( hWnd ) == hWnd ) {
					/*
						EDDEł͂Ȃ(Aڑ)
						EEBhEL([__CAOȂ)
						E|bvAbvEBhE([__CAO)
					*/
					BOOL	bUpdate = FALSE;
					if( p->bUseDde ) {
						/*	DDET[o[̑݃`FbN	*/
						BOOL	bExist;
						bExist = InitiateDDE( hWnd, &(p->DdeInfo), p->hWndLastServer );
						if( bExist ) {
							p->hWndLastServer = p->DdeInfo.hWndServer;
							/*	TerminateDDE()Ȃ	*/
						} else {
							p->hWndLastServer = NULL;
						}
						if( p->bFoundServer != bExist ) {
							p->bFoundServer = bExist;
							bUpdate = TRUE;
						}
					} else {
						/*	EditSend̑MEBhE`FbN	*/
						HWND	hWndTarget = p->EdsApiInfo.hWndTarget;
						BOOL	bExist = ( hWndTarget != NULL && IsWindow( hWndTarget ) );
						if( p->bCanSendEditSend != bExist ) {
							p->bCanSendEditSend = bExist;
							bUpdate = TRUE;
						}
					}
					if( bUpdate ) {
						ShowStatusBarIcon( p );
/*
						ƁAXe[^Xo[̕\肷B
						ȂŁH
						InvalidateRect( p->hWndStatusBar, NULL, TRUE );
*/
					}
				}
			}
		}
	}
}

/*	WM_NOTIFY	*/
void	NEAR	NotifyProc( HWND hWnd, int idCtrl, LPNMHDR pnmh )
{
	NpXsInfo	p = GetXsInfo( hWnd );
	if( p != NULL ) {
		if( idCtrl == ID_SCINTILLA && IsWindow( p->hWndMySci ) ) {
			if( NotifyProcMyScintilla( p->hWndMySci, pnmh, &(p->FileInfo.MarkCommentInfo) ) ) {
				ShowCaption( hWnd );
				SetStateToolBar( p->hWndToolBar, p->szFilePath[0] != _T('\0'), p->bHelpMe, p->bViewMode, p->hWndMySci, p->bEditMode );
			}
			return;
		}
		if( pnmh->code == TTN_NEEDTEXT && !p->bNoTooltip ) {
			LPTOOLTIPTEXT	lptip = (LPTOOLTIPTEXT)pnmh;
			if( pnmh->hwndFrom == GetToolTipHwndToolBar( p->hWndToolBar ) ) {
				/*	c[o[̃c[`bv(o[wv)	*/
				lptip->hinst = p->hInstance;
				lptip->lpszText = GetToolTipTextToolBar( lptip->hdr.idFrom, p->bMultilineTip );
			} else if( pnmh->hwndFrom == p->hWndToolTip ) {
				/*	CEBhE(EDIT/LISTBOX)̃c[`bv	*/
				NeedTextMyToolTip( p->hWndToolTip, p->hInstance, lptip );
				/*	
					TOOLTIPTEXT::lpszTextɃ\[XIDZbg@ł
					80܂ł\ĂȂB
				*/
			}
		}
	}
}

/*	WM_CLOSE	*/
BOOL	NEAR	CloseProc( HWND hWnd )
{
	NpXsInfo	p = GetXsInfo( hWnd );
	BOOL	ret = FALSE;		//	IȂFALSE
	if( p != NULL ) {
		if( p->bEditMode && IsModifiedMyScintilla( p->hWndMySci ) ) {
			/*	ҏW[hōXVĂB	*/
			/*	ۑ邩ǂmFB	*/
			TCHAR	msg[ 256 ];
			int		sel;
			LoadString( p->hInstance, IDS_CFM_SAVE, msg, 255 );
			sel = MessageBox( hWnd, msg, szXsAppName, MB_APPLMODAL|MB_DEFBUTTON1|MB_ICONEXCLAMATION|MB_YESNOCANCEL );
			if( sel == IDCANCEL ) {
				return TRUE;
			} else if( sel == IDYES ) {
				DoSendCommand( hWnd, ID_FILE_SAVE );
				if( IsModifiedMyScintilla( p->hWndMySci ) ) {
					return TRUE;
				}
			}
		}
		if( !p->bViewMode && p->szFilePath[0] != _T('\0') ) {
			/*	o[hŃt@CJ܂܁B	*/
			/*	IĂǂmFB	*/
			TCHAR	buff[ 256 ], msg[ 256 ];
			LoadString( p->hInstance, IDS_CFM_CLOSE, buff, 255 );
			wsprintf( msg, buff, p->szFileName );
			if( IDOK != MessageBox( hWnd, msg, szXsAppName, MB_APPLMODAL|MB_DEFBUTTON1|MB_ICONEXCLAMATION|MB_OKCANCEL ) ) {
				return TRUE;
			}
		}
		/*	t@C	*/
		DoCloseFile( hWnd );
		/*	INIt@C̏	*/
		WriteProfile( p, p->szProfile );
		/*	INIt@Cflush	*/
		WritePrivateProfileString( NULL, NULL, NULL, p->szProfile );
		/*	IMSƂ̘AgI	*/
		if( p->hWndIms != NULL && IsWindow( p->hWndIms ) ) {
			HWND	hWndMonitor;
			hWndMonitor = (HWND)SendMessage( p->hWndIms, p->uImsApiMessage, IMS_API_GET_MONITOR, 0 );
			if( hWndMonitor == p->hWndMyEdit ) {
				SendMessage( p->hWndIms, p->uImsApiMessage, IMS_API_SET_MONITOR, (LPARAM)NULL );
			}
			p->hWndIms = NULL;
		}
		/*	XSDƂ̘AgI	*/
		if( p->hWndXsd != NULL && IsWindow( p->hWndXsd ) ) {
			p->XsdApiInfo.uEventID = XSD_API_EVENT_QUIT;
			p->XsdApiInfo.hWndFrom = hWnd;
			DoXsdEvent( hWnd );
		}
	}
	return( ret );
}


/*	WM_DESTROY	*/
LRESULT	NEAR	DestroyProc( HWND hWnd )
{
	NpXsInfo	p = GetXsInfo( hWnd );
	if( p != NULL ) {
		/*	ҏWs	*/
		if( p->hWndMyEdit != NULL && IsWindow( p->hWndMyEdit ) ) {
			DestroyMyEdit( p->hWndMyEdit );
			p->hWndMyEdit = NULL;
		}
		/*	Xg{bNX()	*/
		if( p->hWndListBoxLow != NULL && IsWindow( p->hWndListBoxLow ) ) {
			DestroyMyList( p->hWndListBoxLow );
			p->hWndListBoxLow = NULL;
		}
		/*	Xg{bNX()	*/
		if( p->hWndListBoxHi != NULL && IsWindow( p->hWndListBoxHi ) ) {
			DestroyMyList( p->hWndListBoxHi );
			p->hWndListBoxHi = NULL;
		}
		/*	c[`bv	*/
		if( p->hWndToolTip != NULL && IsWindow( p->hWndToolTip ) ) {
			DestroyMyToolTip( p->hWndToolTip );
			p->hWndToolTip = NULL;
		}
		/*	c[o[	*/
		if( p->hWndToolBar != NULL && IsWindow( p->hWndToolBar ) ) {
			DestroyToolBar( p->hWndToolBar );
			p->hWndToolBar = NULL;
		}
		/*	Xe[^Xo[	*/
		if( p->hWndStatusBar != NULL && IsWindow( p->hWndStatusBar ) ) {
			DestroyStatusBar( p->hWndStatusBar );
			p->hWndStatusBar = NULL;
		}
		/*	Scintilla		*/
		if( p->hWndMySci != NULL && IsWindow( p->hWndMySci ) ) {
			DestroyMyScintilla( p->hWndMySci );
			p->hWndMySci = NULL;
		}
		/*	tHg폜	*/
		if( p->hFont != NULL ) {
			DeleteObject( p->hFont );
			p->hFont = NULL;
		}
		if( p->hFontNewLine != NULL ) {
			DeleteObject( p->hFontNewLine );
			p->hFontNewLine = NULL;
		}
		/*	t@C̏I	*/
		QuitFileMru( &(p->FileMruInfo) );
#ifdef	WIN32
		/*	StrFormatByteSize() shlwapi.dll	*/
		if( p->bMustFreeShlWapiDll && p->hInstShlWapiDll != NULL ) {
			FreeLibrary( p->hInstShlWapiDll );
		}
		p->bMustFreeShlWapiDll = FALSE;
		p->hInstShlWapiDll = NULL;
		p->lpStrFormatByteSize = NULL;
#endif
		/*	AChĎ^C}[~	*/
		if( p->IdleInfo.uTimerID != 0 ) {
			KillTimer( hWnd, p->IdleInfo.uTimerID );
			p->IdleInfo.uTimerID = 0;
		}
		/*	EditSendI	*/
		QuitEdsApi( &(p->EdsApiInfo) );
		/*	DDEI	*/
		TerminateDDE( hWnd, &(p->DdeInfo) );
		
		LocalFree( (HLOCAL)p );
		SetXsInfo( hWnd, NULL );
	}
	PostQuitMessage( 0 );
	return 0L;
}


/*	EBhEvV[W	*/
LRESULT	MYEXPORT	CALLBACK	XsWndProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	NpXsInfo	p = GetXsInfo( hWnd );
	switch( uMsg ) {
	case WM_CREATE:
		return CreateProc( hWnd, (LPCREATESTRUCT)lParam );
	case WM_XS_OPEN_FILE:
		XsOpenFileProc( hWnd, (LPCTSTR)lParam );
		break;
	case WM_XS_OPEN_MULTI_FILE:
		XsOpenMultiFileProc( hWnd, (BOOL)LOWORD( wParam ), (int)HIWORD(wParam), (LPCTSTR*)lParam );
		break;
	case WM_XS_STARTUP_XSD:
		XsStartupXsd( hWnd );
		break;
	case WM_SETFOCUS:
		if( SetFocusProc( hWnd, (HWND)wParam ) ) {
			return 0L;
		}
		break;
	case WM_WININICHANGE:
		if( p != NULL ) {
			/*	Xe[^Xo[č\z	*/
			if( p->hWndStatusBar != NULL ) {
				DestroyStatusBar( p->hWndStatusBar );
			}
			p->hWndStatusBar = CreateStatusBar( hWnd, ID_STATUSBAR, p->bShowStatusBar, p->bNoTooltip );
			ShowCaption( hWnd );
		}
		/*	̂܂ܗ	*/
	case WM_SIZE:
		RecalcLayout( hWnd );
		break;
	case WM_VSCROLL:
#ifdef	WIN32
		if( VScrollProc( hWnd, (int)LOWORD(wParam), (int)HIWORD(wParam), (HWND)lParam ) ) {
			return 0;
		}
#else
		if( VScrollProc( hWnd, (int)wParam, (int)LOWORD(lParam), (HWND)HIWORD(lParam) ) ) {
			return 0;
		}
#endif
		break;
	case WM_MOUSEWHEEL:
		if( MouseWheelProc( hWnd, LOWORD(wParam), HIWORD(wParam), LOWORD(lParam), HIWORD(lParam) ) ) {
			return TRUE;
		}
		break;
	case WM_PAINT:
		PaintProc( hWnd );
		return 0L;
	case WM_CTLCOLORSTATIC:
	case WM_CTLCOLOREDIT:
		if( p != NULL && wParam != 0 && lParam != 0 ) {
			HWND	hWndCtrl = (HWND)lParam;
			if( hWndCtrl == p->hWndMyEdit ) {
				HBRUSH	hBrush = (HBRUSH)SendMessage( p->hWndMyEdit, WM_EDIT_CTLCOLOR_EDIT, wParam, lParam );
				if( hBrush != NULL ) {
					return( (LRESULT)hBrush );
				}
			}
		}
		break;
	case WM_CTLCOLORLISTBOX:
		if( p != NULL && lParam != 0 ) {
			HWND	hWndListBox = (HWND)lParam;
			HBRUSH	hBrush = NULL;
			if( hWndListBox == p->hWndListBoxLow || hWndListBox == p->hWndListBoxHi ) {
				hBrush = (HBRUSH)SendMessage( hWndListBox, WM_LIST_CTLCOLOR, wParam, lParam );
			}
			if( hBrush != NULL ) {
				return( (LRESULT)hBrush );
			}
		}
		break;
	case WM_DRAWITEM:
		if( p != NULL && lParam != 0 ) {
			LPDRAWITEMSTRUCT	lpdis = (LPDRAWITEMSTRUCT)lParam;
			if( lpdis->CtlType == ODT_LISTBOX ) {
				/*	Xg{bNX̃I[i[`	*/
				DrawListBoxItem( lpdis->hwndItem, lpdis );
			} else if( lpdis->CtlID == ID_STATUSBAR ) {
				/*	Xe[^Xo[̃I[i[`	*/
				DrawStatusBarItem( lpdis->hwndItem, lpdis );
			} else {
				break;
			}
			return TRUE;
		}
		break;
	case WM_INITMENUPOPUP:
		if( InitMenuPopup( hWnd, (HMENU)wParam, (UINT)LOWORD(lParam), (BOOL)HIWORD(lParam) ) ) {
			return 0L;
		}
		break;
	case WM_XS_RECV_FILE:
		XsRecvFile( hWnd, wParam, lParam );
		break;
	case WM_LIST_LOAD_FILE:
		ListLoadFile( hWnd, (int)LOWORD(wParam), (int)HIWORD(wParam), (DWORD)lParam );
		break;
	case WM_LIST_SAVE_FILE:
		ListSaveFile( hWnd, (int)LOWORD(wParam), (int)HIWORD(wParam), (DWORD)lParam );
		break;
	case WM_SCI_RESTORE:
		ScintillaRestore( hWnd, (int)LOWORD(wParam), (int)HIWORD(wParam), (DWORD)lParam );
		break;
	case WM_COMMAND:
#ifdef	WIN32
		if( CommandProc( hWnd, (WORD)HIWORD(wParam), LOWORD(wParam), (HWND)lParam ) ) {
#else
		if( CommandProc( hWnd, (WORD)HIWORD(lParam), wParam, (HWND)LOWORD(lParam) ) ) {
#endif
			return 0L;
		}
		break;
	case WM_CONTEXTMENU:
		if( p != NULL && wParam != 0 ) {
			HWND	hWndFrom = (HWND)wParam;
			if( hWndFrom == p->hWndStatusBar || hWndFrom == p->hWndToolBar || hWndFrom == p->hWndMySci ) {
				ContextMenuProc( hWnd, hWndFrom, (short)LOWORD( lParam ), (short)HIWORD( lParam ) );
			}
		}
		break;
	case WM_MENUSELECT:
		MenuSelectProc( hWnd, LOWORD(wParam), HIWORD(wParam), (HMENU)lParam );
		break;
	case WM_TB_HOVER:
		if( wParam != 0 ) {
			MenuSelectProc( hWnd, (UINT)lParam, 0, NULL );
			break;
		} else {
			/*	̂܂ܗ	*/
		}
	case WM_EXITMENULOOP:
		if( p != NULL ) {
			ExitSimpleTextStatusBar( p->hWndStatusBar );
		}
		ShowCaption( hWnd );
		break;
	case WM_DROPFILES:
		if( DropFilesProc( hWnd, (HDROP)wParam ) ) {
			return 0L;
		}
		break;
	case WM_IMS_SEARCH_SERVER:
		if( p != NULL && p->bUseImsApi ) {
			DWORD	dwResult;
			p->bImsSearching = TRUE;
//			SendMessage( HWND_BROADCAST, p->uImsApiMessage, IMS_API_SEARCH_SERVER, (LPARAM)hWnd );
			SendMessageTimeout( HWND_BROADCAST, p->uImsApiMessage, IMS_API_SEARCH_SERVER, (LPARAM)hWnd, SMTO_ABORTIFHUNG, 2000, &dwResult );
			p->bImsSearching = FALSE;
			if( p->hWndIms != NULL && IsWindow( p->hWndIms ) ) {
				HWND	hWndMonitor;
				/*	T[rXJn	*/
				SendMessage( p->hWndIms, p->uImsApiMessage, IMS_API_START_SERVICE, 0 );
				
				hWndMonitor = (HWND)SendMessage( p->hWndIms, p->uImsApiMessage, IMS_API_GET_MONITOR, 0 );
				if( hWndMonitor != NULL ) {
					DWORD	dwProcessID;
					GetWindowThreadProcessId( hWndMonitor, &dwProcessID );
					if( dwProcessID == GetCurrentProcessId() ) {
						/*	̃vZX̃EBhEj^[Ă΁A	*/
						SendMessage( p->hWndIms, p->uImsApiMessage, IMS_API_SET_MONITOR, (LPARAM)NULL );
					}
				}
			}
		}
		break;
	case WM_LIST_SELECT:
		if( p != NULL ) {
			int		nLoc = (int)wParam;
			if( nLoc < 0 ) {
				nLoc = 0;
			}
			if( nLoc > p->nLineCnt ) {
				nLoc = p->nLineCnt;
			}
			DoMove( hWnd, nLoc );
		}
		break;
	case WM_SB_DBLCLK1:
		if( p != NULL ) {
			if( p->bEditMode ) {
				DoPostCommand( hWnd, ID_VIEW_EDGE );
			}
		}
		break;
	case WM_SB_DBLCLK2:
		if( p != NULL ) {
			if( p->bUseDde ) {
				DoPostCommand( hWnd, ID_DDE_SEARCH_SERVER );
			} else {
				DoPostCommand( hWnd, ID_DDE_EDITSEND_WINDOW );
			}
		}
		break;
	case WM_TB_DBLCLK:
		if( p != NULL ) {
			DoPostCommand( hWnd, ID_TB_RESIZE );
		}
		break;
	case WM_COPYDATA:
		if( CopyDataProc( hWnd, (HWND)wParam, (PCOPYDATASTRUCT)lParam ) ) {
			return( TRUE );
		}
		break;
	case WM_ENTERIDLE:
		if( wParam == MSGF_DIALOGBOX ) {
			HWND	hWndDlg = (HWND)lParam;
			if( hWndDlg != NULL && IsWindow( hWndDlg ) ) {
				PostMessage( hWndDlg, WM_KICK_PROCESS, 0, 0 );
			}
		}
		break;
	case WM_TIMER:
		TimerProc( hWnd, (UINT)wParam );
		break;
	case WM_NOTIFY:
		NotifyProc( hWnd, (int)wParam, (LPNMHDR)lParam );
		break;
	case WM_SYSCOLORCHANGE:
		if( p != NULL ) {
			DoXsIpcNotify( hWnd, XS_IPC_CMD_BITMAP_ON_TOOLBAR, p->bBitmapOnToolbar );
			SetColorMyScintilla( p->hWndMySci );
		}
		break;
	case WM_DDE_ACK:
		if( p != NULL && DdeAckProc( hWnd, &(p->DdeInfo), wParam, lParam ) ) {
			return 0L;
		}
		break;
	case WM_DDE_TERMINATE:
		if( p != NULL && DdeTerminateProc( hWnd, &(p->DdeInfo), wParam, lParam ) ) {
			return 0L;
		}
		break;
	case WM_CLOSE:
		if( CloseProc( hWnd ) ) {
			return 0L;
		}
		break;
	case WM_DESTROY:
		return DestroyProc( hWnd );
	default:
		if( p != NULL && uMsg == p->uImsApiMessage ) {
			ImsApiMsgProc( hWnd, wParam, lParam );
		}
		if( p != NULL && uMsg == p->uXsIpcMessage ) {
			XsIpcMsgProc( hWnd, wParam, lParam );
		}
		if( gnMsgMouseWheel != 0 && uMsg == gnMsgMouseWheel ) {
			WORD	keyState = 0;
			keyState |= ( GetKeyState(VK_CONTROL) < 0 ) ? MK_CONTROL : 0;
			keyState |= ( GetKeyState(VK_SHIFT) < 0 ) ? MK_SHIFT : 0;
			return SendMessage( hWnd, WM_MOUSEWHEEL, (wParam << 16) | keyState, lParam );
		}
		if( p != NULL && uMsg == p->nMsgFindDlg && p->hWndFindDlg != NULL && IsWindow( p->hWndFindDlg ) ) {
			/*	_CAO([hX)̒ʒmbZ[W	*/
			LPFINDREPLACE	pfr = (LPFINDREPLACE)lParam;
			if( pfr->Flags & FR_DIALOGTERM ) {	/*		*/
				p->hWndFindDlg = NULL;
				/*	ݒ肳ꂽp[^̕ۑ	*/
				p->bFindNext = ( pfr->Flags & FR_DOWN );
				p->bMatchCase = ( pfr->Flags & FR_MATCHCASE );
				p->bWholeWord = ( pfr->Flags & FR_WHOLEWORD );
			} else if( pfr->Flags & (FR_FINDNEXT|FR_REPLACE|FR_REPLACEALL) ) {	/*	Eu	*/
				int			ret;
				BOOL		qf = FALSE;
				int			nFound = 0;
				do {
					if( pfr->Flags & FR_DOWN ) {
						ret = FindNextMyScintilla( p->hWndMySci, pfr->Flags, pfr->lpstrFindWhat );
					} else {
						ret = FindPrevMyScintilla( p->hWndMySci, pfr->Flags, pfr->lpstrFindWhat );
					}
					if( ret < 0 ) {
						TCHAR	msg[256];
						if( nFound == 0 ) {	/*	PȂ	*/
							LoadString( p->hInstance, IDS_NOT_FOUND_STRING, msg, 255 );
						} else {			/*	u	*/
							TCHAR	fmt[256];
							LoadString( p->hInstance, IDS_REPLACED, fmt, 255 );
							wsprintf( msg, fmt, nFound );
						}
						MessageBox( p->hWndFindDlg, msg, szXsAppName, MB_ICONINFORMATION|MB_OK );
						SetFocus( p->hWndFindDlg );
						qf = TRUE;
					} else {
						ScrollCaretMyScintilla( p->hWndMySci );
						if( ( ( pfr->Flags & FR_REPLACE ) && nFound == 0 ) || ( pfr->Flags & FR_REPLACEALL ) ) {
							ReplaceSelMyScintilla( p->hWndMySci, pfr->lpstrReplaceWith );
							nFound++;
						} else {
							qf = TRUE;
						}
					}
				} while( !qf );
			}
		}
		break;
	}
	return DefWindowProc( hWnd, uMsg, wParam, lParam );
}

/*	bZ[WvZbT	*/
void	MyProcessMessage( HWND hWnd, LPMSG pMsg )
{
	NpXsInfo	p = GetXsInfo( hWnd );
	BOOL	bNoDispatch = FALSE;
	
	/*	c[`bvTTM_RELAYEVENT	*/
	if( p != NULL && !p->bNoTooltip && p->hWndToolTip != NULL && IsWindow( p->hWndToolTip ) ) {
		RelayEventMyToolTip( p->hWndToolTip, pMsg );
	}
	/*	Eu_CAO([hX)̏	*/
	if( p != NULL && p->hWndFindDlg != NULL && IsWindow( p->hWndFindDlg ) ) {
		bNoDispatch = IsDialogMessage( p->hWndFindDlg, pMsg );
	}
	
	/*	ANZ[^̏	*/
	if( !bNoDispatch && p != NULL && p->hAccel != NULL ) {
		if( p->bEditMode ) {
			if( p->hWndMySci != NULL && IsWindow( p->hWndMySci ) && pMsg->hwnd == p->hWndMySci ) {
				bNoDispatch = TranslateAccelerator( hWnd, p->hAccel, pMsg );
			}
		} else {
			if( p->hWndMyEdit != NULL && IsWindow( p->hWndMyEdit ) && pMsg->hwnd == p->hWndMyEdit ) {
				bNoDispatch = TranslateAccelerator( hWnd, p->hAccel, pMsg );
			}
			/*
				tH[JX͏EDITɂ͂B
				̏ǉȂƁAuv_CAOoĂ鎞ɁA
				VK_UP/VK_DOWN, VK_NEXT/VK_PRIOR Ȃǂ́Aj[ACeɂȂ
				R}hsłĂ܂B
			*/
		}
	}
	
	if( p != NULL && p->bEditMode ) {
		/*	ScitillãANZ[^̏	*/
		if( !bNoDispatch && p != NULL && p->hWndMySci != NULL ) {
			bNoDispatch = TranslateAcceleratorMyScintilla( hWnd, p->hWndMySci, pMsg );
		}
	} else {
		/*	ҏWs̃ANZ[^̏	*/
		if( !bNoDispatch && p != NULL && p->hWndMyEdit != NULL ) {
			bNoDispatch = TranslateAcceleratorMyEdit( hWnd, p->hWndMyEdit, pMsg );
		}
	}
	
	if( !bNoDispatch ) {
		TranslateMessage( pMsg );
		DispatchMessage( pMsg );
	}
}


/*	C	*/
int		WINAPI	WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpszCmdLine, int nCmdShow )
{
	MSG		msg;
	HWND	hWnd;

	if( hPrevInstance == NULL ) {
		WNDCLASS	wc;
		wc.style = CS_DBLCLKS;
		wc.lpfnWndProc = XsWndProc;
		wc.cbClsExtra = 0;
		wc.cbWndExtra = XS_EXTRA_BYTES;
		wc.hInstance = hInstance;
		wc.hIcon = LoadIcon( hInstance, MAKEINTRESOURCE( IDI_ICON_XS ) );
		wc.hCursor = LoadCursor( NULL, IDC_ARROW );
		wc.hbrBackground = (HBRUSH)( COLOR_BTNFACE+1 );
		wc.lpszMenuName = MAKEINTRESOURCE( IDR_MENU_XS );
		wc.lpszClassName = szXsWndClass;
		if( !RegisterClass( &wc ) ) {
			return FALSE;
		}
	}
	InitCommonControls();
	OleInitialize(NULL);
	/*	CEBhE̍쐬	*/
	hWnd = CreateWindow( szXsWndClass, szXsAppName,
		WS_OVERLAPPED|WS_CAPTION|WS_SYSMENU|WS_MINIMIZEBOX|WS_MAXIMIZEBOX|WS_THICKFRAME|WS_CLIPCHILDREN,
		CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
		NULL, NULL, hInstance, NULL );
	if( hWnd == NULL ) {
		return FALSE;
	}
	ShowWindow( hWnd, nCmdShow );
	UpdateWindow( hWnd );
	
	/*	R}hCw肳ꂽt@CJ	*/
	PostMessage( hWnd, WM_XS_OPEN_FILE, 0, (LPARAM)lpszCmdLine );
	
	/*	f[N	*/
	PostMessage( hWnd, WM_XS_STARTUP_XSD, 0, 0 );
	
	/*	bZ[W[v	*/
	while( GetMessage( &msg, NULL, 0, 0 ) ) {
		MyProcessMessage( hWnd, &msg );
	}
	
	/*	tbN	*/
	RemoveHook();
	OleUninitialize();
	
	return (int)msg.wParam;
}
