/*--------------------------------------------------------------*\
		module	:	EditSend.h
		purpose :	DLLC@ʃwb_[t@C
		author	:	_@ Kengo Jinno
		create	:	1998/10/27
		update	:	1998/11/05
					1998/11/12	16bit
					1998/11/17	uWM_PASTEgvǉ
					1998/12/04	EdsGetVersion()ǉ
					1998/12/16	EdsWriteProfile()
								EdsGetProfile()ǉ
\*--------------------------------------------------------------*/

#ifndef	EDS_EDITSEND_H
#define	EDS_EDITSEND_H

#ifndef	_INC_WINDOWS
#include	<windows.h>
#endif	/*	_INC_WINDOWS	*/

#if	!defined(LPCTSTR) && !defined(WIN32)
#define	LPCTSTR	LPCSTR
#endif
#if	!defined(LPTSTR) && !defined(WIN32)
#define	LPTSTR	LPSTR
#endif

#ifdef	__cplusplus
extern "C" {
#endif

/*--------------------------------------------------------------*\
	}N
\*--------------------------------------------------------------*/

/*	bZ[W	*/
#define	EDS_USE_WM_CHAR				0	/*	WM_CHARg		(16/32)	*/
#define	EDS_USE_WM_IME_CHAR			1	/*	WM_IME_CHARg	(32)	*/
#define	EDS_USE_WM_BOTH				2	/*	҂𕹗p		(32)	*/
#define	EDS_USE_WM_PASTE			3	/*	WM_PASTEg		(16/32)	*/
#define	EDS_USE_WM_IME_REPORT		4	/*	WM_IME_REPORTg	(16)	*/

/*	֐	*/
#define	EDS_USE_POSTMESSAGE			0	/*	PostMessage()g	*/
#define	EDS_USE_SENDMESSAGE			1	/*	SendMessage()g	*/

/*	s	*/
#define	EDS_SEND_CR_ONLY			0	/*	CR̂ݑM	*/
#define	EDS_SEND_LF_ONLY			1	/*	LF̂ݑM	*/
#define	EDS_SEND_CRLF				2	/*	CR+LF𑗐M	*/
#define	EDS_SEND_VK_RETURN			3	/*	VK_RETURNg	*/

/*	G[	*/
#define	EDS_ERR_NONE				0
#define	EDS_ERR_NOT_IMPLEMENTED		1	/*	ȋ@\ł	*/
#define	EDS_ERR_BAD_STRUCT_SIZE		2	/*	p[^̍\̃TCYُ	*/
#define	EDS_ERR_BAD_PARAM_VAL		3	/*	p[^̒lُ	*/
#define	EDS_ERR_BAD_WINDOW_HANDLE	4	/*	sȃEBhEnh	*/
#define	EDS_ERR_NULL_ARG			5	/*	NULL|C^nꂽ	*/
#define	EDS_ERR_WINDOWS_API			6	/*	WindowsAPIG[Ԃ	*/

/*--------------------------------------------------------------*\
	\
\*--------------------------------------------------------------*/

typedef	struct	tagEdsParam_Type {
	DWORD	dwStructSize;				/*	\̂̃TCY	*/
	DWORD	nMessage;					/*	bZ[W̎(}N)	*/
	DWORD	nFunction;					/*	֐̎(}N)	*/
	DWORD	nLineFeed;					/*	s̎(}N)	*/
	DWORD	bUseRepeatCnt;				/*	[Ȃ烊s[g񐔂g	*/
} EdsParamType, FAR * LpEdsParamType;

/*--------------------------------------------------------------*\
	֐vg^Cv
\*--------------------------------------------------------------*/

/*	export֐	*/
extern	WORD	WINAPI	EdsGetVersion( void );
extern	BOOL	WINAPI	EdsInitWindow( HWND hWnd );
extern	BOOL	WINAPI	EdsInitWindowDialog( HWND hWndOwner, HWND FAR * lphWnd );
extern	BOOL	WINAPI	EdsInitParam( const LpEdsParamType lpParam );
extern	BOOL	WINAPI	EdsInitParamDialog( HWND hWndOwner, LpEdsParamType lpParam );
extern	BOOL	WINAPI	EdsGetParam( LpEdsParamType lpParam );
extern	BOOL	WINAPI	EdsGetDefaultParam( LpEdsParamType lpParam );
extern	BOOL	WINAPI	EdsSendString( LPCTSTR lpszStr );
extern	BOOL	WINAPI	EdsSendClipboard( void );
extern	BOOL	WINAPI	EdsWriteProfile( LPCTSTR lpszFile, LPCTSTR lpszSection );
extern	BOOL	WINAPI	EdsGetProfile( LPCTSTR lpszFile, LPCTSTR lpszSection );
extern	int		WINAPI	EdsGetLastError( void );
extern	void	WINAPI	EdsClearLastError( void );

/*	GetProcAddress()̖߂lLXg^	*/
typedef	WORD	(WINAPI FAR* LP_FUNC_EDSGETVERSION)( void );
typedef	BOOL	(WINAPI FAR* LP_FUNC_EDSINITWINDOW)( HWND );
typedef	BOOL	(WINAPI FAR* LP_FUNC_EDSINITWINDOWDIALOG)( HWND, HWND FAR * );
typedef	BOOL	(WINAPI FAR* LP_FUNC_EDSINITPARAM)( const LpEdsParamType );
typedef	BOOL	(WINAPI FAR* LP_FUNC_EDSINITPARAMDIALOG)( HWND, LpEdsParamType );
typedef	BOOL	(WINAPI FAR* LP_FUNC_EDSGETPARAM)( LpEdsParamType );
typedef	BOOL	(WINAPI FAR* LP_FUNC_EDSGETDEFAULTPARAM)( LpEdsParamType );
typedef	BOOL	(WINAPI FAR* LP_FUNC_EDSSENDSTRING)( LPCTSTR );
typedef	BOOL	(WINAPI FAR* LP_FUNC_EDSSENDCLIPBOARD)( void );
typedef	BOOL	(WINAPI FAR* LP_FUNC_EDSWRITEPROFILE)( LPCTSTR, LPCTSTR );
typedef	BOOL	(WINAPI FAR* LP_FUNC_EDSGETPROFILE)( LPCTSTR, LPCTSTR );
typedef	int		(WINAPI FAR* LP_FUNC_EDSGETLASTERROR)( void );
typedef	void	(WINAPI FAR* LP_FUNC_EDSCLEARLASTERROR)( void );

#ifdef	__cplusplus
}
#endif

#endif	/*	EDS_EDITSEND_H	*/
