/*--------------------------------------------------------------*\
		module	:	FileMru.h
		purpose :	t@C
		author	:	_@ Kengo Jinno
		create	:	2001/09/05
		update	:	2001/09/06
\*--------------------------------------------------------------*/

#ifndef	FILEMRU_H
#define	FILEMRU_H

#define	MAX_FILE_MRU_CNT	8

#ifdef	WIN32
/*	PathCompactPathEx() (shlwapi.dll)ւ̃|C^^	*/
typedef	BOOL	(WINAPI FAR* LP_FUNC_PATHCOMPACTPATHEX)( LPTSTR, LPCTSTR, UINT, DWORD );
#endif

typedef	struct	tagFileMruType	{
	TCHAR	szFilePath[ MAX_FILE_MRU_CNT ][ _MAX_PATH ];
	int		nSize;		/*	ݗLȌ	*/
#ifdef	WIN32
	BOOL	bMustFreeShlWapiDll;
	HINSTANCE	hInstShlWapiDll;	/*	shlwapi.dll̃CX^Xnh	*/
	LP_FUNC_PATHCOMPACTPATHEX	lpPathCompactPathEx;	/*	PathCompactPathEx()	*/
	BOOL		bNoCompactPath;
#endif
}	FileMru;

extern	BOOL	AddFileMruList( FileMru* p, LPCTSTR lpszFilePath, HMENU hMenu );
extern	LPCTSTR	GetMruFileName( const FileMru* p, int n );
extern	BOOL	UpdateFileMruMenu( const FileMru* p, HMENU hMenu );
extern	BOOL	WriteFileMruProfile( const FileMru* p, LPCTSTR lpszSection, LPCTSTR lpszProfile );
extern	BOOL	GetFileMruProfile( FileMru* p, LPCTSTR lpszSection, LPCTSTR lpszProfile );

extern	BOOL	InitFileMru( FileMru* p );
extern	BOOL	QuitFileMru( FileMru* p );

#endif	/*	FILEMRU_H	*/
