/*--------------------------------------------------------------*\
		module	:	MyList.c
		purpose :	X-Send Xg{bNX
		author	:	_@ Kengo Jinno
		create	:	2001/09/04
		update	:	2001/10/18
					2001/11/01	IsBadReadPtr() IsBadCodePtr()
								ĝ߂B(Win2K/XP)
					2001/11/02	LB_GETITEMHEIGHT̖߂lł
								[h~
					2001/11/13	pv|[ViȃtHgƁA
								sԍ̕ȂƂ̂ŁA
								CalcLineNumWidth()̓[v񂷂悤ɂ
					2001/11/14	InsertMarkMyList()邽߁A
								LoadFilePhase2MyList()Ń}[Ns
								L
					2001/11/21	MarkString="" ƂƁASă}[Ns
								肵Ă̂C(}[N@\Ƃ)
					2001/11/21	IsCommentMyList()ǉ
					2002/03/06	MyListDataType::bMarkAsCommentǉ
					2002/03/20	MarkCommentInfoTypeg
					2002/03/20	Scintillaւ̓ǂݍݏǉ
					2004/02/23	mۃ`FbNd
\*--------------------------------------------------------------*/

#include	"PCH.h"
#include	"MyList.h"
#include	"resource.h"
#include	"Tools.h"
#include	"MySci.h"


static	LPCTSTR		lpszPropertyName = _T("5b493180-a140-11d5-af4f-00c0ca10a705");


/*	Xg{bNX쐬	*/
HWND	CreateMyList( HWND hWndParent, UINT nCtrlID, BOOL bViewMode )
{
	HINSTANCE	hInstance = (HINSTANCE)GetWindowLong( hWndParent, GWL_HINSTANCE );
	HWND	hWnd;
	
	/*	EBhE쐬	*/
	DWORD	dwStyle = LBS_NOINTEGRALHEIGHT|LBS_HASSTRINGS;
	dwStyle |= LBS_OWNERDRAWFIXED|LBS_HASSTRINGS;
	hWnd = CreateWindowEx( WS_EX_CLIENTEDGE, _T("LISTBOX"), NULL,
		WS_CHILD|WS_VISIBLE|WS_CLIPSIBLINGS|dwStyle,
		0, 0, 0, 0, hWndParent, (HMENU)nCtrlID, hInstance, NULL );
	
	if( hWnd != NULL ) {
		if( !SubclassMyList( hWnd, bViewMode ) ) {
			DestroyWindow( hWnd );
			hWnd = NULL;
		}
	}
	
	return( hWnd );
}

/*	TuNX	*/
BOOL	SubclassMyList( HWND hWnd, BOOL bViewMode )
{
	BOOL	ret = FALSE;
	if( hWnd != NULL && IsWindow( hWnd ) ) {
		LpMyListDataType	p;
		p = (LpMyListDataType)GlobalAlloc( GPTR, sizeof(MyListDataType) );
		if( p == NULL ) {
			return ret;
		}
		ZeroMemory( p, sizeof(MyListDataType) );
		p->bShowLineNum = TRUE;
		p->szLineNumFmt[0] = _T('\0');
		p->szDummyFmt[0] = _T('\0');
		p->nLineCnt = 0;
		p->nLineNumWidth1 = 0;
		p->nLineNumWidth2 = 0;
		p->hFontNewLine = NULL;
		p->bShowNewLine = TRUE;
		p->cNewLine = _T('\0');
		p->bMarkAsComment = FALSE;
		p->hTextBuff = NULL;
		p->dwTextbuffSize = 0;
		p->bHelpMe = FALSE;
		p->bViewMode = bViewMode;
		p->bCanHaveFocus = FALSE;
		p->nMarkCnt = 0;
		p->hMarkPos = NULL;
		/*	vpeBɃZbg	*/
		SetProp( hWnd, lpszPropertyName, (HANDLE)p );
		/*	TuNX	*/
		p->lpfnOldWndProc = (WNDPROC)SetWindowLong( hWnd, GWL_WNDPROC, (LONG)MyListWndProc );
		
		ret = TRUE;
	}
	return ret;
}

/*	Xg{bNXj	*/
BOOL	DestroyMyList( HWND hWnd )
{
	BOOL	ret = TRUE;
	if( IsWindow( hWnd ) ) {
		LpMyListDataType	p = (LpMyListDataType)GetProp( hWnd, lpszPropertyName );
		if( p != NULL ) {
			/*	TuNX	*/
			if( p->lpfnOldWndProc != NULL ) {
				SetWindowLong( hWnd, GWL_WNDPROC, (LONG)p->lpfnOldWndProc );
				p->lpfnOldWndProc = NULL;
			}
			/*	obt@	*/
			if( p->hTextBuff != NULL ) {
				GlobalFree( p->hTextBuff );
				p->hTextBuff = NULL;
			}
			p->dwTextbuffSize = 0;
			if( p->hMarkPos != NULL ) {
				GlobalFree( p->hMarkPos );
				p->hMarkPos = NULL;
			}
			p->nMarkCnt = 0;
			/*	vpeB폜	*/
			RemoveProp( hWnd, lpszPropertyName );
			GlobalFree( (HGLOBAL)p );
		}
		/*	p	*/
		ret = DestroyWindow( hWnd );
	}
	return ret;
}

/*	TuNXvV[W	*/
LRESULT	MYEXPORT	CALLBACK	MyListWndProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	LpMyListDataType	p = (LpMyListDataType)GetProp( hWnd, lpszPropertyName );
	if( p == NULL || p->lpfnOldWndProc == NULL ) {
		return DefWindowProc( hWnd, uMsg, wParam, lParam );
	}
	if( uMsg == WM_GETDLGCODE ) {
		LRESULT	ret = CallWindowProc( p->lpfnOldWndProc, hWnd, uMsg, wParam, lParam );
		return( ret & ~DLGC_WANTCHARS );
		/*	DLGC_WANTCHARSԂȂƁA
			'a''a'n܂
			ACeTĈړĂ܂B	*/
	} else if( uMsg == WM_SETFOCUS ) {
		HWND	hWndParent = GetParent( hWnd );
		if( hWndParent != NULL && IsWindow( hWndParent ) ) {
			if( !p->bCanHaveFocus ) {
				/*	tH[JXꂻɂȂA	*/
				/*	eɓnB(éAҏWsɓn)	*/
				SetFocus( hWndParent );
				return 0L;
			}
		}
	} else if( uMsg == WM_LBUTTONDBLCLK ) {
		/*	ǂ̃ACe_uNbN̂AT	*/
		POINT	pt;
		int		nItem = SendMessage( hWnd, LB_GETTOPINDEX, 0, 0 );
		RECT	rectClient;
		pt.x = (short)LOWORD(lParam);
		pt.y = (short)HIWORD(lParam);
		GetClientRect( hWnd, &rectClient );
		for( ; ; ) {
			RECT	rectItem, rect;
			if( SendMessage( hWnd, LB_GETITEMRECT, nItem, (LPARAM)&rectItem ) == LB_ERR ) {
				break;	/*	ACeԍ͈͊O	*/
			}
			if( !IntersectRect( &rect, &rectClient, &rectItem ) ) {
				break;	/*	NCAgOɂACe	*/
			}
			if( PtInRect( &rectItem, pt ) ) {
				/*	eɒʒm	*/
				if( !p->bCanHaveFocus ) {
					nItem -= DUMMY_ITEM_CNT;
				}
				PostMessage( GetParent( hWnd ), WM_LIST_SELECT, (WPARAM)nItem, (LPARAM)hWnd );
				break;
			}
			nItem++;
		}
	} else if( uMsg == WM_LIST_CTLCOLOR ) {
		HBRUSH	hBrush;
		if( p->bViewMode ) {
			if( p->bHelpMe ) {
				hBrush = GetSysColorBrush( COLOR_HIGHLIGHT );
			} else {
				hBrush = GetSysColorBrush( COLOR_BTNFACE );
			}
		} else {
			hBrush = GetSysColorBrush( COLOR_WINDOW );
		}
		return( (LRESULT)hBrush );
	} else if( uMsg == WM_MOUSEWHEEL || uMsg == WM_VSCROLL || ( gnMsgMouseWheel != 0 && uMsg == gnMsgMouseWheel ) ) {
		HWND	hWndParent = GetParent( hWnd );
		if( hWndParent != NULL && IsWindow( hWndParent ) ) {
			if( !p->bCanHaveFocus ) {
				return SendMessage( hWndParent, uMsg, wParam, lParam );
			}
		}
	} else if( uMsg == WM_DESTROY ) {
		RemoveProp( hWnd, lpszPropertyName );
	}
//	if( IsBadReadPtr( &(p->lpfnOldWndProc), sizeof(p->lpfnOldWndProc) ) || IsBadCodePtr( (FARPROC)p->lpfnOldWndProc ) ) {
//		return DefWindowProc( hWnd, uMsg, wParam, lParam );
//	}
	return CallWindowProc( p->lpfnOldWndProc, hWnd, uMsg, wParam, lParam );
}


/*	I[i[`	*/
void	DrawListBoxItem( HWND hWnd, LPDRAWITEMSTRUCT lpDrawItemStruct )
{
	LpMyListDataType	p = (LpMyListDataType)GetProp( hWnd, lpszPropertyName );
	if( p != NULL && lpDrawItemStruct->CtlType == ODT_LISTBOX ) {
		RECT	rect = lpDrawItemStruct->rcItem;
		HDC		hDC = lpDrawItemStruct->hDC;
		UINT	nItem = lpDrawItemStruct->itemID;
		UINT	nState = lpDrawItemStruct->itemState;
		UINT	nAction = lpDrawItemStruct->itemAction;
		DWORD	dwItemData = lpDrawItemStruct->itemData;
		COLORREF	colHilight = GetSysColor( COLOR_HIGHLIGHT );
		COLORREF	colHilightText = GetSysColor( COLOR_HIGHLIGHTTEXT );
		COLORREF	colWindow = GetSysColor( COLOR_WINDOW );
		COLORREF	colWindowText = GetSysColor( COLOR_WINDOWTEXT );
		COLORREF	colOldBack;
		COLORREF	colOldText;
		BOOL		bReverse = FALSE;
		if( p->bCanHaveFocus ) {
			if( nState & ODS_SELECTED ) {
				/*	IĂ	*/
				colOldBack = SetBkColor( hDC, colHilight );
				colOldText = SetTextColor( hDC, colHilightText );
				bReverse = TRUE;
			} else {
				/*	IĂȂ	*/
				colOldBack = SetBkColor( hDC, colWindow );
				colOldText = SetTextColor( hDC, colWindowText );
			}
		} else {
			if( p->bViewMode ) {
				if( p->bHelpMe ) {
					/*	łv̉{[h	*/
					colOldBack = SetBkColor( hDC, colHilight );
					colOldText = SetTextColor( hDC, colHilightText );
					bReverse = TRUE;
				} else {
					/*	ʏ̉{[h	*/
					colOldBack = SetBkColor( hDC, GetSysColor( COLOR_BTNFACE ) );
					colOldText = SetTextColor( hDC, GetSysColor( COLOR_BTNTEXT ) );
				}
			} else {
				/*	ʏ	*/
				colOldBack = SetBkColor( hDC, colWindow );
				colOldText = SetTextColor( hDC, colWindowText );
			}
		}
		if( nItem != LB_ERR ) {
			int		nLen;
			LPTSTR	q = NULL;
			UINT	nOldTextAlign = SetTextAlign( hDC, TA_TOP|TA_LEFT|TA_UPDATECP );
			int		nLineNum = (int)ITEM_DATA_LINENUM( dwItemData );
			BOOL	bIsMark = IS_MARK_ITEM_PARAM( dwItemData );
			BOOL	bIsComment = IS_COMMENT_ITEM_PARAM( dwItemData );
			POINT	pt;
			
			pt.x = rect.left+1;
			pt.y = rect.top+1;
			MoveToEx( hDC, pt.x, pt.y, NULL );
			
			/*	sԍ(El)	*/
			if( p->bShowLineNum && p->nLineCnt > 0 ) {
				TCHAR	szLineNum[20];
				int		nLineNumLen;
				UINT	nOldTextAlign = SetTextAlign( hDC, TA_TOP|TA_RIGHT );
				
				if( dwItemData == DUMMY_ITEM_PARAM ) {
					TCHAR	c = _T('\0');
					nLineNumLen = wsprintf( szLineNum, p->szDummyFmt, &c );
				} else {
					nLineNumLen = wsprintf( szLineNum, p->szLineNumFmt, (long)nLineNum );
				}
				nLineNumLen--;	/*	'|'͕`Ȃ	*/
				pt.x += p->nLineNumWidth2;
				ExtTextOut( hDC, pt.x, pt.y, ETO_CLIPPED|ETO_OPAQUE, &rect, szLineNum, nLineNumLen, NULL );
				if( bIsMark && !p->bCanHaveFocus ) {
					int		nOldBkMode = SetBkMode( hDC, TRANSPARENT );
					ExtTextOut( hDC, pt.x+1, pt.y, ETO_CLIPPED, &rect, szLineNum, nLineNumLen, NULL );
					SetBkMode( hDC, nOldBkMode );
				}
				SetTextAlign( hDC, nOldTextAlign );
				MoveToEx( hDC, pt.x, pt.y, NULL );
				rect.left = pt.x;
				/*	'|'`	*/
				ExtTextOut( hDC, 0, 0, ETO_CLIPPED|ETO_OPAQUE, &rect, szLineNum+nLineNumLen, 1, NULL );
				GetCurrentPositionEx( hDC, &pt );
				rect.left = pt.x;
			}
			
			/*	RgȂ甽]\	*/
			/*	u}[NsRgṽ}[Ns]\(2002/03/06)	*/
			if( ( bIsComment && !p->bCanHaveFocus ) || ( bIsMark && p->bMarkAsComment ) ) {
				SetBkColor( hDC, colHilight );
				SetTextColor( hDC, colHilightText );
				bReverse = TRUE;
			}
			/*	{擾ĕ`	*/
			nLen = SendMessage( hWnd, LB_GETTEXTLEN, nItem, 0 );
			q = (LPTSTR)GlobalAlloc( GPTR, sizeof(TCHAR)*(nLen+1) );
			if( q != NULL ) {
				nLen = SendMessage( hWnd, LB_GETTEXT, nItem, (LPARAM)q );
				ExtTextOut( hDC, 0, 0, ETO_CLIPPED|ETO_OPAQUE, &rect, q, nLen, NULL );
				if( bIsMark && !p->bCanHaveFocus ) {
					UINT	nOldTextAlign = SetTextAlign( hDC, TA_TOP|TA_LEFT );
					int		nOldBkMode = SetBkMode( hDC, TRANSPARENT );
					POINT	pos;
					GetCurrentPositionEx( hDC, &pos );
					ExtTextOut( hDC, pt.x+1, pt.y, ETO_CLIPPED, &rect, q, nLen, NULL );
					SetBkMode( hDC, nOldBkMode );
					SetTextAlign( hDC, nOldTextAlign );
					MoveToEx( hDC, pos.x, pos.y, NULL );
				}
				GlobalFree( (HGLOBAL)q );;
			}
			
			if( !p->bShowNewLine || p->hFontNewLine == NULL || dwItemData == DUMMY_ITEM_PARAM ) {
				/*	s}[N\Ȃ	*/
				/*	ŏI	*/
			} else {
				/*	s}[N̕`	*/
				HFONT	hOldFont = (HFONT)SelectObject( hDC, p->hFontNewLine );
				POINT	pt;
				
				if( !bReverse ) {
					SetTextColor( hDC, colHilight );
				}
				
				GetCurrentPositionEx( hDC, &pt );
				rect.left = pt.x;
				ExtTextOut( hDC, 0, 0, ETO_CLIPPED|ETO_OPAQUE, &rect, &(p->cNewLine), 1, NULL );
				
				SelectObject( hDC, hOldFont );
			}
			
			SetTextAlign( hDC, nOldTextAlign );
			if( nState & ODS_FOCUS ) {
				/*	قƂ͂ŁATextColor߂ȂƂȂ	*/
				SetBkColor( hDC, colOldBack );
				SetTextColor( hDC, colOldText );
				rect = lpDrawItemStruct->rcItem;
				DrawFocusRect( hDC, &rect );
			}
		} else {
			/*	ɗ̂͋ۂ̎B	*/
			SetBkColor( hDC, colOldBack );
			SetTextColor( hDC, colOldText );
			if( ( nAction & ODA_FOCUS ) || ( nState & ODS_FOCUS ) ) {
				DrawFocusRect( hDC, &rect );
			}
		}
		SetBkColor( hDC, colOldBack );
		SetTextColor( hDC, colOldText );
	}
}


/*	œKȍԂ	*/
int		GetSuitableHeightMyList( HWND hWnd, int nExpectedHeight, int nExpectedLineCnt )
{
	int		nHeight = 0;
	if( IsWindow( hWnd ) ) {
		int		nItemHeight;
		int		nLineCnt;
		RECT	rectClient, rectWindow;
		int		nFrameHeight;
		
		/*	g̕l	*/
		GetWindowRect( hWnd, &rectWindow );
		GetClientRect( hWnd, &rectClient );
		nFrameHeight = ( rectWindow.bottom - rectWindow.top ) - ( rectClient.bottom - rectClient.top );
		
		/*	P̃ACe̍	*/
		nItemHeight = (int)SendMessage( hWnd, LB_GETITEMHEIGHT, 0, 0 );
		if( nItemHeight <= 0 ) {
			nItemHeight = 1;
		}
		
		/*	s̍mۂ邩H	*/
		if( nExpectedLineCnt < 1 ) {
			/*	œnꂽɁAŕ\łs	*/
			nLineCnt = ( nExpectedHeight - nFrameHeight ) / nItemHeight;
			if( nLineCnt < 1 ) {
				nLineCnt = 1;
			}
		} else {
			/*	œnꂽs	*/
			nLineCnt = nExpectedLineCnt;
		}
		
		nHeight = nLineCnt * nItemHeight;
		
		/*	g̕l	*/
		nHeight += nFrameHeight;
	}
	return( nHeight );
}


/*	sԍ̕\vZ	*/
static	void	CalcLineNumWidth( HWND hWnd, HDC hDC )
{
	if( IsWindow( hWnd ) ) {
		LpMyListDataType	p = (LpMyListDataType)GetProp( hWnd, lpszPropertyName );
		if( p != NULL ) {
			p->nLineNumWidth1 = 0;
			p->nLineNumWidth2 = 0;
			if( p->nLineCnt > 0 ) {
				HDC		hMyDC = ( hDC == NULL ) ? GetDC( hWnd ) : hDC;
				HFONT	hFont;
				HFONT	hOldFont;
				TCHAR	buff[20];
				int		nLen;
				SIZE	size;
				int		i;
				int		nCnt;
				int		nWidth1, nWidth2;
				LPCTSTR	lpszFmt;
				
				if( hDC == NULL ) {
					hFont = (HFONT)SendMessage( hWnd, WM_GETFONT, 0, 0 );
					hOldFont = (HFONT)SelectObject( hMyDC, hFont );
				}
				
				nCnt = p->nLineCnt;
				lpszFmt = p->szLineNumFmt;
				nWidth1 = nWidth2 = 0;
				
				for( i = 1; i <= nCnt; i++ ) {
					nLen = wsprintf( buff, lpszFmt, i );
					GetTextExtentPoint32( hMyDC, buff, nLen, &size );
					if( nWidth1 < size.cx ) {
						nWidth1 = size.cx;
						GetTextExtentPoint32( hMyDC, buff, nLen-1, &size );
						nWidth2 = size.cx;
					}
				}
				p->nLineNumWidth1 = nWidth1;
				p->nLineNumWidth2 = nWidth2;
				
				if( hDC == NULL ) {
					SelectObject( hMyDC, hOldFont );
					ReleaseDC( hWnd, hMyDC );
				}
			}
		}
	}
}

/*	tHgݒ	*/
void	SetFontMyList( HWND hWnd, HFONT hFont, HFONT hFontNewLine )
{
	if( IsWindow( hWnd ) ) {
		LpMyListDataType	p = (LpMyListDataType)GetProp( hWnd, lpszPropertyName );
		HDC		hDC;
		HFONT	hOldFont;
		TEXTMETRIC	tm;
		int		nHeight;
		
		SendMessage( hWnd, WM_SETFONT, (WPARAM)hFont, MAKELPARAM( TRUE, 0 ) );
		
		/*	Ps̍vZ(I[i[`p)	*/
		hDC = GetDC( hWnd );
		hOldFont = (HFONT)SelectObject( hDC, hFont );
		
		GetTextMetrics( hDC, &tm );
		nHeight = tm.tmHeight/* + tm.tmExternalLeading*/+2;
		SendMessage( hWnd, LB_SETITEMHEIGHT, 0, MAKELPARAM( nHeight, 0 ) );
		
		/*	sԍ̕\߂	*/
		CalcLineNumWidth( hWnd, hDC );
		
		SelectObject( hDC, hOldFont );
		ReleaseDC( hWnd, hDC );
		
		/*	s}[NptHg	*/
		if( p != NULL ) {
			p->hFontNewLine = hFontNewLine;
		}
	}
}

/*	IvVݒ	*/
void	SetOptionMyList( HWND hWnd, BOOL bShowLineNum, BOOL bShowNewLine, TCHAR cNewLine, BOOL bMarkAsComment )
{
	if( IsWindow( hWnd ) ) {
		LpMyListDataType	p = (LpMyListDataType)GetProp( hWnd, lpszPropertyName );
		if( p != NULL ) {
			if( p->bShowLineNum != bShowLineNum ) {
				p->bShowLineNum = bShowLineNum;
			}
			if( p->bShowNewLine != bShowNewLine ) {
				p->bShowNewLine = bShowNewLine;
			}
			if( p->cNewLine != cNewLine ) {
				p->cNewLine = cNewLine;
			}
			if( p->bMarkAsComment != bMarkAsComment ) {
				p->bMarkAsComment = bMarkAsComment;
			}
		}
	}
}

/*	_~[̋s}	*/
static	void	InsertDummyItem( HWND hWnd )
{
	if( IsWindow( hWnd ) ) {
		int		i;
		TCHAR	c = _T('\0');
		LRESULT	lRet;
		for( i = 0; i < DUMMY_ITEM_CNT; i++ ) {
			lRet = SendMessage( hWnd, LB_ADDSTRING, 0, (LPARAM)(&c) );
			SendMessage( hWnd, LB_SETITEMDATA, lRet, (LPARAM)DUMMY_ITEM_PARAM );
		}
	}
}

/*	sԍ̕\tH[}bg߂	*/
void	MakeLineNumFormatMyList( HWND hWnd, int nLineCnt )
{
	if( IsWindow( hWnd ) ) {
		LpMyListDataType	p = (LpMyListDataType)GetProp( hWnd, lpszPropertyName );
		if( p != NULL ) {
			LPCTSTR		lpszFmt = _T("%%%dd|");
			LPCTSTR		lpszDummy = _T("%%%ds|");
			int		n;
			if( nLineCnt < 10 ) {
				n = 1;							//	"%1d|" / "%1s"
			} else if( nLineCnt < 100 ) {
				n = 2;							//	"%2d|" / "%2s"
			} else if( nLineCnt < 1000 ) {
				n = 3;							//	"%3d|" / "%3s"
			} else if( nLineCnt < 10000 ) {
				n = 4;							//	"%4d|" / "%4s"
			} else {
				n = 5;							//	"%5d|" / "%5s"
			}
			wsprintf( p->szLineNumFmt, lpszFmt, n );
			wsprintf( p->szDummyFmt, lpszDummy, n );
			p->nLineCnt = nLineCnt;
			/*	sԍ̕\߂	*/
			CalcLineNumWidth( hWnd, NULL );
		}
	}
}

/*	}[NꗗNA	*/
static	void	ClearMarkList( HWND hWnd )
{
	if( IsWindow( hWnd ) ) {
		LpMyListDataType	p = (LpMyListDataType)GetProp( hWnd, lpszPropertyName );
		if( p != NULL ) {
			if( p->hMarkPos != NULL ) {
				GlobalFree( p->hMarkPos );
				p->hMarkPos = NULL;
			}
			p->nMarkCnt = 0;
		}
	}
}

/*	}[Nꗗɒǉ	*/
static	void	AppendMarkList( HWND hWnd, int nLineCnt )
{
	if( IsWindow( hWnd ) ) {
		LpMyListDataType	p = (LpMyListDataType)GetProp( hWnd, lpszPropertyName );
		if( p != NULL ) {
			int		nStep = 100;
			if( ( p->nMarkCnt % nStep ) == 0 ) {
				DWORD	dwSize = sizeof(int)*( p->nMarkCnt + nStep );
				if( p->hMarkPos == NULL ) {
					p->hMarkPos = GlobalAlloc( GHND, dwSize );
				} else {
					HGLOBAL	h = GlobalReAlloc( p->hMarkPos, dwSize, GMEM_MOVEABLE|GMEM_ZEROINIT );
					if( h == NULL ) {
						GlobalFree( p->hMarkPos );
					}
					p->hMarkPos = h;
				}
			}
			if( p->hMarkPos != NULL ) {
				int*	pMarkList;
				pMarkList = (int*)GlobalLock( p->hMarkPos );
				if( pMarkList != NULL ) {
					pMarkList[ (p->nMarkCnt)++ ] = nLineCnt;
				}
				GlobalUnlock( p->hMarkPos );
			}
		}
	}
}


/*	t@C̓ǂݍ	*/
BOOL	LoadFileMyList( HWND hWnd, WPARAM wParam, LPARAM lParam )
{
	TCHAR	buff[ LIST_LINE_BUFF_SIZE+1 ];
	BOOL	ret = FALSE;
	HANDLE	hFile = INVALID_HANDLE_VALUE;
	
	LpFileInfoType	lpFileInfo = (LpFileInfoType)lParam;
	HWND	hWnd1 = lpFileInfo->hWnd1;
	HWND	hWnd2 = lpFileInfo->hWnd2;
	HGLOBAL	hSaveBuff = NULL;
	DWORD	dwSaveBuffSize = 0;
	DWORD	dwSaveBuffPos = 0;
	
	if( lpFileInfo->lpszFile != NULL ) {
		hFile = CreateFile( lpFileInfo->lpszFile, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL );
	} else {
		hSaveBuff = lpFileInfo->hSaveBuff;
		dwSaveBuffSize = lpFileInfo->dwSaveBuffSize;
	}
	if( hFile != INVALID_HANDLE_VALUE || hSaveBuff != NULL ) {
		int		nLen;
		int		nLastLen = 0;
		DWORD	dwTick = GetTickCount();
		DWORD	dwFileSize;
		LPTSTR	q, r;
		BOOL	qf = FALSE;
		
		if( hFile != INVALID_HANDLE_VALUE ) {
			dwFileSize = GetFileSize( hFile, NULL );
		} else {
			dwFileSize = dwSaveBuffSize;
		}
		
		SendMessage( hWnd, WM_LIST_LOAD_FILE, MAKEWPARAM( 0, 0 ), (LPARAM)dwFileSize );
		LoadFilePhase1MyList( lpFileInfo, (int)dwFileSize );
		
		while( !qf ) {
			if( hFile != INVALID_HANDLE_VALUE ) {
				qf = !( ReadFile( hFile, buff+nLastLen, LIST_LINE_BUFF_SIZE-nLastLen, (LPDWORD)(&nLen), NULL ) && nLen > 0 );
			} else {
				if( dwSaveBuffPos >= dwSaveBuffSize ) {
					qf = TRUE;
				} else {
					nLen = LIST_LINE_BUFF_SIZE-nLastLen;
					if( dwSaveBuffPos + nLen >= dwSaveBuffSize ) {
						nLen = dwSaveBuffSize - dwSaveBuffPos;
					}
					CopyMemory( buff+nLastLen, ((LPCTSTR)hSaveBuff)+dwSaveBuffPos, nLen );
					dwSaveBuffPos += nLen;
				}
			}
			if( qf ) {
				break;
			}
			buff[nLastLen+nLen] = _T('\0');
			/*	Scintillaɑ}	*/
			LoadFilePhase2MyScintilla( lpFileInfo->hWndSci, buff+nLastLen, nLen );
			/*	LF	*/
			q = r = buff;
			while( *q != _T('\0') ) {
				if( *q != _T('\n') ) {
					*(r++) = *q;
				}
				q++;
			}
			*r = _T('\0');
//			/*	Scintillaɑ}	*/
//			LoadFilePhase2MyScintilla( lpFileInfo->hWndSci, buff+nLastLen, lstrlen(buff+nLastLen) );
			/*	CR؂Ƃđ}	*/
			q = r = buff;
			while( *q != _T('\0') ) {
				if( *q == _T('\r') ) {
					*q = _T('\0');
					if( !LoadFilePhase2MyList( lpFileInfo, r, q-r ) ) {
						goto exit_load;
					}
					r = q+1;
				}
				q++;
			}
			if( r == buff ) {
				/*	ReadFile()ł܂P}ĂȂB	*/
				/*	Ps(LIST_LINE_BUFF_SIZEȏ)̂ŁAő}Ă܂	*/
				if( !LoadFilePhase2MyList( lpFileInfo, r, q-r ) ) {
					goto exit_load;
				}
				r = q;
			}
			/*	c	*/
			nLastLen = q-r;
			if( nLastLen > 0 ) {
				MoveMemory( buff, r, sizeof(TCHAR)*nLastLen );
			}
			if( GetTickDiff( GetTickCount(), dwTick ) > 300 ) {
				MSG	msg;
				DWORD	dwFilePos;
				if( hFile != INVALID_HANDLE_VALUE ) {
					dwFilePos = SetFilePointer( hFile, 0, NULL, FILE_CURRENT );
				} else {
					dwFilePos = dwSaveBuffPos;
				}
				SendMessage( hWnd1, WM_SETREDRAW, TRUE, 0 );
				SendMessage( hWnd2, WM_SETREDRAW, TRUE, 0 );
				SendMessage( hWnd, WM_LIST_LOAD_FILE, MAKEWPARAM( 1, lpFileInfo->nLineCnt ), (LPARAM)dwFilePos );
//				InvalidateRect( hWnd1, NULL, TRUE );
//				InvalidateRect( hWnd2, NULL, TRUE );
//				PostMessage( hWnd, WM_SIZE, 0, 0 );
				while( PeekMessage( &msg, NULL, 0, 0, PM_REMOVE ) ) {
					(lpFileInfo->lpfnMessagePump)( hWnd, &msg );
				}
				SendMessage( hWnd1, WM_SETREDRAW, FALSE, 0 );
				SendMessage( hWnd2, WM_SETREDRAW, FALSE, 0 );
				dwTick = GetTickCount();
			}
		}
		/*	ŌɎc}	*/
		if( nLastLen > 0 ) {
			buff[nLastLen] = _T('\0');
			LoadFilePhase2MyList( lpFileInfo, buff, nLastLen );
			/*
				ƂƂŁAt@CCRLFȂĂA̍s͓ǂݍ܂
			*/
		}
exit_load:
		LoadFilePhase3MyList( lpFileInfo );
		SendMessage( hWnd, WM_LIST_LOAD_FILE, MAKEWPARAM( 2, lpFileInfo->nLineCnt ), (LPARAM)dwFileSize );
		
		if( hFile != INVALID_HANDLE_VALUE ) {
			CloseHandle( hFile );
		}
		ret = TRUE;
	}
	
	UNUSE(wParam);
	return( ret );
}

/*	t@C̓ǂݍ(O)	*/
void	LoadFilePhase1MyList( LpFileInfoType lpFileInfo, int nSize )
{
	HWND	hWnd1 = lpFileInfo->hWnd1;
	HWND	hWnd2 = lpFileInfo->hWnd2;
	LRESULT	lRet1, lRet2;
	
	lpFileInfo->nLineCnt = 0;
	lpFileInfo->nSize = 0;
	lpFileInfo->nMaxLen = 0;
	lpFileInfo->nMaxAt = 0;
	
	/*	Xg{bNX̑SACe폜	*/
	SendMessage( hWnd1, LB_RESETCONTENT, 0, 0 );
	SendMessage( hWnd2, LB_RESETCONTENT, 0, 0 );
	SendMessage( hWnd1, WM_SETREDRAW, FALSE, 0 );
	SendMessage( hWnd2, WM_SETREDRAW, FALSE, 0 );
#ifdef	WIN32
	SendMessage( hWnd1, LB_INITSTORAGE, (WPARAM)SHRT_MAX, (LPARAM)nSize );
	SendMessage( hWnd2, LB_INITSTORAGE, (WPARAM)SHRT_MAX, (LPARAM)nSize );
#endif
	/*	_~[̋s}	*/
	InsertDummyItem( hWnd1 );
	InsertDummyItem( hWnd2 );
	
	MD5Init( &(lpFileInfo->md5context) );
	
	/*	}[NꗗNA	*/
	ClearMarkList( hWnd1 );
	ClearMarkList( hWnd2 );
	
	/*	ScintillaNA	*/
	LoadFilePhase1MyScintilla( lpFileInfo->hWndSci );
}

/*	t@C̓ǂݍ(eACe)	*/
BOOL	LoadFilePhase2MyList( LpFileInfoType lpFileInfo, LPCTSTR lpszData, int nLen )
{
	HWND	hWnd1 = lpFileInfo->hWnd1;
	HWND	hWnd2 = lpFileInfo->hWnd2;
	LRESULT	lRet1, lRet2;
	BOOL	ret = TRUE;
	BOOL	bMark;
	BOOL	bComment;
	
	/*	Xg{bNXɒǉ	*/
	lRet1 = SendMessage( hWnd1, LB_ADDSTRING, 0, (LPARAM)lpszData );
	lRet2 = SendMessage( hWnd2, LB_ADDSTRING, 0, (LPARAM)lpszData );
	if( nLen > 0 ) {
		MD5Update( &(lpFileInfo->md5context), (unsigned char *)lpszData, nLen );
	} else {
		MD5Update( &(lpFileInfo->md5context), (unsigned char *)&(lpFileInfo->nLineCnt), sizeof(lpFileInfo->nLineCnt) );
	}
	
	/*	}[N	*/
	bMark = IsMarkStrJudge( &(lpFileInfo->MarkCommentInfo), lpszData, nLen );
	/*	Rg	*/
	bComment = IsCommentStrJudge( &(lpFileInfo->MarkCommentInfo), lpszData, nLen );
	
	if( lRet1 != LB_ERR && lRet1 != LB_ERRSPACE && lRet2 != LB_ERR && lRet2 != LB_ERRSPACE ) {
		DWORD	dwItemData;
		(lpFileInfo->nLineCnt)++;
		dwItemData = MAKE_ITEM_DATA( lpFileInfo->nLineCnt, (bMark?MARK_ITEM_ID:0)|(bComment?COMMENT_ITEM_ID:0) );
		SendMessage( hWnd1, LB_SETITEMDATA, lRet1, (LPARAM)dwItemData );
		SendMessage( hWnd2, LB_SETITEMDATA, lRet2, (LPARAM)dwItemData );
		if( lpFileInfo->nMaxLen < nLen ) {
			lpFileInfo->nMaxLen = nLen;
			lpFileInfo->nMaxAt = lpFileInfo->nLineCnt;
		}
		if( lpFileInfo->nLineCnt >= MAX_LISTBOX_ITEM_NUM ) {
			ret = FALSE;
		}
		if( bMark ) {
			AppendMarkList( hWnd1, lpFileInfo->nLineCnt );
			AppendMarkList( hWnd2, lpFileInfo->nLineCnt );
		}
	} else {
		ret = FALSE;
	}
	if( ret ) {
		lpFileInfo->nSize += nLen;
	}
	return ret;
}

/*	t@C̓ǂݍ(㏈)	*/
void	LoadFilePhase3MyList( LpFileInfoType lpFileInfo )
{
	HWND	hWnd1 = lpFileInfo->hWnd1;
	HWND	hWnd2 = lpFileInfo->hWnd2;
	
	MD5Update( &(lpFileInfo->md5context), (unsigned char *)&(lpFileInfo->nLineCnt), sizeof(lpFileInfo->nLineCnt) );
	MD5Final( lpFileInfo->md5Contents, &(lpFileInfo->md5context) );
	
	/*	_~[̋s}	*/
	InsertDummyItem( hWnd1 );
	InsertDummyItem( hWnd2 );
	/*	sԍ̃tH[}bg	*/
	MakeLineNumFormatMyList( hWnd1, lpFileInfo->nLineCnt );
	MakeLineNumFormatMyList( hWnd2, lpFileInfo->nLineCnt );
	/*	\ĊJ	*/
	SendMessage( hWnd1, WM_SETREDRAW, TRUE, 0 );
	SendMessage( hWnd2, WM_SETREDRAW, TRUE, 0 );
	InvalidateRect( hWnd1, NULL, TRUE );
	InvalidateRect( hWnd2, NULL, TRUE );
	/*	Scintillǎ㏈	*/
	LoadFilePhase3MyScintilla( lpFileInfo->hWndSci, &(lpFileInfo->MarkCommentInfo) );
}

/*	t@C̏o(sԍt)	*/
BOOL	SaveFileMyList( HWND hWnd, WPARAM wParam, LPARAM lParam )
{
	BOOL	ret = FALSE;
	HANDLE	hFile;
	
	LpFileInfoType	lpFileInfo = (LpFileInfoType)lParam;
	HWND	hWnd1 = lpFileInfo->hWnd1;
	HWND	hWnd2 = lpFileInfo->hWnd2;
	
	hFile = CreateFile( lpFileInfo->lpszFile, GENERIC_WRITE, FILE_SHARE_READ, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL );
	if( hFile != INVALID_HANDLE_VALUE ) {
		int		i;
		int		nItem;
		DWORD	dwBuffSize = 0;
		LPTSTR	lpszBuff = NULL;
		DWORD	dwTick = GetTickCount();
		int		nLen;
		DWORD	dwSize;
		DWORD	dwItemData;
		LPCTSTR	lpszNewLine = _T("\r\n");
		int		nLenNewLine = lstrlen( lpszNewLine );
		LpMyListDataType	p;
		
		p = (LpMyListDataType)GetProp( hWnd1, lpszPropertyName );
		SendMessage( hWnd, WM_LIST_SAVE_FILE, MAKEWPARAM( 0, 0 ), (LPARAM)lpFileInfo->nLineCnt );
		
		for( i = 0; i < lpFileInfo->nLineCnt; i++ ) {
			nItem = i+DUMMY_ITEM_CNT;
			nLen = SendMessage( hWnd1, LB_GETTEXTLEN, nItem, 0 );
			if( nLen == LB_ERR ) {
				break;
			}
			dwSize = sizeof(TCHAR)*(20+nLen+nLenNewLine+1);
			if( dwBuffSize < dwSize ) {
				if( lpszBuff == NULL ) {
					lpszBuff = (LPTSTR)GlobalAlloc( GPTR, dwSize );
				} else {
					LPTSTR	q = (LPTSTR)GlobalReAlloc( (HGLOBAL)lpszBuff, dwSize, GMEM_MOVEABLE|GMEM_ZEROINIT );
					if( q == NULL ) {
						GlobalFree( (HGLOBAL)lpszBuff );
						dwSize = 0;
					}
					lpszBuff = q;
				}
				dwBuffSize = dwSize;
			}
			dwItemData = SendMessage( hWnd1, LB_GETITEMDATA, nItem, 0 );
			if( lpszBuff != NULL ) {
				nLen = 0;
				if( p != NULL ) {
					nLen += wsprintf( lpszBuff+nLen, p->szLineNumFmt, (long)ITEM_DATA_LINENUM(dwItemData) );
				}
				nLen += SendMessage( hWnd1, LB_GETTEXT, nItem, (LPARAM)(lpszBuff+nLen) );
				lstrcpy( lpszBuff+nLen, lpszNewLine );
				nLen += nLenNewLine;
				WriteFile( hFile, lpszBuff, nLen, (LPDWORD)(&nLen), NULL );
			}
			if( GetTickDiff( GetTickCount(), dwTick ) > 300 ) {
				MSG	msg;
				SendMessage( hWnd, WM_LIST_SAVE_FILE, MAKEWPARAM( 1, i ), (LPARAM)i );
				while( PeekMessage( &msg, NULL, 0, 0, PM_REMOVE ) ) {
					(lpFileInfo->lpfnMessagePump)( hWnd, &msg );
				}
				dwTick = GetTickCount();
			}
		}
		if( lpszBuff != NULL ) {
			GlobalFree( (HGLOBAL)lpszBuff );
		}
		SendMessage( hWnd, WM_LIST_SAVE_FILE, MAKEWPARAM( 2, lpFileInfo->nLineCnt ), (LPARAM)lpFileInfo->nLineCnt );
		CloseHandle( hFile );
		ret = TRUE;
	}
	
	UNUSE(wParam);
	return( ret );
}

/*	sԍ̕\Ԃ	*/
int		GetLineNumWidthMyList( HWND hWnd, BOOL bFull )
{
	int		nWidth = 0;
	if( IsWindow( hWnd ) ) {
		LpMyListDataType	p = (LpMyListDataType)GetProp( hWnd, lpszPropertyName );
		if( p != NULL && p->bShowLineNum ) {
			if( bFull ) {
				nWidth = p->nLineNumWidth1;
			} else {
				nWidth = p->nLineNumWidth2;
			}
		}
	}
	return nWidth;
}

/*	sԍ̕Ԃ	*/
int		GetLineNumStrMyList( HWND hWnd, LPTSTR lpBuff, int num )
{
	int		nCnt = 0;
	if( IsWindow( hWnd ) ) {
		LpMyListDataType	p = (LpMyListDataType)GetProp( hWnd, lpszPropertyName );
		if( p != NULL && p->bShowLineNum && p->nLineCnt > 0 ) {
			DWORD	dwItemData = SendMessage( hWnd, LB_GETITEMDATA, num+DUMMY_ITEM_CNT, 0 );
			if( dwItemData == DUMMY_ITEM_PARAM ) {
				TCHAR	c = _T('\0');
				nCnt = wsprintf( lpBuff, p->szDummyFmt, &c );
			} else {
				nCnt = wsprintf( lpBuff, p->szLineNumFmt, (long)ITEM_DATA_LINENUM(dwItemData) );
			}
		}
	}
	return nCnt;
}

/*	w肵ԍ̃ACe擪/ɎĂ	*/
void	SetPosIndexMyList( HWND hWnd, int nItem, int nPos )
{
	if( IsWindow( hWnd ) ) {
		nItem += DUMMY_ITEM_CNT;
		if( nPos == POS_INDEX_TOP ) {
			SendMessage( hWnd, LB_SETTOPINDEX, nItem, 0 );
		} else if( nPos == POS_INDEX_BOTTOM ) {
			int		nLineCnt = GetShownLineCntMyList( hWnd, FALSE );	/*	\łs	*/
			SendMessage( hWnd, LB_SETTOPINDEX, nItem-nLineCnt+1, 0 );
		}
	}
}

/*	\łsԂ	*/
int		GetShownLineCntMyList( HWND hWnd, BOOL bNoZero )
{
	int		nCnt = 0;
	if( IsWindow( hWnd ) ) {
		int		nHeight;
		RECT	rect;
		int		nLineCnt;
		
		nHeight = (int)SendMessage( hWnd, LB_GETITEMHEIGHT, 0, 0 );
		if( nHeight <= 0 ) {
			nHeight = 1;
		}
		GetClientRect( hWnd, &rect );
		nCnt = ( rect.bottom - rect.top ) / nHeight;	//	\łs
	}
	if( bNoZero && nCnt < 1 ) {
		nCnt = 1;
	}
	return nCnt;
}

/*	w肵ԍ̃ACe擾	*/
LPCTSTR	GetTextMyList( HWND hWnd, int nItem )
{
	LPCTSTR	str = _T("");
	if( IsWindow( hWnd ) ) {
		LpMyListDataType	p = (LpMyListDataType)GetProp( hWnd, lpszPropertyName );
		int		nLen = SendMessage( hWnd, LB_GETTEXTLEN, nItem+DUMMY_ITEM_CNT, 0 );
		if( p != NULL && nLen != LB_ERR ) {
			DWORD	dwSize = sizeof(TCHAR)*(nLen+1);
			LPTSTR	q;
			if( p->dwTextbuffSize < dwSize ) {
				if( p->hTextBuff == NULL ) {
					p->hTextBuff = GlobalAlloc( GPTR, dwSize );
				} else {
					HGLOBAL	h = GlobalReAlloc( p->hTextBuff, dwSize, GMEM_MOVEABLE|GMEM_ZEROINIT );
					if( h == NULL ) {
						GlobalFree( p->hTextBuff );
						dwSize = 0;
					}
					p->hTextBuff = h;
				}
				p->dwTextbuffSize = dwSize;
			}
			q = (LPTSTR)( p->hTextBuff );
			if( q != NULL ) {
				nLen = SendMessage( hWnd, LB_GETTEXT, nItem+DUMMY_ITEM_CNT, (LPARAM)q );
				if( nLen != LB_ERR ) {
					str = q;
				}
			}
		}
	}
	return( str );
}


/*	łv	*/
void	SetHelpMeMyList( HWND hWnd, BOOL bFlag )
{
	if( IsWindow( hWnd ) ) {
		LpMyListDataType	p = (LpMyListDataType)GetProp( hWnd, lpszPropertyName );
		if( p != NULL ) {
			if( p->bHelpMe != bFlag ) {
				InvalidateRect( hWnd, NULL, TRUE );
			}
			p->bHelpMe = bFlag;
		}
	}
}

/*	{[h̐ݒ	*/
void	SetViewModeMyList( HWND hWnd, BOOL bFlag )
{
	if( IsWindow( hWnd ) ) {
		LpMyListDataType	p = (LpMyListDataType)GetProp( hWnd, lpszPropertyName );
		if( p != NULL ) {
			if( p->bViewMode != bFlag ) {
				InvalidateRect( hWnd, NULL, TRUE );
			}
			p->bViewMode = bFlag;
		}
	}
}

/*	Õ}[NT	*/
int		SearchPrevMarkMyList( HWND hWnd, int nLine )
{
	if( IsWindow( hWnd ) ) {
		LpMyListDataType	p = (LpMyListDataType)GetProp( hWnd, lpszPropertyName );
		if( p != NULL ) {
			int		i;
			DWORD	dwItemData;
			HCURSOR	hCursor = SetCursor( LoadCursor( NULL, IDC_WAIT ) );
			for( i = nLine-1; i >= 0; i-- ) {
				dwItemData = SendMessage( hWnd, LB_GETITEMDATA, i+DUMMY_ITEM_CNT, 0 );
				if( IS_MARK_ITEM_PARAM( dwItemData ) ) {
					nLine = i;
					break;
				}
			}
			SetCursor( hCursor );
		}
	}
	return nLine;
}

/*	̃}[NT	*/
int		SearchNextMarkMyList( HWND hWnd, int nLine )
{
	if( IsWindow( hWnd ) ) {
		LpMyListDataType	p = (LpMyListDataType)GetProp( hWnd, lpszPropertyName );
		if( p != NULL ) {
			int		i;
			DWORD	dwItemData;
			HCURSOR	hCursor = SetCursor( LoadCursor( NULL, IDC_WAIT ) );
			for( i = nLine+1; i < p->nLineCnt; i++ ) {
				dwItemData = SendMessage( hWnd, LB_GETITEMDATA, i+DUMMY_ITEM_CNT, 0 );
				if( IS_MARK_ITEM_PARAM( dwItemData ) ) {
					nLine = i;
					break;
				}
			}
			SetCursor( hCursor );
		}
	}
	return nLine;
}

/*	}[NȂTRUEԂ	*/
BOOL	IsMarkMyList( HWND hWnd, int nLine )
{
	BOOL	ret = FALSE;
	if( IsWindow( hWnd ) ) {
		LpMyListDataType	p = (LpMyListDataType)GetProp( hWnd, lpszPropertyName );
		if( p != NULL ) {
			DWORD	dwItemData;
			dwItemData = SendMessage( hWnd, LB_GETITEMDATA, nLine+DUMMY_ITEM_CNT, 0 );
			if( dwItemData != (DWORD)LB_ERR ) {
				ret = IS_MARK_ITEM_PARAM( dwItemData );
			}
		}
	}
	return ret;
}

/*	RgȂTRUEԂ	*/
BOOL	IsCommentMyList( HWND hWnd, int nLine )
{
	BOOL	ret = FALSE;
	if( IsWindow( hWnd ) ) {
		LpMyListDataType	p = (LpMyListDataType)GetProp( hWnd, lpszPropertyName );
		if( p != NULL ) {
			DWORD	dwItemData;
			dwItemData = SendMessage( hWnd, LB_GETITEMDATA, nLine+DUMMY_ITEM_CNT, 0 );
			if( dwItemData != (DWORD)LB_ERR ) {
				ret = IS_COMMENT_ITEM_PARAM( dwItemData );
			}
		}
	}
	return ret;
}

/*	e	*/
void	EmptyMyList( HWND hWnd )
{
	if( IsWindow( hWnd ) ) {
		LpMyListDataType	p = (LpMyListDataType)GetProp( hWnd, lpszPropertyName );
		if( p != NULL ) {
			p->nLineCnt = 0;
			CalcLineNumWidth( hWnd, NULL );
			if( p->hMarkPos != NULL ) {
				GlobalFree( p->hMarkPos );
				p->hMarkPos = NULL;
			}
			p->nMarkCnt = 0;
		}
		SendMessage( hWnd, LB_RESETCONTENT, 0, 0 );
	}
}

/*--------------------------------------------------------------*\
	牺́A}[Nꗗ̃EBhEŎgp
\*--------------------------------------------------------------*/

/*	tH[JXĂ	*/
void	SetCanHaveFocusMyList( HWND hWnd, BOOL flag )
{
	if( IsWindow( hWnd ) ) {
		LpMyListDataType	p = (LpMyListDataType)GetProp( hWnd, lpszPropertyName );
		if( p != NULL ) {
			p->bCanHaveFocus = flag;
		}
	}
}

/*	}[NRs[	*/
void	InsertMarkMyList( HWND hWndTo, HWND hWndFrom, int nLineNum )
{
	if( hWndTo != NULL && hWndFrom != NULL && IsWindow( hWndTo ) && IsWindow( hWndFrom ) ) {
		int		nItemSel = LB_ERR;
		LpMyListDataType	p = (LpMyListDataType)GetProp( hWndFrom, lpszPropertyName );
		if( p != NULL ) {
			if( p->hMarkPos != NULL ) {
				int*	pMarkList = (int*)GlobalLock( p->hMarkPos );
				if( pMarkList != NULL ) {
					int		nCnt = p->nMarkCnt;
					int		i;
					int		nLine;
					LPCTSTR	q;
					LRESULT	lRet;
					for( i = 0; i < nCnt; i++ ) {
						nLine = pMarkList[i];
						q = GetTextMyList( hWndFrom, nLine-1 );
						if( q != NULL ) {
							lRet = InsertOneMarkMyList( hWndTo, q, nLine );
							if( lRet != LB_ERR ) {
								if( nLine-1 <= nLineNum ) {
									nItemSel = (int)lRet;
								}
							}
						}
					}
				}
				GlobalUnlock( p->hMarkPos );
			}
		}
		CenterMarkMyList( hWndTo, nItemSel );
	}
}

/*	}[N̑}	*/
LRESULT	InsertOneMarkMyList( HWND hWndTo, LPCTSTR lpszStr, int nLine )
{
	LRESULT	lRet;
	
	lRet = SendMessage( hWndTo, LB_ADDSTRING, 0, (LPARAM)lpszStr );
	if( lRet != LB_ERR ) {
		SendMessage( hWndTo, LB_SETITEMDATA, lRet, MARK_ITEM_PARAM( nLine ) );
	}
	return lRet;
}

/*	}[N̑}㏈	*/
void	CenterMarkMyList( HWND hWndTo, int nItemSel )
{
	if( nItemSel != LB_ERR ) {
		/*	݈ʒu㉺Z^O	*/
		int		nLineCnt = GetShownLineCntMyList( hWndTo, FALSE );	/*	\łs	*/
		SendMessage( hWndTo, LB_SETTOPINDEX, nItemSel-nLineCnt/2, 0 );
		/*	݈ʒuI	*/
		SendMessage( hWndTo, LB_SETCURSEL, nItemSel, 0 );
	}
}

/*	sԍԂ	*/
int		GetLineNumMyList( HWND hWnd, int nItem )
{
	int		ret = -1;
	if( IsWindow( hWnd ) ) {
		LpMyListDataType	p = (LpMyListDataType)GetProp( hWnd, lpszPropertyName );
		if( p != NULL ) {
			if( p->bCanHaveFocus ) {
				DWORD	dwItemData;
				if( nItem == LB_ERR ) {
					nItem = SendMessage( hWnd, LB_GETCURSEL, 0, 0 );
				}
				dwItemData = SendMessage( hWnd, LB_GETITEMDATA, nItem, 0 );
				if( dwItemData != (DWORD)LB_ERR ) {
					ret = (int)ITEM_DATA_LINENUM(dwItemData);
					ret--;
				}
			}
		}
	}
	return ret;
}
