/*--------------------------------------------------------------*\
		module	:	MySci.c
		purpose :	X-Send Scintilla
		author	:	_@ Kengo Jinno
		create	:	2002/03/19
		update	:	2002/04/17
					2004/02/20	SaveFileMyScintilla()̃oOC
								艻
					2004/02/20	̐FAFƔwiF
								ԐFɂȂ悤ɂ
					2004/02/20	LbgI͈͓ɂ鎞
								̔wiFLbgF߂
					2004/02/23	mۃ`FbNd
\*--------------------------------------------------------------*/

#include	"PCH.h"
#include	"MySci.h"
#include	"resource.h"
#include	"MyList.h"
#include	"Tools.h"

static	HINSTANCE	hInstSciltilla = NULL;

static	LPCTSTR		lpszPropertyName = _T("73a1e0e0-3b66-11d6-afba-00c0ca10a705");

/*	Scintilla̍쐬	*/
HWND	CreateMyScintilla( HWND hWndParent, UINT nCtrlID, LPCTSTR lpszDllPath )
{
	HINSTANCE	hInstance = (HINSTANCE)GetWindowLong( hWndParent, GWL_HINSTANCE );
	HWND	hWnd = NULL;
	/*	DLL̃[h	*/
	if( hInstSciltilla == NULL ) {
		LPCTSTR	lpszDllName = _T("Scintilla.dll");
		TCHAR	szDllPath[ _MAX_PATH ];
		/*	st@CƓfBNg	*/
		lstrcpy( szDllPath, lpszDllPath );
		lstrcat( szDllPath, lpszDllName );
		hInstSciltilla = LoadLibraryEx( szDllPath, NULL, 0 );
		/*	_Ax[X݂̂DLLpXg	*/
		if( hInstSciltilla == NULL ) {
			hInstSciltilla = LoadLibraryEx( lpszDllName, NULL, 0 );
		}
	}
	/*	EBhE쐬	*/
	if( hInstSciltilla != NULL ) {
		hWnd = CreateWindowEx( WS_EX_CLIENTEDGE, _T("Scintilla"), _T(""),
			WS_CHILD|WS_VSCROLL|WS_HSCROLL|WS_CLIPSIBLINGS,
			0, 0, 0, 0, hWndParent, (HMENU)nCtrlID, hInstance, NULL );
	}
	if( hWnd != NULL ) {
		LpMySciDataType	p;
		p = (LpMySciDataType)GlobalAlloc( GPTR, sizeof(MySciDataType) );
		if( p == NULL ) {
			DestroyWindow( hWnd );
			FreeLibrary( hInstSciltilla );
			hInstSciltilla = NULL;
			return( NULL );
		}
		ZeroMemory( p, sizeof(MySciDataType) );
		p->bEnableDiamond = TRUE;
		p->bEnableCtrlXC = TRUE;
		p->hAccelSci = LoadAccelerators( hInstance, MAKEINTRESOURCE( IDR_ACCEL_SCI ) );
		p->hAccelDiamond = LoadAccelerators( hInstance, MAKEINTRESOURCE( IDR_ACCEL_DIAMOND_SCI ) );
		p->bShowLineNum = TRUE;
		p->bShowNewLine = TRUE;
		p->bShowEdge = FALSE;
		p->nEdgeColumn = 10;
		p->bMarkAsComment = FALSE;
		p->nLineNumWidth = 0;
		p->colNormal = (COLORREF)0;
		p->colReverse = (COLORREF)0;
		p->hTextBuff = NULL;
		p->dwTextBuffSize = 0;
		p->hSaveBuff = NULL;
		p->dwSaveBuffSize = 0;
		p->fn = (LP_FUNC_SCI_DIRECT)SendMessage( hWnd, SCI_GETDIRECTFUNCTION, 0, 0 );
		p->pt = (LP_DATA_SCI_DIRECT)SendMessage( hWnd, SCI_GETDIRECTPOINTER, 0, 0 );
		/*	vpeBɃZbg	*/
		SetProp( hWnd, lpszPropertyName, (HANDLE)p );
		/*	TuNX	*/
		p->lpfnOldWndProc = (WNDPROC)SetWindowLong( hWnd, GWL_WNDPROC, (LONG)MyScintillaWndProc );
		
		SendMessage( hWnd, SCI_SETCODEPAGE, 932, 0 );	/*	{DBCS(!UTF8)	*/
		SendMessage( hWnd, SCI_SETCARETWIDTH, 3, 0 );	/*	Lbg̕	*/
		
		/*	}[J[`	*/
		SendMessage( hWnd, SCI_MARKERDEFINE,  MARKER_SCI_MARK, (LPARAM)SC_MARK_CIRCLE/*SC_MARK_SHORTARROW*/ );
		SendMessage( hWnd, SCI_MARKERDEFINE,  MARKER_SCI_POS,  (LPARAM)SC_MARK_SHORTARROW );
		SendMessage( hWnd, SCI_SETMARGINMASKN, MARGIN_POS,  MARKER_BIT( MARKER_SCI_POS ) );
		SendMessage( hWnd, SCI_SETMARGINMASKN, MARGIN_MARK, MARKER_BIT( MARKER_SCI_MARK ) );
		
		/*	Scintillaɂ̓ReLXgj[oȂB(eŏ)	*/
		SendMessage( hWnd, SCI_USEPOPUP, 0, 0 );
		
		/*	VK_INSERTł̑}/㏑؂ւE	*/
		SendMessage( hWnd, SCI_CLEARCMDKEY, MAKEWPARAM(SCK_INSERT,0), 0 );
		
		/*	RgśA[܂Ŕ]	*/
		SendMessage( hWnd, SCI_STYLESETEOLFILLED, STYLE_SCI_COMMENT, (LPARAM)TRUE );
		SendMessage( hWnd, SCI_STYLESETEOLFILLED, STYLE_SCI_MARK,    (LPARAM)TRUE );
	}
	
	return hWnd;
}


/*	Scintilla̔j	*/
BOOL	DestroyMyScintilla( HWND hWnd )
{
	BOOL	ret = TRUE;
	if( IsWindow( hWnd ) ) {
		LpMySciDataType	p = (LpMySciDataType)GetProp( hWnd, lpszPropertyName );
		if( p != NULL ) {
			/*	TuNX	*/
			if( p->lpfnOldWndProc != NULL ) {
				SetWindowLong( hWnd, GWL_WNDPROC, (LONG)p->lpfnOldWndProc );
				p->lpfnOldWndProc = NULL;
			}
			/*		*/
			if( p->hTextBuff != NULL ) {
				GlobalFree( (HGLOBAL)p->hTextBuff );
				p->hTextBuff = NULL;
			}
			p->dwTextBuffSize = 0;
			if( p->hSaveBuff != NULL ) {
				GlobalFree( (HGLOBAL)p->hSaveBuff );
				p->hSaveBuff = NULL;
			}
			p->dwSaveBuffSize = 0;
			/*	vpeB폜	*/
			RemoveProp( hWnd, lpszPropertyName );
			GlobalFree( (HGLOBAL)p );
		}
		/*	p	*/
		ret = DestroyWindow( hWnd );
	}
	if( hInstSciltilla != NULL ) {
		FreeLibrary( hInstSciltilla );
		hInstSciltilla = NULL;
	}
	return ret;
}


/*	TuNXvV[W	*/
LRESULT	MYEXPORT	CALLBACK	MyScintillaWndProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	LpMySciDataType	p = (LpMySciDataType)GetProp( hWnd, lpszPropertyName );
	if( p == NULL || p->lpfnOldWndProc == NULL ) {
		return DefWindowProc( hWnd, uMsg, wParam, lParam );
	}
	if( uMsg == WM_SCI_UPDATE_CARET_COLOR ) {
		/*	Lbg̐Fݒ肷	*/
		LP_FUNC_SCI_DIRECT	fn = p->fn;
		LP_DATA_SCI_DIRECT	pt = p->pt;
		int		pos = fn( pt, SCI_GETCURRENTPOS, 0, 0 );
		int		nStyle = fn( pt, SCI_GETSTYLEAT, pos, 0 );
		int		nSt = fn( pt, SCI_GETSELECTIONSTART, 0, 0 );
		int		nEn = fn( pt, SCI_GETSELECTIONEND, 0, 0 );
		COLORREF	col = p->colNormal;
		if( nSt != nEn && nSt <= pos && pos < nEn ) {
			col = p->colReverse;	/*	IĂ	*/
		}
		switch( nStyle ) {
		case STYLE_SCI_MARK:
			if( !p->bMarkAsComment ) {
				break;
			}
			//	̂܂ܗ
		case STYLE_SCI_COMMENT:
			col = p->colReverse;
			break;
		}
#if	defined(__LCC__)
		{
			BYTE	r = GetRValue(col);
			BYTE	g = GetGValue(col);
			BYTE	b = GetBValue(col);
			col = RGB(255-r,255-g,255-b);
		}
#else
		col = RGB(255-GetRValue(col),255-GetGValue(col),255-GetBValue(col));
#endif
		if( col != (COLORREF)fn( pt, SCI_GETCARETFORE, 0, 0 ) ) {
			fn( pt, SCI_SETCARETFORE, col, 0 );
		}
	} else if( uMsg == SCI_CLEARALL ) {
		if( p->hSaveBuff != NULL ) {
			GlobalFree( (HGLOBAL)p->hSaveBuff );
			p->hSaveBuff = NULL;
		}
		p->dwSaveBuffSize = 0;
	} else if( uMsg == WM_DESTROY ) {
		RemoveProp( hWnd, lpszPropertyName );
	}
//	if( IsBadReadPtr( &(p->lpfnOldWndProc), sizeof(p->lpfnOldWndProc) ) || IsBadCodePtr( (FARPROC)p->lpfnOldWndProc ) ) {
//		return DefWindowProc( hWnd, uMsg, wParam, lParam );
//	}
	return CallWindowProc( p->lpfnOldWndProc, hWnd, uMsg, wParam, lParam );
}


/*	Lbg_Ŏ̐ݒ	*/
void	SetCaretPeriodMyScintilla( HWND hWnd, UINT uPeriod )
{
	if( hWnd != NULL && IsWindow( hWnd ) ) {
		SendMessage( hWnd, SCI_SETCARETPERIOD, (WPARAM)uPeriod, 0 );
	}
}

static	void	SetFontAttr( HWND hWnd, int nStyleNum, const LOGFONT* plf )
{
	SendMessage( hWnd, SCI_STYLESETCHARACTERSET, nStyleNum, (LPARAM)plf->lfCharSet );
	SendMessage( hWnd, SCI_STYLESETFONT,         nStyleNum, (LPARAM)plf->lfFaceName );
	SendMessage( hWnd, SCI_STYLESETSIZE,         nStyleNum, (LPARAM)plf->lfHeight );
	SendMessage( hWnd, SCI_STYLESETITALIC,       nStyleNum, (LPARAM)plf->lfItalic );
	SendMessage( hWnd, SCI_STYLESETBOLD,         nStyleNum, (LPARAM)(plf->lfWeight>400) );
	SendMessage( hWnd, SCI_STYLESETUNDERLINE,    nStyleNum, (LPARAM)FALSE );
}

/*	tHgݒ	*/
void	SetFontMyScintilla( HWND hWnd, HFONT hFont, HFONT hFontNewLine )
{
	if( hWnd != NULL && IsWindow( hWnd ) ) {
		LpMySciDataType	p = (LpMySciDataType)GetProp( hWnd, lpszPropertyName );
		if( p != NULL ) {
			int		nWidth;
			LOGFONT	lf;
			HDC		hDC = GetDC( hWnd );
			GetObject( hFont, sizeof(lf), &lf );
			if( hDC != NULL ) {
				int		nOldMapMode = SetMapMode( hDC, MM_TWIPS );
				POINT	pt;
				pt.x = lf.lfWidth;
				pt.y = lf.lfHeight;
				DPtoLP( hDC, &pt, 1 );
				lf.lfHeight = pt.y / 20;
				SetMapMode( hDC, nOldMapMode );
				ReleaseDC( hWnd, hDC );
			} else {
				lf.lfHeight *= 72;
				lf.lfHeight /= 96;	// GetDeviceCaps( hDC, LOGPIXELSY );
			}
			if( lf.lfHeight < 0 ) {
				lf.lfHeight = -lf.lfHeight;
			}
			SetFontAttr( hWnd, STYLE_DEFAULT,     &lf );
			SetFontAttr( hWnd, STYLE_SCI_NORMAL,  &lf );
			SetFontAttr( hWnd, STYLE_SCI_MARK,    &lf );
			SetFontAttr( hWnd, STYLE_SCI_COMMENT, &lf );
			SetFontAttr( hWnd, STYLE_LINENUMBER,  &lf );
			
			{
				LOGFONT	lf2;
				GetObject( hFontNewLine, sizeof(lf2), &lf2 );
				lf.lfCharSet = lf2.lfCharSet;
				lstrcpy( lf.lfFaceName, lf2.lfFaceName );
			}
			lf.lfHeight = (4*lf.lfHeight)/5;
			lf.lfWeight = 500;
			SetFontAttr( hWnd, STYLE_CONTROLCHAR, &lf );
			
			/*	sԍ̕	*/
			hDC = GetDC( hWnd );
			if( hDC != NULL ) {
				HFONT	hOldFont = SelectObject( hDC, hFont );
				SIZE	size;
				GetTextExtentPoint32( hDC, _T("99999"), 5, &size );	//	T
				p->nLineNumWidth = ( size.cx * 110 ) / 100;			//	10%
				SelectObject( hDC, hOldFont );
				ReleaseDC( hWnd, hDC );
			}
			SendMessage( hWnd, SCI_SETMARGINWIDTHN, MARGIN_LINENUM, p->bShowLineNum ? p->nLineNumWidth : 0 );
			
			/*	}[J[̕(Ɠ)	*/
			GetObject( hFont, sizeof(lf), &lf );
			nWidth = lf.lfHeight;
			if( nWidth < 0 ) {
				nWidth = -nWidth;
			}
			if( nWidth < GetSystemMetrics( SM_CXVSCROLL ) ) {
				nWidth = GetSystemMetrics( SM_CXVSCROLL );
			}
			SendMessage( hWnd, SCI_SETMARGINWIDTHN, MARGIN_POS,  nWidth );
			SendMessage( hWnd, SCI_SETMARGINWIDTHN, MARGIN_MARK, nWidth );
		}
	}
}

/*	Fݒ	*/
void	SetColorMyScintilla( HWND hWnd )
{
	if( IsWindow( hWnd ) ) {
		LpMySciDataType	p = (LpMySciDataType)GetProp( hWnd, lpszPropertyName );
		if( p != NULL ) {
			COLORREF	colText, colBack;
			
			colText = GetSysColor( COLOR_WINDOWTEXT );
			colBack = GetSysColor( COLOR_WINDOW );
			/*	ʏ̃eLXg	*/
			SendMessage( hWnd, SCI_STYLESETFORE, STYLE_DEFAULT,      (LPARAM)colText );
			SendMessage( hWnd, SCI_STYLESETBACK, STYLE_DEFAULT,      (LPARAM)colBack );
			SendMessage( hWnd, SCI_STYLESETFORE, STYLE_SCI_NORMAL,   (LPARAM)colText );
			SendMessage( hWnd, SCI_STYLESETBACK, STYLE_SCI_NORMAL,   (LPARAM)colBack );
			/*	}[Ns	*/
			if( !p->bMarkAsComment ) {
				SendMessage( hWnd, SCI_STYLESETFORE, STYLE_SCI_MARK,   (LPARAM)colText );
				SendMessage( hWnd, SCI_STYLESETBACK, STYLE_SCI_MARK,   (LPARAM)colBack );
			}
			p->colNormal = colBack;
			
			colText = GetSysColor( COLOR_HIGHLIGHTTEXT );
			colBack = GetSysColor( COLOR_HIGHLIGHT );
			/*	Rgs	*/
			SendMessage( hWnd, SCI_STYLESETFORE, STYLE_SCI_COMMENT,  (LPARAM)colText );
			SendMessage( hWnd, SCI_STYLESETBACK, STYLE_SCI_COMMENT,  (LPARAM)colBack );
			/*	}[J[̐F	*/
			SendMessage( hWnd, SCI_MARKERSETFORE, MARKER_SCI_MARK, (LPARAM)colBack );
			SendMessage( hWnd, SCI_MARKERSETBACK, MARKER_SCI_MARK, (LPARAM)colBack );
			SendMessage( hWnd, SCI_MARKERSETFORE, MARKER_SCI_POS,  (LPARAM)colBack );
			SendMessage( hWnd, SCI_MARKERSETBACK, MARKER_SCI_POS,  (LPARAM)colBack );
			/*	}[Ns	*/
			if( p->bMarkAsComment ) {
				SendMessage( hWnd, SCI_STYLESETFORE, STYLE_SCI_MARK,   (LPARAM)colText );
				SendMessage( hWnd, SCI_STYLESETBACK, STYLE_SCI_MARK,   (LPARAM)colBack );
			}
			/*	I𒆃eLXg	*/
			SendMessage( hWnd, SCI_SETSELFORE, TRUE, colText );
			SendMessage( hWnd, SCI_SETSELBACK, TRUE, colBack );
			p->colReverse = colBack;
			
			/*	sԍ̐F	*/
			if( GetSysColor( COLOR_INFOBK ) != GetSysColor( COLOR_WINDOW ) ) {
				colText = GetSysColor( COLOR_INFOTEXT );
				colBack = GetSysColor( COLOR_INFOBK );
			} else {
				colText = GetSysColor( COLOR_BTNTEXT );
				colBack = GetSysColor( COLOR_BTNFACE );
			}
			SendMessage( hWnd, SCI_STYLESETFORE, STYLE_LINENUMBER,   (LPARAM)colText );
			SendMessage( hWnd, SCI_STYLESETBACK, STYLE_LINENUMBER,   (LPARAM)colBack );
			
#if 0
			/*	sL̐F	*/
			colText = GetSysColor( COLOR_HIGHLIGHTTEXT );
			colBack = GetSysColor( COLOR_HIGHLIGHT );
			SendMessage( hWnd, SCI_STYLESETFORE, STYLE_CONTROLCHAR,   (LPARAM)colText );
			SendMessage( hWnd, SCI_STYLESETBACK, STYLE_CONTROLCHAR,   (LPARAM)colBack );
#endif
			
			/*	̐F	*/
#if 1
			{
				USHORT	r, g, b;
				colText = GetSysColor( COLOR_WINDOWTEXT );
				colBack = GetSysColor( COLOR_WINDOW );
				r = GetRValue( colText ) + GetRValue( colBack );
				g = GetGValue( colText ) + GetGValue( colBack );
				b = GetBValue( colText ) + GetBValue( colBack );
				SendMessage( hWnd, SCI_SETEDGECOLOUR, (WPARAM)RGB( r/2, g/2, b/2 ), 0 );
				/*	FƔwiF̒	*/
			}
#else
			if( GetSysColor( COLOR_BTNFACE ) != GetSysColor( COLOR_WINDOW ) ) {
				colText = GetSysColor( COLOR_BTNFACE );
			} else {
				colText = GetSysColor( COLOR_HIGHLIGHT );
			}
			SendMessage( hWnd, SCI_SETEDGECOLOUR, (WPARAM)colText, 0 );
#endif
			
			/*	Lbg̐F	*/
			PostMessage( hWnd, WM_SCI_UPDATE_CARET_COLOR, 0, 0 );
		}
	}
}

/*	IvVݒ	*/
void	SetOptionMyScintilla( HWND hWnd, BOOL bDiamond, BOOL bCtrlXC, BOOL bShowLineNum, BOOL bShowNewLine, TCHAR cNewLine, BOOL bMarkAsComment, BOOL bShowEdge, int nEdgeColumn )
{
	if( IsWindow( hWnd ) ) {
		LpMySciDataType	p = (LpMySciDataType)GetProp( hWnd, lpszPropertyName );
		if( p != NULL ) {
			if( p->bEnableDiamond != bDiamond ) {
				p->bEnableDiamond = bDiamond;
			}
			
			if( p->bEnableCtrlXC != bCtrlXC ) {
				p->bEnableCtrlXC = bCtrlXC;
			}
			
			if( p->bShowLineNum != bShowLineNum ) {
				p->bShowLineNum = bShowLineNum;
			}
			SendMessage( hWnd, SCI_SETMARGINWIDTHN, MARGIN_LINENUM, p->bShowLineNum ? p->nLineNumWidth : 0 );
			
			if( p->bShowNewLine != bShowNewLine ) {
				p->bShowNewLine = bShowNewLine;
			}
			SendMessage( hWnd, SCI_SETVIEWEOL, (WPARAM)p->bShowNewLine, 0 );
			
			if( p->bMarkAsComment != bMarkAsComment ) {
				p->bMarkAsComment = bMarkAsComment;
			}
			
			SendMessage( hWnd, SCI_SETCONTROLCHARSYMBOL, (WPARAM)((BYTE)cNewLine), 0 );
			
			if( p->bShowEdge != bShowEdge ) {
				p->bShowEdge = bShowEdge;
			}
			if( p->nEdgeColumn != nEdgeColumn ) {
				p->nEdgeColumn = nEdgeColumn;
			}
			SendMessage( hWnd, SCI_SETEDGECOLUMN, (WPARAM)(p->nEdgeColumn*2), 0 );
			SendMessage( hWnd, SCI_SETEDGEMODE, p->bShowEdge?EDGE_LINE:EDGE_NONE, 0 );
			
			SetColorMyScintilla( hWnd );
		}
	}
}

/*	X^Cݒ(SCN_STYLENEEDED)	*/
static	void	OnStyleNeeded( HWND hWnd, int nPosFrom, int nPosTo, LpMarkCommentInfoType pInfo )
{
	if( IsWindow( hWnd ) ) {
		LpMySciDataType	p = (LpMySciDataType)GetProp( hWnd, lpszPropertyName );
		if( p != NULL ) {
			LP_FUNC_SCI_DIRECT	fn = p->fn;
			LP_DATA_SCI_DIRECT	pt = p->pt;
			int		pos = nPosFrom;
			int		to = nPosTo;
			int		nLine;
			int		pos0, pos1;
			int		nState;
			int		nStyle;
			LPCTSTR	pBuff;
			int		nLen;
			BOOL	bMark;
			BOOL	bComment;
			
			if( to < 0 ) {
				to = fn( pt, SCI_GETTEXTLENGTH, 0, 0 );
			}
			
			nLine = fn( pt, SCI_LINEFROMPOSITION, pos, 0 );
			pos0 = fn( pt, SCI_POSITIONFROMLINE, nLine, 0 );
			
			while( pos < to ) {
				pBuff = GetTextMyScintilla( hWnd, nLine, &nLen );
				nState = STATE_SCI_NORMAL;
				nStyle = STYLE_SCI_NORMAL;
				
				if( pBuff != NULL ) {
					bMark = IsMarkStrJudge( pInfo, pBuff, nLen );
					bComment = IsCommentStrJudge( pInfo, pBuff, nLen );
				} else {
					bMark = bComment = FALSE;
				}
				fn( pt, SCI_MARKERDELETE, nLine, MARKER_SCI_MARK );
				if( bComment ) {
					nStyle = STYLE_SCI_COMMENT;
					nState = STATE_SCI_COMMENT;
				}
				if( bMark ) {
					if( nStyle == STYLE_SCI_NORMAL ) {
						nStyle = STYLE_SCI_MARK;
						nState = STATE_SCI_MARK;
					}
					fn( pt, SCI_MARKERADD, nLine, MARKER_SCI_MARK );
				}
				pos1 = fn( pt, SCI_POSITIONFROMLINE, nLine+1, 0 );
				fn( pt, SCI_STARTSTYLING, pos0, 0xff );
				fn( pt, SCI_SETSTYLING, pos1-pos0, nStyle );
#if 0
				if( nStyle != STYLE_SCI_COMMENT ) {
					pos0 = fn( pt, SCI_GETLINEENDPOSITION, nLine, 0 );
					fn( pt, SCI_STARTSTYLING, pos0, 0xff );
					fn( pt, SCI_SETSTYLING, pos1-pos0, STYLE_CONTROLCHAR );
				}
#endif
				fn( pt, SCI_SETLINESTATE, nLine, nState );
				/*	̍s	*/
				pos = pos0 = pos1;
				nLine++;
			}
		}
	}
}

/*	XV(SCN_UPDATEUI)	*/
static	void	OnUpdateUi( HWND hWnd )
{
	if( IsWindow( hWnd ) ) {
		LpMySciDataType	p = (LpMySciDataType)GetProp( hWnd, lpszPropertyName );
		if( p != NULL ) {
			/*	}[J[()̐ݒ	*/
			LP_FUNC_SCI_DIRECT	fn = p->fn;
			LP_DATA_SCI_DIRECT	pt = p->pt;
			int		pos = fn( pt, SCI_GETCURRENTPOS, 0, 0 );
			int		nLine = fn( pt, SCI_LINEFROMPOSITION, (WPARAM)pos, 0 );
			int		nMarker = fn( pt, SCI_MARKERGET, (WPARAM)nLine, 0 );
			LPARAM	lParam = MARKER_BIT( MARKER_SCI_POS );
			if( ( nMarker & lParam ) == 0 ) {
				while( 0 <= (int)fn( pt, SCI_MARKERNEXT, 0, lParam ) ) {
					fn( pt, SCI_MARKERDELETEALL, MARKER_SCI_POS, 0 );
				}
				fn( pt, SCI_MARKERADD, nLine, MARKER_SCI_POS );
			}
			/*	Lbg̐Fݒ肷	*/
			PostMessage( hWnd, WM_SCI_UPDATE_CARET_COLOR, 0, 0 );
		}
	}
}

/*	ʒmbZ[W	*/
BOOL	NotifyProcMyScintilla( HWND hWnd, LPNMHDR pnmh, LpMarkCommentInfoType pInfo )
{
	BOOL	ret = FALSE;
	if( pnmh->code == SCN_STYLENEEDED ) {
		struct	SCNotification*	q = (struct SCNotification*)pnmh;
		int		pos = SendMessage( hWnd, SCI_GETENDSTYLED, 0, 0 );
		OnStyleNeeded( hWnd, pos, q->position, pInfo );
	} else if( pnmh->code == SCN_UPDATEUI ) {
		OnUpdateUi( hWnd );
	} else if( pnmh->code == SCN_SAVEPOINTREACHED || pnmh->code == SCN_SAVEPOINTLEFT ) {
		ret = TRUE;
	}
	return ret;
}

/*	t@C̓ǂݍ(O)	*/
void	LoadFilePhase1MyScintilla( HWND hWnd )
{
	if( hWnd != NULL && IsWindow( hWnd ) ) {
		SendMessage( hWnd, SCI_CLEARALL, 0, 0 );
		SendMessage( hWnd, SCI_SETSAVEPOINT, 0, 0 );
	}
}

/*	t@C̓ǂݍ(eACe)	*/
BOOL	LoadFilePhase2MyScintilla( HWND hWnd, LPCTSTR lpszData, int nLen )
{
	if( hWnd != NULL && IsWindow( hWnd ) ) {
		SendMessage( hWnd, SCI_ADDTEXT, nLen, (LPARAM)lpszData );
	}
	return TRUE;
}

/*	t@C̓ǂݍ(㏈)	*/
void	LoadFilePhase3MyScintilla( HWND hWnd, LpMarkCommentInfoType pInfo )
{
	if( hWnd != NULL && IsWindow( hWnd ) ) {
		SendMessage( hWnd, SCI_GOTOPOS, 0, 0 );				/*	擪Ɉړ	*/
		SendMessage( hWnd, SCI_SETSAVEPOINT, 0, 0 );
		SendMessage( hWnd, SCI_EMPTYUNDOBUFFER, 0, 0 );		/*	UNDOobt@NA	*/
		DoStylingMyScintilla( hWnd, pInfo );	/*	X^C	*/
	}
}

#define	BUFF_SIZE	4096

/*	Xg{bNXRs[	*/
BOOL	CopyFromListBoxMyScintilla( HWND hWnd, WPARAM wParam, LPARAM lParam )
{
	LpCopyFromListBoxMyScintillaInfoType	pInfo = (LpCopyFromListBoxMyScintillaInfoType)lParam;
	HWND	hWndTo = pInfo->hWndTo;
	HWND	hWndFrom = pInfo->hWndFrom;
	int		nLineCnt = pInfo->nLineCnt;
	
	if( hWndTo != NULL && IsWindow( hWndTo ) && hWndFrom != NULL && IsWindow( hWndFrom ) ) {
		int		i;
		LPCTSTR	q;
		int		nLen;
		LPCTSTR	lpszNewLine = _T("\r\n");
		int		nNewLineLen = lstrlen( lpszNewLine );
		TCHAR	buff[ BUFF_SIZE+1 ];
		int		nBuffLen = 0;
		DWORD	dwTick = GetTickCount();
		
		SendMessage( hWnd, WM_SCI_RESTORE, MAKEWPARAM( 0, 0 ), (LPARAM)nLineCnt );
		LoadFilePhase1MyScintilla( hWndTo );
		
		buff[nBuffLen] = _T('\0');
		/*	Xg{bNXPsoāAobt@ɗ߂	*/
		for( i = 0; i < nLineCnt; i++ ) {
			q = GetTextMyList( hWndFrom, i );
			nLen = lstrlen( q );
			if( nBuffLen + nLen + nNewLineLen >= BUFF_SIZE ) {
				/*	obt@tɂȂ肻Ȃ̂ŁA}ăNA	*/
				LoadFilePhase2MyScintilla( hWndTo, buff, nBuffLen );
				buff[0] = _T('\0');
				nBuffLen = 0;
			}
			/*	obt@ɗ߂	*/
			lstrcpy( buff+nBuffLen, q );
			lstrcpy( buff+nBuffLen+nLen, lpszNewLine );
			nBuffLen += nLen + nNewLineLen;
			
			if( GetTickDiff( GetTickCount(), dwTick ) > 300 ) {
				MSG	msg;
				SendMessage( hWnd, WM_SCI_RESTORE, MAKEWPARAM( 1, i ), (LPARAM)i );
				while( PeekMessage( &msg, NULL, 0, 0, PM_REMOVE ) ) {
					(pInfo->lpfnMessagePump)( hWnd, &msg );
				}
				dwTick = GetTickCount();
			}
		}
		if( nBuffLen > 0 ) {
			/*	ŌɎcĂ̂}	*/
			LoadFilePhase2MyScintilla( hWndTo, buff, nBuffLen );
		}
		SendMessage( hWnd, WM_SCI_RESTORE, MAKEWPARAM( 2, nLineCnt ), (LPARAM)nLineCnt );
		LoadFilePhase3MyScintilla( hWndTo, pInfo->pInfo );
	}
	return TRUE;
}

/*	t@C̏o	*/
BOOL	SaveFileMyScintilla( HWND hWnd, WPARAM wParam, LPARAM lParam )
{
	BOOL	ret = FALSE;
	LpFileInfoType	lpFileInfo = (LpFileInfoType)lParam;
	LpMySciDataType	p = (LpMySciDataType)GetProp( lpFileInfo->hWndSci, lpszPropertyName );
	
	if( p != NULL ) {
		HANDLE	hFile;
		TCHAR	path[ _MAX_PATH ] = {0};
		BOOL	bUseTemp = TRUE;			/*	e|t@Cg	*/
		if( GetTempPath( _MAX_PATH, path ) > 0 && path[0] != _T('\0') ) {
			TCHAR	dir[ _MAX_PATH ];
			lstrcpy( dir, path );
			GetTempFileName( dir, _T("XS-"), 0, path );
		} else {
			bUseTemp = FALSE;
			lstrcpy( path, lpFileInfo->lpszFile );
		}
		hFile = CreateFile( path, GENERIC_WRITE, FILE_SHARE_READ, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL );
		if( hFile != INVALID_HANDLE_VALUE ) {
			TCHAR	buff[ BUFF_SIZE+1 ];
			DWORD	dwTotalLen = (p->fn)( p->pt, SCI_GETTEXTLENGTH, 0, 0 );
			DWORD	dwRemain = dwTotalLen;
			DWORD	dwLen;
			DWORD	dwTick = GetTickCount();
			LPTSTR	lpszSaveBuff;
			struct	TextRange	tr;
			/*	ScintillãeLXg擾pobt@	*/
			tr.chrg.cpMin = 0;
			tr.chrg.cpMax = 0;
			tr.lpstrText = buff;
			/*	Z[ueۑpobt@	*/
			if( p->dwSaveBuffSize != (dwTotalLen+1)*sizeof(TCHAR) ) {
				p->dwSaveBuffSize = (dwTotalLen+1)*sizeof(TCHAR);
				if( p->hSaveBuff == NULL ) {
					p->hSaveBuff = GlobalAlloc( GPTR, p->dwSaveBuffSize );
				} else {
					HANDLE	h = GlobalReAlloc( p->hSaveBuff, p->dwSaveBuffSize, GMEM_MOVEABLE|GMEM_ZEROINIT );
					if( h == NULL ) {
						GlobalFree( p->hSaveBuff );
						p->dwSaveBuffSize = 0;
					}
					p->hSaveBuff = h;
				}
			}
			lpszSaveBuff = (LPTSTR)p->hSaveBuff;
			if( lpszSaveBuff != NULL ) {
				lpszSaveBuff[0] = _T('\0');
			}
			/*	Jn	*/
			ret = TRUE;
			SendMessage( hWnd, WM_LIST_SAVE_FILE, MAKEWPARAM( 0, 0 ), (LPARAM)lpFileInfo->nLineCnt );
			while( dwRemain > 0 ) {
				dwLen = BUFF_SIZE;
				if( dwLen > dwRemain ) {
					dwLen = dwRemain;
				}
				tr.chrg.cpMin = tr.chrg.cpMax;
				tr.chrg.cpMax += dwLen;
				dwLen = (p->fn)( p->pt, SCI_GETTEXTRANGE, 0, (LPARAM)&tr );
				dwRemain -= dwLen;
				if( !WriteFile( hFile, buff, dwLen, &dwLen, NULL ) ) {
					ret = FALSE;
					break;
				}
				if( lpszSaveBuff != NULL ) {
					CopyMemory( lpszSaveBuff+tr.chrg.cpMin, buff, dwLen );
					lpszSaveBuff[tr.chrg.cpMin+dwLen] = _T('\0');
				}
				if( GetTickDiff( GetTickCount(), dwTick ) > 300 ) {
					MSG		msg;
					int		nLine = (p->fn)( p->pt, SCI_LINEFROMPOSITION, (WPARAM)tr.chrg.cpMin,  0 );
					SendMessage( hWnd, WM_LIST_SAVE_FILE, MAKEWPARAM( 1, nLine ), (LPARAM)nLine );
					while( PeekMessage( &msg, NULL, 0, 0, PM_REMOVE ) ) {
						(lpFileInfo->lpfnMessagePump)( hWnd, &msg );
					}
					dwTick = GetTickCount();
				}
			}
			CloseHandle( hFile );
			if( bUseTemp ) {
				if( ret ) {
					/*	e|t@C̃TCYmF	*/
					WIN32_FIND_DATA	wfd;
					HANDLE	h;
					ZeroMemory( &wfd, sizeof(wfd) );
					h = FindFirstFile( path, &wfd );
					if( h != INVALID_HANDLE_VALUE ) {
						ret = ( wfd.nFileSizeLow == dwTotalLen );
						FindClose( h );
					} else {
						ret = FALSE;
					}
				}
				if( ret && CopyFile( path, lpFileInfo->lpszFile, FALSE ) ) {
					ret = DeleteFile( path );
				} else {
					DeleteFile( path );
					ret = FALSE;
				}
			}
			SendMessage( hWnd, WM_LIST_SAVE_FILE, MAKEWPARAM( 2, lpFileInfo->nLineCnt ), (LPARAM)lpFileInfo->nLineCnt );
		}
		if( ret ) {
			(p->fn)( p->pt, SCI_SETSAVEPOINT, 0, 0 );
		}
	}
	
	UNUSE(wParam);
	return( ret );
}

/*	X^C	*/
void	DoStylingMyScintilla( HWND hWnd, LpMarkCommentInfoType pInfo )
{
	if( hWnd != NULL && IsWindow( hWnd ) ) {
		HCURSOR	hCursor = SetCursor( LoadCursor( NULL, IDC_WAIT ) );
		int		pos = SendMessage( hWnd, SCI_GETENDSTYLED, 0, 0 );
		OnStyleNeeded( hWnd, pos, -1, pInfo );
		SetCursor( hCursor );
	}
}

/*	Õ}[NT	*/
int		SearchPrevMarkMyScintilla( HWND hWnd, int nLine )
{
	int		ret = nLine;
	if( hWnd != NULL && IsWindow( hWnd ) ) {
		if( nLine > 0 ) {
			nLine = SendMessage( hWnd, SCI_MARKERPREVIOUS, nLine-1, MARKER_BIT( MARKER_SCI_MARK ) );
			if( nLine >= 0 ) {
				ret = nLine;
			}
		}
	}
	
	return ret;
}

/*	̃}[NT	*/
int		SearchNextMarkMyScintille( HWND hWnd, int nLine )
{
	int		ret = nLine;
	if( hWnd != NULL && IsWindow( hWnd ) ) {
		/*	DoStylingMyScintilla()Ăł	*/
		
		nLine = SendMessage( hWnd, SCI_MARKERNEXT, nLine+1, MARKER_BIT( MARKER_SCI_MARK ) );
		if( nLine >= 0 ) {
			ret = nLine;
		}
	}
	return ret;
}

/*	}[NȂTRUEԂ	*/
BOOL	IsMarkMyScintilla( HWND hWnd, int nLine )
{
	BOOL	ret = FALSE;
	/*	}[N̓}[J[Ŕ肷	*/
	if( hWnd != NULL && IsWindow( hWnd ) ) {
		int		nMarker = SendMessage( hWnd, SCI_MARKERGET, (WPARAM)nLine, 0 );
		ret = ( ( nMarker & MARKER_BIT( MARKER_SCI_MARK ) ) != 0 );
	}
	return ret;
}

/*	RgȂTRUEԂ	*/
BOOL	IsCommentMyScintilla( HWND hWnd, int nLine )
{
	BOOL	ret = FALSE;
	/*	Rg̓X^CŔ肷	*/
	if( hWnd != NULL && IsWindow( hWnd ) ) {
		int		pos = SendMessage( hWnd, SCI_POSITIONFROMLINE, nLine, 0 );
		int		nStyle = SendMessage( hWnd, SCI_GETSTYLEAT, pos, 0 );
		ret = ( nStyle == STYLE_SCI_COMMENT );
	}
	return ret;
}

/*	e	*/
void	EmptyMyScintilla( HWND hWnd )
{
	if( hWnd != NULL && IsWindow( hWnd ) ) {
		SendMessage( hWnd, SCI_CLEARALL, 0, 0 );
		SendMessage( hWnd, SCI_SETSAVEPOINT, 0, 0 );
		SendMessage( hWnd, SCI_EMPTYUNDOBUFFER, 0, 0 );		/*	UNDOobt@NA	*/
	}
}

/*	݂̍sԍ𓾂	*/
int		GetCurrentLineMyScintilla( HWND hWnd )
{
	int		nLine = 0;
	if( hWnd != NULL && IsWindow( hWnd ) ) {
		int		pos = SendMessage( hWnd, SCI_GETCURRENTPOS, 0, 0 );
		nLine = SendMessage( hWnd, SCI_LINEFROMPOSITION, (WPARAM)pos, 0 );
	}
	return nLine;
}

/*	s𓾂	*/
int		GetLineCntMyScintilla( HWND hWnd )
{
	int		ret = 0;
	if( hWnd != NULL && IsWindow( hWnd ) ) {
		ret = SendMessage( hWnd, SCI_GETLINECOUNT, 0, 0 );
	}
	return ret;
}

/*	TCYԂ	*/
int		GetLengthMyScintilla( HWND hWnd )
{
	int		ret = 0;
	if( hWnd != NULL && IsWindow( hWnd ) ) {
		ret = SendMessage( hWnd, SCI_GETLENGTH, 0, 0 );
	}
	return ret;
}

/*	ẅʒuֈړ	*/
void	DoMoveMyScintilla( HWND hWnd, int nLineNum, int nOfs )
{
	if( hWnd != NULL && IsWindow( hWnd ) ) {
		/*	[(̃Xg{bNX̐K)Ɉړ	*/
		int		nLineCnt = SendMessage( hWnd, SCI_LINESONSCREEN, 0, 0 );
		SendMessage( hWnd, SCI_GOTOLINE, ( nLineNum - nOfs + nLineCnt >= 0 ) ? nLineNum - nOfs + nLineCnt: 0, 0 );
		
		/*	擪(̃Xg{bNX̓)Ɉړ	*/
		SendMessage( hWnd, SCI_GOTOLINE, ( nLineNum - nOfs >= 0 ) ? nLineNum - nOfs : 0, 0 );
		/*	ׂsɈړ	*/
		SendMessage( hWnd, SCI_GOTOLINE, nLineNum, 0 );
	}
}

#if 0
/*	ẅʒuֈړ	*/
void	DoMove2MyScintilla( HWND hWnd, int nLineNum )
{
	if( hWnd != NULL && IsWindow( hWnd ) ) {
		SendMessage( hWnd, SCI_GOTOLINE, nLineNum, 0 );
	}
}

/*	̍sֈړ	*/
void	DoMoveNextMyScintilla( HWND hWnd )
{
	if( hWnd != NULL && IsWindow( hWnd ) ) {
		int		pos = SendMessage( hWnd, SCI_GETCURRENTPOS, 0, 0 );
		int		nLine = SendMessage( hWnd, SCI_LINEFROMPOSITION, (WPARAM)pos, 0 );
		SendMessage( hWnd, SCI_GOTOLINE, nLine+1, 0 );
		SendMessage( hWnd, SCI_LINESCROLL, 0, 1 );
	}
}
#endif

/*	eLXg擾	*/
LPCTSTR	GetTextMyScintilla( HWND hWnd, int nLine, int* pLen )
{
	LPCTSTR	ret = _T("");
	if( pLen != NULL ) {
		*pLen = 0;
	}
	if( hWnd != NULL && IsWindow( hWnd ) ) {
		LpMySciDataType	p = (LpMySciDataType)GetProp( hWnd, lpszPropertyName );
		if( p != NULL ) {
			int		nLen = (p->fn)( p->pt, SCI_LINELENGTH, nLine, 0 );
			DWORD	dwSize = sizeof(TCHAR)*(nLen+1);
			LPTSTR	q;
			if( p->dwTextBuffSize < dwSize ) {
				if( p->hTextBuff == NULL ) {
					p->hTextBuff = GlobalAlloc( GPTR, dwSize );
				} else {
					HGLOBAL	h = GlobalReAlloc( p->hTextBuff, dwSize, GMEM_MOVEABLE|GMEM_ZEROINIT );
					if( h == NULL ) {
						GlobalFree( p->hTextBuff );
						dwSize = 0;
					}
					p->hTextBuff = h;
				}
				p->dwTextBuffSize = dwSize;
			}
			q = (LPTSTR)( p->hTextBuff );
			if( q != NULL ) {
				LPTSTR	r, s;
				TCHAR	c;
				nLen = (p->fn)( p->pt, SCI_GETLINE, (WPARAM)nLine, (LPARAM)q );
				*(q+nLen) = _T('\0');
				/*	CR LF菜	*/
				r = s = q;
				while( ( c = *(r++) ) != _T('\0') ) {
					if( c != CR && c != LF ) {
						*(s++) = c;
					}
				}
				*s = _T('\0');
				ret = q;
				if( pLen != NULL ) {
					*pLen = s - q;
				}
			}
		}
	}
	return ret;
}

/*	ReLXgj[̕\ʒu߂	*/
void	GetContextMenuPosMyScintilla( HWND hWnd, int* x, int* y )
{
	if( hWnd != NULL && IsWindow( hWnd ) ) {
		int		nCurrentPos = SendMessage( hWnd, SCI_GETCURRENTPOS, 0, 0 );
		POINT	pos;
		RECT	rect;
		pos.x = SendMessage( hWnd, SCI_POINTXFROMPOSITION, 0, nCurrentPos );
		pos.y = SendMessage( hWnd, SCI_POINTYFROMPOSITION, 0, nCurrentPos );
		GetClientRect( hWnd, &rect );
		/*	݂͂h~	*/
		if( pos.x < rect.left )		pos.x = rect.left;
		if( pos.x >= rect.right )	pos.x = rect.right-1;
		if( pos.y < rect.top )		pos.y = rect.top;
		if( pos.y >= rect.bottom )	pos.y = rect.bottom-1;
		/*	XN[Wɕϊ	*/
		ClientToScreen( hWnd, &pos );
		if( x != NULL )		*x = pos.x;
		if( y != NULL )		*y = pos.y;
	}
}

/*	ANZ[^	*/
BOOL	TranslateAcceleratorMyScintilla( HWND hWndParent, HWND hWnd, LPMSG pMsg )
{
	LpMySciDataType	p;
	
	if( !IsWindow( hWnd ) ) {
		return FALSE;
	}
	if( pMsg->hwnd != hWnd ) {
		return FALSE;
	}
	p = (LpMySciDataType)GetProp( hWnd, lpszPropertyName );
	if( p == NULL ) {
		return FALSE;
	}
	/*	_CAhJ[\̃ANZ[^	*/
	if( p->bEnableDiamond && p->hAccelDiamond != NULL && TranslateAccelerator( hWndParent, p->hAccelDiamond, pMsg ) ) {
		return TRUE;
	}
//	if( p->bEnableDiamond && p->bEnableCtrlXC && p->hAccelCtrlXC != NULL && TranslateAccelerator( hWndParent, p->hAccelCtrlXC, pMsg ) ) {
//		return TRUE;
//	}
	/*	ʏ(Nbv{[h֌W)̃ANZ[^	*/
	if( p->hAccelSci != NULL && TranslateAccelerator( hWndParent, p->hAccelSci, pMsg ) ) {
		return TRUE;
	}
	return FALSE;
}

/*	}[NRs[	*/
void	InsertMarkMyScintilla( HWND hWndTo, HWND hWndFrom, int nLineNum )
{
	if( hWndTo != NULL && hWndFrom != NULL && IsWindow( hWndTo ) && IsWindow( hWndFrom ) ) {
		int		nItemSel = LB_ERR;
		int		nLine = -1;
		LPCTSTR	q;
		LRESULT	lRet;
		HCURSOR	hCursor = SetCursor( LoadCursor( NULL, IDC_WAIT ) );
		do {
			nLine = SendMessage( hWndFrom, SCI_MARKERNEXT, nLine+1, MARKER_BIT( MARKER_SCI_MARK ) );
			if( nLine >= 0 ) {
				q = GetTextMyScintilla( hWndFrom, nLine, NULL );
				if( q != NULL ) {
					lRet = InsertOneMarkMyList( hWndTo, q, nLine+1 );
					if( lRet != LB_ERR ) {
						if( nLine <= nLineNum ) {
							nItemSel = (int)lRet;
						}
					}
				}
			}
		} while( nLine >= 0 );
		CenterMarkMyList( hWndTo, nItemSel );
		SetCursor( hCursor );
	}
}

/*	Z[uẽobt@Ԃ	*/
HGLOBAL	GetSaveBuffMyScintilla( HWND hWnd, LPDWORD lpdwLen )
{
	HGLOBAL	h = NULL;
	if( lpdwLen != NULL ) {
		*lpdwLen = 0;
	}
	if( hWnd != NULL && IsWindow( hWnd ) ) {
		LpMySciDataType	p = (LpMySciDataType)GetProp( hWnd, lpszPropertyName );
		if( p != NULL ) {
			h = p->hSaveBuff;
			if( lpdwLen != NULL ) {
				if( p->dwSaveBuffSize > 0 ) {
					*lpdwLen = p->dwSaveBuffSize;
				} else {
					*lpdwLen = 0;
				}
			}
			p->hSaveBuff = NULL;
			p->dwSaveBuffSize = 0;
		}
	}
	/*	߂ĺAĂяoGlobalFree()Kv	*/
	return h;
}

/*	I͈͂̃eLXg擾	*/
void	GetSelTextMyScintilla( HWND hWnd, LPTSTR lpszBuff, int nSize )
{
	if( hWnd != NULL && IsWindow( hWnd ) ) {
		int		nSt, nEn;
		nSt = SendMessage( hWnd, SCI_GETSELECTIONSTART, 0, 0 );
		nEn = SendMessage( hWnd, SCI_GETSELECTIONEND, 0, 0 );
		if( nSt != nEn && nEn - nSt < nSize ) {
			SendMessage( hWnd, SCI_GETSELTEXT, 0, (LPARAM)lpszBuff );
		}
	}
}

/*	O(Ɍ)	*/
int		FindNextMyScintilla( HWND hWnd, UINT nFlag, LPCTSTR lpszText )
{
	int		nSt, nEn;
	UINT	nNewFlag;
	nSt = SendMessage( hWnd, SCI_GETSELECTIONSTART, 0, 0 );
	nEn = SendMessage( hWnd, SCI_GETSELECTIONEND, 0, 0 );
	if( nFlag & FR_FINDNEXT ) {
		SendMessage( hWnd, SCI_SETCURRENTPOS, nEn, 0 );
	} else {
		SendMessage( hWnd, SCI_SETCURRENTPOS, nSt, 0 );
	}
	SendMessage( hWnd, SCI_SEARCHANCHOR, 0, 0 );
	nNewFlag = 0;
	if( nFlag & FR_MATCHCASE )	nNewFlag |= SCFIND_MATCHCASE;
	if( nFlag & FR_WHOLEWORD )	nNewFlag |= SCFIND_WHOLEWORD;
	return SendMessage( hWnd, SCI_SEARCHNEXT, nNewFlag, (LPARAM)lpszText );
}

/*	(Ɍ)	*/
int		FindPrevMyScintilla( HWND hWnd, UINT nFlag, LPCTSTR lpszText )
{
	int		nSt, nEn;
	UINT	nNewFlag;
	int		ret;
	nSt = SendMessage( hWnd, SCI_GETSELECTIONSTART, 0, 0 );
	nEn = SendMessage( hWnd, SCI_GETSELECTIONEND, 0, 0 );
	if( nFlag & FR_FINDNEXT ) {
		SendMessage( hWnd, SCI_SETCURRENTPOS, nSt-1, 0 );
	} else {
		SendMessage( hWnd, SCI_SETCURRENTPOS, nEn, 0 );
	}
	SendMessage( hWnd, SCI_SEARCHANCHOR, 0, 0 );
	nNewFlag = 0;
	if( nFlag & FR_MATCHCASE )	nNewFlag |= SCFIND_MATCHCASE;
	if( nFlag & FR_WHOLEWORD )	nNewFlag |= SCFIND_WHOLEWORD;
	ret = SendMessage( hWnd, SCI_SEARCHPREV, nNewFlag, (LPARAM)lpszText );
	if( ret < 0 ) {
		SendMessage( hWnd, SCI_GOTOPOS, nSt, 0 );
//		SendMessage( hWnd, SCI_SETCURRENTPOS, nSt, 0 );
//		SendMessage( hWnd, SCI_SETANCHOR, nSt, 0 );
	}
	return ret;
}

/*	Lbg\悤ɃXN[	*/
void	ScrollCaretMyScintilla( HWND hWnd )
{
	if( hWnd != NULL && IsWindow( hWnd ) ) {
		SendMessage( hWnd, SCI_SCROLLCARET, 0, 0 );
	}
}

/*	I͈͂u	*/
void	ReplaceSelMyScintilla( HWND hWnd, LPCTSTR lpszText )
{
	if( hWnd != NULL && IsWindow( hWnd ) ) {
		SendMessage( hWnd, SCI_REPLACESEL, 0, (LPARAM)lpszText );
	}
}

/*	sɃ}[N}	*/
void	InsertMarkTopMyScintilla( HWND hWnd, LpMarkCommentInfoType pInfo )
{
	if( hWnd != NULL && IsWindow( hWnd ) ) {
		SendMessage( hWnd, SCI_HOME, 0, 0 );
		SendMessage( hWnd, SCI_REPLACESEL, 0, (LPARAM)(pInfo->szMark) );
	}
}

/*	sɃRg}	*/
void	InsertCommentTopMyScintilla( HWND hWnd, LpMarkCommentInfoType pInfo )
{
	if( hWnd != NULL && IsWindow( hWnd ) ) {
		SendMessage( hWnd, SCI_HOME, 0, 0 );
		SendMessage( hWnd, SCI_REPLACESEL, 0, (LPARAM)(pInfo->szComment) );
	}
}


static	BOOL	QueryValue( UINT uTranslationLen, DWORD* pTranslation, LPVOID lpBlock, LPCTSTR lpszBlock, LPVOID* lplpBuff )
{
	UINT	i;
	DWORD	dwTranslation;
	TCHAR	fmt[ 255 ];
	TCHAR	szBlock[ 255 ];
	UINT	uLen;
	BOOL	ret = FALSE;
	lstrcpy( fmt, _T("\\StringFileInfo\\%04x%04x\\") );
	lstrcat( fmt, lpszBlock );
	for( i = 0; i < uTranslationLen; i++ ) {
		dwTranslation = pTranslation[i];
		wsprintf( szBlock, fmt, LOWORD(dwTranslation), HIWORD(dwTranslation) );
		if( VerQueryValue( lpBlock, szBlock, lplpBuff, &uLen ) != 0 ) {
			ret = TRUE;
			break;
		}
	}
	return ret;
}

/*	o[W̕擾	*/
BOOL	GetDllVersionInfoMyScintilla( LPTSTR lpszString )
{
	BOOL	ret = TRUE;
	if( hInstSciltilla == NULL ) {
		ret = FALSE;
	}
	if( lpszString == NULL ) {
		ret = FALSE;
	} else {
		lpszString[0] = _T('\0');
	}
	if( ret ) {
		TCHAR	szPath[_MAX_PATH];
		DWORD	dwInfoSize;
		LPVOID	lpBlock = NULL;
		DWORD*	pTranslation;
		UINT	uTranslationLen;
		
		if( ret ) {
			ret = ( GetModuleFileName( hInstSciltilla, szPath, _MAX_PATH ) != 0 );
		}
		if( ret ) {
			DWORD	dwDummy = 0;
			dwInfoSize = GetFileVersionInfoSize( szPath, &dwDummy );
		}
		if( ret ) {
			lpBlock = (LPVOID)GlobalAlloc( GPTR, sizeof(BYTE)*dwInfoSize );
			ret = ( lpBlock != NULL );
		}
		if( ret ) {
			ret = GetFileVersionInfo( szPath, 0, dwInfoSize, lpBlock );
		}
		if( ret ) {
			ret = ( VerQueryValue( lpBlock, _T("\\VarFileInfo\\Translation"), (LPVOID*)&pTranslation, &uTranslationLen ) != 0 );
		}
		if( ret ) {
			LPTSTR	lpszValue;
			LPCTSTR	lpszNewLine = _T("\n");
			
			uTranslationLen /= sizeof(DWORD);
			
			if( QueryValue( uTranslationLen, pTranslation, lpBlock, _T("FileDescription"), (LPVOID*)&lpszValue ) ) {
				lstrcat( lpszString, lpszValue );
				lstrcat( lpszString, _T(" ") );
			}
			if( QueryValue( uTranslationLen, pTranslation, lpBlock, _T("FileVersion"), (LPVOID*)&lpszValue ) ) {
				lstrcat( lpszString, lpszValue );
				lstrcat( lpszString, lpszNewLine );
			}
			if( QueryValue( uTranslationLen, pTranslation, lpBlock, _T("LegalCopyright"), (LPVOID*)&lpszValue ) ) {
				lstrcat( lpszString, lpszValue );
				lstrcat( lpszString, lpszNewLine );
			}
			if( QueryValue( uTranslationLen, pTranslation, lpBlock, _T("SpecialBuild"), (LPVOID*)&lpszValue ) ) {
				lstrcat( lpszString, lpszValue );
				lstrcat( lpszString, lpszNewLine );
			}
		}
		if( lpBlock != NULL ) {
			GlobalFree( (HGLOBAL)lpBlock );
		}
	}
	return ret;
}




/*	XVĂ邩H	*/
BOOL	IsModifiedMyScintilla( HWND hWnd )
{
	BOOL	ret = FALSE;
	if( hWnd != NULL && IsWindow( hWnd ) ) {
		ret = ( SendMessage( hWnd, SCI_GETMODIFY, 0, 0 ) != 0 );
	}
	return ret;
}

/*	Undoł邩H	*/
BOOL	CanUndoMyScintilla( HWND hWnd )
{
	BOOL	ret = FALSE;
	if( hWnd != NULL && IsWindow( hWnd ) ) {
		ret = ( SendMessage( hWnd, SCI_CANUNDO, 0, 0 ) != 0 );
	}
	return ret;
}

/*	Redoł邩H	*/
BOOL	CanRedoMyScintilla( HWND hWnd )
{
	BOOL	ret = FALSE;
	if( hWnd != NULL && IsWindow( hWnd ) ) {
		ret = ( SendMessage( hWnd, SCI_CANREDO, 0, 0 ) != 0 );
	}
	return ret;
}

/*	IĂ邩H	*/
BOOL	IsSelectedMyScintilla( HWND hWnd )
{
	BOOL	ret = FALSE;
	if( hWnd != NULL && IsWindow( hWnd ) ) {
		int		nSt, nEn;
		nSt = SendMessage( hWnd, SCI_GETSELECTIONSTART, 0, 0 );
		nEn = SendMessage( hWnd, SCI_GETSELECTIONEND, 0, 0 );
		ret = ( nSt != nEn );
	}
	return ret;
}

/*	\tł邩H	*/
BOOL	CanPasteMyScintilla( HWND hWnd )
{
	BOOL	ret = FALSE;
	if( hWnd != NULL && IsWindow( hWnd ) ) {
		ret = IsClipboardFormatAvailable( CF_TEXT );
	}
	return ret;
}

/*	Undo	*/
void	DoUndoMyScintilla( HWND hWnd )
{
	if( CanUndoMyScintilla( hWnd ) ) {
		SendMessage( hWnd, SCI_UNDO, 0, 0 );
	}
}

/*	Redo	*/
void	DoRedoMyScintilla( HWND hWnd )
{
	if( CanRedoMyScintilla( hWnd ) ) {
		SendMessage( hWnd, SCI_REDO, 0, 0 );
	}
}

/*	؂	*/
void	DoCutMyScintilla( HWND hWnd )
{
	if( IsSelectedMyScintilla( hWnd ) ) {
		SendMessage( hWnd, SCI_CUT, 0, 0 );
	}
}

/*	Rs[	*/
void	DoCopyMyScintilla( HWND hWnd )
{
	if( IsSelectedMyScintilla( hWnd ) ) {
		SendMessage( hWnd, SCI_COPY, 0, 0 );
	}
}

/*	\t	*/
void	DoPasteMyScintilla( HWND hWnd )
{
	if( CanPasteMyScintilla( hWnd ) ) {
		SendMessage( hWnd, SCI_PASTE, 0, 0 );
	}
}

/*	擪	*/
void	DoTopMyScintilla( HWND hWnd )
{
	if( hWnd != NULL && IsWindow( hWnd ) ) {
		SendMessage( hWnd, SCI_HOME, 0, 0 );
	}
}

/*	Ō	*/
void	DoLastMyScintilla( HWND hWnd )
{
	if( hWnd != NULL && IsWindow( hWnd ) ) {
		SendMessage( hWnd, SCI_LINEEND, 0, 0 );
	}
}

/*	폜	*/
void	DoDelMyScintilla( HWND hWnd )
{
	if( hWnd != NULL && IsWindow( hWnd ) ) {
		SendMessage( hWnd, SCI_CLEAR, 0, 0 );
	}
}

/*	O	*/
void	DoPrevMyScintilla( HWND hWnd )
{
}

/*		*/
void	DoNextMyScintilla( HWND hWnd )
{
}

/*	s	*/
void	DoNewLineMyScintilla( HWND hWnd )
{
	if( hWnd != NULL && IsWindow( hWnd ) ) {
		SendMessage( hWnd, SCI_NEWLINE, 0, 0 );
	}
}

/*	[Abv	*/
void	DoRollUpMyScintilla( HWND hWnd )
{
	if( hWnd != NULL && IsWindow( hWnd ) ) {
		SendMessage( hWnd, SCI_LINESCROLL, 0, (LPARAM)1 );
	}
}

/*	[_E	*/
void	DoRollDownMyScintilla( HWND hWnd )
{
	if( hWnd != NULL && IsWindow( hWnd ) ) {
		SendMessage( hWnd, SCI_LINESCROLL, 0, (LPARAM)-1 );
	}
}

/*	ׂđI	*/
void	DoSelectAllMyScintilla( HWND hWnd )
{
	if( hWnd != NULL && IsWindow( hWnd ) ) {
		SendMessage( hWnd, SCI_SELECTALL, 0, 0 );
	}
}

/*	obNXy[X	*/
void	DoBackMyScintilla( HWND hWnd )
{
	if( hWnd != NULL && IsWindow( hWnd ) ) {
		SendMessage( hWnd, SCI_DELETEBACK, 0, 0 );
	}
}
