/*--------------------------------------------------------------*\
		module	:	ScrlBar.c
		purpose :	X-Send XN[o[
		author	:	_@ Kengo Jinno
		create	:	2001/09/04
		update	:	2001/09/12
\*--------------------------------------------------------------*/

#include	"PCH.h"
#include	"ScrlBar.h"



/*	XN[o[쐬	*/
HWND	CreateScrollBar( HWND hWndParent, UINT nCtrlID, BOOL bShow )
{
	HWND	hWnd;
	HINSTANCE	hInstance = (HINSTANCE)GetWindowLong( hWndParent, GWL_HINSTANCE );
	
	hWnd = CreateWindow( _T("SCROLLBAR"), NULL,
		WS_CHILD|SBS_VERT,
		0, 0, 0, 0, hWndParent, (HMENU)nCtrlID, hInstance, NULL );
	
	if( hWnd != NULL ) {
		if( bShow ) {
			ShowWindow( hWnd, SW_SHOW );
		}
	}
	
	return( hWnd );
}


/*	͈͐ݒ	*/
BOOL	SetRangeScrollBar( HWND hWnd, int nMin, int nMax )
{
	BOOL	ret = FALSE;
	if( IsWindow( hWnd ) ) {
		ret = SetScrollRange( hWnd, SB_CTL, nMin, nMax, TRUE );
	}
	return( ret );
}


/*	ʒuݒ	*/
BOOL	SetPosScrollBar( HWND hWnd, int nPos )
{
	BOOL	ret = FALSE;
	if( IsWindow( hWnd ) ) {
#ifdef	WIN32
		SCROLLINFO	si;
		ZeroMemory( &si, sizeof(si) );
		si.cbSize = sizeof(si);
		si.fMask = SIF_ALL|SIF_DISABLENOSCROLL;
		if( GetScrollInfo( hWnd, SB_CTL, &si ) ) {
			si.nPos = nPos;
			ret = SetScrollInfo( hWnd, SB_CTL, &si, TRUE );
		}
#else
		ret = SetScrollPos( hWnd, SB_CTL, nPos, TRUE );
#endif
	}
	return( ret );
}

/*	XN[	*/
int		SetInfoScrollBar( HWND hWnd, int nPage )
{
	int		ret = 0;
#ifdef	WIN32
	if( IsWindow( hWnd ) ) {
		SCROLLINFO	si;
		ZeroMemory( &si, sizeof(si) );
		si.cbSize = sizeof(si);
		si.fMask = SIF_POS|SIF_RANGE;
		if( GetScrollInfo( hWnd, SB_CTL, &si ) ) {
			si.fMask |= SIF_DISABLENOSCROLL|SIF_PAGE;
			si.nPage = nPage;
			ret = SetScrollInfo( hWnd, SB_CTL, &si, TRUE );
		}
	}
#endif
	return( ret );
}
