/*--------------------------------------------------------------*\
		module	:	StatBar.h
		purpose :	X-Send Xe[^Xo[
		author	:	_@ Kengo Jinno
		create	:	2001/09/06
		update	:	2001/09/26
					2002/04/12	ShowSimpleTextStatusBar()
								ExitSimpleTextStatusBar()ǉ
					2011/02/10	WM_SB_DBLCLK1 ǉ
\*--------------------------------------------------------------*/

#ifndef	STATBAR_H
#define	STATBAR_H

#include	"ToolTip.h"

#ifdef	__cplusplus
extern "C" {
#endif

#define	MAX_STATUS_BAR_TEXT	80

typedef	enum	tagIconStateType	{
	eIconDdeNg,
	eIconDdeStop,
	eIconDdeGo,
	eIconEditSendOk,
	eIconEditSendNg,
}	IconStateType;

typedef	struct	tagStatusBarInfoType	{
	WNDPROC	lpfnOldWndProc;
	
	HWND	hWndToolTip;	/*	c[`bv		*/
	BOOL	bNoTooltip;		/*	c[`bvȂ	*/
	TCHAR	szTooltipText[ MAX_MY_TOOLTIP_TEXT ];
	
/*	P	*/
	TCHAR	szText1[ MAX_STATUS_BAR_TEXT ];	/*	\eLXg	*/
	
/*	Q	*/
	BOOL	bShowText;		/*	TRUE:eLXg\ FALSE:is󋵂\	*/
	
	IconStateType	eIconState;	/*	ACR	*/
	HICON	hIconState;
	
	TCHAR	szText2[ MAX_STATUS_BAR_TEXT ];	/*	\eLXg	*/
	
	DWORD	dwTotalSize;	/*	Ŝ̃TCY	*/
	DWORD	dwCurrentPos;	/*	݂̈ʒu		*/
	
}	StatusBarInfoType, FAR* LpStatusBarInfoType;

/*	P_uNbN	*/
#define	WM_SB_DBLCLK1	(WM_APP+23)
/*	Q_uNbN	*/
#define	WM_SB_DBLCLK2	(WM_APP+24)


/*	Xe[^Xo[̍쐬	*/
extern	HWND	CreateStatusBar( HWND hWndParent, UINT nCtrlID, BOOL bShow, BOOL bNoTooltip );

/*	Xe[^Xo[̔j	*/
extern	BOOL	DestroyStatusBar( HWND hWnd );

/*	TuNXvV[W	*/
extern	LRESULT	MYEXPORT	CALLBACK	MyStatusBarWndProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam );

/*	TCY	*/
extern	void	AutoSizeStatusBar( HWND hWnd );

/*	eLXg\(P)	*/
extern	void	ShowTextStatusBar( HWND hWnd, LPCTSTR lpszText );

/*	eLXg\(Q)	*/
extern	void	SetTextStatusBar( HWND hWnd, LPCTSTR lpszText );

/*	ACR\	*/
extern	void	SetIconStatusBar( HWND hWnd, IconStateType state );

/*	is󋵂\	*/
extern	void	SetProgressSizeStatusBar( HWND hWnd, DWORD dwSize );
extern	void	SetProgressPosStatusBar( HWND hWnd, DWORD dwPos );

/*	R}h̐\	*/
extern	void	ShowSimpleTextStatusBar( HWND hWnd, LPCTSTR lpszText );
extern	void	ExitSimpleTextStatusBar( HWND hWnd );

/*	I[i[`	*/
extern	void	DrawStatusBarItem( HWND hWnd, LPDRAWITEMSTRUCT lpDrawItemStruct );

#ifdef	__cplusplus
}
#endif

#endif	/*	STATBAR_H	*/
