/*--------------------------------------------------------------*\
		module	:	ToolBar.c
		purpose :	X-Send c[o[
		author	:	_@ Kengo Jinno
		create	:	2001/09/04
		update	:	2001/10/10
					2001/11/01	IsBadReadPtr() IsBadCodePtr()
								ĝ߂B(Win2K/XP)
					2002/03/22	[ҏW]{^̒ǉ
					2002/04/12	_TrackMouseEvent()
\*--------------------------------------------------------------*/

#include	"PCH.h"
#include	"resource.h"
#include	"ToolBar.h"
#include	"ToolTip.h"
#include	"MySci.h"

static	LPCTSTR		lpszPropertyName = _T("9229fb60-b835-11d5-af4f-00c0ca10a705");

/*	c[o[̍쐬	*/
HWND	CreateToolBar( HWND hWndParent, UINT nCtrlID, LpToolBarCreateInfo lptbci )
{
	HINSTANCE	hInstance = (HINSTANCE)GetWindowLong( hWndParent, GWL_HINSTANCE );
	TBBUTTON	tbb12[] = {
		{  0, ID_OPERATE_EDIT_MODE, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0, 0, IDS_F0  },
		{  0, 0,                    TBSTATE_ENABLED, TBSTYLE_SEP,    0, 0, 0, 0       },
		{  1, ID_FILE_OPEN,         TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0, 0, IDS_F1  },
		{  2, ID_FILE_CLOSE,        TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0, 0, IDS_F2  },
		{  3, ID_FILE_SEND,         TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0, 0, IDS_F3  },
		{  4, ID_OPERATE_VIEW_MODE, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0, 0, IDS_F4  },
		{  0, 0,                    TBSTATE_ENABLED, TBSTYLE_SEP,    0, 0, 0, 0       },
		{  5, ID_OPERATE_HELP_ME,   TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0, 0, IDS_F5  },
		{  6, ID_MOVE_LIST_MARK,    TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0, 0, IDS_F6  },
		{  7, ID_MOVE_PREV_MARK,    TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0, 0, IDS_F7  },
		{  8, ID_MOVE_NEXT_MARK,    TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0, 0, IDS_F8  },
		{  0, 0,                    TBSTATE_ENABLED, TBSTYLE_SEP,    0, 0, 0, 0       },
		{  9, ID_OPERATE_SEND_ALL,  TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0, 0, IDS_F9  },
		{ 10, ID_NO_COMMAND_F10,    TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0, 0, IDS_F10 },
		{ 11, ID_OPERATE_SEND_NULL, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0, 0, IDS_F11 },
		{ 12, ID_OPERATE_SETUP,     TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0, 0, IDS_F12 },
	};
	TBBUTTON	tbb10[] = {
		{  0, ID_OPERATE_EDIT_MODE, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0, 0, IDS_F0  },
		{  0, 0,                    TBSTATE_ENABLED, TBSTYLE_SEP,    0, 0, 0, 0       },
		{  1, ID_FILE_OPEN,         TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0, 0, IDS_F1  },
		{  2, ID_FILE_CLOSE,        TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0, 0, IDS_F2  },
		{  3, ID_FILE_SEND,         TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0, 0, IDS_F3  },
		{  4, ID_OPERATE_VIEW_MODE, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0, 0, IDS_F4  },
		{  5, ID_OPERATE_HELP_ME,   TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0, 0, IDS_F5  },
		{  0, 0,                    TBSTATE_ENABLED, TBSTYLE_SEP,    0, 0, 0, 0       },
		{  6, ID_MOVE_LIST_MARK,    TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0, 0, IDS_F6  },
		{  7, ID_MOVE_PREV_MARK,    TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0, 0, IDS_F7  },
		{  8, ID_MOVE_NEXT_MARK,    TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0, 0, IDS_F8  },
		{  9, ID_OPERATE_SEND_ALL,  TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0, 0, IDS_F9  },
		{ 10, ID_NO_COMMAND_F10,    TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0, 0, IDS_F10 },
		{  0, 0,                    TBSTATE_ENABLED, TBSTYLE_SEP,    0, 0, 0, 0       },
		{ 11, ID_OPERATE_SEND_NULL, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0, 0, IDS_F11 },
		{ 12, ID_OPERATE_SETUP,     TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0, 0, IDS_F12 },
		{ 13, ID_NO_COMMAND_F13,    TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0, 0, IDS_F13 },
		{ 14, ID_NO_COMMAND_F14,    TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0, 0, IDS_F14 },
		{ 15, ID_NO_COMMAND_F15,    TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0, 0, IDS_F15 },
	};
	TBBUTTON*	tbb;
	int			nBtnCnt;
	int			i;
	DWORD		dwStyle;
	HWND		hWnd;
	HBITMAP		hBitmap;
	TBADDBITMAP	tbab;
	int		nID = 0;
	
	if( lptbci->bFunction10 ) {
		nBtnCnt = sizeof(tbb10) / sizeof(TBBUTTON);
		tbb = tbb10;
	} else {
		nBtnCnt = sizeof(tbb12) / sizeof(TBBUTTON);
		tbb = tbb12;
	}
	
	dwStyle = WS_CHILD|WS_CLIPSIBLINGS|CCS_TOP;
	dwStyle |= ( lptbci->bNoToolTip ? 0 : TBSTYLE_TOOLTIPS );
	dwStyle |= ( lptbci->bFlat ? TBSTYLE_FLAT : 0 );
	hWnd = CreateWindowEx( 0, TOOLBARCLASSNAME, NULL, dwStyle,
		0, 0, 0, 0, hWndParent, (HMENU)nCtrlID, hInstance, NULL );
	if( hWnd == NULL ) {
		return( NULL );
	}
	
	if( lptbci->bShow ) {
		ShowWindow( hWnd, SW_SHOW );
	}
	SendMessage( hWnd, TB_BUTTONSTRUCTSIZE, (WPARAM)sizeof(TBBUTTON), 0 );
	
	tbab.hInst = hInstance;
	if( lptbci->bBitmap ) {
		tbab.nID = IDB_TOOLBAR2;
	} else {
		tbab.nID = IDB_TOOLBAR1;
	}
	hBitmap = LoadBitmap( tbab.hInst, MAKEINTRESOURCE(tbab.nID) );
	if( hBitmap != NULL ) {
		BITMAP	bm;
		if( GetObject( hBitmap, sizeof(bm), &bm ) > 0 ) {
			int		cx = bm.bmWidth;
			int		cy = bm.bmHeight;
			SendMessage( hWnd, TB_SETBITMAPSIZE, 0, MAKELONG( cx/16, cy ) );
			nID = SendMessage( hWnd, TB_ADDBITMAP, nBtnCnt, (LPARAM)&tbab );
		}
		DeleteObject( hBitmap );
	}
	
	for( i = 0; i < nBtnCnt; i++ ) {
		if( ( tbb[i].fsStyle & TBSTYLE_SEP ) == 0 ) {
			int		nStringID;
			TCHAR	szText[ _MAX_PATH ];
			ZeroMemory( szText, sizeof(TCHAR)*_MAX_PATH );
			nStringID = tbb[i].iString;
			if( lptbci->bBitmap ) {
				nStringID += 16;
			}
			LoadString( hInstance, nStringID, szText, _MAX_PATH );
			tbb[i].iString = SendMessage( hWnd, TB_ADDSTRING, 0, (LPARAM)szText );
			tbb[i].iBitmap += nID;
		}
		if( tbb[i].idCommand == ID_OPERATE_HELP_ME ) {
			/*	[]{^̓`FbN{^	*/
			tbb[i].fsStyle |= TBSTYLE_CHECK;
		}
		if( tbb[i].idCommand == ID_OPERATE_VIEW_MODE ) {
			/*	[{]{^̓`FbN{^	*/
			tbb[i].fsStyle |= TBSTYLE_CHECK;
		}
		if( tbb[i].idCommand == ID_OPERATE_EDIT_MODE ) {
			/*	[ҏW]{^̓`FbN{^	*/
			tbb[i].fsStyle |= TBSTYLE_CHECK;
		}
	}
	SendMessage( hWnd, TB_ADDBUTTONS, nBtnCnt, (LPARAM)tbb );
	if( lptbci->bSystemFont ) {
		HFONT	hFont = (HFONT)GetStockObject(SYSTEM_FONT);
		SendMessage( hWnd, WM_SETFONT, (WPARAM)hFont, MAKELPARAM( TRUE, 0 ) );
	}
	SendMessage( hWnd, TB_AUTOSIZE, 0, 0);
	
	for( i = 0; i < nBtnCnt; i++ ) {
		int		nCommand = tbb[i].idCommand;
		if( nCommand >= ID_NO_COMMAND_FIRST && nCommand <= ID_NO_COMMAND_LAST ) {
			SendMessage( hWnd, TB_ENABLEBUTTON, nCommand, MAKELPARAM( FALSE, 0 ) );
		}
	}
	
	if( !lptbci->bNoToolTip && lptbci->bMultilineTip ) {
		DoMultilineMyToolTip( GetToolTipHwndToolBar( hWnd ) );
		/*
			Tips(IDS_TIPL_FILE_CONNECT`)̒́A
			80ɗ}Ȃ΂ȂȂB(蔲)
		*/
	}
	
	if( hWnd != NULL ) {
		LpToolBarInfoType	p;
		p = (LpToolBarInfoType)GlobalAlloc( GPTR, sizeof(ToolBarInfoType) );
		if( p == NULL ) {
			DestroyWindow( hWnd );
			return( NULL );
		}
		/*	vpeBɃZbg	*/
		SetProp( hWnd, lpszPropertyName, (HANDLE)p );
		/*	TuNX	*/
		p->lpfnOldWndProc = (WNDPROC)SetWindowLong( hWnd, GWL_WNDPROC, (LONG)MyToolBarWndProc );
		/*	_TrackMouseEvent()	*/
		p->lpTrackMouseEvent = NULL;
		{
			HINSTANCE	hInstDll = GetModuleHandle( _T("COMCTL32.DLL") );
			if( hInstDll != NULL ) {
				p->lpTrackMouseEvent = (LP_FUNC_TRACKMOUSEEVENT)GetProcAddress( hInstDll, _T("_TrackMouseEvent") );
			}
		}
		p->bHover = FALSE;
		p->nHoverItem = -1;
	}
	
	return( hWnd );
}

/*	c[o[̔j	*/
BOOL	DestroyToolBar( HWND hWnd )
{
	BOOL	ret = TRUE;
	if( IsWindow( hWnd ) ) {
		LpToolBarInfoType	p = (LpToolBarInfoType)GetProp( hWnd, lpszPropertyName );
		if( p != NULL ) {
			/*	TuNX	*/
			if( p->lpfnOldWndProc != NULL ) {
				SetWindowLong( hWnd, GWL_WNDPROC, (LONG)p->lpfnOldWndProc );
				p->lpfnOldWndProc = NULL;
			}
			p->lpTrackMouseEvent = NULL;
			p->bHover = FALSE;
			p->nHoverItem = -1;
			/*	vpeB폜	*/
			RemoveProp( hWnd, lpszPropertyName );
			GlobalFree( (HGLOBAL)p );
		}
		ret = DestroyWindow( hWnd );
	}
	return ret;
}


/*	TuNXvV[W	*/
LRESULT	MYEXPORT	CALLBACK	MyToolBarWndProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	LpToolBarInfoType	p = (LpToolBarInfoType)GetProp( hWnd, lpszPropertyName );
	if( p == NULL || p->lpfnOldWndProc == NULL ) {
		return DefWindowProc( hWnd, uMsg, wParam, lParam );
	}
	if( uMsg == WM_CONTEXTMENU ) {
		POINT	pt;
		int		nItem;
		pt.x = LOWORD( lParam );
		pt.y = HIWORD( lParam );
		ScreenToClient( hWnd, &pt );
		nItem = SendMessage( hWnd, WM_TB_HITTEST, 0, MAKELPARAM( pt.x, pt.y ) );
		if( nItem < 0 ) {
			//	eɗ
		} else {
			return 0;
		}
	} else if( uMsg == WM_LBUTTONDBLCLK ) {
		int		nItem;
		nItem = SendMessage( hWnd, WM_TB_HITTEST, 0, lParam );
		if( nItem < 0 ) {
			PostMessage( GetParent( hWnd ), WM_TB_DBLCLK, 0, 0 );
		}
	} else if( uMsg == WM_TB_HITTEST ) {
		int			nBtnCnt = SendMessage( hWnd, TB_BUTTONCOUNT, 0, 0 );
		int			i;
		RECT		rect;
		POINT		pt;
		LRESULT		ret = -1;
		TBBUTTON	tbb;
		pt.x = LOWORD( lParam );
		pt.y = HIWORD( lParam );
		for( i = 0; i < nBtnCnt; i++ ) {
			SendMessage( hWnd, TB_GETITEMRECT, i, (LPARAM)&rect );
			if( PtInRect( &rect, pt ) ) {
				SendMessage( hWnd, TB_GETBUTTON, i, (LPARAM)&tbb );
				if( ( tbb.fsStyle & TBSTYLE_SEP ) == 0 ) {
					ret = i;
				}
				break;
			}
		}
		return ret;
	} else if( uMsg == WM_MOUSEMOVE ) {
		if( p->lpTrackMouseEvent != NULL ) {
			int		nItem;
			nItem = SendMessage( hWnd, WM_TB_HITTEST, 0, lParam );
			if( p->nHoverItem != nItem ) {
				UINT	nCmdID = 0;
				if( nItem >= 0 ) {
					/*	{^̃R}hID𓾂	*/
					TBBUTTON	tbb;
					SendMessage( hWnd, TB_GETBUTTON, nItem, (LPARAM)&tbb );
					nCmdID = tbb.idCommand;
				}
				PostMessage( GetParent( hWnd ), WM_TB_HOVER, (WPARAM)TRUE, nCmdID );
				p->nHoverItem = nItem;
			}
			if( !p->bHover ) {
				TRACKMOUSEEVENT	tme;
				ZeroMemory( &tme, sizeof(tme) );
				tme.cbSize = sizeof(tme);
				tme.dwFlags = TME_LEAVE;
				tme.hwndTrack = hWnd;
				(*(p->lpTrackMouseEvent))( &tme );
				p->bHover = TRUE;
			}
		}
	} else if( uMsg == WM_MOUSELEAVE ) {
		if( p->lpTrackMouseEvent != NULL ) {
			p->bHover = FALSE;
			PostMessage( GetParent( hWnd ), WM_TB_HOVER, (WPARAM)FALSE, 0 );
			p->nHoverItem = -1;
		}
	} else if( uMsg == WM_DESTROY ) {
		RemoveProp( hWnd, lpszPropertyName );
	}
//	if( IsBadReadPtr( &(p->lpfnOldWndProc), sizeof(p->lpfnOldWndProc) ) || IsBadCodePtr( (FARPROC)p->lpfnOldWndProc ) ) {
//		return DefWindowProc( hWnd, uMsg, wParam, lParam );
//	}
	return CallWindowProc( p->lpfnOldWndProc, hWnd, uMsg, wParam, lParam );
}


/*	TCY	*/
void	AutoSizeToolBar( HWND hWnd )
{
	if( IsWindow( hWnd ) && IsWindowVisible( hWnd ) ) {
		SendMessage( hWnd, TB_AUTOSIZE, 0, 0);
//		InvalidateRect( hWnd, NULL, TRUE );
	}
}


/*	Ԃ	*/
int		GetWidthToolBar( HWND hWnd )
{
	int		nWidth = 0;
	if( IsWindow( hWnd ) ) {
		int		nCnt;
		nCnt = SendMessage( hWnd, TB_BUTTONCOUNT, 0, 0 );
		if( nCnt > 0 ) {
			RECT	rect1, rect2;
			RECT	rect;
			SendMessage( hWnd, TB_GETITEMRECT, 0, (LPARAM)&rect1 );
			SendMessage( hWnd, TB_GETITEMRECT, nCnt-1, (LPARAM)&rect2 );
			nWidth = rect2.right - rect1.left;
			GetClientRect( hWnd, &rect );
			nWidth += 2 * ( rect1.left - rect.left );	/*	̗͂]	*/
		}
	}
	return( nWidth );
}

/*	Ԑݒ	*/
void	SetStateToolBar( HWND hWnd, BOOL bFileLoaded, BOOL bHelpMe, BOOL bViewMode, HWND hWndMySci, BOOL bEditMode )
{
	if( IsWindow( hWnd ) ) {
		BOOL	flag;
		
		/*	`FbN	*/
		SendMessage( hWnd, TB_CHECKBUTTON, ID_OPERATE_HELP_ME,   MAKELPARAM( bHelpMe,   0 ) );
		SendMessage( hWnd, TB_CHECKBUTTON, ID_OPERATE_VIEW_MODE, MAKELPARAM( bViewMode, 0 ) );
		SendMessage( hWnd, TB_CHECKBUTTON, ID_OPERATE_EDIT_MODE, MAKELPARAM( bEditMode, 0 ) );
		
		flag = bViewMode;	/*	{[hȂAłv͖	*/
		SendMessage( hWnd, TB_ENABLEBUTTON, ID_OPERATE_HELP_ME,   MAKELPARAM( !flag, 0 ) );
		flag = ( !bViewMode && bHelpMe );	/*	o[hŎłvȂA{[h͖	*/
		SendMessage( hWnd, TB_ENABLEBUTTON, ID_OPERATE_VIEW_MODE, MAKELPARAM( !flag, 0 ) );
		
		flag = ( bViewMode || bHelpMe || !bFileLoaded || bEditMode );	/*	{[hłvt@Cǂݍ݂ȂA]	*/
		SendMessage( hWnd, TB_ENABLEBUTTON, ID_FILE_SEND, MAKELPARAM( !flag, 0 ) );
		
		flag = !bFileLoaded;	/*	t@Cǂݍ݂ȂA}[Nړ	*/
		if( bEditMode ) {
			flag = ( flag && GetLengthMyScintilla( hWndMySci ) == 0 );
		}
		SendMessage( hWnd, TB_ENABLEBUTTON, ID_MOVE_PREV_MARK, MAKELPARAM( !flag, 0 ) );
		SendMessage( hWnd, TB_ENABLEBUTTON, ID_MOVE_NEXT_MARK, MAKELPARAM( !flag, 0 ) );
		SendMessage( hWnd, TB_ENABLEBUTTON, ID_MOVE_LIST_MARK, MAKELPARAM( !flag, 0 ) );
		
		flag = !bFileLoaded;	/*	t@Cǂݍ݂ȂA͖	*/
		SendMessage( hWnd, TB_ENABLEBUTTON, ID_FILE_CLOSE, MAKELPARAM( !flag, 0 ) );
		
		flag = ( bHelpMe || bViewMode );
		SendMessage( hWnd, TB_ENABLEBUTTON, ID_OPERATE_SEND_ALL,  MAKELPARAM( !flag, 0 ) );
		SendMessage( hWnd, TB_ENABLEBUTTON, ID_OPERATE_SEND_NULL, MAKELPARAM( !flag, 0 ) );
		
		flag = ( hWndMySci == NULL || !IsWindow( hWndMySci ) );	/*	ScintillaƁAҏW[h͖	*/
		SendMessage( hWnd, TB_ENABLEBUTTON, ID_OPERATE_EDIT_MODE, MAKELPARAM( !flag, 0 ) );
	}
}

/*	c[`bṽEBhEnh	*/
HWND	GetToolTipHwndToolBar( HWND hWnd )
{
	HWND hWndToolTip = NULL;
	if( IsWindow( hWnd ) ) {
		hWndToolTip = (HWND)SendMessage( hWnd, TB_GETTOOLTIPS, 0, 0 );
	}
	return hWndToolTip;
}

/*	c[`bv̕	*/
LPTSTR	GetToolTipTextToolBar( UINT nID, BOOL bMultilineTip )
{
	int		nStrID = -1;
	switch( nID ) {
	case ID_OPERATE_EDIT_MODE:	nStrID = IDS_TIPS_OPERATE_EDIT_MODE;	break;
	case ID_FILE_OPEN:			nStrID = IDS_TIPS_FILE_OPEN;			break;
	case ID_FILE_CLOSE:			nStrID = IDS_TIPS_FILE_CLOSE;			break;
	case ID_FILE_SEND:			nStrID = IDS_TIPS_FILE_SEND;			break;
	case ID_OPERATE_SETUP:		nStrID = IDS_TIPS_OPERATE_SETUP;		break;
	case ID_OPERATE_HELP_ME:	nStrID = IDS_TIPS_OPERATE_HELP_ME;		break;
	case ID_OPERATE_VIEW_MODE:	nStrID = IDS_TIPS_OPERATE_VIEW_MODE;	break;
	case ID_MOVE_PREV_MARK:		nStrID = IDS_TIPS_MOVE_PREV_MARK;		break;
	case ID_MOVE_NEXT_MARK:		nStrID = IDS_TIPS_MOVE_NEXT_MARK;		break;
	case ID_OPERATE_SEND_ALL:	nStrID = IDS_TIPS_OPERATE_SEND_ALL;		break;
	case ID_OPERATE_SEND_NULL:	nStrID = IDS_TIPS_OPERATE_SEND_NULL;	break;
	case ID_MOVE_LIST_MARK:		nStrID = IDS_TIPS_MOVE_LIST_MARK;		break;
	}
	if( nStrID >= 0 ) {
		if( bMultilineTip ) {
			nStrID += 16;
		}
		return MAKEINTRESOURCE( nStrID );
	}
	return NULL;
}
