/*--------------------------------------------------------------*\
		module	:	ToolBar.h
		purpose :	X-Send c[o[
		author	:	_@ Kengo Jinno
		create	:	2001/09/04
		update	:	2001/10/03
					2002/03/22	[ҏW]{^̒ǉ
					2002/04/12	_TrackMouseEvent()
\*--------------------------------------------------------------*/

#ifndef	TOOLBAR_H
#define	TOOLBAR_H

#ifdef	__cplusplus
extern "C" {
#endif

typedef	struct	tagToolBarCreateInfo	{
	BOOL	bShow;				/*	\	*/
	BOOL	bFunction10;		/*	5+5+5	*/
	BOOL	bSystemFont;		/*	VXetHgg	*/
	BOOL	bNoToolTip;			/*	c[`bvȂ	*/
	BOOL	bMultilineTip;		/*	s̃c[`bv	*/
	BOOL	bBitmap;			/*	rbg}bv\	*/
	BOOL	bFlat;				/*	tbgc[o[	*/
}	ToolBarCreateInfo, FAR* LpToolBarCreateInfo;

/*	_TrackMouseEvent()	*/
typedef	BOOL	(WINAPI FAR* LP_FUNC_TRACKMOUSEEVENT)( LPTRACKMOUSEEVENT );

typedef	struct	tagToolBarInfoType	{
	WNDPROC	lpfnOldWndProc;
	
	LP_FUNC_TRACKMOUSEEVENT	lpTrackMouseEvent;
	BOOL	bHover;			/*	c[o[({^ザȂĂ)}EXJ[\TRUE	*/
	int		nHoverItem;		/*	}EXJ[\̂{^̃{^ID({^łȂΕ)		*/
}	ToolBarInfoType, FAR* LpToolBarInfoType;

/*	Zp[^_uNbN	*/
#define	WM_TB_DBLCLK	(WM_APP+25)

/*	qbgeXg	*/
#define	WM_TB_HITTEST	(WM_APP+26)
/*
	wParam = 0
	lParam = MAKELPARAM( x, y )	//	NCAgW
	return = -1 ǂ̃{^ɂqbgȂ
	       >= 0 qbg{^
*/

/*	}EXJ[\c[o[ɂ/ȂʒmbZ[W	*/
#define	WM_TB_HOVER		(WM_APP+27)
/*
	wParam = 0	c[o[痣ꂽ
	wParam = 1	c[o[ɂ(lParam={^̃R}hID)
*/

/*	c[o[̍쐬	*/
extern	HWND	CreateToolBar( HWND hWndParent, UINT nCtrlID, LpToolBarCreateInfo lptbci );

/*	c[o[̔j	*/
extern	BOOL	DestroyToolBar( HWND hWnd );

/*	TuNXvV[W	*/
extern	LRESULT	MYEXPORT	CALLBACK	MyToolBarWndProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam );

/*	TCY	*/
extern	void	AutoSizeToolBar( HWND hWnd );

/*	Ԃ	*/
extern	int		GetWidthToolBar( HWND hWnd );

/*	Ԑݒ	*/
extern	void	SetStateToolBar( HWND hWnd, BOOL bFileLoaded, BOOL bHelpMe, BOOL bViewMode, HWND hWndMySci, BOOL bEditMode );

/*	c[`bṽEBhEnh	*/
extern	HWND	GetToolTipHwndToolBar( HWND hWnd );

/*	c[`bv̕	*/
extern	LPTSTR	GetToolTipTextToolBar( UINT nID, BOOL bMultilineTip );

#ifdef	__cplusplus
}
#endif

#endif	/*	TOOLBAR_H	*/
