/*--------------------------------------------------------------*\
		module	:	Tools.c
		purpose :	X-Editor ec[
		author	:	_@ Kengo Jinno
		create	:	2001/09/04
		update	:	2001/10/15
					2001/12/03	InsertPath()AShift-JIS 2byteڂ
								0x5clĂȂoOCB
\*--------------------------------------------------------------*/

#include	"PCH.h"

#include	"Tools.h"

/*	tHgI	*/
BOOL	OptionFont( HWND hWnd, LOGFONT* plf )
{
	CHOOSEFONT	cf;
	LOGFONT		lf;
	
	lf = *plf;
	cf.lStructSize = sizeof(cf);
	cf.hwndOwner = hWnd;
	cf.hDC = NULL;
	cf.lpLogFont = &lf;
	cf.iPointSize = 0;
#ifdef	WIN32
	cf.Flags = CF_INITTOLOGFONTSTRUCT|CF_SCREENFONTS|CF_ANSIONLY|CF_NOVERTFONTS;
#else
	cf.Flags = CF_INITTOLOGFONTSTRUCT|CF_SCREENFONTS;
#endif
	cf.rgbColors = 0;
	cf.lCustData = 0;
	cf.lpfnHook = NULL;
	cf.lpTemplateName = NULL;
	cf.hInstance = NULL;
	cf.lpszStyle = NULL;
	cf.nFontType = 0;
	cf.nSizeMin = cf.nSizeMax = 0;
	if( ChooseFont( &cf ) ) {
		*plf = lf;
		return TRUE;
	}
	return FALSE;
}

#if 0
UINT	MYEXPORT	CALLBACK	ColorHookProc( HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	if( uMsg == WM_INITDIALOG ) {
		LPCHOOSECOLOR	lpcc = (LPCHOOSECOLOR)lParam;
		if( lpcc != NULL && ( lpcc->Flags & CC_ENABLEHOOK ) && lpcc->lCustData != 0 ) {
			SetWindowText( hDlg, (LPCTSTR)lpcc->lCustData );
		}
	}
	UNUSE(wParam);
	return FALSE;
}

/*	FI	*/
BOOL	OptionColor( HWND hWnd, COLORREF* pcol, LPDWORD lpCustColors, HINSTANCE hInstance, UINT nDlgTitleID )
{
	CHOOSECOLOR	cc;
	TCHAR	buff[ 80 ];
	
	cc.lStructSize = sizeof(cc);
	cc.hwndOwner = hWnd;
	cc.hInstance = NULL;
	cc.rgbResult = (DWORD)*pcol;
	cc.lpCustColors	= lpCustColors;
	cc.Flags = CC_RGBINIT;
	cc.lCustData = 0;
	cc.lpfnHook = NULL;
	cc.lpTemplateName = NULL;
	
	if( hInstance != NULL && nDlgTitleID != 0 && LoadString( hInstance, nDlgTitleID, buff, 80 ) != 0 ) {
		cc.Flags |= CC_ENABLEHOOK;
		cc.lCustData = (DWORD)buff;
		cc.lpfnHook = ColorHookProc;
	}
	
	if( ChooseColor( &cc ) ) {
		*pcol = (COLORREF)cc.rgbResult;
		return TRUE;
	}
	return FALSE;
}
#endif

BOOL	ScreenToClientRect( HWND hWnd, LPRECT lprect )
{
	POINT	p;
	p.x = lprect->left;
	p.y = lprect->top;
#ifdef	WIN32
	if( !ScreenToClient( hWnd, &p ) ) {
		return FALSE;
	}
#else
	ScreenToClient( hWnd, &p );
#endif
	lprect->left = p.x;
	lprect->top = p.y;
	p.x = lprect->right;
	p.y = lprect->bottom;
#ifdef	WIN32
	if( !ScreenToClient( hWnd, &p ) ) {
		return FALSE;
	}
#else
	ScreenToClient( hWnd, &p );
#endif
	lprect->right = p.x;
	lprect->bottom = p.y;
	return TRUE;
}

BOOL	ClientToScreenRect( HWND hWnd, LPRECT lprect )
{
	POINT	p;
	p.x = lprect->left;
	p.y = lprect->top;
#ifdef	WIN32
	if( !ClientToScreen( hWnd, &p ) ) {
		return FALSE;
	}
#else
	ClientToScreen( hWnd, &p );
#endif
	lprect->left = p.x;
	lprect->top = p.y;
	p.x = lprect->right;
	p.y = lprect->bottom;
#ifdef	WIN32
	if( !ClientToScreen( hWnd, &p ) ) {
		return FALSE;
	}
#else
	ClientToScreen( hWnd, &p );
#endif
	lprect->right = p.x;
	lprect->bottom = p.y;
	return TRUE;
}

#if 0

#if		defined(__BORLANDC__) || defined(__LCC__)

/*	CRTDLL.DLL𗘗p̂ŁAsscanf()̃RXg͒Ⴂ	*/

#include	<stdio.h>

void	ReadColorFormat( COLORREF* pCol, LPTSTR lpszData )
{
	int		r, g, b;
	if( sscanf( lpszData, _T("%d,%d,%d"), &r, &g, &b ) == 3 ) {
		*pCol = RGB( r, g, b );
	}
}

#else

static	LPTSTR	NEAR	my_strchr( LPCTSTR p, TCHAR c )
{
	LPTSTR	q = (LPTSTR)p;
	while( *q != _T('\0') ) {
		if( *q == c ) {
			return q;
		}
		q++;
	}
	return NULL;
}

static	long	NEAR	my_atoi( LPCTSTR p )
{
	long	ret = 0;
	BOOL	bIsMinus = FALSE;
	BOOL	bSign = TRUE;
	while( *p != _T('\0') ) {
		if( *p >= _T('0') && *p <= _T('9') ) {
			ret *= 10;
			ret += *p - _T('0');
			bSign = FALSE;
		} else if( *p == _T(' ') ) {
			//	Ȃ
		} else if( *p == _T('+') ) {
			if( bSign ) {
				bIsMinus = FALSE;
				bSign = FALSE;
			} else {
				break;
			}
		} else if( *p == _T('-') ) {
			if( bSign ) {
				bIsMinus = TRUE;
				bSign = FALSE;
			} else {
				break;
			}
		} else {
			
			break;
		}
		p++;
	}
	return bIsMinus ? -ret : ret;
}

void	ReadColorFormat( COLORREF* pCol, LPTSTR lpszData )
{
	LPTSTR	lpszNow, lpszLoc;
	int		r, g, b;
	lpszNow = lpszData;
	if( ( lpszLoc = my_strchr( lpszNow, _T(',') ) ) != NULL ) {
		r = (int)my_atoi( lpszNow );
		lpszNow = lpszLoc+1;
		if( ( lpszLoc = my_strchr( lpszNow, _T(',') ) ) != NULL ) {
			g = (int)my_atoi( lpszNow );
			lpszNow = lpszLoc+1;
			b = (int)my_atoi( lpszNow );
			*pCol = RGB( r, g, b );
		}
	}
}

#endif

void	WriteColorFormat( COLORREF col, LPTSTR lpszData )
{
	const	TCHAR	BASED_CODE	lpszColorFormat[] = _T("%d,%d,%d");
	wsprintf( lpszData, lpszColorFormat, (int)GetRValue(col), (int)GetGValue(col), (int)GetBValue(col) );
}

#endif

BOOL	WritePrivateProfileInt( LPCTSTR lpszSection, LPCTSTR lpszKey, DWORD dwValue, LPCTSTR lpszFile )
{
	TCHAR	buff[256];
	static	const	TCHAR	szFmt[] = _T("%ld");
	wsprintf( buff, szFmt, dwValue );
	return WritePrivateProfileString( lpszSection, lpszKey, buff, lpszFile );
}

HFONT	MyCreateFont( HWND hWnd, HFONT hFont, const LOGFONT* plf )
{
	LOGFONT	lf2 = *plf;
	LONG	lHeight = plf->lfHeight;
	HFONT	hFont2, hOldFont;
	int		nStep = ( lHeight < 0 ) ? -1 : 1;
	int		i;
	HDC		hDC = GetDC( hWnd );
	SIZE	size1, size2;
	
	/*	傫āASpPƔpQTCYɂȂ鍂T	*/
	for( i = 0; ( i < 0 ? -i : i ) < 5; i += nStep ) {
		lf2.lfHeight = lHeight + i;
		hFont2 = CreateFontIndirect( &lf2 );
		hOldFont = (HFONT)SelectObject( hDC, hFont2 );
		GetTextExtentPoint32( hDC, _T("@"), 2, &size1 );
		GetTextExtentPoint32( hDC, _T("  "), 2, &size2 );
		SelectObject( hDC, hOldFont );
		DeleteObject( hFont2 );
		if( size1.cx == size2.cx ) {
			lHeight = lf2.lfHeight;
			break;
		}
	}
	lf2.lfHeight = lHeight;
	ReleaseDC( hWnd, hDC );
	
	if( hFont != NULL ) {
		DeleteObject( hFont );
	}
	hFont = CreateFontIndirect( &lf2 );
	return hFont;
}

HFONT	MyCreateNewLineFont( HFONT hFont, HFONT hFontNewLine )
{
	HFONT	hNewLineFont;
	LOGFONT	lf;
	
	if( hFontNewLine != NULL ) {
		DeleteObject( hFontNewLine );
	}
	
	GetObject( hFont, sizeof(lf), &lf );
	hNewLineFont = CreateFont( (4*lf.lfHeight)/5, 0,
			lf.lfEscapement, lf.lfOrientation, FW_BOLD/*lf.lfWeight*/,
			lf.lfItalic, FALSE, FALSE, /*	lfUnderline lfStrikeOut	*/
			SYMBOL_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,
			DEFAULT_QUALITY	, DEFAULT_PITCH, _T("Symbol") );
	/*	Â95ƁASymbolTrueTypeH	*/
	return hNewLineFont;
}

/*	DLL̃o[W𒲂ׂ	*/
BOOL	GetDllVersion( LPCTSTR lpszDllName, LPDWORD lpdwFileMS, LPDWORD lpdwFileLS, LPDWORD lpdwProdMS, LPDWORD lpdwProdLS )
{
	BOOL	ret = TRUE;
	BOOL	bMustFree = FALSE;
	HINSTANCE	hInstDll = GetModuleHandle( lpszDllName );
	if( hInstDll == NULL ) {
		hInstDll = LoadLibrary( lpszDllName );
		bMustFree = TRUE;
	}
	if( hInstDll == NULL ) {
		ret = FALSE;
	} else {
		TCHAR	szPath[_MAX_PATH];
		DWORD	dwInfoSize;
		LPVOID	lpBlock = NULL;
		VS_FIXEDFILEINFO	*lpInfo;
		
		if( ret ) {
			ret = ( GetModuleFileName( hInstDll, szPath, _MAX_PATH ) != 0 );
		}
		if( ret ) {
			dwInfoSize = GetFileVersionInfoSize( szPath, NULL );
			ret = ( dwInfoSize != 0 );
		}
		if( ret ) {
			lpBlock = (LPVOID)GlobalAlloc( GPTR, sizeof(BYTE)*dwInfoSize );
			ret = ( lpBlock != NULL );
		}
		if( ret ) {
			ret = GetFileVersionInfo( szPath, 0, dwInfoSize, lpBlock );
		}
		if( ret ) {
			UINT	uLen;
			ret = VerQueryValue( lpBlock, _T("\\"), (LPVOID*)&lpInfo, &uLen );
		}
		if( ret ) {
			if( lpdwFileMS != NULL )	*lpdwFileMS = lpInfo->dwFileVersionMS;
			if( lpdwFileLS != NULL )	*lpdwFileLS = lpInfo->dwFileVersionLS;
			if( lpdwProdMS != NULL )	*lpdwProdMS = lpInfo->dwProductVersionMS;
			if( lpdwProdLS != NULL )	*lpdwProdLS = lpInfo->dwProductVersionLS;
		}
		if( lpBlock != NULL ) {
			GlobalFree( (HGLOBAL)lpBlock );
		}
		if( bMustFree ) {
			FreeLibrary( hInstDll );
		}
	}
	return ret;
}

/*	`bN̍߂	*/
DWORD	GetTickDiff( DWORD dwTo, DWORD dwFrom )
{
	if( dwTo < dwFrom ) {
		/*	t]Ă遁JE^I[o[t[	*/
		return( dwTo + ~dwFrom + 1 );
	}
	return( dwTo - dwFrom );
}

/*	t@C_CAÕtbN֐	*/
UINT	MYEXPORT	CALLBACK	FileHookProc( HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	/*	gp	*/
	UNUSE(hDlg);
	UNUSE(uMsg);
	UNUSE(wParam);
	UNUSE(lParam);
	return FALSE;
}

static	void	InsertPath( LPTSTR lpszBuff, LPCTSTR path )
{
	int		nDiff;
	LPTSTR	p, q;
	
	/*	'\0'܂'\\'܂ł̕𐔂	*/
	p = lpszBuff;
	while( *p != _T('\0') ) {
		if( IsDBCSLeadByte( *p ) ) {
			p++;
		} else if( *p == _T('\\') ) {
			break;
		}
		p++;
	}
	
	/*	ړȂ΂ȂȂ	*/
	nDiff = lstrlen( path ) - ( p - lpszBuff );
	if( nDiff > 0 ) {
		/*	ւ炷	*/
		/*	"PROGRA~1"  "Program Files"̂悤ȃp^[	*/
		q = lpszBuff + lstrlen( lpszBuff );
		while( q >= p ) {
			*(q+nDiff) = *q;
			q--;
		}
	} else if( nDiff < 0 ) {
		/*	Oւ炷	*/
		/*	"_~1.TXT"  "+.txt"̂悤ȃp^[	*/
		q = p+nDiff;
		while( *p != _T('\0') ) {
			*(q++) = *(p++);
		}
		*q = _T('\0');
	}
	
	/*	֑}	*/
	while( *path != _T('\0') ) {
		*(lpszBuff++) = *(path++);
	}
	/*	'\0'͏Ȃ	*/
}

void	GetLongPathName95( LPCTSTR lpszPathShort, LPTSTR lpszPathLong, DWORD dwBuffSize )
{
	TCHAR	path[ _MAX_PATH ];
	LPTSTR	p, q;
	BOOL	qf = FALSE;
	
	lstrcpy( path, lpszPathShort );
	lstrcpy( lpszPathLong, lpszPathShort );
	
	while( !qf ) {
		/*	Ō'\\'T	*/
		qf = TRUE;
		p = path;
		while( *p != _T('\0') ) {
			if( IsDBCSLeadByte( *p ) ) {
				p++;
			} else if( *p == _T('\\') ) {
				q = p;
				qf = FALSE;
			}
			p++;
		}
		if( !qf ) {
			WIN32_FIND_DATA	wfd;
			HANDLE	h;
			ZeroMemory( &wfd, sizeof(wfd) );
			h = FindFirstFile( path, &wfd );
			if( h != INVALID_HANDLE_VALUE ) {
				if( wfd.cFileName[0] != _T('\0') ) {
					/*	'.'ȊO̕邩H	*/
					LPCTSTR	r = wfd.cFileName;
					while( *r != _T('\0') ) {
						if( *r != _T('.') ) {
							break;
						}
						r++;
					}
					if( *r != _T('\0') ) {
						InsertPath( lpszPathLong + ( q - path + 1 ), wfd.cFileName );
					}
				}
				FindClose( h );
			}
			/*	'\\''\0'ɒu	*/
			*q = _T('\0');
		}
	}
}

#if	defined(__LCC__)
/*	BȂłH	*/
#undef	DEFINE_SHLGUID
#define	DEFINE_SHLGUID(name,l,w1,w2)	GUID name = { l,w1,w2,{ 0xC0,0,0,0,0,0,0,0x46}}
      DEFINE_SHLGUID( CLSID_ShellLink, 	0x00021401L, 0, 0);
      DEFINE_SHLGUID( IID_IShellLink,	0x000214EEL, 0, 0);
const DEFINE_SHLGUID( IID_IPersistFile,	0x0000010BL, 0, 0);
#endif

/*	ZpXEV[gJbg̉	*/
void	ResolveShortcut( LPTSTR lpszPath )
{
	SHFILEINFO		shfi;
	
	if( !( lpszPath[0] == _T('\\') && lpszPath[1] == _T('\\') ) ) {
		LPCTSTR		p = lpszPath;
		/*	':'邩H@ΐ΃pX낤	*/
		while( *p != _T('\0') ) {
			if( *p == _T(':') ) {
				break;
			}
			p++;
		}
		if( *p == _T('\0') ) {
			/*	΃pX΃pX	*/
			TCHAR	buff[ _MAX_PATH ];
			LPTSTR	s;
			if( GetFullPathName( lpszPath, _MAX_PATH, buff, &s ) > 0 ) {
				lstrcpy( lpszPath, buff );
			}
		}
	}
	
	/*	ZpXpX(98ȍ~GetLongPathName())	*/
	GetLongPathName95( lpszPath, lpszPath, _MAX_PATH );
	
	/*	V[gJbgNpX	*/
	ZeroMemory( &shfi, sizeof(shfi) );
	if( SHGetFileInfo( lpszPath, 0, &shfi, sizeof(shfi), SHGFI_ATTRIBUTES ) != 0
		&& ( shfi.dwAttributes & SFGAO_LINK ) ) {
		
		IShellLink*		ShellLink;
		IPersistFile*	PersistFile;
		HRESULT			hResult;
		
		hResult = CoCreateInstance( &CLSID_ShellLink, NULL, CLSCTX_INPROC_SERVER, &IID_IShellLink, (void **)&ShellLink );
		
		if( SUCCEEDED( hResult ) ) {
			hResult = ShellLink->lpVtbl->QueryInterface( ShellLink, &IID_IPersistFile, (void **)&PersistFile );
			
			if( SUCCEEDED( hResult ) ) {
				WCHAR	wszPath[_MAX_PATH];
				
				MultiByteToWideChar( CP_ACP, 0, lpszPath, -1, wszPath, _MAX_PATH );
				hResult = PersistFile->lpVtbl->Load( PersistFile, wszPath, STGM_READ );
				if( SUCCEEDED( hResult ) ) {
					WIN32_FIND_DATA		wfd;
					TCHAR	szPath[ _MAX_PATH ];
					
					ZeroMemory( &wfd, sizeof(wfd) );
					hResult = ShellLink->lpVtbl->GetPath( ShellLink, szPath, _MAX_PATH, &wfd, SLGP_UNCPRIORITY );
					if( SUCCEEDED( hResult ) ) {
						lstrcpy( lpszPath, szPath );
					}
				}
				
				PersistFile->lpVtbl->Release( PersistFile );
			}
			
			ShellLink->lpVtbl->Release( ShellLink );
		}
	}
}

/*	RECTłMoveWindow()	*/
BOOL	MyMoveWindow( HWND hWnd, const LPRECT lpRect, BOOL bRepaint )
{
	BOOL	ret = FALSE;
	if( lpRect != NULL ) {
		ret = MoveWindow( hWnd, lpRect->left, lpRect->top, lpRect->right - lpRect->left, lpRect->bottom - lpRect->top, bRepaint );
	}
	return( ret );
}
