/*--------------------------------------------------------------*\
		module	:	WaitDlg.c
		purpose :	X-Send _CAO
		author	:	_@ Kengo Jinno
		create	:	2001/09/14
		update	:	2001/09/14
\*--------------------------------------------------------------*/

#include	"PCH.h"
#include	"WaitDlg.h"

#include	"resource.h"

BOOL	MYEXPORT	CALLBACK	WaitDlgProc( HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	if( uMsg == WM_INITDIALOG ) {
		FpWaitDlgInfo	p = (FpWaitDlgInfo)lParam;
		p->bOnce = TRUE;
		SetWindowLong( hDlg, DWL_USER, (long)lParam );
		return TRUE;
	} else if( uMsg == WM_KICK_PROCESS ) {
		FpWaitDlgInfo	p = (FpWaitDlgInfo)GetWindowLong( hDlg, DWL_USER );
		if( p != NULL && p->bOnce ) {
			p->bOnce = FALSE;
			p->bRetCode = (p->lpfnProcess)( p->hWnd, p->wParam, p->lParam );
		}
		EndDialog( hDlg, IDOK );
		return TRUE;
	}
	return FALSE;
}
