/*--------------------------------------------------------------*\
		module	:	X-Send.h
		purpose :	X-Send C
		author	:	_@ Kengo Jinno
		create	:	2001/09/03
		update	:	2001/10/09
					2001/12/03	DoSendCommand() ǉ
					2002/03/06	XsInfo::bMarkAsComment ǉ
					2002/03/19	XsInfo::bEditMode ǉ
					2002/03/19	XsInfo::hWndMySci ǉ
					2002/03/26	֌W̒ǉ
					2002/04/09	
\*--------------------------------------------------------------*/

#ifndef	X_SEND_H
#define	X_SEND_H

#include	"bccres.h"
#include	"resource.h"

#include	"FileMru.h"
#include	"XSD-API.h"
#include	"MyList.h"
#include	"HOOK.h"
#include	"EDS-API.h"
#include	"MyDDE.h"

#ifdef	WIN32
/*	StrFormatByteSize() (shlwapi.dll)ւ̃|C^^	*/
typedef	LPTSTR	(WINAPI FAR* LP_FUNC_STRFORMATBYTESIZE)( DWORD, LPTSTR, UINT );
#endif

//	̒̕
#define	MAX_FIND_TEXT_LEN	255

typedef	struct	tagXsInfo	{
	HINSTANCE	hInstance;		/*	g̃CX^Xnh	*/
	
	TCHAR		szProfile[_MAX_PATH];		/*	INIt@C̃pX	*/
	TCHAR		szInitialDir[_MAX_PATH];	/*	OpenFile_CAȌfBNg	*/
	TCHAR		szFilePath[_MAX_PATH];		/*	JĂt@C̃tpX	*/
	TCHAR		szFileName[_MAX_PATH];		/*	JĂt@C̃t@C	*/
	TCHAR		szPathName[_MAX_PATH];		/*	JĂt@C̃pX	*/
	BYTE		md5FileName[16];			/*	t@CMD5l	*/
	TCHAR		cFilePathDummy;				/*	szFilePath[0]ɓ_~[	*/
	TCHAR		szDllPath[ _MAX_PATH ];		/*	Scintilla.dll[hpX	*/
	
	HACCEL		hAccel;				/*	ANZ[^	*/
	
	HWND		hWndToolBar;		/*	c[o[	*/
	HWND		hWndScrollBar;		/*	XN[o[	*/
	HWND		hWndMyEdit;			/*	ҏWs	*/
	HWND		hWndListBoxLow;		/*	Xg{bNX()	*/
	HWND		hWndListBoxHi;		/*	Xg{bNX()	*/
	HWND		hWndStatusBar;		/*	Xe[^Xo[	*/
	HWND		hWndToolTip;		/*	c[`bv	*/
	HWND		hWndMySci;			/*	Scintilla		*/
	
	int			nCurrentLine;		/*	܂sԍ(0`)	*/
	int			nLineCnt;			/*	s	*/
	int			nSize;				/*	t@C̃oCg	*/
	int			nMaxLen;			/*	ő啶	*/
	int			nMaxAt;				/*	̍sԍ	*/
	BYTE		md5Contents[16];	/*	t@CeMD5l	*/
	FileInfoType	FileInfo;		/*	t@Cǂݍݗp[N	*/
	BOOL		bRecvFile;			/*	t@C]󂯂ĂŒ	*/
	DWORD		dwSendFileInterval;	/*	t@C]̑҂	*/
	BOOL		bBeepOnResend;		/*	]̍đvBeep	*/
	SIZE		sizeMarkList;		/*	}[Nꗗ_CAÕTCY	*/
	
#ifdef	WIN32
	/*	StrFormatByteSize() shlwapi.dll	*/
	BOOL		bMustFreeShlWapiDll;
	HINSTANCE	hInstShlWapiDll;	/*	shlwapi.dll̃CX^Xnh	*/
	LP_FUNC_STRFORMATBYTESIZE	lpStrFormatByteSize;	/*	StrFormatByteSize()	*/
#endif
	
	/*	[h	*/
	BOOL		bHelpMe;			/*	łv	*/
	BOOL		bViewMode;			/*	{[h	*/
	BOOL		bEditMode;			/*	ҏW[h	*/
	
	/*	[\(V)]	*/
	BOOL		bShowToolbar;		/*	c[o[\	*/
	BOOL		bShowNewLine;		/*	s}[N\	*/
	BOOL		bShowLineNum;		/*	sԍ\		*/
	BOOL		bShowScrollBar;		/*	XN[o[\	*/
	BOOL		bShowStatusBar;		/*	Xe[^Xo[\	*/
	BOOL		bBitmapOnToolbar;	/*	ACRtc[o[	*/
	BOOL		bShowEdge;			/*	\			*/
	int			nEdgeColumn;		/*					*/
	
	/*	ݒ	*/
	LOGFONT		lfText;				/*	tHg	*/
	HFONT		hFont;
	HFONT		hFontNewLine;		/*	s}[NptHg	*/
	TCHAR		cNewLine;			/*	s}[N̕		*/
	BOOL		bDiamondCursor;		/*	_CAhJ[\	*/
	BOOL		bCtrlXCCursor;		/*	Ctrl+X/CJ[\ړ	*/
	BOOL		bCaretRight;		/*	Lbg͉E[		*/
	BOOL		bMarkAsComment;		/*	}[NsRg	*/
	BOOL		bFunctionKey10;		/*	5+5̃t@NVL[	*/
	BOOL		bSystemFont;		/*	VXetHgg	*/
	BOOL		bNoTooltip;			/*	c[`bvȂ		*/
	BOOL		bMultilineTip;		/*	s̃c[`bv	*/
	BOOL		bFlatToolbar;		/*	tbgc[o[		*/
	
	/*	IMS-API֌W	*/
	UINT		uImsApiMessage;		/*	APIpbZ[W	*/
	BOOL		bUseImsApi;			/*	IMS-APIgTRUE	*/
	HWND		hWndIms;			/*	IMS.exẽEBhEnh	*/
	BOOL		bImsSearching;		/*	T[o[TRUE	*/
	TCHAR		szHelpMe[_MAX_PATH];	/*	łv̕	*/
	
	/*	t@C֌W	*/
	FileMru		FileMruInfo;		/*	t@C\	*/
	HMENU		hFileMenu;			/*	[t@C(F)]̃nh	*/
	
	/*	vZXԒʐM	*/
	UINT		uXsIpcMessage;		/*	IPCpbZ[W	*/
	
	/*	f[API	*/
	UINT			uXsdApiMsg;		/*	f[APIpbZ[W	*/
	XsdApiInfoType	XsdApiInfo;		/*	APIʒmp\	*/
	HWND			hWndXsd;		/*	f[̃EBhEnh	*/
	
	/*	tbN	*/
	IdleInfoType	IdleInfo;
	
	/*	EditSend֌W	*/
	BOOL		bCanUseEditSend;	/*	EditSendgp\	*/
	EdsApiInfoType	EdsApiInfo;
	BOOL		bCanSendEditSend;	/*	EBhE	*/
	
	/*	DDE֌W	*/
	BOOL		bUseDde;			/*	DDEg	*/
	MyDdeInfoType	DdeInfo;
	TCHAR		szDdeServerName[ _MAX_FNAME ];	/*	DDET[o[		*/
	TCHAR		szDdeServiceList[ _MAX_PATH ];	/*	T[o[Xg	*/
	TCHAR		szDdeServiceBuff[ _MAX_PATH ];	/*	T[o[Xg	*/
	LPCTSTR		szDdeServiceArray[ _MAX_PATH ];	/*	T[o[Xg	*/
	int			nDdeServiceArry;				/*	Xg̐	*/
	BOOL		bFoundServer;		/*	T[o[	*/
	HWND		hWndLastServer;		/*	O񌩂T[o[	*/
	
	/*	֌W	*/
	HWND		hWndFindDlg;	/*	_CAÕnh([hX)	*/
	BOOL		bFindNext;		/*	O̎TRUE	*/
	BOOL		bMatchCase;		/*	P[Xˑ	*/
	BOOL		bWholeWord;		/*	PŌ	*/
	UINT		nMsgFindDlg;	/*	_CAÕbZ[W	*/
	FINDREPLACE	frString;		/*	_CAOɓnp[^	*/
	TCHAR		szFindText[MAX_FIND_TEXT_LEN];		/*		*/
	TCHAR		szReplaceText[MAX_FIND_TEXT_LEN];	/*	u	*/
	
}	XsInfo, NEAR* NpXsInfo;

#define	GWL_XS_INFO		0

#ifdef	WIN32
#define	XS_EXTRA_BYTES			sizeof(LONG)
#define	GetXsInfo(x)			( (NpXsInfo)GetWindowLong(x,GWL_XS_INFO) )
#define	SetXsInfo(x,y)			SetWindowLong(x,GWL_XS_INFO,(LONG)y)
#else
#define	XS_EXTRA_BYTES			sizeof(WORD)
#define	GetXsInfo(x)			( (NpXsInfo)GetWindowWord(x,GWL_XS_INFO) )
#define	SetXsInfo(x,y)			SetWindowWord(x,GWL_XS_INFO,(WORD)y)
#endif



/*	qEBhEID	*/
#define	ID_TOOLBAR		1
#define	ID_SCROLLBAR	2
#define	ID_EDIT_LINE	3
#define	ID_LISTBOX_LOW	4
#define	ID_LISTBOX_HI	5
#define	ID_STATUSBAR	6
#define	ID_SCINTILLA	7

/*	IMST	*/
#define	WM_IMS_SEARCH_SERVER	(WM_APP+1)

/*	R}hC̃t@Cǂݍ/J	*/
#define	WM_XS_OPEN_FILE			(WM_APP+2)

/*	̃t@Cǂݍ/J	*/
#define	WM_XS_OPEN_MULTI_FILE	(WM_APP+3)

/*	f[N	*/
#define	WM_XS_STARTUP_XSD		(WM_APP+4)

/*	t@C]Cxg	*/
#define	WM_XS_RECV_FILE			(WM_APP+5)

#ifdef	WIN32
#define	DoPostCommand( h, c )	PostMessage( h, WM_COMMAND, MAKEWPARAM( c, 0 ), (LPARAM)NULL )
#define	DoSendCommand( h, c )	SendMessage( h, WM_COMMAND, MAKEWPARAM( c, 0 ), (LPARAM)NULL )
#else
#define	DoPostCommand( h, c )	PostMessage( h, WM_COMMAND, c, MAKELPARAM( NULL, 0 ) );
#define	DoSendCommand( h, c )	SendMessage( h, WM_COMMAND, c, MAKELPARAM( NULL, 0 ) );
#endif


#ifdef	__cplusplus
extern "C" {
#endif

extern	void	DoMove( HWND hWnd, int nLine );

extern	void	RecalcLayout( HWND hWnd );

extern	void	MyProcessMessage( HWND hWnd, LPMSG pMsg );

#ifdef	__cplusplus
}
#endif

#endif	/*	X_SEND_H	*/
