/*--------------------------------------------------------------*\
		module	:	XSD-API.c
		purpose :	X-Send f[ API
		author	:	_@ Kengo Jinno
		create	:	2001/09/11
		update	:	2001/10/10
					2002/03/27	ҏW[hXSD_API_EVENT_CLOSE_FILE
								ĂAȂ悤
\*--------------------------------------------------------------*/

#include	"PCH.h"
#include	"XSD-API.h"
#include	"X-Send.h"
#include	"MyList.h"
#include	"md5.h"

/*	f[ɃCxg𑗂	*/
void	DoXsdEvent( HWND hWnd )
{
	NpXsInfo	p = GetXsInfo( hWnd );
	if( p != NULL && p->hWndXsd != NULL && IsWindow( p->hWndXsd ) ) {
		DWORD	dwResult;
		COPYDATASTRUCT	cds;
		ZeroMemory( &cds, sizeof(cds) );
		cds.dwData = p->uXsdApiMsg;
		cds.cbData = sizeof( XsdApiInfoType );
		cds.lpData = &(p->XsdApiInfo);
		SendMessageTimeout( p->hWndXsd, WM_COPYDATA, (WPARAM)hWnd, (LPARAM)&cds, SMTO_ABORTIFHUNG|SMTO_BLOCK, 500, &dwResult );
		/*
			Kvȏp->XsdApiInfoɃZbgĂĂяoƁB
		*/
	}
}

/*	f[痈Cxg(WM_COPYDATA)	*/
void	ParseXsdEvent( HWND hWnd, HWND hWndFrom, PCOPYDATASTRUCT pcds )
{
	NpXsInfo	p = GetXsInfo( hWnd );
	if( p != NULL && hWndFrom != NULL && IsWindow( hWndFrom ) && pcds != NULL && pcds->dwData == p->uXsdApiMsg ) {
		LpXsdApiInfoType	pInfo = (LpXsdApiInfoType)(pcds->lpData);
		switch( pInfo->uEventID ) {
		case XSD_API_EVENT_SCROLL:		/*	XN[	*/
			if( MD5Compare( pInfo->md5FileName, p->md5FileName ) ) {
				BOOL	bGo = FALSE;
				if( GetActiveWindow() != hWnd ) {	/*	ANeBu	*/
					bGo = TRUE;
				}
				if( p->bViewMode && p->IdleInfo.bIsIdle ) {	/*	{[hŃACh	*/
					bGo = TRUE;
				}
				if( bGo ) {
					DoMove( hWnd, (int)(pInfo->wParam) );
				}
			}
			break;
		case XSD_API_EVENT_VIEW_MODE:	/*	{[h	*/
			if( !p->bViewMode ) {
				/*	o[hA{[hɖ߂	*/
				DoPostCommand( hWnd, ID_OPERATE_VIEW_MODE );
				/*	t@C͊֌WȂ	*/
			}
			break;
		case XSD_API_EVENT_HELP_ME:	/*	łv	*/
			if( MD5Compare( pInfo->md5FileName, p->md5FileName ) ) {
				BOOL	bHelpMe = (BOOL)(pInfo->wParam);
				if( p->bHelpMe != bHelpMe ) {
					DoPostCommand( hWnd, ID_OPERATE_HELP_ME );
					DoMove( hWnd, (int)(pInfo->lParam) );
				}
			}
			break;
//		case XSD_API_EVENT_CHECK_FILE:	/*	t@C̓emF	*/
//			if( lstrcmp( pInfo->szFileName, p->szFileName ) == 0 ) {
//				CopyMemory( p->XsdApiInfo.md5digest, pInfo->md5digest, sizeof(BYTE)*sizeof(pInfo->md5digest) );
//				DoPostCommand( hWnd, ID_FILE_CHECK );
//			}
//			break;
		case XSD_API_EVENT_SEND_FILE:	/*	t@C̓]	*/
			CopyMemory( &(p->XsdApiInfo), pInfo, sizeof(XsdApiInfoType) );
			PostMessage( hWnd, WM_XS_RECV_FILE, pInfo->wParam, pInfo->lParam );
			break;
		case XSD_API_EVENT_CLOSE_FILE:	/*	t@C	*/
			if( MD5Compare( pInfo->md5FileName, p->md5FileName ) ) {
				if( p->bViewMode && !p->bEditMode ) {
					/*	{[hȂA	*/
					/*	ҏW[hȂAȂ(2002/03/27)	*/
					DoPostCommand( hWnd, ID_FILE_CLOSE );
				}
			}
		}
	}
}
