/*--------------------------------------------------------------*\
		module	:	XSD-API.h
		purpose :	X-Send f[ API
		author	:	_@ Kengo Jinno
		create	:	2001/09/11
		update	:	2001/10/10
					2004/02/24	XSD_API_EVENT_SEND_FILE
								wParam==4ǉ(ping)
\*--------------------------------------------------------------*/

#ifndef	XSD_API_H
#define	XSD_API_H

#if	!defined(WIN32)
#error This APIs support only Win32.
#endif

#if	defined(UNICODE) || defined(_UNICODE)
#error This APIs support only MBCS(Shift-JIS).
#endif

#if		defined(__BORLANDC__)
#pragma option	push	-a4
#endif

#ifdef	__cplusplus
extern "C" {
#endif

/*--------------------------------------------------------------*\
	ʐMp\
\*--------------------------------------------------------------*/

#define	MAX_XSD_API_BUFF	_MAX_FNAME

typedef	struct	tagXsdApiInfoType	{
	UINT	uEventID;	/*	Cxg̎ʎq	*/
	HWND	hWndFrom;	/*	𑗂ẴEBhEnh	*/
	ULONG	ulAddr;		/*	𑗂ĂPC̃AhX(PCԒʐMŎgp)	*/
	
	WPARAM	wParam;		/*	p[^	*/
	LPARAM	lParam;		/*	p[^	*/
	
	BYTE	md5FileName[16];	/*	t@CMD5l	*/
	BYTE	md5Contents[16];	/*	t@CeMD5l	*/
	
	BYTE	buff[MAX_XSD_API_BUFF];
	
}	XsdApiInfoType, FAR* LpXsdApiInfoType;
/*
	̍\̂WM_COPYDATAŒʒm
*/

/*--------------------------------------------------------------*\
	(\)
\*--------------------------------------------------------------*/

#define	XSD_API_EVENT_RESERVED	0

/*--------------------------------------------------------------*\
	I
\*--------------------------------------------------------------*/

#define	XSD_API_EVENT_QUIT	1

/*
	wParam = 0
	lParam = 0
*/

/*
	X-SendȂȂ΁AXSDIB
*/

/*--------------------------------------------------------------*\
	XN[
\*--------------------------------------------------------------*/

#define	XSD_API_EVENT_SCROLL	2

/*
	wParam = sԍ
	lParam = 0
	md5FileName = ̃t@CMD5l
*/

/*--------------------------------------------------------------*\
	{[hɂ
\*--------------------------------------------------------------*/

#define	XSD_API_EVENT_VIEW_MODE	3

/*
	wParam = 0
	lParam = 0
	md5FileName = ̃t@CMD5l
*/

/*
	o[hɂȂ甭B
	󂯂͉{[hɈڂB
*/

/*--------------------------------------------------------------*\
	łv
\*--------------------------------------------------------------*/

#define	XSD_API_EVENT_HELP_ME	4

/*
	wParam = (BOOL)bFlag
				TRUE  łv
				FALSE łv
	lParam = sԍ
	md5FileName = ̃t@CMD5l
*/

/*
	łv𔭗/甭B
*/

/*--------------------------------------------------------------*\
	t@C̓emF(MD5l`FbN)
\*--------------------------------------------------------------*/

#define	XSD_API_EVENT_CHECK_FILE	5

/*
	gp
*/

/*--------------------------------------------------------------*\
	t@C̓]
\*--------------------------------------------------------------*/

#define	XSD_API_EVENT_SEND_FILE	6

/*
	wParam = Xe[^X (0: 1:] 2:I 3:đv 4:ping)
	lParam = 0: Ŝ̃TCY
	         1: MAKELPARAM( buffɔ[߂, R[hԍ )
	         2: ړ̍sԍ
	         3: (1Ɠ)
	         4: gp
	md5FileName = ̃t@CMD5l
	md5Contents = ̃t@CeMD5l
	buff = 0: t@C
	       1: ]e
	       2: ꎞt@C
	       3:
	       4: gp
*/

/*
	o[ĥ甭B
*/

/*--------------------------------------------------------------*\
	t@C
\*--------------------------------------------------------------*/

#define	XSD_API_EVENT_CLOSE_FILE	7

/*
	wParam = 0
	lParam = 0
	md5FileName = ̃t@CMD5l
*/

/*
	o[ĥ甭
*/


/*--------------------------------------------------------------*\
	f[
\*--------------------------------------------------------------*/

/*	[JX-Send瑗ĂCxg̏	*/
extern	void	XsdLocalMsgProc( HWND hWnd );

/*	UDPőĂCxg̏	*/
extern	void	XsdSocketMsgProc( HWND hWnd );

/*--------------------------------------------------------------*\
	X-Send
\*--------------------------------------------------------------*/

/*	f[ɃCxg𑗂	*/
extern	void	DoXsdEvent( HWND hWnd );

/*	f[痈Cxg(WM_COPYDATA)	*/
extern	void	ParseXsdEvent( HWND hWnd, HWND hWndFrom, PCOPYDATASTRUCT pcds );

#ifdef	__cplusplus
}
#endif

#if		defined(__BORLANDC__)
#pragma	option	pop
#endif


#endif	/*	XSD_API_H	*/
