/*--------------------------------------------------------------*\
		module	:	XSD-API.c
		purpose :	X-Send f[ API
		author	:	_@ Kengo Jinno
		create	:	2001/09/11
		update	:	2001/10/02
\*--------------------------------------------------------------*/

#include	"PCH.h"
#include	"XSD-API.h"
#include	"XSD.h"
#include	"XSD-sock.h"

/*	X-Send̏Iɂ킹āAI	*/
static	BOOL	CALLBACK	EnumLocalXsWindowQuitProc( HWND hWnd, LPARAM lParam )
{
	HWND	hWndThis = (HWND)lParam;
	NpXsdInfo	p = GetXsdInfo( hWndThis );
	if( p != NULL && IsWindow( hWnd ) ) {
		/*	܂NXmF	*/
		TCHAR	szClassName[ _MAX_PATH ];
		if( GetClassName( hWnd, szClassName, _MAX_PATH ) > 0 ) {
			if( lstrcmp( szClassName, p->lpszXsWndClass ) == 0 ) {
				if( hWnd != p->XsdApiInfo.hWndFrom ) {	/*	Ăł͂Ȃ	*/
					p->bMustQuit = FALSE;
					return( FALSE );
				}
			}
		}
	}
	return( TRUE );
}

/*	[JX-SendɁAWM_COPYDATAŃCxgʒm	*/
static	BOOL	CALLBACK	EnumLocalXsWindowExecuteProc( HWND hWnd, LPARAM lParam )
{
	HWND	hWndThis = (HWND)lParam;
	NpXsdInfo	p = GetXsdInfo( hWndThis );
	if( p != NULL && IsWindow( hWnd ) ) {
		/*	܂NXmF	*/
		TCHAR	szClassName[ _MAX_PATH ];
		if( GetClassName( hWnd, szClassName, _MAX_PATH ) > 0 ) {
			if( lstrcmp( szClassName, p->lpszXsWndClass ) == 0 ) {
				if( ( !(p->XsdSocketInfo.bLocalSocket) && p->XsdSocketInfo.ulAddr != p->XsdApiInfo.ulAddr ) ||
					hWnd != p->XsdApiInfo.hWndFrom ) {
					/*
						E[J̒ʒmɂ̓\PbggȂ  茳͎ł͂Ȃ
						EEBhEnhႤ
						̂ǂ炩̏ꍇʒmB
						E[J̒ʒmɃ\Pbgg ܂ 茳ł
						EEBhEnhv
						̗΁ACxg̑茳Ȃ̂ŒʒmȂB
					*/
					DWORD	dwResult;
					COPYDATASTRUCT	cds;
					cds.dwData = p->uXsdApiMsg;
					cds.cbData = sizeof( XsdApiInfoType );
					cds.lpData = &(p->XsdApiInfo);
					SendMessageTimeout( hWnd, WM_COPYDATA, (WPARAM)hWndThis, (LPARAM)&cds, SMTO_ABORTIFHUNG|SMTO_BLOCK, 500, &dwResult );
				}
			}
		}
	}
	return( TRUE );
}

/*	t@C]Cxg̏	*/
static	void	SendFileProc( HWND hWnd )
{
	NpXsdInfo	p = GetXsdInfo( hWnd );
	if( p != NULL && p->XsdApiInfo.uEventID == XSD_API_EVENT_SEND_FILE ) {
		switch( p->XsdApiInfo.wParam ) {
		case 0:		/*	]Jn	*/
			/*	ȑÕobt@	*/
			if( p->lpszSendDataBuff != NULL ) {
				GlobalFree( (HGLOBAL)p->lpszSendDataBuff );
				p->lpszSendDataBuff = NULL;
			}
			p->lpszWritePos = NULL;
			p->dwSendDataBuffSize = 0;
			/*	Vobt@m	*/
			p->dwSendDataBuffSize = ( p->XsdApiInfo.lParam + 1 ) * sizeof(TCHAR);
			p->lpszSendDataBuff = (LPTSTR)GlobalAlloc( GPTR, p->dwSendDataBuffSize );
			if( p->lpszSendDataBuff == NULL ) {
				p->dwSendDataBuffSize = 0;
			} else {
				p->lpszWritePos = p->lpszSendDataBuff;
				if( !p->bNoHighPriority ) {
					/*	vZX̗D揇ʂグ	*/
					SetPriorityClass( p->hProcess, HIGH_PRIORITY_CLASS );
				}
			}
			p->dwCurrentRecord = 0;
			break;
		case 1:		/*	]	*/
			if( p->lpszSendDataBuff != NULL ) {
				DWORD	dwRecord = (DWORD)HIWORD(p->XsdApiInfo.lParam);
				int		nLen = LOWORD(p->XsdApiInfo.lParam);
				if( dwRecord < p->dwCurrentRecord ) {
					/*		*/
				} else if( dwRecord > p->dwCurrentRecord ) {
					/*	肱ڂĂ̂ōđv	*/
					p->XsdApiInfo.wParam = 3;
					p->XsdApiInfo.lParam = MAKELPARAM( nLen, p->dwCurrentRecord );
					p->XsdApiInfo.hWndFrom = hWnd;
				} else {	//	dwRecord == p->dwCurrentRecord
					if( ( p->lpszWritePos - p->lpszSendDataBuff + nLen ) * sizeof(TCHAR) <= p->dwSendDataBuffSize ) {
						CopyMemory( p->lpszWritePos, p->XsdApiInfo.buff, nLen );
						p->lpszWritePos += nLen;
					}
					(p->dwCurrentRecord)++;
				}
			}
			break;
		case 2:		/*	]I	*/
			if( p->lpszSendDataBuff != NULL ) {
				TCHAR	szTempPath[ _MAX_PATH ];
				HANDLE	hFile;
				int		nLen = p->lpszWritePos - p->lpszSendDataBuff;
				DWORD	dwWrite;
				/*	ȑÖꎞt@C폜	*/
				if( p->szFileSend[0] != _T('\0') ) {
					DeleteFile( p->szFileSend );
					p->szFileSend[0] = _T('\0');
				}
				/*	ꎞt@Cɏ	*/
				GetTempPath( _MAX_PATH, szTempPath );
				GetTempFileName( szTempPath, _T("XSD"), 0, p->szFileSend );
				hFile = CreateFile( p->szFileSend, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL );
				if( hFile != INVALID_HANDLE_VALUE ) {
					WriteFile( hFile, p->lpszSendDataBuff, nLen * sizeof(TCHAR), (LPDWORD)&dwWrite, NULL );
					CloseHandle( hFile );
				}
				/*		*/
				GlobalFree( (HGLOBAL)p->lpszSendDataBuff );
				p->lpszSendDataBuff = NULL;
				p->lpszWritePos = NULL;
				p->dwSendDataBuffSize = 0;
				/*	ꎞt@Cn	*/
				lstrcpy( (LPTSTR)(p->XsdApiInfo.buff), p->szFileSend );
				/*	vZX̗D揇ʂ߂	*/
				SetPriorityClass( p->hProcess, p->dwPriority );
			}
			break;
		}
	}
}

/*	[JX-Send瑗ĂCxg̏	*/
void	XsdLocalMsgProc( HWND hWnd )
{
	NpXsdInfo	p = GetXsdInfo( hWnd );
	if( p != NULL ) {
		if( p->XsdApiInfo.uEventID == XSD_API_EVENT_QUIT ) {
			/*	X-SendI悤ƂĂ	*/
			p->bMustQuit = TRUE;
			EnumWindows( EnumLocalXsWindowQuitProc, (LPARAM)hWnd );
			if( p->bMustQuit ) {
				PostMessage( hWnd, WM_CLOSE, 0, 0 );	/*	E	*/
			}
		} else {
			if( p->XsdApiInfo.uEventID == XSD_API_EVENT_SEND_FILE ) {
				/*	t@C]	*/
				SendFileProc( hWnd );
			}
			if( !(p->XsdSocketInfo.bLocalSocket) ) {
				/*	[JX-Sendɒʒm	*/
				EnumWindows( EnumLocalXsWindowExecuteProc, (LPARAM)hWnd );
			}
			
			/*	LANX-Send(f[)Ƀu[hLXgĒʒm	*/
			if( p->XsdSocketInfo.bIsLoaded && p->XsdSocketInfo.ulAddr != INADDR_NONE ) {
				XsdSocketBroadcast( &(p->XsdSocketInfo), (LPBYTE)&(p->XsdApiInfo), sizeof( XsdApiInfoType ) );
			}
		}
	}
}

/*	UDPőĂCxg̏	*/
void	XsdSocketMsgProc( HWND hWnd )
{
	NpXsdInfo	p = GetXsdInfo( hWnd );
	if( p != NULL ) {
		if( p->XsdSocketInfo.bLocalSocket || p->XsdSocketInfo.ulAddr != p->XsdApiInfo.ulAddr ) {
			/*
				E[Jɂ\PbgŒʒm(fobOp)
				EʂPC(IPAhX)͂
				̂ǂ炩̏ꍇB
			*/
			if( p->XsdApiInfo.uEventID == XSD_API_EVENT_SEND_FILE ) {
				/*	t@C]	*/
				if( p->XsdSocketInfo.bLocalSocket && p->XsdSocketInfo.ulAddr == p->XsdApiInfo.ulAddr ) {
					/*	[J\PbgŎg痈̂́AłɏςȂ̂ŉȂ	*/
				} else {
					SendFileProc( hWnd );
				}
			}
			/*	[JX-Sendɒʒm	*/
			EnumWindows( EnumLocalXsWindowExecuteProc, (LPARAM)hWnd );
		}
	}
}
