/*--------------------------------------------------------------*\
		module	:	XSD-sock.h
		purpose :	X-Send f[ \Pbg
		author	:	_@ Kengo Jinno
		create	:	2001/09/13
		update	:	2001/09/27
\*--------------------------------------------------------------*/

#ifndef	XSD_SOCK_H
#define	XSD_SOCK_H

/*
	WSOCK32.DLLłg悤ɁAÖٓIN
	INB
	̏ꍇAlbg[N͎gȂ̂
	EXN[
	Et@C]
	Ełv̒ʒm
	Ȃǂ͎gȂB
*/

/*	WSAStartup	*/
typedef	int		(PASCAL FAR* LP_FUNC_WSASTARTUP)( WORD, LPWSADATA );

/*	WSACleanup	*/
typedef	int		(PASCAL FAR* LP_FUNC_WSACLEANUP)( void );

/*	gethostname	*/
typedef	int		(PASCAL FAR* LP_FUNC_GETHOSTNAME)( char FAR*, int );

/*	gethostbyname	*/
typedef	struct	hostent FAR* (PASCAL FAR* LP_FUNC_GETHOSTBYNAME)( const char FAR* );

/*	inet_ntoa	*/
typedef	char	FAR*	(PASCAL FAR* LP_FUNC_INET_NTOA)( struct in_addr );

/*	ntohl	*/
typedef	ULONG	(PASCAL FAR* LP_FUNC_NTOHL)( ULONG );

/*	htonl	*/
typedef	ULONG	(PASCAL FAR* LP_FUNC_HTONL)( ULONG );

/*	socket	*/
typedef	SOCKET	(PASCAL FAR* LP_FUNC_SOCKET)( int, int, int );

/*	bind	*/
typedef	int		(PASCAL FAR* LP_FUNC_BIND)( SOCKET, const struct sockaddr FAR*, int );

/*	htons	*/
#if	defined(__LCC__)
typedef	ULONG	(PASCAL FAR* LP_FUNC_HTONS)( USHORT );
#else
typedef	USHORT	(PASCAL FAR* LP_FUNC_HTONS)( USHORT );
#endif
/*
	c@USHORTAlcc-win32ł
	X^bNj󂳂Ă܂B
	sockAddr.sin_port = (pInfo->lpfn_htons)( (USHORT)(pInfo->uPort) );
	RpCēfoꂽR[hB
	[lccwin32/USHORT]
	004021F9 0F B7 47 0C          movzx       eax,word ptr [edi+0Ch]
	004021FD 50                   push        eax
	004021FE FF 97 D4 01 00 00    call        dword ptr [edi+1D4h]      ;htons
	00402204 83 C4 04             add         esp,4                     ;
	00402207 66 89 85 EA FE FF FF mov         word ptr [ebp-116h],ax
	[lccwin32/ULONG]
	004021F9 0F B7 47 0C          movzx       eax,word ptr [edi+0Ch]
	004021FD 50                   push        eax
	004021FE FF 97 D4 01 00 00    call        dword ptr [edi+1D4h]      ;htons
	00402204 66 89 85 EA FE FF FF mov         word ptr [ebp-116h],ax
	Ƃ킯ŁAadd esp,4KB
	PASCALĂяoȂ񂾂AĂяoł܍킹Kv͂ȂB
	[lccwin32/ʂhtons()]
	004021F9 0F B7 47 0C          movzx       eax,word ptr [edi+0Ch]
	004021FD 50                   push        eax
    004021FE E8 41 02 00 00       call        00402444                  ;htons
	00402203 66 89 85 EA FE FF FF mov         word ptr [ebp-116h],ax
	[bcc55]
	00402077 66 8B 53 0C          mov         dx,word ptr [ebx+0Ch]
	0040207B 52                   push        edx
	0040207C FF 93 D4 01 00 00    call        dword ptr [ebx+1D4h]      ;htons
	00402082 66 89 85 EA FE FF FF mov         word ptr [ebp-116h],ax
	USHORTłULONGłR[hB
*/

/*	WSAGetLastError	*/
typedef	int		(PASCAL FAR* LP_FUNC_WSAGETLASTERROR)( void );

/*	closesocket	*/
typedef	int		(PASCAL FAR* LP_FUNC_CLOSESOCKET)( SOCKET );

/*	WSAAsyncSelect	*/
typedef	int		(PASCAL FAR* LP_FUNC_WSAASYNCSELECT)( SOCKET, HWND, UINT, long );

/*	ioctlsocket	*/
typedef	int		(PASCAL FAR* LP_FUNC_IOCTLSOCKET)( SOCKET, long, ULONG FAR* );

/*	sendto	*/
typedef	int		(PASCAL FAR* LP_FUNC_SENDTO)( SOCKET, const char FAR*, int, int, const struct sockaddr FAR*, int );

/*	recvfrom	*/
typedef	int		(PASCAL FAR* LP_FUNC_RECVFROM)( SOCKET, char FAR*, int, int, struct sockaddr FAR*, int FAR* );

/*	setsockopt	*/
typedef	int		(PASCAL FAR* LP_FUNC_SETSOCKOPT)( SOCKET, int, int, const char FAR*, int );

/*
	gĂȂ̂邪A܂B
*/


typedef	struct	tagXsdSocketInfoType	{
/*	public	*/
	BOOL		bIsLoaded;		/*	\Pbgp\ȂTRUE	*/
	ULONG		ulAddr;			/*	IPAhX	*/
	UINT		uSockAsyncMsg;	/*	\Pbg̔񓯊ʒmbZ[W	*/
	
	UINT		uPort;			/*	|[gԍ	*/
	BOOL		bNoBroadcast;	/*	u[hLXgȂ(fobOp)	*/
	BOOL		bLocalSocket;	/*	[Jɂ\PbgŒʒm(fobOp)	*/
	
/*	private	*/
	HINSTANCE	hInstWsock32;	/*	WSOCK32.DLL̃CX^Xnh	*/
	WSADATA		wsd;			/*	\Pbg	*/
	SOCKET		hSocket;		/*	\Pbgnh	*/
	
	/*	֐|C^	*/
	LP_FUNC_WSASTARTUP		lpfn_WSAStartup;
	LP_FUNC_WSACLEANUP		lpfn_WSACleanup;
	LP_FUNC_GETHOSTNAME		lpfn_gethostname;
	LP_FUNC_GETHOSTBYNAME	lpfn_gethostbyname;
	LP_FUNC_INET_NTOA		lpfn_inet_ntoa;
	LP_FUNC_NTOHL			lpfn_ntohl;
	LP_FUNC_HTONL			lpfn_htonl;
	LP_FUNC_SOCKET			lpfn_socket;
	LP_FUNC_BIND			lpfn_bind;
	LP_FUNC_HTONS			lpfn_htons;
	LP_FUNC_WSAGETLASTERROR	lpfn_WSAGetLastError;
	LP_FUNC_CLOSESOCKET		lpfn_closesocket;
	LP_FUNC_WSAASYNCSELECT	lpfn_WSAAsyncSelect;
	LP_FUNC_IOCTLSOCKET		lpfn_ioctlsocket;
	LP_FUNC_SENDTO			lpfn_sendto;
	LP_FUNC_RECVFROM		lpfn_recvfrom;
	LP_FUNC_SETSOCKOPT		lpfn_setsockopt;
	
}	XsdSocketInfoType, NEAR* NpXsdSocketInfoType;

/*	\Pbg񓯊ʒmbZ[W	*/
#define	WM_XSD_SOCK_ASYNC_MSG	(WM_APP+18)

/*	UDP|[gԍ	*/
#define	XSD_PORT	9122

#ifdef	__cplusplus
extern "C" {
#endif

/*		*/
extern	BOOL	XsdSocketInit( NpXsdSocketInfoType pInfo, HWND hWndNotify );

/*	I	*/
extern	void	XsdSocketQuit( NpXsdSocketInfoType pInfo );

/*	񓯊ʒmbZ[W̏	*/
extern	void	XsdSocketAsyncMsgProc( HWND hWnd, WPARAM wParam, LPARAM lParam, NpXsdSocketInfoType pInfo );

/*	u[hLXg	*/
extern	void	XsdSocketBroadcast( NpXsdSocketInfoType pInfo, LPBYTE pData, DWORD dwSize );

#ifdef	__cplusplus
}
#endif

#endif	/*	XSD_SOCK_H	*/
