/*--------------------------------------------------------------*\
		module	:	XSD.h
		purpose :	X-Send f[ C
		author	:	_@ Kengo Jinno
		create	:	2001/09/11
		update	:	2001/10/02
\*--------------------------------------------------------------*/

#ifndef	XSD_H
#define	XSD_H

#include	"bccres.h"
#include	"resource.h"

#include	"XSD-API.h"
#include	"XSD-sock.h"

typedef	struct	tagXsdInfo	{
	HINSTANCE	hInstance;		/*	g̃CX^Xnh	*/
	
	TCHAR		szProfile[_MAX_PATH];		/*	INIt@C̃pX	*/
	
	UINT		uPort;				/*	|[gԍ	*/
	BOOL		bNoBroadcast;		/*	u[hLXgȂ(fobOp)	*/
	BOOL		bLocalSocket;		/*	[Jɂ\PbgŒʒm(fobOp)	*/
	BOOL		bNoHighPriority;	/*	]̗D揇ʂグȂ(fobOp)	*/
	
	/*	API	*/
	UINT			uXsdApiMsg;			/*	vZXԒʐM(WM_COPYDATA)Ŏg鎯ʎq	*/
	XsdApiInfoType	XsdApiInfo;			/*	vZXԒʐMPCԒʐMłƂ肳\	*/
	LPCTSTR			lpszXsWndClass;		/*	X-Send̃EBhENX	*/
	BOOL			bMustQuit;			/*	ICxgTRUE	*/
	
	TCHAR		szFileSend[_MAX_PATH];	/*	]t@C̈ꎞt@C	*/
	LPTSTR		lpszSendDataBuff;
	LPTSTR		lpszWritePos;
	DWORD		dwSendDataBuffSize;
	DWORD		dwCurrentRecord;		/*	݂̃R[hԍ	*/
	
	HANDLE		hProcess;				/*	̃vZXnh	*/
	DWORD		dwPriority;				/*	vZXD揇	*/
	
	/*	\Pbg	*/
	XsdSocketInfoType	XsdSocketInfo;
	
	/*	gCACR֌W	*/
	NOTIFYICONDATA	nid;				/*	gCʒmp\	*/
	BOOL			bInTray;			/*	gCɓĂTRUE	*/
//	HMENU			hMenuPopup;			/*	gC̃|bvAbvj[	*/
	UINT			uTaskbarCreatedMsg;	/*	^XNo[č\zbZ[W	*/
	
}	XsdInfo, NEAR* NpXsdInfo;

#define	GWL_XSD_INFO		0

#ifdef	WIN32
#define	XSD_EXTRA_BYTES			sizeof(LONG)
#define	GetXsdInfo(x)			( (NpXsdInfo)GetWindowLong(x,GWL_XSD_INFO) )
#define	SetXsdInfo(x,y)			SetWindowLong(x,GWL_XSD_INFO,(LONG)y)
#else
#define	XSD_EXTRA_BYTES			sizeof(WORD)
#define	GetXsdInfo(x)			( (NpXsdInfo)GetWindowWord(x,GWL_XSD_INFO) )
#define	SetXsdInfo(x,y)			SetWindowWord(x,GWL_XSD_INFO,(WORD)y)
#endif

/*	gC̒ʒmbZ[W	*/
#define	WM_XSD_TRAY_ICON		(WM_APP+12)

#define	XSD_TRAY_ID				1

#define	WM_XSD_LOCAL_MSG		(WM_APP+13)

#define	WM_XSD_SOCKET_MSG		(WM_APP+14)

#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif

#endif	/*	XSD_H	*/
